Welcome to SQL Manager for Oracle!

EMS SQL Manager for Oracle is a high performance tool for Oracle database server development and administration. SQL Manager for Oracle works with any Oracle versions from 8.1.7 to 21c and supports the latest Oracle database features including compressed, OLAP, read-only/read-write tables, invisible indexes, compound triggers, triggers with FOLLOWS clause and others. It offers plenty of powerful tools for experienced users such as PL/SQL code debugger, Backup/Restore database wizards, Query designer, Database statistics to satisfy all user needs. SQL Manager has advanced graphical user interface with a well-described wizard system, so clear in use that even a newbie will not be confused with it.

Visit our web-site for details: http://www.sqlmanager.net/

Key features

  • Latest Oracle database version support
  • Rapid database management and navigation
  • Powerful tools to make your work with Oracle database as easy as it can be
  • Easy-to-use wizards performing Oracle database administrative tasks
  • Simple management of all Oracle database objects (including create/edit/drop operations)
  • Effective security management
  • Advanced data manipulation tools
  • Excellent visual and text tools for query designing
  • Impressive data export and import capabilities
  • Visual Database Designer to handle database structure in a few clicks
  • Report designer with clear in use report construction wizard
  • Connection via local port forwarding through the SSH tunnel
  • Support of Unicode data
  • Modern graphical user interface with dark schema support

Product information

Homepage: | http://www.sqlmanager.net/en/products/oracle/manager
Support Ticket System: | http://www.sqlmanager.net/support
Register on-line at: | http://www.sqlmanager.net/en/products/oracle/manager/buy


What's new

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

What's new?

Version | Release date
SQL Manager for Oracle 3.6.2 | February 21, 2022

What's new in SQL Manager for Oracle?

1. Support for 21c database version implemented.

2. Editor tabs can be now highlighted with the specific DB color.

3. Improved processing of dependencies in large databases.

4. SQL Assistant didn't save size and settings on restore. Fixed now.

5. In some cases objects types were not filtered in DB Explorer. Fixed now.

6. Other fixes and improvements.

See also:

Version history


System requirements

System requirements for SQL Manager for Oracle

  • Microsoft Windows XP, Microsoft Windows Server 2003, Microsoft Windows Server 2008, Microsoft Windows Server 2008 R2, Microsoft Windows Server 2012, Microsoft Windows Server 2012 R2, Microsoft Windows Server 2016, Microsoft Windows Server 2019, Microsoft Windows Vista, Microsoft Windows 7, Microsoft Windows 8/8.1, Microsoft Windows 10, Microsoft Windows 11
  • 512 Mb RAM (1 Gb or above is recommended)
  • 200MB of available HD space for program installation
  • Oracle Client 8.1.7 or higher
  • Local or remote Oracle Database Server 8.1.7 or higher


Feature matrix

The FREE Lite version of SQL Manager for Oracle does not include all features of the Full version and has some limitations concerning the number and size of the databases (4Gb) that can be registered and the number of data manipulation and server maintenance tools. The detailed feature matrix is given below.

Note that when using the FREE Lite version of SQL Manager for Oracle you can activate a 30-day period of fully-functional usage. After the period expires, you will be able to continue using the Lite version.

For more information on activating the Full version features see Full Mode activation.

 | Full version | Lite version
Latest Oracle versions support
Support of all server versions from 8.1.7 to 21c | + | +
Support of compressed tables, OLAP tables, read-only/read-write tables, virtual columns | + | +
Support of invisible indexes | + | +
Support of compound triggers, triggers with FOLLOWS clause | + | +
Powerful and easy management of object permissions, including column-level permissions | + | +
Support of Unicode data | + | +
Rapid database management and navigation
Multiple database connections | + | +
Connecting via local port forwarding through the SSH tunnel | + | -
Schema restriction to see only required schemas | + | +
Projects to work with the selected database objects only | + | +
Multiple user-defined tabs for any tree node to access it in one-click | + | +
Working with multiple selected objects at a time | + | +
Grouping/ungrouping registered databases | + | +
Database Registration Manager which allows adding and deleting database registrations quickly | + | -
Search in Metadata tool is implemented for performing the quick search within the scope of database metadata | + | -
Instance Manager service which allows checking the service status of Oracle server and starting/stopping the service | + | -
Powerful tools to make your work with Oracle Database as easy as it can be
PL/SQL Code Debugger for step-by-step code debugging of anonymous blocks, procedures, functions, packages, triggers, object types | + | -
Database Statistics to provide all essential statistics on the database: system statistics, statistics on sessions; statistics on storage, wait events, latches | + | -
Database Information to get all information on database instance and NLS parameters | + | +
Extracting metadata into text files or Execute Script editor | + | +
Powerful print metadata module to create customizable metadata reports | + | -
Search in metadata | + | -
Report Designer for building powerful reports visually | + | -
SQL Monitor | + | +
HTML Report Wizard to create a detailed HTML report about your database quickly | + | -
Client Checker to check the validity of Oracle client and provide common information on client settings | + | +
Database Comparer tool which allows getting a script to synchronize the database structure | + | -
Simple management of all Oracle Database objects (including create/edit/drop operations)
Managing tables and all their subobjects: fields, primary, unique and foreign keys, indexes, triggers, and check constraints | + | +
Managing views and all their subobjects: fields, triggers, primary, unique and foreign keys | + | +
Managing procedures, functions, sequences, packages and package bodies | + | +
Managing users, roles, profiles, consumer groups and resource plans | + | +
Managing database and schema triggers, clusters, synonyms, database links, materialized views and materialized view logs | + | +
Managing object and array types, object type bodies, libraries | + | +
Managing Java sources, resources and classes | + | +
Managing index types, operators, dimensions | + | +
Managing contexts, directories, tablespaces, rollback segments, redo log groups | + | +
Managing scheduler objects: schedules, programs, chains, job classes and jobs, window groups and windows | + | +
Managing jobs | + | -
Duplicating database objects | + | +
Viewing dependencies between database objects | + | +
Advanced data manipulation tools
Powerful BLOB viewer/editor with several modes of viewing BLOB data | + | -
Plenty of useful tools such as data grouping, summarizing, fast search and filtering | + | +
Master-detail view to work with two linked tables at the same time | + | -
Table and card views to see data the way you like | + | -
Ability to copy and paste selected records | + | -
Advanced printing system | + | -
Effective security management
Grant manager displaying all database object grants in the form of a grid | + | +
Ability to set permissions for table columns | + | +
Easy management of database users, roles and profiles | + | +
Viewing and changing object permissions in object editors | + | +
Excellent visual and text tools for query building
Query Designer allowing you to build complicated queries without any knowledge of SQL syntax | + | -
Multiple SQL editors with code completion, syntax highlight and code folding | + | +
Large script execution (Execute script editor) | + | +
Ability to view query plan as a diagram | + | -
SQL Formatter (available from Query Data editor context menu) | + | -
Favorite Queries (Save and use your frequently used queries easily) | + | +
Ability to format DML and DDL | + | -
Impressive data export and import capabilities
Exporting data to most popular formats: MS Excel, MS Word, MS Access, HTML, PDF, TXT, CSV, DBF, XML, ODF, etc. | + | -
Importing data from MS Excel, MS Access, DBF, XML, ODF, TXT and CSV | + | -
Exporting data to Execute Script as INSERT statements, with destination DMBMS specified | + | -
Report designer with a clear in use report construction wizard
Create Report Wizard allows you to create simple reports in a few clicks | + | -
Managing reports in the same way as if they were database objects: accessing reports directly through the DB Explorer tree | + | -
Visual Database Designer to handle database structure in a few clicks
Creating diagram of existing database using Reverse Engineering tool | + | -
Dividing diagram into different subject areas located on separate pages | + | -
Navigating through diagram using Diagram Navigator | + | -
Creating/editing/dropping tables and table fields, views, setting links between them visually | + | -
Ability to add comments to diagram | + | -
Saving as image or printing database diagram | + | -
Two diagram notations (IDEF1x and IE) | + | -
A lot of visual customization options | + | -
Easy-to-use wizards performing Oracle Database administrative tasks
Backing up database | + | -
Restoring database | + | -
Flashback | + | -
Collecting and managing optimizer statistics | + | -
Recompiling invalid objects | + | -
Enabling/disabling constraints | + | -
Truncating table or cluster data | + | -
New state-of-the-art graphical user interface
Well-described Wizard system | + | +
Improved database explorer for easy management of all Oracle objects | + | +
MDI and floating-window styles implementation | + | +
Windows Toolbar to switch between windows easily, like in Windows Task Bar | + | +
Navigation bars with hot actions in most of the windows | + | +
Ability to save all program settings | + | +
Customizable toolbars for all program windows | + | +
Fully customizable program interface | + | +
Localizable program interface | + | +
...and other useful features
Keyboard templates | + | +
To-Do list | + | +


Installation

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Installation of SQL Manager for Oracle

If you are installing SQL Manager for Oracle for the first time on your PC:

  • download the SQL Manager for Oracle distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • run OraManagerFullSetup.exe (Full version) or OraManagerLiteSetup.exe (Lite version) from the local directory and follow the instructions of the installation wizard;
  • after the installation process is complete, find the SQL Manager shortcut in the corresponding group of Windows Start menu.

If you want to upgrade an installed copy of SQL Manager for Oracle to the latest version:

  • download the SQL Manager for Oracle distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • close SQL Manager application if it is running;
  • run OraManagerFullSetup.exe (Full version) or OraManagerLiteSetup.exe (Lite version) from the local directory and follow the instructions of the installation wizard.

See also:

SQL Manager FAQ


Registration

All purchases are provided by Digital River registration service. The Digital River order process is protected via a secure connection and makes on-line ordering by credit/debit card quick and safe.

Digital River is a global e-commerce provider for software and shareware sales via the Internet. It accepts payments in US Dollars, Euros, Pounds Sterling, Japanese Yen, Australian Dollars, Canadian Dollars or Swiss Franks by Credit Card (Visa, MasterCard/EuroCard, American Express, Diners Club), Bank/Wire Transfer, Check or Cash.

If you want to review your order information, or you have questions about ordering or payments please visit our Customer Care Center, provided by Digital River.

Please note that all of our products are delivered via ESD (Electronic Software Delivery) only. After purchase you will be able to immediately download the registration keys or passwords. Also you will receive a copy of registration keys or passwords by email. Please make sure to enter a valid email address in your order. If you have not received the keys within 2 hours, please, contact us at sales@sqlmanager.net.

Product distribution | MyCommerce/Digital River
EMS SQL Manager for Oracle (Business license) + 1-Year Maintenance* | Register Now!
EMS SQL Manager for Oracle (Business license) + 2-Year Maintenance*
EMS SQL Manager for Oracle (Business license) + 3-Year Maintenance*
EMS SQL Manager for Oracle (Non-commercial license) + 1-Year Maintenance*
EMS SQL Manager for Oracle (Non-commercial license) + 2-Year Maintenance*
EMS SQL Manager for Oracle (Non-commercial license) + 3-Year Maintenance*
EMS SQL Manager for Oracle (Trial version) | Download Now!
EMS SQL Manager for Oracle Lite | Download Now!

*EMS Maintenance Program provides the following benefits:

  • Free software bug fixes, enhancements, updates and upgrades during the maintenance period
  • Free unlimited communications with technical staff for the purpose of reporting Software failures
  • Free reasonable number of communications for the purpose of consultation on operational aspects of the software

After your maintenance expires you will not be able to update your software or get technical support. To protect your investments and have your software up-to-date, you need to renew your maintenance.

You can easily reinitiate/renew your maintenance with our on-line, speed-through Maintenance Reinstatement/Renewal Interface. After reinitiating/renewal you will receive a confirmation e-mail with all the necessary information.

See also:

How to register SQL Manager


How to register SQL Manager

If you have not registered your copy of SQL Manager for Oracle yet, you can do it by pressing the Register Now button and entering your registration information in the Register SQL Manager for Oracle dialog.

Welcome to SQL Manager - About

To register your newly purchased copy of EMS SQL Manager for Oracle:

  • receive the notification letter from Digital River with the registration info;
  • enter the Registration Name and the Registration Key from this letter;
  • make sure that the registration process has been completed successfully – check the registration information in the About SQL Manager for Oracle dialog (use the Help | About menu item to open this dialog).

Welcome to SQL Manager - Register product

See also:

Registration


Version history

Product name | Version | Release date
SQL Manager for Oracle | Version 3.6.1 | January 19, 2021
SQL Manager for Oracle | Version 3.6 | June 6, 2019
SQL Manager for Oracle | Version 3.5 | November 26, 2018
SQL Manager for Oracle | Version 3.4.1 | July 27, 2017
SQL Manager for Oracle | Version 3.4 | January 26, 2017
SQL Manager for Oracle | Version 3.3 | June 9, 2015
SQL Manager for Oracle | Version 3.2 | December 23, 2013
SQL Manager for Oracle | Version 3.1.0.1 | July 15, 2013
SQL Manager for Oracle | Version 3.0.0.1 | March 21, 2012
SQL Manager 2011 for Oracle | Version 2.6.0.1 | July 4, 2011
SQL Manager 2010 for Oracle | Version 2.5.0.1 | August 2, 2010
SQL Manager 2010 for Oracle | Version 2.4.0.1 | January 28, 2010
SQL Manager 2008 for Oracle | Version 2.3.0.1 | July 27, 2009
SQL Manager 2008 for Oracle | Version 2.2.0.1 | December 17, 2008
SQL Manager 2008 for Oracle | Version 2.1.0.1 | October 7, 2008
SQL Manager 2008 for Oracle | Version 2.0.0.1 | August 25, 2008
SQL Manager 2007 for Oracle | Version 1.5.0.1 | November 19, 2007
SQL Manager 2007 for Oracle | Version 1.4.0.1 | August 17, 2007
SQL Manager 2007 for Oracle | Version 1.3.0.1 | June 6, 2007
SQL Manager 2007 for Oracle | Version 1.2.0.1 | March 26, 2007
SQL Manager 2007 for Oracle | Version 1.1.0.1 | January 26, 2007
SQL Manager 2005 for Oracle | Version 1.0.0.1 | December 5, 2006

Version 3.6.1

1. Favorite objects info was not saved on Save settings wizard used. Fixed now.

2. Detailed info about Favorite objects was not displayed in SQL Assistant. Fixed now.

3. Visual schema was not reset on applying default program settings.

4. The RUSSIA value for NLS_LANG parameter was not supported at Check client. Fixed now.

5. Now you can register the database if no Home is available.

6. Object privileges were not displayed on the DDL tab for roles. Fixed now.

7. Query condition was corrupted on exporting query data. Fixed now.

8. Other improvements and fixes.

Version 3.6

  1. The new look with updated icons.
  2. Support of dark visual scheme added.

dark schema news

  3. Added support for Amazon RDS for Oracle.
  4. Added support for the 18C Oracle server version.
  5. Improved support of high-DPI monitors and large-scale fonts.
  6. Support of Unicode added for object names.
  7. Objects can be now added to Favorites from the popup menu.
  8. Databases can be re-ordered in Database explorer now.
  9. Many other bug-fixes.
  10. Other improvements in interface and usability.

Version 3.5

  1. Support for Oracle 18C added.
  2. Added statistics for redo logs switches.
  3. BLOB editor is automatically opened for BLOB data in binary fields.
  4. Query Data. Content of multiple tabs can be easily saved and restored from one file now.
  5. Added possibility for editing jobs by non-owners.
  6. Compare database wizard. Views are now created with FORCE option to aviod errors on synchronization.
  7. Compare database wizard. Fix of error on comparing materialized views.
  8. Compare database wizard. Target schemas were not loaded from the template. Fixed now.
  9. Package bodies created in lower case were incorrectly created with quotes. Fixed now.
  10. Data for invalid views was not displayed correctly. Fixed now.
  11. Many other fixes and improvements.

Version 3.4.1

1. Data frame. Now you can add conditions to Quick Filter with Shift button.

2. "Reduced precision" option has been added for Materialized views.

3. Search of objects has been improved in Visual Database Designer.

4. Default parameters are processed correctly on executing procedures now.

5. "ORA-30757" error occurred on displaying XMLData values. Fixed now.

6. The error occurred when launching the program on OS with Breton locale. Fixed now.

7. Column autowidth was applied incorrectly in some cases. Fixed now.

8. Errors of editing partitions in Index editor have been fixed.

9. Delete rule was not applied for new objects in Foreign key editor. Fixed now.

10. It was not possible to set the "Follow trigger" option to none in Trigger editor. Fixed now.

11. Some errors in Scheduler Window editor have been fixed.

12. Some errors in Scheduler editor have been fixed.

13. Replace dialog. "Yes to all" button did not work properly if "Prompt on replace" option was enabled. Fixed now.

14. Many other improvements and bugfixes.

Version 3.4

  1. Considerable improvement of performance in Execute Script, Extract Database, Compare Database and Dependency Tree tools.
  2. BLOB Editor. Support for viewing PDF data has been implemented.
  3. Ctrl+C can be used for copying text from error messages now.
  4. Out of memory error on extracting large amounts of data has been fixed.
  5. With UTF-8 connection national symbols were lost on executing DDL statement. Fixed now.
  6. Code Folding feature has been improved.
  7. Multiline /* */ comments were not highlighted correctly. Fixed now.
  8. The errors of processing reports have been fixed.
  9. Many other improvements and bug-fixes.

Version 3.3

  1. The approach of working with data buffers has been changed. The memory is allocated now only for real data stored in the table, and not just relying on its definition. It has lead to a considerable economy of memory.
  2. The mechanism of user schema filtration has been improved. Now all the database editors, services and tools work only with the set of schemas indicated in the schema filter in the DB registration.
  3. Compare Databases. The mechanism of ordering of objects as per their dependencies has become better and faster. Now there is a possibility to compare only the schema objects, ignore objects of the schema PUBLIC, ignore objects’ parameters storage.
  4. Extract Databse. The mechanism of ordering of objects as per their dependencies has been refined and significantly improved.
  5. Duplicate Table. Now there is a possibility to choose sub-objects.
  6. Databases that are connected through SSH, are now marked with the special sign "lock-up".
  7. Now one can simultaneously execute several queries in Query Data, separated by ";" with browsing their data sets.
  8. The current schema in the objects tree is now marked with bold-faced type.
  9. Design Query parser work with the big number of ANSI joins has been fixed.
  10. Numerous errors related to group editing (deleting, relocation ..) in Visual Database Designer (VDBD) are fixed now.
  11. Export data of large data sets used to finish with the error "Out of memory". Fixed now.
  12. Running multiple instances of DB Comparer was finished with the error Out of Memory. Fixed now.
  13. Query Data. During the process of asynchronous execution of the long query with the specified timeout the query was interrupted and the data set was closed, even in the case when the query met the timeout limits. Fixed now.
  14. Many interface errors in case of editing the Storage Data for the table are fixed.
  15. Incorrect work with the ISO8859-5 DB encoding. Fixed now.
  16. Other improvements and bug fixes.

Version 3.2

  1. Support of new Oracle 12c feature: Use of sequences in fields editor. Support of autoincrement fields.
  2. Support of new Oracle 12c feature: DEFAULT ON NULL option of column editors.
  3. Support of new Oracle 12c feature: Size of varсhar type fields is up to 32767 bytes.
  4. Support of new Oracle 12c feature: PL/SQL subprograms in WITH … SELECT queries.
  5. Support of new Oracle 12c feature: Partitioning mechanism is improved:
  • Online move of partitions (without demounting database)
  • Delete and remove several partitions at once
  • Split and merge partitions
  6. Support of new Oracle 12c feature: Granting and revoking program module roles.
  7. Support of new Oracle 12c feature: Support of limits when uploading table and view data.
  8. Support of new Oracle 12c feature: Support of KEEP … SESSION option in sequences.
  9. Extract Database. Option "Delete existing records" is added.
  10. Role editor. Support of IDENTIFIED USING option.
  11. HTML Report. Operating procedure is significantly improved; HTML reports are created much faster now.
  12. When connecting through SSH, if SID and alias in tnsnames.ora were different, the connection error ORA-12514 occurred. Fixed now.
  13. When saving the diagram of Visual Database Designer as image, it was cut. Fixed now.
  14. Despite the restrictions set in "Schema Restriction" the whole range of schemas was requested from the server. Fixed now.
  15. When opening large tables the query interruption occurred with the 4 second time-out, despite the time-out settings. Fixed now.
  16. Lots of other improvements and bug-fixes.

Version 3.1.0.1

  1. Debugger PL/SQL code. The mechanism is fundamentally changed; a lot of bugs is fixed. Visual Options are "remembered" now.
  2. Recompile invalid objects. The mechanism is fundamentally changed and improved. It is possible to determine invalid dependencies and to recompile both single problem objects and all dependencies as a whole.
  3. A new "Calculate dependencies" option appeared in Extract Database. It analyses dependencies and arranges them in accordance with the use.
  4. At any start/restart of the current connection when "Use separate connections for each data view within a database" option at Data options was on, AV error occurred. (e.g., Query Data, Execute Script, Register DB Options). Fixed now.
  5. When "Schema restriction" option for PUBLIC and Current at Operator Editor was on, AV error occurred. Fixed now.
  6. The DATE values were wrongly double-quoted importing from CSV. Fixed Now.
  7. If close several editors with the right-click menu of the windows bar (Close All) and open editor of other object, the close of unnecessary editors stopped. Fixed now.
  8. Data Manipulation | Export Data. "Failed: Out of Memory" error occurred when exporting table data with a great number of rows. Fixed now.
  9. DB Explorer. If the object was not deleted in DB Explorer, it was possible to open it in DB Explorer. Fixed now.
  10. If a table and a cluster with the same name were created, the cluster columns were added to the table columns when opening the table; if open the cluster, the table columns were added to the cluster columns. Fixed now.
  11. When "Sort by aliases" was on, the table fields were sorted in object tree. Fixed now.
  12. Lots of other improvements and bug-fixes.

Version 3.0.0.1

  1. Added the Database Comparer tool which allows getting a script to synchronize the database structure.
  2. The Search in Metadata tool is implemented for performing the quick search within the scope of database metadata. The tool allows you to set various search conditions and view the results.
  3. Visual Database Designer.
  • Added the 'Undo' and 'Redo' operations.
  • Added tools for formatting diagram objects: setting fonts, colors, etc.
  4. HTML Report. Now it is possible to define the report visual style.
  5. Added the Database Registration Manager which allows adding and deleting database registrations quickly.
  6. Added the Instance Manager service which allows checking the service status of Oracle server and staring/stopping the service.
  7. Added the possibility to define shortcuts not only for Query Data commands, but for some other commands too (Environment Options | Global Shortcuts).
  8. SQL Formatter now allows formatting DDL statements.
  9. The switching between windows is now performed with the Ctrl + Tab shortcut.
  10. Added the possibility to duplicate objects in other databases by drag-and-dropping them in DB Explorer.
  11. Now it is possible to set the Connection string manually, while creating a database connection.
  12. Save and Restore layout. Now it is possible to save the column width while executing queries to Query Data and SQL Design Query.
  13. Added the possibility to set the font size only in DataGrid.
  14. Many other small improvements and bugfixes.

Version 2.6.0.1

  1. Query Data and Execute Script.
  • Added the possibility to set timeout for query execution.
  • It was not possible to cancel a query using the “Asynchronous Query Execution” option. Query Data hanged up when performing large queries. Fixed now.
  2. Added the possibility to detect resource-intensive queries whose execution could take a long time (more than 10 seconds).
  3. Now if the Oracle Home list is empty (the client is not set), an alert message occurs.
  4. Now when setting a string type for the newly created table field, the size is set to 10 by default.
  5. Added the possibility to select the “multi-insert” option when exporting data as SQL-script (if this option is supported by the server).
  6. The changing of the "Object Type Body" source code caused the lost of the custom formatting. Fixed now.
  7. It was not possible to quote identifiers when using the “Convert created object names to upper case” option. Fixed now.
  8. If a field name started with a number, the error message occurred upon the data export. Fixed now.
  9. If none of the databases was registered upon using the "Edit local naming parameters" option, AV error occurred. Fixed now.
  10. When creating the "Flashback” restore point, the "Invalid identifier or cannot open address file" error occurred. Fixed now.
  11. When duplicating the table with the replacement of the layout scheme, the tablespace changed incorrectly. Fixed now.
  12. Design Query. When executing queries such as "Insert As Select, AV error occurred. Fixed now.
  13. Create procedures. After pressing the “Compile" button in the "Convert created object names to upper case"option, AV error occurred. Fixed now.
  14. It is now possible to execute queries, which contain string values ​​with the “ ’ ” (apostrophe) symbols.
  15. It was not possible to insert rows with 1000 and more characters into the varchar (4000) field. Fixed now.
  16. When selecting the "Autoincrement" option to edit the previously created field, the autoincrement metadata was not created. Fixed now.
  17. When creating a key, the value inserted into the "Tablespace" filed was ignored. Fixed now.
  18. There were redundant records in the grid, when executing queries such as "select cast (fieldname as varchar (100)) from tablename". Fixed now.
  19. Objects located in the current tablespace were not displayed. Fixed now.
  20. Some other improvements and bugfixes.

Version 2.5.0.1

  1. Added the new objects: Queue and Queue Table.
  2. Added the TKProf Wizard to work with TKProf program for handling trace files.
  3. Backup Database Wizard. The possibility to schedule the backup process is added.
  4. Design Query. If a file is opened, its name is displayed in the window title.
  5. Now SQL Manager does not execute “Alter session set …” queries under the Normal User as they used to result in the “ORA-01031: insufficient privileges” error.
  6. The speed of working with the object tree is increased. The work of the Normal User is optimized.
  7. Execute Script Editor. Added the support of the “/” delimiter for all objects.
  8. “Edit Local Naming Parameters” option is added to the main menu.
  9. Added the possibility to change the password for the Normal User.
  10. The work with two registered databases that had the same ServiceName caused to the “SQL command not properly ended” error if the Schema Restriction option was enabled. Fixed now.
  11. When importing data from the CHAR(1) field with the value of ' ' (a space), this field was imported as empty. Fixed now.
  12. Design Query. When pressing the Clear button, the query type was not reset to “Select”. Fixed now.
  13. Array Types Editor. The list of objects for quick switching was not filled. Fixed now.
  14. After refreshing and disconnecting from a database and closing SQL Manager, an error occurred. Fixed now.
  15. When moving to the Permissions tab under the Normal User, the ORA-00942 error occurred. Fixed now.
  16. Materialized Views.
  • When creating a materialized view, an extra “;” was added to the DDL description and an error occurred. Fixed now.
  • When deleting a materialized view whose editor was running, the DDL of the non-existent view was generated. Fixed now.
  17. When editing a function, the “There is an error in input of field…” message appeared. Fixed now.
  18. When trying to connect through SSH, the “ORA-01031: insufficient privileges” error occurred. Fixed now.
  19. When the “Hide empty schemes” option was enabled, the current user scheme was hidden if it did not contain any object. Fixed now.
  20. Tablespace Editor. If you did not go to the Files tab, data files were not displayed in DDL. Fixed now.
  21. Some other small improvements and bugfixes.

Version 2.4.0.1

  1. Database alerts.
  • New events for monitoring are added.
  • It is now possible to view the description for each alert and the objects which the alert refers to.
  2. Oracle client checker.
  • The algorithm of Oracle homes searching is changed (e.g. INSTANT_CLIENT and XE_CLIENTS are supported now).
  • The errors are now displayed with the fixing instructions.
  3. Dependency Tree. The mechanism of the dependency tree building is improved; the building speed is increased.
  4. Added the possibility to enable/disable triggers in the object context menu in the DB Explorer.
  5. Register Database wizard. The new item is added to the “Connect Using” list which indicates that the connection will be performed through TNS_ADMIN.
  6. Environment Options.
  • The “Quote low case identifiers” option is added.
  • Added the “Autocreation options” option which automatically creates synonyms when creating a new object.
  7. Field Editor. Added the possibility to imitate an auto increment field by creating a corresponding trigger and a sequence.
  8. Recompile Invalid Objects. Synonyms are added to the list of available objects.
  9. The “Compile With Debug Info” task is added to the drop-down menu of PL/SQL objects.
  10. Scheduler Jobs/Scheduler Windows.
  • After creating a new metaobject, its editor did not start. Fixed now.
  • It was not possible to delete several metaobjects at once. Fixed now.
  11. Scheduler Programs. When the Enabled box was checked, the Disable script was generated and vice versa. Fixed now.
  12. After downloading a HTML report and upon refreshing any collection, the "Not enough available timer" message was displayed. Fixed now.
  13. Trigger Editor. It was not possible to set a fields list for which the trigger should fire. Fixed now.
  14. Export as SQL Script from Design Query. The ROWID column was included in the table DDL. Fixed now.
  15. Export as SQL Script from a view. Table and scheme names were quoted incorrectly. Fixed now.
  16. HTML Report wizard.
  • Hyperlinks did not work if the object name included the “#” character. Fixed now.
  • Indices were not indicated as unique in the corresponding column. Fixed now.
  17. Visual Database Designer. If a scheme was not implicitly indicated, a new table was created without columns. Fixed now.
  18. Fixed multiple errors occurred in the asynchronous query execution mode.
  19. When the parsing was disabled, execution of an empty script in the Execute Script tool caused an error. Fixed now.
  20. Key mappings for macroses did not work. Fixed now.
  21. Other small improvements and bugfixes.

Version 2.3.0.1

  • Added a number of new Oracle 10g objects: Scheduler Job Classes, Scheduler Jobs, Scheduler Window Groups, Scheduler Windows, Scheduler schedules, Scheduler programs, Scheduler chains
  • Improved Execute Script performance: SQL statements parsing is enhanced
  • Now table and view objects are not refreshed if the 'Refresh on connect' option is enabled
  • Object editors' performance is enhanced, the dependencies are loaded faster when switching to the Dependencies tab
  • DB Explorer: the program automatically hides SQL Assistant to increase performance
  • Materialized View: it is now possible to create and edit partitions
  • DB Explorer: it is now possible to drag-n-drop objects between different database groups
  • Design Query, Select mode: the field created in the Selection section disappeared after saving and reloading a diagram. Fixed now
  • Design Query, Update mode: the 'Delete Current Row' function deleted a row from the diagram only, not from the query text. Fixed now
  • Design Query: after creating a query with a subquery at the Edit tab, the subsequent switching from the Edit tab to the Builder tab resulted in the 'ORA-00942: table or view does not exist' error. Fixed now
  • Query Data: with the 'Asynchronous query execution' option enabled, query syntax errors were not displayed. Fixed now
  • Query Data: when executing a query with the 'Asynchronous query execution' option disabled and then executing the same query with this option enabled, the Access Violation error occurred. Fixed now
  • DB Explorer: the new tabs created in the DB Explorer were minimized after the program restart. Fixed now
  • Even if the 'Login prompt before connection' option was enabled, the program stored the password in system registry. Fixed now
  • Keyboard templates: inactive templates became active again after the program restart. Fixed now

Scroll to top

Version 2.2.0.1

  • Create Database Wizard with the ability to create a standby database is added
  • DDL: Unicode support is implemented
  • Using macro is now possible in Query Data and Execute Script
  • Added the possibility to connect to databases absent in TNS file
  • Design Query: added the ANSI join option that allows users to create queries in ANSI-92 SQL standard
  • DB Explorer: the Find Object dialog is improved
  • DB Explorer: the possibility to reorder database groups by drag-and-drop is implemented
  • DB Explorer: the button for switching the search mode is added to the toolbar
  • DB Explorer: the program saves the information about the last opened database before shutdown. When it is started next time, this database will be automatically selected in the DB Explorer tree
  • DB Explorer: double-clicking the object group folds or unfolds it
  • Most of the options from the Grid | Data Options section of the Environment Options dialog can now be specified individually for each of the registered databases in the Database Registration Info dialog. The values specified in the Grid | Data Options section will be applied as default settings for newly registered databases
  • Database Registration Info: metadata and Query Data logs can now be saved in UNICODE or ANSI
  • Query Data: creation of queries with identical names was allowed. Fixed now
  • Data Grid: the method of work in the asynchronous mode is changed – the usage of a separate connection for each data grid makes it possible to perform simultaneous fetching without losing the ability to use other functions of the program
  • Data Grid: the mouse cursor color changes when the grid is not active
  • Data View | Blob View: the XML tab allowing you to view BLOB field values as XML is added
  • Extract Database / Export as SQL Script: now the script is directly generated in the selected charset which reduces the script generation time
  • Visual Database Designer: tables are arranged more compactly in the reverse engineering mode
  • Windows List: the 'Close All Database Windows' command is implemented
  • Query Data: fixed several errors concerning SQL code highlight (alias usage in queries such as 'UPDATE : SET :', when using multiline comments, etc.)
  • Query Data: when saving data to file using any charset different from Unicode, further opening the save dialog would set the charset to Unicode. Fixed now
  • Query Data -> Explain query: the scrollbar was absent. Fixed now
  • Extract Database/ Export as SQL Script: extracting external cursor data resulted in the ORA-00900 error. Fixed now
  • Extract Database/ Export: the ORA-00900 error occurred when extracting queries with subquery block. Fixed now
  • Visual Database Designer: alignment options did not work when a diagram was opened from the file. Fixed now
  • Visual Database Designer: some printers could not print field and table icons. Fixed now
  • Dependency Tree: pressing the Cancel button gave no result. Fixed now
  • Other minor improvements and bug-fixes

Scroll to top

Version 2.1.0.1

  • Added the Flashback wizard - a very powerful tool for restoring data to a certain state
  • The possibility to search in metadata is implemented
  • Debugger: a watch can now be removed by the Delete key
  • Tablespace Editor: added the 'Flashback on' option which displays the flashback mode value
  • Query Data: the code formatter is improved in order to better process huge and complex queries
  • Visual Database Designer: the "Table is unavailable in database" error occurred on attempt to edit the table after the reverse engineering process. Fixed now
  • Debugger: the Ctrl+Del shortcut caused the deletion of the current debugger tab. Fixed now
  • ORA-54016 error occurred in 11G Oracle databases if the DESC and ASC compound index existed in a table. Fixed now
  • If a field constraint and index had different names, an incorrect DDL was formed. Fixed now
  • When editing PL/SQL Object’s body, the Compile action was not available. Fixed now
  • If the Oracle Database client was not installed, the Local Naming Parameters editor activation resulted in the Access Violation error. Fixed now
  • Extract Database: the data containing symbol " ' " were extracted improperly. Fixed now
  • The "List index out of bounds" error occurred when editing huge and complex queries in Query Data. Fixed now
  • Other minor improvements and bug-fixes

Scroll to top

Version 2.0.0.1

  • Support of partitioning for tables and indexes including Oracle Database 11g new features: system and reference partitioning
  • PL/SQL Profiler is a very powerful tool to help you profile existing PL/SQL applications and identify performance bottlenecks
  • Database Alerts is a very powerful tool that performs a series of check alerts on a selected database and displays the results in real-time
  • Support of many new features of Oracle 11g: compress tables, OLAP tables, read-only/read-write tables, invisible indexes, compound triggers, follows triggers, virtual columns, and others
  • Support of Unicode data in Query Data, Design Query, Grid View, Export/Import Data Wizards
  • All wizards, including Data Export/Import, DB Extract, Backup/Restore Database wizards, now run in the background mode, so that you could continue working with the program
  • New improved Query Data of the Visual Studio 2005 kind with the Code Folding function, Unicode support, code completion, syntax highlight and other useful features
  • Enhanced Import Data Wizard - now data can be imported up to 10 times faster; also added support of the following source file formats: HTML, XML Document, Open Document Format (ODF), Open XML Format (MS Word 2007, MS Excel 2007)
  • Added the Permissions tab to object editors, making it possible to grant privileges on objects to users and roles
  • Improved DB Explorer in several respects: added a menu for generation of common SQL statements for database objects (Script to Query Data, Script to Clipboard) - it is now possible to get CREATE, ALTER, DROP, SELECT statements for each database object; added the Search Panel
  • Now it is possible to save frequently used queries within the Favorite Queries node of DB Explorer; Favorite Queries can be stored either locally in Windows Registry (in this case they are only available for local users), or in a special table of the database (therefore, the queries can be accessed by all database users)
  • Improved Export Data Wizard: now works faster; added several output file formats: XML Document, Open Document Format (ODF), Open XML Format (MS Word 2007, MS Excel 2007)
  • Added the Find Option tool which allows one to find the required option in the scope of all program settings, by a word or an expression from the option title
  • Enhanced the reports management system
  • Improved Visual Database Designer: added a new diagram object (Comment); possibility to select the specification level for displaying objects (only object names, only fields)

Scroll to top

Version 1.5.0.1

  • Implemented PL/SQL Code Debugger in Query Data
  • Added an ability to log the values of bind-variables in SQL Monitor
  • Added Tips of the Day
  • Statements of type MERGE INTO... USING ... were parsed incorrectly. Fixed now
  • An Access Violation error occurred on attempt to Recompile invalid objects. Fixed now
  • The application used to freeze upon adding an object to Visual Database Designer when a large number of objects were opened. Fixed now
  • Other minor improvements and bug-fixes
  • Added Polish localization
  • Updated English localization

Scroll to top

Version 1.4.0.1

  • Backup/Restore Database features are implemented; the User managed and RMAN user strategies are available
  • Recompile Invalid Objects is also available for users who have no SELECT_CATALOG_ROLE privilege
  • The Dependency Tree building speed has been significantly increased
  • It was impossible to obtain data via a WITH-prefixed query. Fixed now
  • Export as SQL Script: when extracting the CLOB field data as a string, the ' symbol was not processed correctly. Fixed now
  • Key Mapping: the Quick Code settings used to be displayed incorrectly. Fixed now
  • The Ctrl+Alt+Q key combination used to invoke the procedure list in the default scheme, which made it impossible to enter the @ symbol in the German layout. Fixed now
  • A wrong script used to be generated when setting the 'Not Null' option in Table Editor. Fixed now
  • When obtaining a sequence definition the current sequence value was not taken into account. Fixed now
  • Database Registration Info: the Reconnection prompt used to popup even if no changes had been made. Fixed now
  • Other minor improvements and bug-fixes

Scroll to top

Version 1.3.0.1

  • Oracle Client Checker is added to check client and home settings at the program startup. It can also be called from the Database Registration Info dialog
  • Advanced Statistics Wizard is added to collect, delete and import/export the statistics on specified objects for optimizer
  • Truncate Wizard is added for truncating table and cluster data
  • Enable/Disable Constraints Wizard is added to disable and enable the constraints of different types (for selected tables)
  • Procedures and functions are shown as subobjects for the packages in DB Explorer, as well as in the Code Completion list
  • The Recompile Invalid Objects service is added, which allows you to recompile selected invalid PL/SQL objects
  • Code Completion: now the objects are displayed in the Code Completion list even if they were not refreshed in the object tree list of DB Explorer (can be switched off with the help of the corresponding option)
  • Extract Database: wrong statements for creating materialized views used to be displayed in the target script. Fixed now
  • When duplicating a table, the schema name of the target table was missing in field descriptions, which caused an error upon the script execution. Fixed now
  • Visual Database Designer: when opening a previously saved diagram the 'Object not found in database' error used to occur. Fixed now
  • Visual Database Designer: in some rare cases foreign keys were not displayed. Fixed now
  • Database Registration Info: the value of the 'Rollback on Disconnect' option was not taken into account in case of emergency disconnect. Fixed now
  • When deleting multiple materialized view logs in the object tree, a wrong script used to be generated. Fixed now
  • Fixed the AV error which used to occur upon creating a view
  • Dependency Tree: it was impossible to open the editor from a diagram for indices and triggers. Fixed now
  • Execute Script: in some rare cases the script parser incorrectly detected object type for materialized views, object types, array types; those objects were placed into the wrong branch in DB Explorer. Fixed now
  • DB Explorer: after disconnecting from a database the Recent Objects list remained active. Fixed now
  • Other small improvements and bug-fixes

Scroll to top

Version 1.2.0.1

  • Database Statistics form is added; it displays a summary of the instance performance, date of the last gathering statistics on tables and indexes. It also outputs the information on I/O sessions performance, CPU-time, memory, Hit-Ratios, Locks; the information on Tablespaces, Segments, SGA, Control Files, Data Files, Rollback Segments. Free space estimation is displayed graphically. Detailed information on wait events and latches is also available
  • Database Information form is added; it contains common information on the current database instance and NLS parameters; allows viewing and editing its configuration parameters
  • Object Tables support is implemented
  • The ability to start gathering information for a separate table or schema is added
  • The method of access level test to data dictionary (hierarchical privileges by roles, by system privileges) is fixed and expanded
  • Print Metadata: a report on the table now includes field descriptions
  • Visual Database Designer: the method of refreshing during reverse engineering is optimized. While performing reverse engineering, it is now possible to refresh the selected schemas only
  • Creating and editing database reports is now available for users with limited access privileges
  • DB Explorer: added the ability to rename database groups
  • Query Data: the SELECT queries containing the DISTINCT keyword used to work incorrectly. Fixed now
  • Reports could not be renamed. Fixed now
  • When extracting a database by a user with limited access to the data dictionary, an error used to occur. Fixed now
  • When opening invalid objects within the 'floating windows' environment the 'Can't focus a disabled or invisible window' error used to occur. Fixed now
  • Local Naming Parameters Editor: some errors in the editor work are fixed
  • The bug concerning incorrect displaying dependencies for materialized view log is fixed now
  • Other small improvements and bug-fixes

Scroll to top

Version 1.1.0.1

  • Full support of External and Index-Organized tables
  • Invalid status objects are marked with a cross in the DB Explorer tree now. Users are considered invalid if any of EXPIRED, LOCKED, EXPIRED GRACE, EXPIRED TIMED account statuses takes place
  • Execute Script: ability to execute selected statements and statement under cursor added
  • Execute Script: DBMS output is displayed now
  • Execute Script: script is not loaded into memory anymore when executing a script from file
  • Query Data: DBMS output is displayed now
  • Query Data: when switching between queries, the cursor and scrolling bar positions were not saved. Fixed now
  • XMLType is added to the list of available fields
  • Changing Metadata window: if an error occurs, the cursor is now moved to the place which caused an error
  • When refreshing tablespaces on Oracle 9.2, an error used to occur. Fixed now
  • If table or view lists were not refreshed in DB Explorer, the first attempt to execute a query in Query Data could take a long time, especially if connection was slow or the server was overloaded. Fixed now
  • In some rare cases on opening the Code Completion window and typing symbols the window started to blink. Fixed now
  • In some cases, when closing a report, the Access Violation errors used to occur. Fixed now
  • Some objects could be refreshed by a user with no SELECT_CATALOG_ROLE privilege. Fixed now
  • Visual Database Designer: when deleting foreign keys, the confirmation dialog did not appear. Fixed now
  • Database Registration: the database list always displayed databases from the default home directory, irrespective of the selected home. Fixed now
  • When creating a tablespace on Oracle 8 or Oracle 9 the Minimum Extent Size parameter was ignored in some cases. Fixed now
  • Other small improvements and bug-fixes

Scroll to top

Version 1.0.0.1

Basic features:

  • Rapid database management and navigation
  • Easy management of all Oracle objects (including create/edit/drop operations)
  • Advanced data management and manipulation tools
  • Impressive data export and import capabilities
  • Effective security management
  • Excellent visual and text tools for query building
  • Report designer with clear in use report construction wizard
  • Powerful Visual Database Designer
  • Latest Oracle version support
  • New state-of-the-art graphical user interface

and more...

Scroll to top

See also:

What's new


FAQ

Please read this page attentively if you have questions about EMS SQL Manager for Oracle.

Table of contents

Product questions

  • What is EMS SQL Manager for Oracle?
  • What is the difference between Full and Lite versions of EMS SQL Manager for Oracle?
  • What do I need to start working with EMS SQL Manager for Oracle?
  • What is the difference between the Export/Import functions in SQL Manager and the Data Export/Import utilities?
  • What is the difference between the Design Query module in SQL Manager and the SQL Query for Oracle standalone utility?
  • What is the difference between the Extract Database function in SQL Manager for Oracle and the DB Extract for Oracle standalone utility?

Common questions

  • I can't modify DDL. Why?
  • I can't configure connection to Oracle server via SSH. Which values do I need to input in the SSH section of the Database Registration Info dialog?
  • When I create database objects, their names are always converted to upper case. How I can prevent it?
  • How can I create a report?
  • How can I customize data formats in grid?
  • I need to perform some changes in database objects of my test database and then make the same changes on another database. Are there any tools for this purpose in SQL Manager for Oracle?
  • How can I speed up my work with large tables?

Export/Import questions

  • I am trying to export a table, but text fields are not exported.
  • What is the difference between the "Extract Database" and "Export as SQL Script" functions?
  • How can I change the default directory where exported data will be saved?

Question/answer list

Product questions

Q: What is EMS SQL Manager for Oracle?

A: EMS SQL Manager for Oracle is a powerful tool for Oracle Database administration and development. SQL Manager for Oracle supports all of the latest Oracle features. It offers plenty of powerful tools for experienced users to satisfy all their needs. SQL Manager for Oracle has a new state-of-the-art graphical user interface with well-described wizard system, so clear in use that even a newbie will not be confused with it.

Q: What is the difference between Full and Lite versions of EMS SQL Manager for Oracle?

A: These editions of SQL Manager for Oracle differ in price and features. To register SQL Manager for Oracle, see the Purchase page, and to learn about the difference in features please go to our Feature Matrix page.

Q: What do I need to start working with EMS SQL Manager for Oracle?

A: First of all, you must have an opportunity to connect to some instance of Oracle server to work with SQL Manager. Besides, you need your workstation to satisfy the system requirements of SQL Manager for Oracle.

Q: What is the difference between the Export/Import functions in SQL Manager and the Data Export/Import utilities?

A: The Data Export/Import for Oracle utilities include some additional features which are not available in SQL Manager, such as:

  • export/import data from/to several tables simultaneously;
  • a command-line utility to export/import data using the configuration file with all the export/import options.

Q: What is the difference between the Design Query module in SQL Manager and the SQL Query for Oracle standalone utility?

A: First of all, SQL Query for Oracle works faster, as it is a much lighter product. Besides, it provides additional features for query building, e.g.

  • keeping query history which allows you to rollback to any edited query;
  • various interface improvements for more productive and easier work.

Q: What is the difference between the Extract Database function in SQL Manager for Oracle and the DB Extract for Oracle standalone utility?

A: The DB Extract for Oracle utility includes some additional features which are not available in SQL Manager, such as:

  • a console application for performing extract in one-touch;
  • faster extraction speed.

Scroll to top

Common questions

Q: I can't modify DDL. Why?

A: The DDL tab of the SQL Manager editors is read-only. It displays object structure as SQL text and reflects the operations you perform over the object under other editor tabs. To modify an object, you can copy the text to the clipboard and edit it using Query data. For more details refer to Viewing object DDL structure.

Q: I can't configure connection to Oracle server via SSH. Which values do I need to input in the SSH section of the Database Registration Info dialog?

A: To setup the connection via SSH tunnel, you need to input the following:

within the SSH Tunneling section:

  • SSH host name is the name of the host where SSH server is running
  • SSH port indicates the port where SSH server is activated
  • SSH user name stands for the user on the machine where SSH server is running
  • SSH password is the Linux/Windows user password

within the Connection section:

  • User name is an Oracle user name
  • Password is password for Oracle user

For more details refer to SSH tunneling options.

Q: When I create database objects, their names are always converted to upper case. How I can prevent it?

A: Please switch off the "Convert created objects' names to upper case" option within the Object Editors section of the Environment Options dialog.

Q: How can create a report?

A: To create a report, you can use the Create Report wizard or Report Designer. To create a simple report based on a query, you need to select "Master Data band" on the Selecting report bands step of the wizard and specify the query for your report. After that you need to set the remaining options on subsequent steps of the wizard and press Run.

Q: How can I customize data formats in grid?

A: You can customize all display formats: integer, float, date, time and date/time using the Color & Formats page of the Environment Options dialog.

Q: I need to perform some changes in database objects of my test database and then make the same changes on another database. Are there any tools for this purpose in SQL Manager for Oracle?

A: The Database Registration Info dialog provides the Logs section where you can enable logging metadata changes performed over the database and/or SQL queries executed in Query Data.

Q: How can I speed up my work with large tables?

A: For your convenience and to speed up your work, the Data Grid allows customizing a number of data display parameters. Here are the most important of them (accessible through the Grid | Data Options section of the Environment Options dialog):
- Limit options in table and view editors. The 'Select all records of a table' option will enable you to see all table records without extra references to the server, yet in case of large tables or low speed connection channel the data may be fetched with huge delays and the incoming traffic might grow considerably. This mode is recommended when working with local databases or in a private network. The 'Select only' mode restricts the maximum number of records returned after the query. A man cannot process a massive amount of information at once. Hence, we came up with this mode. This mode speeds up table data viewing considerably, prevents hanging and connection timeout. It is recommended to work with large tables, in case of low speed connection channels and when the traffic volume is of importance. This is the default mode. When in this mode, enabling the 'Use SQL sorting in data view' and 'Use SQL filter in data view' options comes really helpful.
- Default Grid Mode. This option defines whether the requested rows will be loaded in the Grid all at once ('Load all rows'), or in parts ('Load visible rows') as the user scrolls down table data. The first mode increases the query opening time, but speeds up scrolling. In the second mode the query opens very fast, but there might be delays when navigating the grid.
We recommend that you set the following option values to achieve maximum efficiency when working with large tables:
- Select only – ON
- Load visible rows – ON

Scroll to top

Export/Import questions

Q: I am trying to export a table, but text fields are not exported.

A: Fields of types BLOB, CLOB, NCLOB, BFILE, LONG, LONG ROW and XML are not exported by default. You should select these fields manually at the Selecting fields for export step.

Q: What is the difference between the "Extract Database" and "Export as SQL Script" functions?

A: Export as SQL Script is intended for exporting table data that will be inserted into a database system other than Oracle Database. Use Extract Database Wizard to copy metadata and/or data to a database on Oracle afterwards.

Q: How can I change the default directory where exported data will be saved?

A: Follow the steps below to change the default directory:

1. Right-click the database alias in DB Explorer and select the 'Database Registration Info...' context menu item (you can also find this item in the 'Database' main menu) to open the Database Registration Info dialog.

2. Proceed to the Directories section within the dialog.

3. Set the 'Default directory for Export Data'.

Scroll to top

If you still have any questions, contact us at our Support Center.


Other EMS Products

Quick navigation

MySQL

Microsoft SQL Server

PostgreSQL

InterBase / FireBird

Oracle

IBM DB2

Tools & components

MySQL

 | SQL Management Studio for MySQL EMS SQL Management Studio for MySQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for MySQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for MySQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for MySQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for MySQL Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to MySQL.
datagenerator | Data Generator for MySQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for MySQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for MySQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for MySQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for MySQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Microsoft SQL Server

 | SQL Management Studio for SQL Server EMS SQL Management Studio for SQL Server is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for SQL Server Perform backup and restore, log shipping and many other regular maintenance tasks on the whole set of SQL Servers in your company.
sqladmin | SQL Administrator for SQL Server Perform administrative tasks in the fastest, easiest and most efficient way. Manage maintenance tasks, monitor their performance schedule, frequency and the last execution result.
 | SQL Manager for SQL Server Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for SQL Server Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for SQL Server Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for SQL Server Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to Microsoft® SQL Server™.
datagenerator | Data Generator for SQL Server Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for SQL Server Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for SQL Server Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for SQL Server Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for SQL Server Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

PostgreSQL

 | SQL Management Studio for PostgreSQL EMS SQL Management Studio for PostgreSQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for PostgreSQL Creates backups for multiple PostgreSQL servers from a single console. You can use automatic backup tasks with advanced schedules and store them in local or remote folders or cloud storages
 | SQL Manager for PostgreSQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for PostgreSQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for PostgreSQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for PostgreSQL Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, InterBase/Firebird, etc.) to PostgreSQL.
datagenerator | Data Generator for PostgreSQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for PostgreSQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for PostgreSQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for PostgreSQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for PostgreSQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

InterBase / Firebird

 | SQL Management Studio for InterBase/Firebird EMS SQL Management Studio for InterBase and Firebird is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for InterBase/Firebird Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for InterBase/Firebird Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for InterBase/Firebird Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for InterBase/Firebird Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, PostgreSQL, etc.) to InterBase/Firebird.
datagenerator | Data Generator for InterBase/Firebird Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for InterBase/Firebird Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for InterBase/Firebird Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for InterBase/Firebird Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for InterBase/Firebird Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Oracle

 | SQL Management Studio for Oracle EMS SQL Management Studio for Oracle is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for Oracle Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for Oracle Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for Oracle Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for Oracle Migrate from most popular databases (MySQL, PostgreSQL, MySQL, DB2, InterBase/Firebird, etc.) to Oracle
datagenerator | Data Generator for Oracle Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for Oracle Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for Oracle Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for Oracle Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for Oracle Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

IBM DB2

 | SQL Manager for DB2 Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for DB2 Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for DB2 Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for DB2 Migrate from most popular databases (MySQL, PostgreSQL, Oracle, MySQL, InterBase/Firebird, etc.) to DB2
datagenerator | Data Generator for DB2 Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
extract | DB Extract for DB2 Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for DB2 Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
 | Scroll to top

Tools & components

advancedexport | Advanced Data Export for RAD Studio VCL Advanced Data Export for RAD Studio VCL allows you to save your data in the most popular office programs formats.
advancedexport | Advanced Data Export .NET Advanced Data Export .NET is a component for Microsoft Visual Studio .NET that will allow you to save your data in the most popular data formats for the future viewing, modification, printing or web publication. You can export data into MS Access, MS Excel, MS Word (RTF), PDF, TXT, DBF, CSV and more! There will be no need to waste your time on tiresome data conversion - Advanced Data Export will do the task quickly and will give the result in the desired format.
advancedimport | Advanced Data Import for RAD Studio VCL Advanced Data Import for RAD Studio VCL will allow you to import your data to the database from files in the most popular data formats.
pdfgenerator | Advanced PDF Generator for RAD Studio Advanced PDF Generator for RAD Studio gives you an opportunity to create PDF documents with your applications written on Delphi or C++ Builder.
querybuilder | Advanced Query Builder for RAD Studio VCL Advanced Query Builder for RAD Studio VCL is a powerful component for Delphi and C++ Builder intended for visual building SQL statements for the SELECT, INSERT, UPDATE and DELETE clauses.
excelreport | Advanced Excel Report for RAD Studio Advanced Excel Report for RAD Studio is a powerful band-oriented generator of template-based reports in MS Excel.
advancedlocalizer | Advanced Localizer for RAD Studio VCL Advanced Localizer for RAD Studio VCL is an indispensable component for Delphi for adding multilingual support to your applications.
 | Scroll to top


Getting Started

SQL Manager for Oracle provides you with an ability to contribute to efficient Oracle administration and development using a variety of available tools easily and quickly.

The succeeding chapters of this document are intended to inform you about the tools implemented in SQL Manager for Oracle. Please see the instructions below to learn how to perform various operations in the easiest way.

  • Selecting style and language
  • How the application looks when you start it for the first time
  • Using Desktop Panel
  • Database navigation
  • Working with database objects
  • Using context menus
  • Working with child windows

See the How to... chapter to view brief instructions on how to perform some operations on databases, database objects, etc.

Enjoy your work with EMS SQL Manager for Oracle!

See also:

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Options

How To...

.


Selecting style and language

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Selecting environment style and program language

Before you start SQL Manager for the first time, you have to choose the environment style and the interface language. You can change these settings any time using the Environment Options dialog to configure environment style and the language.

Appearance theme

Select the main color theme for the application: Light, Blue or Dark.

Bar style for editors

Here you can define the location of action buttons: RadioButton within the Navigation bar (on the left) and/or RadioButton on the Toolbar.

Program language

Select the interface language from the list of available languages.

Getting started - Selecting style and language

Sample

See the example of selected options for interface.

See also:

First time started

Using Desktop Panel

Database navigation

Working with database objects

Using context menus

Working with windows


First time started

This is how SQL Manager for Oracle looks when you start it for the first time. Use the Desktop panel to fulfill any of common tasks: Manage existing database(s), Edit local naming parameters using TNS Editor, and several tasks that do not require database registration, i.e. Execute SQL Script, accessing the reference system or using available Internet resources.

The main menu allows you to perform various Database operations, open To-Do List and activate/deactivate Database Explorer, SQL Assistant and various toolbars within the View menu, manage your databases using items of the Tools and Services menus, customize the application using the Options menu, manage SQL Manager Windows using Window List and other tools, access Registration information and product documentation, update the product to the latest version using the corresponding items available within the Help menu.

See the How to... chapter to view brief instructions on how to perform some operations on databases, database objects, etc.

To start working with your Oracle server, you should first register one or several databases using Register Database Wizard.

By default the corresponding btnRegisterDB Register Database button is available on the toolbar and within the Database menu.

When the database connection settings are specified, you can set connection to your database and proceed to Database navigation, Database Objects management, working with SQL queries and other tools of SQL Manager.

Getting started - First time started

See also:

Selecting style and language

Using Desktop Panel

Database navigation

Working with database objects

Using context menus

Working with windows


Using Desktop Panel

Desktop Panel is the area that is visible when no child windows are open in SQL Manager for Oracle. The working area of Desktop Panel is divided into four sections: Getting Started, Database Tools, Help and Support, Internet Resources.

Getting started - Using Desktop Panel

Getting Started

register existing database(s) to operate them afterwards in SQL Manager

edit local naming parameters using TNS Editor

create a new table within the current database using the New Table window (this item is available if there is at least one active database connection)

create a new database object within the current database (this item is available if there is at least one active database connection)

Database Tools

execute a script using Execute Script Editor

execute a SQL query (this item is available if there is at least one active database connection)

grant permissions on database objects to Oracle users using Grant Manager(this item is available if there is at least one active database connection)

Help and Support

show this help file

Internet Resources

visit SQL Manager Home Page

browse SQL Manager on-line documentation

go to Technical Support Center

look through the Frequently Asked Questions page

See also:

Selecting style and language

First time started

Database navigation

Working with database objects

Using context menus

Working with windows


Database navigation

After you have registered the required database(s), the corresponding alias(es) appear in the DB Explorer tree on the left. If the Show database groups option is checked on the Environment Options | DB Explorer page, the group nodes are also displayed in the tree (alternatively, you can use the Show Database Groups item of the Database context menu, or the drop-down menu of the View Mode btnViewMode toolbar button for the same purpose). If necessary, you can also specify that empty schemas should be hidden in the tree: use the corresponding option available on the DB Explorer page of the Environment Options dialog.

Getting started - Database navigation

DB Explorer displays all registered hosts and databases. Connected/disconnected hosts and databases can be easily distinguished in the tree: aliases of disconnected hosts and databases are grayed out.

Getting started - Database navigation - Disconnected DB

To connect to a database, simply double-click its alias (or select the database alias in DB Explorer and press Enter). If the connection is successful, the database node expands into a tree of objects.

Now you can navigate within the database objects. Use SQL Assistant to get extended information about the currently selected object.

For your convenience objects having different type (for tables: Index-organized, Clustered, Object, Partitioned, Temporary), status (e.g. enabled/disabled) are displayed with different icons in Database Explorer.

Database Explorer also allows you to distinguish invalid database objects by their icons which are marked with a red cross. In the screenshot below the view 'VIEW1' is marked as invalid because of some errors in its SQL definition, or the referenced table has been dropped from the database.

Getting started - Database navigation - Object status

See also:

Selecting style and language

First time started

Using Desktop Panel

Working with database objects

Using context menus

Working with windows


Working with database objects

The nodes of the DB Explorer tree allow you to access objects of the selected database. If Oracle server you are connected to supports certain types of objects, their nodes will appear in the tree.

Double-click an object group to expand/collapse the corresponding tree node.

Double-click an object to open it in the corresponding editor.

Right-click an object to display its context menu which allows you to perform various operations over the selected object or database.

Getting started - Working with database objects

If you want to use the DB Explorer tree for working with table subobjects (fields, indexes, Foreign keys, etc.), check the Show table subobjects option which is available within the General options group of the Environment Options | DB Explorer page (you can also use the Show Table Subobjects menu item in the drop-down menu of the View Mode btnViewMode toolbar button for the same purpose.)

Getting started - Working with database objects - View Mode

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Using context menus

Working with windows


Using context menus

The context menus are aimed at facilitating your work with SQL Manager for Oracle: you can perform a variety of operations using context menu items.

Select an object in DB Explorer and right-click its alias to open the context menu.

  • DB Group context menu
  • Database context menu
  • Object context menu

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Working with database objects

Working with windows


DB Group context menu

The context menu of a DB Group in the DB Explorer tree allows you to:

  • register a new database using Register Database Wizard;
  • unregister the selected database group;
  • rename the database group;
  • create database;
  • run SQL *Plus:
  • edit local naming parameters using TNS Editor ;
  • configure representation of DB Groups and databases in Database Explorer;
  • create a new tab for the selected database group to access it through this tab quickly and/or manage the existing tab;
  • search for an object within the tree.

Using context menus - DB Group context menu

See also:

Database context menu

Object context menu


Database context menu

The context menu of a registered database in the DB Explorer tree allows you to:

  • connect to the selected database (if connection to the database is not active yet);
  • disconnect from the selected database (if connection to the database has been already activated);
  • access database tools available in the Tasks submenu;
  • drop the selected database;
  • register a new database using Register Database Wizard;
  • unregister the selected database;
  • unregister the database group to which the database belongs;
  • view/edit the selected database registration information within the Database Registration Info dialog;
  • edit local naming parameters using TNS Editor;
  • configure representation of DB Groups and databases in Database Explorer;
  • refresh the selected database;
  • create a new tab for the selected database to access it through this tab quickly and/or manage the existing tab;
  • search for an object within the tree.

Using context menus - Database context menu

See also:

DB Group context menu

Object context menu


Object context menu

The context menu of an object (e.g. table) in the DB Explorer tree allows you to:

  • create a new database object of the same type;
  • edit the selected object in its editor;
  • rename the selected object;
  • drop the selected object from the database;
  • duplicate the selected object (create a new object with the same DDL structure and properties as the selected object has);
  • access common Tasks applied to this object;
  • perform data manipulation operations (for tables and views);
  • define grants for the selected object;
  • generate the object script and open it in Query data;
  • generate the object script and copy its text to Windows clipboard;
  • refresh all objects of the selected object type;
  • view/edit the database registration information within the Database Registration Info dialog;
  • create a new tab for the selected object to access it through this tab quickly and/or manage the existing tab;
  • search for an object within the tree.

Using context menus - Object context menu

See also:

DB Group context menu

Database context menu


Working with windows

The Windows Toolbar of SQL Manager allows you to switch between child windows easily, like in Windows Task Bar.

To activate the window you need, simply click one of the window buttons. To perform some additional actions with the window, right-click its tab and select the corresponding menu item from the popup menu.

Getting started - Switching windows

If you have multiple windows opened, you can also switch between them using the Ctrl+Tab shortcut.

The Number of open editors is restricted option available in the Environment Options options dialog allows you to set the maximum number of editors that may be opened simultaneously. When the number of editors exceeds the specified value, the previously opened editors will be closed automatically.

The Windows menu facilitates your work with SQL Manager windows.

The Windows menu allows you to:

  • view the Windows List within the corresponding tab of DB Explorer;
  • set all current windows cascade:

Getting started - Windows - Cascade

  • minimize all windows;
  • restore all windows;
  • tile all current windows horizontally:

Getting started - Windows - Tile Horizontal

  • tile all current windows vertically:

Getting started - Windows - Tile Vertical

  • set defaults to all windows;
  • reset all toolbars and menus;
  • close all windows;
  • close all database windows (closes all windows owned by the database selected in the windows list);
  • close all editors of the specified object type (can be selected from the submenu);
  • switch to the previous window;
  • switch to the next window;
  • activate one of currently opened windows.

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Working with database objects

Using context menus


Database Explorer

Database Explorer (or DB Explorer) is the basic window of SQL Manager for Oracle for navigation within databases and working with database objects. The tree-like structure of DB Explorer allows you to manage the databases, database objects and perform other everyday operations quickly and easily.

The following list contains the most frequently used features provided by Database Explorer.

  • Managing database registration info
  • Connecting to databases
  • Performing basic operations upon database objects
  • Selecting multiple objects
  • Navigating database objects using multiple tabs
  • Easy access to recently opened objects
  • Managing Favorite objects
  • Searching within the tree
  • Viewing extended information about database objects
  • Configuring Database Explorer
  • Managing Favorite queries

All objects are structured by their types and are available within the corresponding nodes of the tree. The number of objects of each type is displayed in brackets after the node name denoting the object type. To expand/collapse a node, you can double-click it or use the +/- icons.

NOTE: To view/hide the Database Explorer window, use the View | DB Explorer main menu item or press the F11 key.

DB Explorer - View

Use the Ctrl+Shift+C shortcut to collapse current DB Explorer tree branch and switch to the parent node.

Note that you can change database and database groups order by dragging them within the DB Explorer tree.

See also:

Getting Started

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Options

How To...


Managing database registration info

After you have created and/or registered your database in SQL Manager for Oracle, you can perform a number of operations with the database using the context menu.

If you need to view/edit the registration information of a database, right-click the database alias in DB Explorer and select the Database Registration Info... context menu item to open the Database Registration Info dialog.

DB Explorer - Managing database registration info

See also:

Register Database

Database Registration Info

Database Registration Manager


Connecting to databases

When the database registration is complete, you can establish connection to your database.

The simplest way to connect to a database is to double-click its alias in the Database Explorer tree. The same operation can be performed by selecting the Connect to Database item of the database context menu, or by using the Database | Connect to Database main menu item.

DB Explorer - Connecting to databases

Alternatively, you can use the Shift+Ctrl+C shortcut or the btnConnectToDB Connect to Database toolbar button.

DB Explorer - Connecting to databases - Toolbar

See also:

Register Database

Database Registration Info

Database Registration Manager


Operations with database objects

Database Explorer allows you to perform various operations with database objects.

To open an object in its editor, you can double-click the object in the DB Explorer tree.

You can also right-click an object within the DB Explorer tree and use its context menu to perform a number of operations:

  • create a new object (the New <object>... item);
  • edit currently selected object (the Edit <object_name>... item);
  • rename currently selected object (the Rename <object_name>... item);
  • drop the selected object from the database (the Drop <object_name>... item);
  • duplicate the selected object (the Duplicate <object_name>... item);
  • define grants for the selected object (the Grants for <object_name>... item).

Note that the context menu contains object-specific items only when the object is currently selected in DB Explorer.

DB Explorer - Operations with database objects

Using drag-and-drop operations you can add objects to Query data, Design Query or Execute Script Editor. For your convenience the Insert to editor dialog is implemented. The dialog allows you to specify the statement to be inserted into the editor: Name, SELECT, INSERT, UPDATE, DELETE, CREATE, ALTER, DROP, Fields list, Name and Type. If necessary, set the Alias and Prefix for variable.

If more convenient, you can edit the generated statement manually (see Working with Query Data area).

DB Explorer - Insert to Editor

See also:

Database Objects Management

Query Data

Selecting multiple objects


Selecting multiple objects

You can select more than one object in Database Explorer by pressing the Ctrl or the Shift key and selecting multiple objects one by one.

The context menu of several selected objects allows you to:

  • create a new database object of the same type;
  • edit the selected objects;
  • drop the selected objects;
  • perform other operations with the first of the selected objects (see Operations with database objects).

DB Explorer - Selecting multiple objects

Hint: You can move several objects to your favorite objects: just drag and drop the selected objects to the previously created subfolder within the Favorite Objects node of DB Explorer.

See also:

Operations with database objects

Database Objects Management

Managing Favorite objects


Using tabs for database navigation

To make your work with Database Explorer even more convenient, the capability of working with several tabs is implemented.

You can use tabs when you wish to work with a particular node of the DB Explorer tree only: with one specific schema, or with tables of some schema, or with specific database favorite objects. Creating such tabs will minimize scrolling within large trees, you only need to switch between them with a single click on the corresponding tab.

Creating tabs

  • right-click the node (e.g. the Tables node) for which you wish to create a tab and select the New Tab from Here... context menu item.

Note: A tab can be created only on the basis of a tree node. For example, if the Show Table Subobjects option is disabled in the View Mode menu, the New Tab from Here... item will not be available for tables, since none of them will be a tree node anymore.

DB Explorer - Using tabs - New tab

The specified tabs can be displayed in either of the two views:

  • as icons on the lower pane of DB Explorer:

DB Explorer - Using tabs - View as icons

  • as tabs with captions:

DB Explorer - Using tabs - View as tabs

Hint: You can reorder items in the tabs view by dragging their captions up and down.

To add/remove items to/from the tabs view, you can drag the horizontal splitter up/down:

DB Explorer - Splitter for tabs

or click the Configure buttons icon available in the bottom right corner of the DB Explorer window, and select Show More Buttons / Show Fewer Buttons / Add or Remove Buttons items from the popup menu.

DB Explorer - Using tabs - Add or remove buttons

Renaming tabs

  • switch to the tab by clicking its caption or icon (there can be only one active tab, and it is highlighted with a different color);
  • right-click within the DB Explorer area and select the Rename Current Tab... context menu item.

Removing tabs

  • switch to the tab by clicking its caption or icon (there can be only one active tab, and it is highlighted with a different color);
  • right-click within the DB Explorer area and select the Delete Current Tab context menu item.

See also:

Managing Favorite objects

Windows List

Database Objects Management


Recently opened objects

Use the Recent Objects btnRecentObjects button available on the DB Explorer toolbar to access the list of recently opened database objects (during the current session).

This list is common for all registered databases. Next to the object name the database name and the database group are displayed. Select an object from this list to open it using its editor.

DB Explorer - Recently opened objects

To change the number of objects that are considered 'recent' set the Recent objects count option value at Environment Options.

See also:

Database Objects Management

Environment Options


Managing Favorite objects

Use the Favorite objects node for each database to work with the selected objects of this database only. You can place any object from the database tree here.

You can also create a separate tab for your Favorite objects folder. See Using tabs for database navigation section for details.

DB Explorer - Managing projects - New Subfolder

Creating Favorite objects folders

  • right-click the Favorite objects node and select the New Sub Folder... context menu item;
  • enter the folder name within the New Folder dialog.

DB Explorer - Managing projects - Adding objects

Adding objects

To add a new object to the Favorite objects folder:

  • expand the Favorite objects node in DB Explorer;
  • drag an object (or multiple objects) from the database tree to the Favorite objects folder

or

  • right-click the Favorite objects folder and select the Add Object... context menu item, or use the Ins key;
  • use the Select Object dialog to specify objects to be added to the Favorite objects folder.

or

  • right-click the desired object in DB Explorer and select the Add to Favorite Objects context menu item;

Removing objects from the Favorite objects folder

  • right-click the object and select the Remove <object_name> from Favorite objects context menu item, or use the Shift+Ctrl+Del shortcut;
  • confirm removing in the dialog window.

Note: This operation does not drop the object from the database, but only removes its alias from the Favorite objects tree.

See also:

Using tabs for database navigation

Select Object dialog

Database Objects Management


Searching within the tree

SQL Manager for Oracle provides an ability to search for items within the DB Explorer tree. Searching for items may be useful if you have a lot of database objects, and it may be sometimes hard to find the one you need.

There are two search facilities implemented in SQL Manager for your convenience. You can search for objects within the DB Explorer tree in either of the following ways:

  • using the Find Object dialog

To call the Find Object dialog, right-click the Database alias, any database object group nodes or objects in the DB Explorer tree and select the Find Object... context menu item, or use the Ctrl+F shortcut.

DB Explorer - Find Object

Available search options are similar to those provided by the Find Text dialog. For detailed description of the search options refer to the Find Text dialog page.

Note: You can specify whether the search will be performed within the entire tree or within the currently selected node only: toggle search mode using the [image] Search by categories button on the Search Panel, or use the corresponding option available in the Tools | DB Explorer section of the Environment Options dialog.

  • using the Search Panel

Type in the first letters in the edit-box, and the corresponding object will be highlighted in the tree, as displayed in the picture below. The [image] [image] buttons allow you to define the search direction. The [image] button toggles searching by category.

DB Explorer - Search Panel

Click More buttons... btnMoreButtons on the right side of the toolbar and use the Add or Remove Buttons popup menu items to disable the panel by deselecting the checkbox at the corresponding popup menu item.

DB Explorer - Search Panel - Customize

Hint: The Search Panel is dockable, i.e. you can drag it to any location within the DB Explorer form.

See also:

Find Text dialog


SQL Assistant

SQL Assistant which is located at the bottom of the Database Explorer window helps you to work with your database objects. Depending on the current selection in DB Explorer, the SQL Assistant area displays additional information pertaining to the selected object.

DB Explorer - SQL Assistant

Database and schemas
If you select a database or schema in DB Explorer, SQL Assistant displays the list of the database object groups and the number of objects in each group.

Objects group

Selecting an object group in DB Explorer displays the list of the objects in SQL Assistant. Double-clicking the object name in SQL Assistant makes the object available for editing in the appropriate editor. The context menu of the object or group of objects allows you to edit or drop the selected objects.

Tables and views
SQL Assistant displays the list of the table/view subobjects (e.g. fields and their types) by default. You can change the content of SQL Assistant clicking the View Mode btnViewMode toolbar button or using the context menu of SQL Assistant.

DB Explorer - SQL Assistant - Object details

Procedures and functions

SQL Assistant displays parameters list (arguments and types) by default. You can switch to displaying object definition at the popup menu.

Other objects

Selecting other objects in DB Explorer displays the definition in SQL Assistant by default. Use the Other Objects' Details | Show... context menu item within the SQL Assistant area to display object Description.

You can also use SQL Assistant to work with your queries quickly. You can drag-and-drop object aliases to the Execute script working area, in the same way as this operation is performed in Database Explorer.

See also:

Database Objects Management


Configuring Database Explorer

DB Explorer toolbar

The toolbar of Database Explorer contains most frequently used tools for working with databases and database objects, and a tool for configuring DB Explorer. The following actions are available in the toolbar by default:

  • create a new object;
  • refresh the current tree branch;
  • connect to a database;
  • disconnect from a database;
  • view the selected object properties;
  • configure Database Explorer using the View Mode menu;
  • view the list of recently opened objects;
  • jump to any of registered databases quickly.

Click More buttons... btnMoreButtons on the right side of the toolbar and use the Add or Remove Buttons popup menu items to define the set of actions available in the toolbar. To customize the toolbar, select the Add or Remove Buttons | Customize... item from the popup menu.

DB Explorer - Configuring DB Explorer - Toolbar

Search Panel

Click More buttons... btnMoreButtons on the right side of the Search Panel and use the Add or Remove Buttons popup menu items to define the set of the panel elements. To customize the panel, select the Add or Remove Buttons | Customize... item from the popup menu.

DB Explorer - Search Panel - Customize

View Mode menu

Use the View Mode btnViewMode toolbar button to configure Database Explorer according to your needs.

The drop-down menu called upon clicking this button allows you to:

  • show/hide table subobjects as child nodes of tables;
  • show/hide view subobjects as child nodes of views;
  • show/hide package subobjects as child nodes of packages;
  • show/hide database group nodes for registered databases;
  • sort the list of databases by their aliases in the DB Explorer tree;
  • show/hide disconnected databases;
  • show/hide empty schemas;
  • configure table/view/procedure/function/other objects' details for the SQL Assistant area.

DB Explorer - Configuring DB Explorer - View Mode

Use the DB Explorer section of the Environment Options dialog (Options | Environment Options...) to see more options to configure Database Explorer.

See also:

Customize toolbars and menus

Environment Options


Managing Favorite queries

Use the Favorite Queries node of DB Explorer to access the list of your Favorite queries quickly. Queries stored in the database and those stored in Windows registry can be easily distinguished by their icons.

Using the context menu you can create a new Favorite query or edit an existing one using Favorites editor, open any of the existing queries in Query data editor or remove a query if you don't need it any longer.

DB Explorer - Managing Favorite queries

You can also create a separate tab for your Favorite queries. See Using tabs for database navigation section for details.

See also:

Using tabs for database navigation

Favorites editor


Database Management

SQL Manager for Oracle provides a number of tools you may need to manage your Oracle databases.

Find the list of common database management operations for working in SQL Manager below.

Registering Databases

  • select the Database | Register Database... main menu item or use the corresponding btnRegisterDB Register Database toolbar button

or

  • right-click an existing database or database group alias and select the Register Database... context menu item in the DB Explorer tree;
  • set all the necessary options using Register Database wizard which guides you through the entire process of Database registration.

Unregistering Databases and Database Groups

  • select the database (or the database group) to unregister in the DB Explorer tree;
  • select the Database | Unregister Database (or Database | Unregister Database Group) main menu item or use the corresponding btnUnregisterDB Unregister Database toolbar button

or

  • right-click the database (or the database group) alias and select the Unregister Database (or Unregister Database Group) context menu item in the DB Explorer tree;
  • confirm unregistering in the corresponding dialog window.

Creating Databases

  • select the Database | Create Database... main menu item or use the corresponding Create Database btnCreateDB toolbar button

or

  • right-click an existing database or database group alias and select the Create Database... context menu item in the DB Explorer tree;
  • set all the necessary options using Create Database wizard which guides you through the entire process of Database creation.

Connecting to Databases

  • select the database to connect to in the DB Explorer tree;
  • select the Database | Connect to Database main menu item or use the corresponding btnConnectToDB Connect to Database toolbar button

or

  • right-click the database alias and select the Connect to Database context menu item in the DB Explorer tree.

Disconnecting from Databases

  • select the database to disconnect from in the DB Explorer tree;
  • select the Database | Disconnect from Database main menu item or use the corresponding btnDisconnectFromDB Disconnect from Database toolbar button

or

  • right-click the database alias and select the Disconnect from Database context menu item in the DB Explorer tree.

Viewing and Editing Database Registration Info

  • select the database or any of its objects in the DB Explorer tree;
  • select the Database | Database Registration Info... main menu item

or

  • right-click the database alias or any of its objects and select the btnDBRegInfo Database Registration Info... context menu item in the DB Explorer tree.

Viewing and editing TNS file

  • right-click the database or database group alias and select the TNS Editor context menu item;
  • use the TNS Editor to view/edit local naming parameters.

See also:

Getting Started

Database Explorer

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Options

How To...


Create Database Wizard

Create Database wizard allows you to create a new Oracle database.

To start the wizard, select the Database | Create Database... main menu item, or use the Create Database btnCreateDB button on the main toolbar.

  • Specifying database name
  • Specifying memory parameters
  • Defining additional settings
  • Defining database directories
  • Data storage and redo log settings
  • Creating database scripts

See also:

Register Database wizard

Database Registration Info

Database Registration Manager


Specifying database name

At this step you need to specify the database name, SID, Oracle compatible version and OS specific options.

Create Database Wizard - Setting database name

Database name

Specify the name of the database to be created.

Note: The database name is case insensitive and is stored in uppercase ASCII characters.

SID

Specify a unique Oracle system identifier for your instance (ORACLE_SID).

Note: ORACLE_SID is used to distinguish this Oracle instance from other instances that you may create later and run concurrently on the same host computer.

Compatible version

Use the drop-down list to select the version of Oracle the new database will be compatible with. The database script will be generated by the application in accordance with the selected server version. Possible values are: 8.1.7, 9.0.1, 9.2.0, 10.1.0, 10.2.0, 11.1.0, 12.1, 12.2, 18.0).

OS specific options

Specify the operating system for the database being created: RadioButton Unix or RadioButton Windows. The result script will be generated in accordance with the selected operating system specifications.

CheckBox Register after creating

Check this option to register the newly created database in SQL Manager (the Database Registration Info dialog will be opened after database creation).

Click the Next button to proceed to the Specifying memory parameters step of the wizard.


Specifying memory parameters

This step allows you to specify the database template and to define memory parameters.

Create Database Wizard - Setting memory parameters

Database Template

Use this group to select a template with storage parameters that best meet your needs:

RadioButton OLTP

RadioButton General purpose

RadioButton Data warehouse

RadioButton Standby database (for version 10.1.0 and higher)

If you need to customize these parameters, press the View/Edit button to open the corresponding Parameters dialog.

Create Database Wizard - Setting memory parameters - Parameters

Memory parameters in megabytes

Use the spinner controls and drop-down lists to specify memory parameters (in megabytes):

Shared pool

Processes

Java pool

Large pool

PGA

Primary database parameters

This group is available if the RadioButton Standby database template is selected. Use the editing controls to specify primary database parameters:

SID (system identifier, for description see Specifying database name)

Sys password (password for the SYS user)

Create Database Wizard - Setting memory parameters - Standby database

CheckBox Primary in archivelog

Use this option to define whether the primary database is in archivelog mode (i.e. the contents of a redo log file group is archived

before the group can be reused). If it is, you need to specify its Log archive format in the corresponding field.

Click the Next button to proceed to the Defining additional settings step of the wizard.


Defining additional settings

Use this step to define additional database settings.

Note: This step is skipped if the RadioButton Standby database template is specified at the Specifying memory parameters step of the wizard.

Create Database Wizard - Defining additional settings

Archive

RadioButton Noarchivelog mode

If this mode is used, the contents of a redo log file group is not archived before the group can be reused. This mode does not allow the possibility of media recovery, i.e. the database can be completely recovered after an instance failure, but not after a disk failure. Also, the database can be backed up only while it is completely closed.

RadioButton Archivelog mode

If this mode is used, the contents of a redo log file group is archived before the group can be reused. This mode prepares for the possibility of media recovery, i.e. the database can be completely recovered after both an instance failure and a disk failure. Also, the database can be backed up while it is open and available for use.

If the Archivelog mode is specified, you also need to define archivelog filename format size, archivelog destination using the corresponding controls, or use the default values.

Note: The specified paths and file names must comply with specifications of the operating system selected at the first step of the wizard.

Character set

Use the drop-down list to specify the character set the database will use to store data. The supported character sets depend on your operating system.

National character set

Use the drop-down list to specify the national character set to be used to store data in columns specifically defined as NCHAR, NCLOB, or NVARCHAR2.

You also need to define log buffer size, CPU count using the corresponding controls, or use the default values.

Click the Next button to proceed to the Defining special directories and filenames step of the wizard.


Defining database directories

At this step you should specify common and special directories.

Create Database Wizard - Defining special directories and filenames

Common directories

Oracle base

Use this field to specify the directory where Oracle base files will be stored.

Oracle home

Use this field to specify the Oracle home directory.

The Init parameters and Server parameters fields indicate the location of the initialization parameter file (init{SID}.ora) and server parameter file (spfile{SID}.ora) respectively and are read-only.

Note: The specified paths and file names must comply with specifications of the operating system selected at the first step of the wizard.

Special directories

This group is available if the RadioButton OLTP, RadioButton General purpose, or RadioButton Data warehouse database template is selected at the Specifying memory parameters step.

Use this group to define paths to the User trace, Background trace and Core dumps logs, or press the Set defaults button to use the pre-defined values.

Note: The specified paths and file names must comply with specifications of the operating system selected at the first step of the wizard.

Click the Next button to proceed to the Data storage and redo log settings step of the wizard.


Data storage and redo log settings

This step allows you to manage tablespaces and redo logs.

Note: This step is skipped if the RadioButton Standby database template is specified at the Specifying memory parameters step of the wizard.

Create Database Wizard - Data storage settings

Use the btnAddItem Add item button to add the corresponded item.

Use the btnRemoveItem Remove item button to delete the selected item.

Note: There are several system tablespaces that cannot be removed from the list: SYSTEM, UNDO, SYSAUX, TEMP.

The Add Tablespace allows you to define properties for a newly added tablespace.

Create Database Wizard - Data storage settings - Add tablespace

Tablespace name

Specify the name of the tablespace to be created.

File Name

Specify the tempfile to make up the temporary tablespace.

Size (Mb)

Specify the tablespace size (in megabytes).

Extent management

RadioButton Dictionary

Use this option if you want the tablespace to be managed using dictionary tables. In this case you should set the Default storage parameters.

RadioButton Locally

Select this option if you want the tablespace to be locally managed. Locally managed tablespaces have some part of the tablespace set aside for a bitmap.

Default storage

This group is available only for a locally managed tablespace. Using these controls you can specify the default storage parameters for all objects created in the tablespace: Initial extent, Next extent, Percent increase, Minimum extents, Maximum extents, Minimum extent size.

For more information see Storage attributes.

The Add Redo Log allows you to define properties for a newly added redo log file.

Create Database Wizard - Data storage settings - Add redo log

File Name

Specify the path and name of the redo log file to be added.

File size (Mb)

Specify the redo log file size (in megabytes).

Note: There should be no less than two redo logs in a database.

Click the Next button to proceed to the Creating database scripts step of the wizard.


Creating database scripts

At the final step of the wizard you need to specify script generation options and some additional settings.

If the RadioButton OLTP, RadioButton General purpose, or RadioButton Data warehouse database template is specified at the Specifying memory parameters step of the wizard, you should specify script directory, generation options and other options.

Create Database Wizard - Creating DB scripts

Script directory

Use this field to specify the CREATE DATABASE script location.

Generation options

RadioButton Run script now

Select this option execute the generated script to create the database immediately.

RadioButton Generate scripts

Select this option to generate database creation scripts for future use.

In case you intend to CheckBox Create sample scheme, CheckBox Create JServer scheme, CheckBox Enable database replication, CheckBox Install SQL*Plus Help, enable the corresponding options.

If the RadioButton Standby database template is specified at the Specifying memory parameters step of the wizard, you should specify script directory and options specific for a standby database.

Create Database Wizard - Creating DB scripts - Standby database

Script directory

Use this field to specify the CREATE DATABASE script location.

You need to specify Standby archive destination, Fal server and Fal client to finish database customization.

When all settings are done, click the Run button to complete the operation.


Register Database Wizard

Register Database Wizard allows you to register a single database.

To start the wizard, select the Database | Register Database... main menu item, or use the Register Database btnRegisterDB button on the main toolbar. You can also use the Shift+Alt+R shortcut for the same purpose.

  • Setting connection parameters
  • Specifying tunneling parameters
  • Selecting databases
  • Setting specific options

See also:

Create Database wizard

Database Registration Info

Database Registration Manager


Setting connection parameters

Use this step of the wizard to set the necessary connection parameters for the new database and optional database group alias.

Register Database wizard - Setting connection parameters

Connect using

Specify your Oracle Home storage for this connection. If there are several database homes set on your local system, you can use the arrow-down btnDropDown button to select one from the drop-down list.

Choose Connection string if you need to connect to a database that is absent in the TNS file.

Note: If no database are registered in Oracle Client (DB list is empty in this case), then you need to add registration info manually.

DB group name

Specify a new database group for the database being registered, or select one from the drop-down list called by pressing the arrow-down btnDropDown button.

Edit TNS File...

If necessary, use this button to call the Local Naming Parameters editor window.

Client Checker...

If necessary, use this button to call the Oracle Client Checker dialog.

CheckBox Register a single database

Check this option if you wish to register only one database during the current session of the wizard.

CheckBox Use Secure Shell (SSH) tunneling

Select this option to establish connection to an intermediate SSH server and forward all Oracle commands through the secure tunnel. The next step of the wizard allows you to define the corresponding parameters for SSH tunneling.

If this option is checked, you should set tunneling parameters at the Specifying tunneling parameters step of the wizard.


Specifying tunneling parameters

This step appears if the Use Secure Shell (SSH) tunneling option is enabled at the Setting connection parameters step.

Specify SSH Host name, SSH port, SSH user name, SSH password, the path to the SSH key file (if necessary) in the corresponding boxes.

See SSH connection properties for details.

Register Database wizard - Setting connection parameters - SSH

Click the Next button to proceed to the Setting specific options step or to the Selecting databases step of the wizard, depending on whether the CheckBox Register a single database option has been selected or not.


Selecting databases

This step of the wizard allows you to select the database(s) that are registered in the TNS file.

To select a database, you need to move it from the Available databases list to the Selected databases list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the databases from one list to another.

Register Database Wizard - Selecting databases

Click the Next button to proceed to the Setting specific options step of the wizard.


Setting specific options

This step of the wizard allows you to set the database name, database alias, and registration options (using the Connect, General, Logs tabs).

Register Database wizard - Setting specific options - Connect

Database name

Type in or use the drop-down list to select the database name to be registered (if more than one Oracle database are registered in the TNS file).

Note: If no database are registered in Oracle Client (DB list is empty in this case), then you need to add registration info manually.

If Connect using -> Connection string was selected at the Setting connection parameters step, the Connection string field will substitute the Database name field.

Press the arrow-down btnDropDown button to open the popup dialog allowing you to specify the connection parameters.

Register Database wizard - Setting specific options - Connection string

Protocol - specify the protocol that will be used for connection to the database. Possible values are: TCP (by default), TCPS, SDP, IPC, NMP, SPX.

Host - specify the domain name or IP address (for a remote Oracle server), or type in localhost (for a local Oracle server).

Port - define the port used for connection to the database (1521 by default).

Server - you should select either DEDICATED or SHARED server type from this drop-down list. Server type affects memory allocation. Select DEDICATED to use private memory allocation.

Service name - specify a valid instance name in this field.

Database alias

Enter the alias to be used to display the database in DB Explorer and SQL Manager tools.

The Connect tab allows you to specify authentication parameters:

Authentication

Specify the type of authentication to be used for the connection: RadioButton Windows authentication or RadioButton Server authentication.

If RadioButton Windows authentication is selected as the authentication type, the following conditions must be fulfilled:

  • for privileged users (SYSDBA, SYSOPER):

1) if the user can be in ORA_DBA server group, then he can connect to any database;

2) if the user can be in ORA_XXX_DBA server group, then he can connect to the XXX database;

3) if SQLNET.AUTHENTICATION_SERVICES=(NTS), then only privileged users gain the connection privilege;

  • for unprivileged users:

1) correct os_authent_prefix parameter value (OPS$ by default) is needed to make search of a user in database possible. This parameter value can be defined in init.ora file or using the ALTER DATABASE command;

2) if the server is installed in a domain, parameter HKLM/SOFTWARE/ORACLE/HOME<%>/OSAUTH_PREFIX_DOMAIN = TRUE should be added to the registry (it is absent by default);

3) parameter remote_os_authent = TRUE should be defined in the init.ora or sqlnet.ora file;

4) parameter SQLNET.AUTHENTICATION_SERVICES value should be correct but not equal to (NTS). This parameter should also be defined in the init.ora or sqlnet.ora file.

Note that Windows authentication is only supported in Oracle version 9.0 and higher.

If RadioButton Server authentication is selected as the authentication type, you should also provide authorization settings: User name and Password. Server Authentication stores logins and passwords in the server and does not depend upon Windows. The default superuser name is 'SYS' (for Oracle 9.0 and higher) and the default password is 'change_on_install'.

Connect as

Select the type of connection to be established: Normal (by default), SYSDBA, SYSOPER.

Register Database wizard - Setting specific options - General

The Database tab allows you to set common database registration options:

Database alias

Edit the database alias to be displayed in DB Explorer.

Font charset

Specify the character set to be used to display data in the grid. Use the drop-down list to select the required charset value, or leave this option unchanged to apply the default charset.

CheckBox Statement cached

This option indicates whether or not the session will use a client-side statement cache. Note that this option is applicable to Oracle Net 9.2 and later, it is ignored for older Oracle versions.

Cache size

Specify the maximum number of cached statements. The least recently used statements will be removed from the cache when this maximum is reached.

CheckBox Login prompt before connection

Enables SQL Manager for Oracle to prompt for user name and password each time you connect to the database.

CheckBox Autoconnect at startup

With this option set, connection to the registered database is established automatically at application startup.

CheckBox Rollback on disconnect

If this option is selected, all active transactions are rolled back upon disconnect from the server.

CheckBox Refresh objects on connection

This option allows you to enable/disable refreshing objects on connection to the database. It is highly recommended to uncheck this option if your database contains many objects or if connection to the database is slow.

Register Database wizard - Setting specific options - Logs

The Logs tab allows you to set log options for the database:

CheckBox Enable log of metadata changes

Check this option if you wish to log metadata changes of your database in a file.

Log file

This field is enabled if the Enable log of metadata changes option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the metadata logs.

CheckBox Enable log of data queries

Check this option if you wish to log your Query data queries in a file.

Log file

This field is enabled if the Enable log of Query Data queries option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the logs of SQL queries.

CheckBox Is Unicode

Enable this option to save logs in Unicode. If the option is disabled, ANSI will be used.

Click the Run button when done to start working with the newly registered database in SQL Manager for Oracle.


Database Registration Info

Use the Database Registration Info dialog to view and edit the registration properties of the database.

To open the dialog, select the database or any of its objects in the DB Explorer tree, then select the Database | Database Registration Info... main menu item, or right-click the database alias in DB Explorer and use the Database Registration Info... context menu item. You can also use the btnDBRegistrationInfo Database Registration Info... button on the main toolbar.

  • Editing connection properties
  • Setting common database options
  • Setting display options
  • Setting default directories
  • Setting log options
  • Setting SSH tunneling options
  • Setting data options
  • Find Option

See also:

Create Database wizard

Register Database wizard

Database Registration Manager


Connection

The Connection section of the Database Registration Info dialog allows you to view and/or edit the authentication parameters and the connection properties.

Database Registration Info - Editing connection properties

Authentication

Specifies the type of authentication used for the connection:

RadioButton Windows authentication

Select this type if you wish to use Windows Integrated Security for the connection.

RadioButton Server authentication

Select this type if you wish to use Oracle server authentication for the connection. Server Authentication stores logins and passwords in the server and does not depend upon Windows.

User name

If necessary, edit the user name used to access the database (server authentication).

Password

If necessary, edit the password used to access the database (server authentication).

Connect as

Select the privilege type to be used for the connection: Normal (by default), SYSDBA, SYSOPER.

Connect using

Specify your Oracle Home storage for this connection. If there are several database homes set on your local system, you can use the arrow-down button to select one from the drop-down list.

Database name

Stores the name of the database.

Database alias

Stores the database alias which is displayed in the DB Explorer tree and SQL Manager tools.

DB group name

Select the group name to be displayed in DB Explorer.

Font charset

Stores the character set used to display data in the grid.

If necessary, use the Edit TNS File... button to open TNS Editor.

You can also click the Client Checker... button to check whether the client(s) is identified by the application and view the status and details for the client(s) using the Oracle Client Checker dialog.

Once you have specified the connection properties, you can check whether it is possible to establish connection to the database: click the Test Connect button for this purpose. If connection is successful, you will get the 'Connected!' message; otherwise an error message will be returned.

The Load Connection Info from... menu allows you to select the alias of a previously registered database and use it for the newly created/configured database.


Options

The Options section of the Database Registration Info dialog allows you to set various options for the database.

Database Registration Info - Setting common database options

Customize common database options according to your needs. The detailed description is given below.

CheckBox Login prompt before connection

Enables SQL Manager for Oracle to prompt for user name and password each time you connect to the database.

CheckBox Autoconnect at startup

Check this option to specify that SQL Manager for Oracle automatically establishes connection to the registered database at application startup.

CheckBox Refresh objects on connection

This option allows you to enable/disable refreshing objects on connection to the database. It is highly recommended to uncheck this option if your database contains many objects or if connection to the database is slow.

CheckBox Enable trace

Creates a trace log file at the client side which allows you to view statistics data on sessions, connections, etc.

CheckBox Auto commit

When checked, transactions are committed automatically.

CheckBox Hide empty schemas

This option allows you to specify whether schemas containing no objects will be displayed in the DB Explorer tree.

CheckBox Convert created objects' names to upper case

Enable this option if you need to convert the names of all newly created objects to the upper case automatically.

CheckBox Show storage parameters

With this option enabled storage parameters for objects are displayed in DDL.

Decimal separator

Define the separator which will be used for floating point type values. Possible separators are: dot ("."), comma (",").

CheckBox Schema restriction

This option allows you to hide schemas and disable refreshing their objects. Select the schemas for displaying in DB Explorer. Note that the current and PUBLIC schemas are allowed by default and cannot be restricted.


Display options

The Display Options section of the Database Registration Info dialog allows you to specify which objects will be displayed in the Database Explorer tree.

CheckBox Use custom color for DB editors

With this option checked the text color for editor tabs is black. To apply user font color uncheck the option and select the color.

Database Registration Info - Setting display options

For your convenience the Select All and Deselect All functions are implemented in the context menu of the objects list area.

See also:

Database Explorer

Database Objects Management


Default directories

The Directories section of the Database Registration Info dialog allows you to set the directories to be used by default for database extract, data export, data import, saving HTML reports, creating reports, saving scripts operations.

Database Registration Info - Setting default directories


Logs

The Logs section of the Database Registration Info dialog allows you to specify log file names for metadata changes logging and Query data logging, if necessary.

Logging can be useful when you are going to move the changes made in the development database to the production database.

Database Registration Info - Setting log options

See also:

Default directories


SSH tunneling options

The SSH Tunneling section of the Database Registration Info dialog allows you to enable/disable SSH tunneling for connection to the database and set all the necessary SSH tunneling parameters.

CheckBox Connect through the Secure Shell (SSH) tunnel

Select this option to establish connection to an intermediate SSH server and forward all Oracle commands through the secure tunnel.

Specify SSH Host name, SSH port, SSH user name, SSH password, the path to the SSH key file (if necessary) in the corresponding boxes.

See SSH connection properties for details.

Database Registration Info - Setting SSH tunnel options

See also:

SSH connection properties


Data options

The Data Options section allows you to define options for data view. These options will be applied only to this database. Default settings for newly registered databases can be defined on the Grid|Data Options page of the Environment Options dialog.

Advanced

CheckBox Use separate connection for each data view within a database

Select this option to use a separate connection for each data view within a database. Disabling this option is recommended if maximum allowed number of connections is too low.

CheckBox Asynchronous query execution

Check this option to allow executing queries in background mode (asynchronously). Note that this option is only available when the Use separate connections for each data view within a database option is enabled.

CheckBox Timeout for query execution

Define time limit for query execution (ms). If query execution takes longer time than specified, than the operation will be aborted. Specify '-1' for unlimited timeout.

CheckBox Timestamp as string

Display Timestamp type as strings.

Also you can set Timestamp and Timestamp with time zone formats in the appropriate fields.

CheckBox Perform data filtration on client in data view

If enabled, data are filtered by SQL Manager for Oracle (on the client side).

If disabled, SQL filter is used in data view. In this case filtering is performed on the Oracle server with the help of the WHERE clause used in SQL query.

Database Registration Info - Setting data options

Default grid mode

These options allow you to define the grid mode for data which will be used by default. It can be changes individually for each table from the context menu of the grid.

RadioButton Load visible records

The grid loads only a fixed number of dataset records into memory. This option minimizes dataset loading time. Automatic sorting, filtering, summary calculations are not supported in this mode.

RadioButton Load all records

The grid loads all records from a dataset. This option increases the grid performance by reloading only changed dataset records when updating. In this mode all features (automatic sorting, filtering and summary calculations) are available.

See also:

Data View


Find option

The Find Option section allows you to search for options available within the Database Registration Info dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within the database registration options.

Database Registration Info - Find Option

The Available options area lists all options of the Database Registration category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


TNS Editor

Local naming parameters are gathered in the TNS file which is a configuration file that contains net service names mapped to connect descriptors to local naming method, or net service names mapped to listener protocol addresses.

TNS Editor allows you to view and edit the TNS file.

To open TNS editor

  • select Tools | iconEditLocalNamigParameters TNS Editor from the main menu

or

  • right-click the database or database group in DB Explorer and select the iconEditLocalNamigParameters TNS Editor context menu item.

  • Using Navigation bar and Toolbar
  • Viewing file contents


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in TNS Editor.

Local Naming parameters - Using Navigation bar

Connect Using

iconDB select an Oracle Home or connection string

General

iconCopyToClipboard copy content to clipboard

load content from an external *.ora file

iconSaveToFile save file content

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Viewing file contents

In the editor you can see TNS file content and edit text manually.

Using the Navigation bar you can save the content to a file or copy the selected text to Windows clipboard.

Local Naming parameters - File Contents


General options

The General tab allows you to browse the general client/server configuration settings in groups: Tracing, Logging, Routing, Advanced.

Profile parameters - General options

Tracing and logging options can be configured for the server and for the client. Switch to the respective tabs of the Tracing / Logging groups.

Tracing

Trace level

Use the drop-down list to turn off tracing or select trace level: USER, ADMIN, SUPPORT.

Trace directory / Trace filename

Type in or use the ExplorerButton button to specify the directory and the name of the trace file.

CheckBox Client trace file name should be unique

Use the option to specify whether or not a unique trace file is created for each client trace session. When this option is selected, a process identifier is appended to the name of each trace file, enabling several files to coexist.

Logging

Log directory

Type in or use the ExplorerButton button to specify the directory for the client or server (depending on whether the Client or the Server tab is selected) log file.

Log file name

Type in or use the ExplorerButton button to specify the name of the log file for the client/server.

Routing

CheckBox Route the client to a Connection Manager protocol address

Routes the client to a protocol address for Oracle Connection Manager.

CheckBox Always use a dedicated server

Enables connections from this client use a dedicated server process, even if a shared server is configured.

Advanced

Wait duration for active connection probe

Use this parameter to specify the time interval (in minutes) to send a probe to verify that client/server connections are active.

Client registration ID

Set a unique identifier for this client computer. This identifier is passed to the listener with any connection request and is included in the Audit Trail. The identifier can be any alphanumeric string up to 128 characters long.

CheckBox Disable signal handling for Unix

Use this parameter to turn signal handling on or off for UNIX systems.

CheckBox Disable Out-of-Band break messages

If turned on, disables the ability to send and receive "break" messages using urgent data provided by the underlying protocol. Once enabled, this feature applies to all protocols used by this client.

See also:

Naming options

Oracle Advanced Security

Utilities

File contents


Naming options

The Naming tab provides tools for editing naming options.

Methods

This group allows you to select the naming methods, such as TNSNAMES or Oracle Names, that will be used for client name requests.

To select a method, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the methods from one list to another.

Profile parameters - Naming

Preferred Servers

This tab is used to specify the protocols, addresses, and the order of addresses that will be used for a client's name requests.

Use the context menu to insert/append/delete an address. You can also test the address using the corresponding item of the context menu or the Navigation bar.

Profile parameters - Naming - Preferred Servers

Oracle Names

Wait duration before disconnection from Names server

Limits the amounts of time the Oracle Names server will wait for the connection from a client to complete.

Default domain

Indicates the domain from which the client most often requests names. When this parameter is set, the default domain name will be automatically appended to any unqualified service name.

Resolution persistence

Wait duration before connection retry

Determines how long a client will wait for a response from an Oracle Names server before reiterating the request to the next server in the preferred servers list.

Number of retries per each Names server

Specifies the number of times the client should try each server in the list of preferred servers before allowing the operation to fail.

Performance

Number of connections to a Names server

Determines how many connections an Oracle Names client may have open at one time.

Initial number of preallocated messages

Determines the initial number of messages allocated in the client's message pool which are used for forwarded message requests.

Profile parameters - Naming - Oracle Names

DCE

DCE cell name

Specifies the Distributed Computing Environment (DCE) cell name (prefix) to use for name lookup.

Profile parameters - Naming - DCE

NIS

NIS map file name

Type in or use the ExplorerButton button to specify the file to be used to map Network Information Service (NIS) attributes to a NIS mapname.

NIS is a Sun Microsystems' Yellow Pages (yp) client/server protocol for distributing system configuration data such as user and host names between computers on a network.

Profile parameters - Naming - NIS

See also:

General options

Oracle Advanced Security

Utilities

File contents


Oracle Advanced Security

The Oracle Advanced Security tab provides configuration tools for the following security areas:

  • Authentication
  • Integrity and Encryption
  • TCP/IP Access Rights
  • SSL

See also:

General options

Naming options

Utilities

File contents


Authentication

The Authentication tab allows you to set up authentication options for your Oracle system: select authentication method(s) and set their properties.

Methods

This group allows you to select the authentication methods that will be used by the system.

To select a method, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the methods from one list to another.

Profile parameters - Advanced Security - Authentication

Kerberos5

Service name

Define the name of the service used to obtain a Kerberos service ticket.

Credential cache file

Type in or use the ExplorerButton button to specify the complete path and name of the Kerberos credentials cache file.

Configuration file

Type in or use the ExplorerButton button to specify the complete path and name of the Kerberos configuration file which contains the realm for the default KDC and maps realms to KDC hosts.

Realm translation file

Type in or use the ExplorerButton button to specify the complete path and name of the Kerberos realm translation file which provides a mapping from a host name or domain name to a realm.

Key table

Type in or use the ExplorerButton button to specify the complete path and name of the Kerberos principal/secret key mapping file which is used to extract keys and decrypt incoming authentication information.

Waiting time before credential expiration

Specify how many seconds must pass before a Kerberos credential is considered out of date.

Profile parameters - Advanced Security - Authentication - Kerberos5

CyberSAFE

GSSAPI service

Use this field to define the CyberSAFE service principal.

Profile parameters - Advanced Security - Authentication - CyberSAFE

Identix

Database

Specify the service name or alias for the authentication fingerprint database.

Database user

Specify the user name known to the fingerprint database.

Database password

Specify the password known to the fingerprint database.

Identix method

Specify the method name for the fingerprint database. The method name must be ORACLE.

Profile parameters - Advanced Security - Authentication - Identix

RADIUS

Please note that parameters of the Servers group (host name, port and number of connection retries) can be configured for the primary server as well as for the alternate server. Switch to the respective tabs of the Servers group.

Profile parameters - Advanced Security - Authentication - RADIUS

Host name

Specifies the location of the primary RADIUS server, either by its host name or IP address.

Port

Listening port of the primary RADIUS server.

Number of connection retries

Times to resend.

Wait duration before disconnection from server

Time to wait for response before server connection is closed.

RADIUS secret key file

Type in or use the ExplorerButton button to specify the full path to the file containing the RADIUS shared secret.

Default keyword

This parameter sets the keyword to request a challenge from the RADIUS server. User types no password on the client.

Interface class name

Sets the name of the Java class that contains the graphical user interface when RADIUS is in the challenge-response (asynchronous) mode.

CheckBox Send accounting

This option enables/disables accounting.

If you enable accounting, packets will be sent to the active RADIUS server at the listening port plus one. By default, packets are sent to port 1646. You need to turn this feature on only when your RADIUS server supports accounting and you want to keep track of the number of times the user is logging on to the system.

CheckBox Challenge response

This option turns on/off the challenge-response, or asynchronous, mode support.

See also:

Integrity and Encryption

TCP/IP Access Rights

SSL


Integrity and Encryption

The Integrity and Encryption tab allows you to set up encryption and integrity options for your Oracle system: select encryption and integrity methods and set their properties.

Please note that encryption and integrity parameters can be configured for the server as well as for the client. Switch to the respective tabs of the Encryption and Integrity groups.

Profile parameters - Advanced Security - Integrity and Encryption

Encryption

This group allows you to specify the encryption type (ACCEPTED, REJECTED, REQUESTED, REQUIRED) and select the encryption algorithms that will be used by this client / server acting as a client or by the server (depending on whether the Client or the Server tab is selected). This list is used to negotiate a mutually acceptable algorithm with the other end of the connection.

To select a method, you need to move it from the Available Methods list to the Selected Methods list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the methods from one list to another.

Encryption seed

The characters that form the value for this parameter can be used to seed the random number generator that is used to generate cryptographic key material. The more random the characters entered into this field are, the stronger the keys are.

Integrity

This group allows you to select the checksum level (specifies the desired data integrity behavior when a client or another server acting as a client connects to this server: ACCEPTED, REJECTED, REQUESTED, REQUIRED) and to specify a list of data integrity algorithms used by this client / server acting as a client or by the server (depending on whether the Client or the Server tab is selected). This list is used to negotiate a mutually acceptable algorithm with the other end of the connection.

To select a method, you need to move it from the Available Methods list to the Selected Methods list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the methods from one list to another.

See also:

Authentication

TCP/IP Access Rights

SSL


TCP/IP Access Rights

The TCP/IP Access Rights tab allows you to grant/deny access privileges to your Oracle system.

Profile parameters - Advanced Security - TCPIP Acess Rights

Use the CheckBox Check access rights for TCP/IP connections option to determine to which clients access is to be allowed or denied.

Grant access for

Specify which clients are allowed access to the database. This list takes precedence over the Deny access for list if both lists are present.

Deny access for

Specify which clients are denied access to the database.

If necessary, you can choose to CheckBox Preempt delays in buffer flushing within the TCP/IP protocol stack.

See also:

Authentication

Integrity and Encryption

SSL


SSL

The SSL tab allows you to set up SSL (Secure Sockets Layer) options for your Oracle system in groups: Wallet configuration, Certificate revocation checking, Cipher suite configuration.

Profile parameters - Advanced Security - SSL

Wallet configuration

Specify the location of wallets - certificates, keys and trustpoints processed by SSL.

Method

Specify the type of storage: none, on the file system, Microsoft certificate store, in Windows registry, entrust wallets.

Directory

Type in or use the ExplorerButton button to specify the location of Oracle wallets (for wallets stored on the file system).

Registry key

Specify the registry key where Oracle wallets are stored (for wallets stored in Windows registry).

Profile / Inifile

Type in or use the ExplorerButton button to specify the path to the wallets profile / inifile (for entrust wallets).

Certificate revocation checking

Method

Use the drop-down list to configure a revocation check for a certificate: select the one of the available methods: NONE, REQUESTED, REQUIRED.

CRL file / CRL path

Type in or use the ExplorerButton button to specify the directory and the name of the file where you can assemble the CRL of Cas for client authentication.

Cipher suite configuration

Use this group to control what combination of encryption and data integrity is used by the Secure Sockets Layer (SSL).

To select an item, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the items from one list to another.

Require SSL version

Use the drop-down list to select the required SSL version: Any version, 2.0, 3.0.

CheckBox Require client SSL authentication

Use this option to force the selected version of the SSL connection. Clients and database servers must use a compatible version.

CheckBox Require server X.509 name match

Use the option to enforce that the distinguished name (DN) for the database server matches its service name. If you enforce the match verifications, then SSL ensures that the certificate is from the server. If you select to not enforce the match verification, then SSL performs the check but allows the connection, regardless if there is a match. Not enforcing the match allows the server to potentially fake its identify.

See also:

Authentication

Integrity and Encryption

TCP/IP Access Rights


Utilities

The Utilities tab allows you to configure native Oracle configuration utilities: Oracle Enterprise Manager Daemon, Oracle Names Control utility, TNSPing utility.

Profile parameters - Utilities

Oracle Enterprise Manager Daemon

Trace level

Use the drop-down list to turn off tracing or select trace level for the Oracle Enterprise Manager daemon: USER, ADMIN, SUPPORT.

Trace directory

Type in or use the ExplorerButton button to specify the destination directory of the Oracle Enterprise Manager daemon trace file.

Trace mask

Using this field you can specify that only the Oracle Enterprise Manager daemon trace entries are logged into the trace file.

Oracle Names Control utility

Server password

Use the parameter (NAMESCTL.SERVER_PASSWORD) to indicate the value that matches the configured password set in the names.ora file with the NAMES.PASSWORD parameter.

CheckBox Encrypt password internally

If checked, the password is sent to the Oracle Names server encrypted.

CheckBox Enable a set of internal undocumented commands

The option enables/disables a set of internal undocumented commands.

CheckBox Suppress any connection error messages

If checked, any error messages are suppressed when the client is unable to connect to a default Oracle Names server.

CheckBox Run sensitive commands without confirmation

Use this option to indicate whether sensitive commands should be prompted with a confirmation when running the Oracle Names Control utility.

Trace level

Use the drop-down list to turn off tracing or select trace level for the Oracle Names Control utility: USER, ADMIN, SUPPORT.

Trace directory

Type in or use the ExplorerButton button to specify the directory for the Oracle Names Control utility trace file.

Trace file

Type in or use the ExplorerButton button to specify the file in which the Oracle Names Control utility trace output is placed.

CheckBox Trace file name should be unique

Indicates whether or not a process identifier is appended to the name of each trace file generated. If this option is enabled, several trace files can co-exist.

TNSPing utility

Trace level

Use the drop-down list to turn off tracing or select trace level for the TNSPing utility: USER, ADMIN, SUPPORT.

Trace directory

Type in or use the ExplorerButton button to specify the destination directory for the TNSPing utility trace file.

See also:

General options

Naming options

Oracle Advanced Security

File contents


Viewing file contents

The File Contents tab allows you browse the SQLNET.ORA Network Configuration file contents. If necessary, you can edit the text manually.

Using the Navigation bar you can load an existing file, save the content to a file or copy the selected text to Windows clipboard.

Profile parameters - File Contents

See also:

General options

Naming options

Oracle Advanced Security

Utilities


Database Registration Manager

Database Registration Manager allows you to register new databases and delete the registration of non-existing databases.

To open Database Registration Manager

  • use the corresponding item of the database context menu in DB Explorer

or

  • open Database --> Database Registration Manager from the main menu

Database Registration Info - Database Registration Manager

The table contains all databases located in the selected group. You can change Oracle home selection using the appropriate drop-down list in the navigation bar.

Check all databases to be registered.

For automatic registration of the selected databases click the iconCommit Apply changes button.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Register Database Wizard

Database Registration Info


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Registration Manager.

Database Registration Manager - Using Navigation bar

The Navigation bar of Database Registration Manager allows you to:

Oracle home

iconHost select a group

General

iconRefresh Refresh the list of databases

iconCommit Apply changes to register selected databases

Selection

Select all selects all databases located in the group, but not registered in <PRODUCT_TITLE>

iconUncheckAllDb Uncheck all databases to unregister them

Uncheck deleted DB unchecks databases removed from the server

Legend

iconDB Exist on host

Removed from host

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Database Objects

SQL Manager for Oracle provides powerful tools to manage database objects.

To obtain detailed information concerning Oracle database objects, refer to the official Oracle server documentation.

Note: Before working with database objects in SQL Manager for Oracle you should connect to the database first.

Creating Database Objects

  • select the Database | New Object... main menu item;
  • select the type of object within the New Object dialog;
  • follow the steps of the wizard which guides you through the entire process of creating the object, or set the object properties using its editor - depending on the selected object type.

Note that you can also create a database object by selecting the appropriate context menu item of the DB Explorer tree or using the Ctrl+N shortcut.

Editing Database Objects

  • select the database object in the DB Explorer tree;
  • right-click the object to call its context menu and select the Edit <object type> <object name> context menu item, or double-click the object to open it in its editor.

Renaming Database Objects

  • select the object to rename in the DB Explorer tree;
  • right-click the object and select the Rename <object type> <object name>... item from the context menu;
  • edit the object name using the Rename Object... dialog.

Note: This operation is possible only for triggers, tables, views, sequences, private synonyms (for schema owners).

Dropping Database Objects

  • select the database object in the DB Explorer tree;
  • right-click the object to call its context menu and select the Drop <object type> <object name> context menu item;
  • confirm dropping in the dialog window.

When using an object editor, you can benefit from tabs. To switch between tab views, click on their respective tabs at the top of the main editor window. You can do it at any time, since the tab views are absolutely independent.

To compile a newly created or edited object, you can use the iconCompile Compile item available within the Navigation bar or Toolbar of the object editor.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new object;

Ctrl+O to edit the selected object;

Shift+Del to drop the object from the database.

See also:

Getting Started

Database Explorer

Database Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Options

How To...


New Object

The Create New Object dialog allows you to select the type of the object to be created and run the appropriate wizard or editor.

To open the dialog, select the Database | iconNewObject New Object... main menu item.

Use the Database drop-down list to select the alias of the database where the new object should be created. Pick an object type icon and click OK to invoke the corresponding wizard or dialog.

Database Objects management - Create New Object

See also:

Operations with database objects

Duplicate Object Wizard

Schema Objects

Non-schema Objects

Users and Roles


Duplicate Object Wizard

Use the Duplicate Object Wizard to create a new database object of the same type and having the same properties as one of the existing ones.

To run the wizard, select the Database | iconDuplicateObject Duplicate Object... main menu item, or right-click an object of the desired type in the DB Explorer tree and use the Duplicate <object type> <object name>... context menu item.

  • Selecting the source database
  • Selecting object to duplicate
  • Selecting destination database
  • Modifying the new object's definition

See also:

Operations with database objects

New Object

Schema Objects

Non-schema Objects

Users and Roles


Selecting the source database

This step of the wizard allows you to select the source database containing the source object to be duplicated.

Duplicate Object Wizard - Selecting the source database

Click the Next button to proceed to the Selecting object to duplicate step of the wizard.


Selecting object to duplicate

Use the Objects drop-down menu to select the type of object you intend to duplicate.

Select a database object to copy its properties to the new object.

Hint: The context menu of the objects list area allows you to specify whether objects of the specified type should be displayed as icons or as list.

Duplicate Object Wizard - Selecting object to duplicate

Click the Next button to proceed to the Selecting destination database step of the wizard.


Selecting destination database

Select the target database and object namespace (schema) to create the new object in, set the name of the new database object.

Check the CheckBox Include grants option to duplicate grants currently defined for the object.

Check the CheckBox Copy data option to copy data from the source table to the new one.

Duplicate Object Wizard - Selecting destination database

Click the Next button to proceed to the Selecting table subobjects step of the wizard.


Selecting table subobjects

Specify object details (subobjects, dependent objects) to be duplicated in the target object.

Note: This step is available when duplicating tables only.

Duplicate Object Wizard - Selecting table subobjects

Click the Next button to proceed to the Modifying the new object's definition step of the wizard.


Modifying the new object's definition

This step of the wizard allows you to browse the result SQL statement.

If necessary, you can edit the definition of the new object.

Duplicate Object Wizard - Modifying the new object's definition

Click the Run button to create the object.


Schema objects

A schema is a collection of logical structures of data, or schema objects. A schema is owned by a database user. Each user can own a single schema. Schema objects can be created and manipulated with SQL and include the following types of objects:

  • Tables
  • Views
  • Procedures
  • Functions
  • Triggers,
  • DB and Schema Triggers
  • Indexes
  • Packages, Package Bodies
  • Sequences
  • Clusters
  • Materialized Views, Materialized View Logs
  • Synonyms
  • Database Links
  • Object Types, Object Type Bodies
  • Array Types
  • Libraries
  • Java Sources, Java Classes, Java Resources
  • Index Types
  • Operators
  • Dimensions
  • Queues
  • Queue Tables

Use the DB Explorer tree to navigate within the existing schemas and their objects.

See also:

Operations with database objects

New Object dialog

Duplicate Object Wizard

Non-schema Objects

Users and Roles


Tables

Relational databases store all their data in Tables. A table is a data structure consisting of an unordered set of horizontal rows, each containing the same number of vertical columns. The intersection of an individual row and column is a field that contains a specific piece of information. Much of the power of relational databases comes from defining the relations among the tables.

Creating Tables

  • select the Database | New Object... main menu item;
  • select Table in the Create New Object dialog;
  • define table properties and fields using the appropriate tabs of Table Editor.

Hint: To create a new table, you can also right-click the Tables node or any object within this node in the DB Explorer tree and select the New Table... item from the context menu.

To create a new table with the same properties as one of existing tables has:

  • select the Database | Duplicate Object... menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a table in the DB Explorer tree and select the Duplicate Table <table_name>... context menu item.

Editing Tables

  • select the table for editing in the DB Explorer tree (type the first letters of the table name for quick search);
  • right-click the object and select the Edit Table <table_name> context menu item, or simply double-click the table;
  • edit table subobjects and data using the appropriate tabs of Table Editor.

Dropping Tables

  • select the table to drop in the DB Explorer tree;
  • right-click the object and select the Drop Table <table_name>... context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new table;

Ctrl+O to edit the selected table;

Shift+Del to drop the object from the database.


New table

The New Table window is a mode of Table Editor that opens automatically when you create a new table (see Create table for details) and allows you to create a new table, set table properties, specify table fields and edit table description.

To call Table Editor for creating a new table, you can right-click the Tables node or any object within this node in the DB Explorer tree and use the Ctrl+N shortcut.

  • Using Navigation bar and Toolbar
  • Setting table properties
  • Specifying table fields
  • Setting physical attributes
  • Setting overflow attributes
  • Partitioning


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Table Editor.

New table - Using Navigation bar

The Navigation bar of Table Editor (in the New table mode) allows you to:

Database

iconDB select a database to create a new table in

General

iconCompile compile the newly created table

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the table:

Fields

add a new field

edit selected field

drop selected field(s)

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Setting table properties

Use the Table tab of Table Editor to specify new table properties.

Name

Specify the name of the table to be created. Note that the table name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the table will be created.

New table - Setting table properties

Organization

This group allows you to specify the order in which the data rows of the table are stored:

RadioButton Regular

RadioButton Global temporary

RadioButton Clustered

RadioButton Index-organized

RadioButton External

CheckBox Object table

Defines that an object table (which is a table that uses an object type for a column definition) should be created. An object table is explicitly defined to hold object instances of a particular type.

Object type owner

Use the drop-down list to select the schema in which the object type is located.

Object type name

Use the drop-down list to select the object type that will be used by the object table.

The columns of an object table correspond to the top-level attributes of type which is specified in the Object type name field. Each row will contain an object instance, and each instance will be assigned a unique, system-generated object identifier when a row is inserted.

The properties below vary according to the selected table organization type. For details see Table Properties.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Specifying fields

The Fields tab is intended for setting up table fields. Double-click a field to open Field Editor for editing the field.

Right-click within the Table Fields area to display the context menu allowing you to add, insert, edit, delete, and reorder fields.

Field management tools are also available through the Navigation bar of Table Editor.

New table - Specifying fields

The Fields list provides the following attributes of each field of the table:

Key

Column Name

Data Type

Size

Scale

Not Null

Default Value

Click within the Key column to specify a primary key field, and type the name of the primary key constraint name in the corresponding edit box.

For details see Fields.

To compile the table, use the iconCompile Compile item available within the Navigation bar.


Specifying foreign keys

The Foreign Keys tab is provided for setting up table foreign keys.

Double-click a foreign key to open the Foreign Key Editor for editing the foreign key.

Right-click a foreign key to display the context menu allowing you to create new, edit, or drop the selected foreign key. Using the menu you can also export the list of the table foreign keys to any of supported formats.

New table - Specifying foreign keys

The Foreign Keys list provides the following attributes of each foreign key of the table:

Foreign Key Name

Columns

Foreign Table

Foreign Columns

On Delete

Disabled

For details see Foreign Keys.


Setting physical attributes

The Physical attributes tab is provided for setting up physical attributes for the new table.

The physical properties relate to the treatment of extents and segments and to the storage characteristics of the table.

New table - Setting physical attributes

For more information refer to the Storage attributes page.


Setting overflow attributes

The Overflow Attributes tab is provided for setting up overflow attributes for the new index-organized table.

This tab allows you to instruct the database that index-organized table data rows exceeding the specified threshold are placed in the data segment specified within this tab.

New table - Setting overflow attributes

Overflow column

Use the drop-down list to specify a column at which to divide an index-organized table row into index and overflow portions. The primary key columns are always stored in the index. The overflow column can be either the last primary key column or any non-primary key column. All non primary key columns that follow the overflow column are stored in the overflow data segment.

For more information refer to the Storage attributes page.


Partitioning

The Partitioning tab is provided for setting up partitioning parameters for a partitioned table.

New table - Partitioning

Partitioning by

Range

Select this item to partition the table on ranges of values from the column list. For an index-organized table, the column list must be a subset of the primary key columns of the table.

Hash

Select this item to specify that the table is to be partitioned using the hash method. Oracle Database assigns rows to partitions using a hash function on values found in columns designated as the partitioning key.

List

Select this item to partition the table on lists of literal values from column. List partitioning is useful for controlling how individual rows map to specific partitions.

Reference

Select this item to partition the table by reference. Partitioning by reference is a method of equipartitioning the table being created (the child table) by a referential constraint to an existing partitioned table (the parent table).

System

Select this item to create system partitions. System partitioning does not entail any partitioning key columns, nor do system partitions have any range or list bounds or hash algorithms. Rather, they provide a way to equipartition dependent tables such as nested table or domain index storage tables with partitioned base tables.

Partition keys

Use this group to specify an ordered list of columns used to determine into which partition a row belongs. These columns are the partitioning key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

CheckBox Composite

If this option is selected, the table is first partitioned by range, and then the partitions are further partitioned into range, hash, or list sub-partitions.

Sub-partition keys

Use this group to specify an ordered list of columns used to determine into which sub-partition a row belongs. These columns are the sub-partitioning key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Sub-partitioning by

Use the drop-down list to indicate the type of sub-partitioning you want for each composite range partition: hash or list.

Partitions

This area allows you to specify individual partitions. Right-click within the list area to call the context menu allowing you to create a new partition, edit or delete the selected partition.

Values

Specify the non-inclusive upper bound for the current partition. The value list is an ordered list of literal values corresponding to the column list.


Table Editor

Table Editor is the basic SQL Manager tool for working with tables. It opens automatically in the New table mode when you create a new table and is available on editing an existing one (see Create table and Edit table for details).

Table Editor allows you to create, edit and drop table's fields, indexes, foreign keys and other table subobjects, manage table data, and much more.

To open a table in Table Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar
  • Managing table fields
  • Managing table keys
  • Managing table foreign keys
  • Managing table checks
  • Managing table indexes
  • Managing table triggers
  • Browsing object dependencies
  • Working with table data
  • Editing table description
  • Viewing DDL definition
  • Setting object permissions
  • Table properties


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Table Editor.

Table Editor - Using Navigation bar

The Navigation bar of Table Editor (in the Edit table mode) allows you to:

Object

iconDB select a database

select a table for editing

General

iconProperties view/edit table properties

iconPrint set printing options to print metadata of the table

iconRefresh refresh the content of the active tab

iconOptions adjust Table Editor options

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompile compile the table (if it is being modified)

Tools

call Truncate Wizard to truncate the table

iconAddRestorePoint add restore point

view the dependency tree for the table

Explorer

iconDBExplorer browse the table subobjects using the Explorer tree

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the table:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

Fields

add a new field

edit selected field

drop selected field(s)

Keys

add a new primary/unique key

edit selected primary/unique key

drop selected primary/unique key

Foreign Keys

add a new foreign key

edit selected foreign key

drop selected foreign key(s)

Checks

add a new check

edit selected check

drop selected check(s)

Indices

add a new index

edit selected index

drop selected index(-es)

Triggers

add a new trigger

edit selected trigger

drop selected trigger(s)

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export data from the table using Export Data Wizard

export data from the table as Execute Script using Export as SQL Script Wizard

import data into the table using Import Data Wizard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Managing fields

The Fields tab is intended for managing table fields.

Double-click a field to open the Field Editor for editing the table field.

Right-click a field to display the context menu allowing you to create new, edit, drop, rename, or duplicate the selected field. Using the menu you can also export the list of the table fields to the any of supported formats, or copy the list to clipboard.

Field management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing fields

The Fields list provides the following attributes of each field of the table:

Field Name

Field Type

Not Null

Unique

Default Value

For details see Fields.

If necessary, you can also use the Field Description area to supply a description for each field.


Managing keys

The Keys tab is provided for managing table keys.

Double-click a key to open the Key Editor for editing the table key.

Right-click a key to display the context menu allowing you to create new, edit, drop, enable/disable the selected key, or enable/disable all keys. Using the menu you can also export the list of the table keys to any of supported formats.

Key management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing keys

The Keys list provides the following attributes of each key of the table:

Key Name

Columns

Primary

Disabled

For details see Keys.


Managing foreign keys

The Foreign Keys tab is provided for managing table foreign keys.

Double-click a foreign key to open the Foreign Key Editor for editing the foreign key.

Right-click a foreign key to display the context menu allowing you to create new, edit, drop, enable/disable the selected foreign key, or enable/disable all foreign keys. Using the menu you can also export the list of the table foreign keys to any of supported formats.

Foreign key management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing foreign keys

The Foreign Keys list provides the following attributes of each foreign key of the table:

Foreign Key Name

Columns

Foreign Table

Foreign Columns

On Delete

Disabled

For details see Foreign Keys.


Managing checks

The Checks tab is provided for managing table checks.

Double-click a check to open the Check Editor for editing the table check.

Right-click a check to display the context menu allowing you to create new, edit, drop, enable/disable the selected check, or enable/disable all checks. Using the menu you can also export the list of the table checks to any of supported formats.

Check management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing checks

The Checks list provides the following attributes of each check of the table:

Name

Definition

Disabled

For details see Checks.


Managing indices

The Indices tab is provided for managing table indexes.

Double-click an index to open the Index Editor for editing the table index.

Right-click an index to display the context menu allowing you to create new, edit, drop, or duplicate the selected index. Using the menu you can also export the list of the table indexes to any of supported formats.

Index management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing indexes

The Indexes list provides the following attributes of each index of the table:

Index Name

Columns

Index Type

For details see Indexes.


Managing triggers

The Triggers tab is provided for managing table triggers.

Double-click a trigger to open the Trigger Editor for editing the table trigger.

Right-click a trigger to display the context menu allowing you to create new, edit, drop, enable/disable the selected trigger, or enable/disable all triggers. Using the menu you can also export the list of the table triggers to any of supported formats.

Trigger management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing triggers

The Triggers list provides the following attributes of each trigger of the table:

Name

Type

For Each Row

Insert

Update

Delete

Disabled

For details see Triggers.


Managing partitions

The Partitions tab is provided for managing table partitions.

Table Editor - Managing partitions

Partitions

This area allows you to specify individual partitions. Right-click within the list area to call the context menu allowing you to create a new partition, edit or delete the selected partition. Several partitions can be deleted and truncated at the same time.

Using the context menu you can also:

  • Split partition
  • Truncate partition
  • Merge partitions

To merge several partitions select them with the Shift button and click the Merge partitions context menu item. After that specify the name for the newly created result partition.

Use the Split partition item to redistribute the contents of a partition into two or more new partitions. The following dialog is opened on splitting a partition.

Table Editor - Managing partitions - Splitting partitions

Define partitions names and values of the partition being splitted and click the OK button.

Use the Truncate partition context menu item to remove all rows from a table partition. Truncating a partition is similar to dropping a partition, except that the partition is emptied of its data, but not physically dropped.

For details see Partitioning.


Working with table data

The Data tab displays the table data as a grid by default (see Data View for details). The context menu of this tab allows you to Export Data, Import Data, Export as SQL Script.

Data management tools are also available through the Navigation bar of Table Editor.

While working with data, you are provided with a number of filtering and grouping facilities.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Table Editor - Working with table data

Note: You can add a restore point before changing data, to get an opportunity to flash back to the current data state.

Click iconAddRestorePoint Add restore point on the Navigation bar or toolbar to open the Add restore point dialog. For details see Adding restore point.

See also:

Working with view data

Data View


Table Properties

The Properties tab allows you to view/edit common properties of the table: Table name, Schema name, Organization type (Regular, Global Temporary, Clustered, Index-organized, External, etc.), type-specific properties.

Hint: These properties are also available within a modal dialog which is called through the Table Properties... context menu item of the table alias in DB Explorer.

Depending on the specified table organization the following specific properties can be set:

  • Regular table properties
  • Global Temporary table properties
  • Clustered table properties
  • Index-organized table properties
  • External table properties


Regular

A [image] regular table is a HEAP-organized table in which data rows are stored in no particular order.

Table properties - Regular

The following type-specific properties can be set for Regular tables:

CheckBox Logging

This option indicates that the creation of the table will be logged in the redo log file.

CheckBox Monitoring

Use the option to start the collection of modification statistics on this table.

CheckBox Partitioning

Select this option to create a partitioned table.

See also:

Physical Attributes

Partitioning


Global Temporary

A [image] Global Temporary table is a temporary table and its definition is visible to all sessions with appropriate privileges. The data in a temporary table are visible only to the session that inserts the data into the table.

Table properties - Global Temporary

The following type-specific properties can be set for Global Temporary tables:

Duration

The table segment and any data the table contains can be either session-specific or transaction-specific data. Use this group to specify whether the table segment and data are session- or transaction-specific.

On commit

This group specifies action performed over the table data on commit:

RadioButton Delete rows

This option is specified for a transaction-specific temporary table. Oracle will truncate the table (delete all its rows) after each commit.

RadioButton Preserve rows

This option is specified for a session-specific temporary table. Oracle will truncate the table (delete all its rows) when you terminate the session.

See also:

Physical Attributes


Clustered

A [image] Clustered table is the table that is part of a cluster. The table columns correspond to the cluster columns. Generally, the cluster columns of a table are the column or columns that make up its primary key or a portion of its primary key.

Table properties - Clustered

The following type-specific properties can be set for Clustered tables:

To create a clustered table, you need to specify name of the cluster and its schema.

Cluster owner

Use the drop-down list to select schema to contain the cluster.

Cluster name

Use the drop-down list to select name of the cluster for the clustered table.

Use the area below to specify one column from the table for each column in the cluster key.

See also:

Physical Attributes


Index-organized

In an [image] index-organized table, the data rows are held in an index defined on the primary key for the table. Oracle Database maintains the table rows, both primary key column values and non-key column values, in an index built on the primary key. Index-organized tables are therefore best suited for primary key-based access and manipulation.

Table properties - Index-organized

The following type-specific properties can be set for Index-organized tables:

Index name

Use the edit box to specify the name of the index for this table.

PCT threshold

Specify the percentage of space reserved in the index block for an index-organized table row, or select DEFAULT from the drop-down list.

This value must be large enough to hold the primary key. All trailing columns of a row, starting with the column that causes the specified threshold to be exceeded, are stored in the overflow segment.

CheckBox Partitioning

Select this option to create a partitioned table.

IOT Primary Constraint

This group allows you to specify a primary key column for the index-organized table, since the primary key uniquely identifies a row.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

See also:

Physical Attributes

Overflow Attributes

Partitioning


External

An external table is a read-only table whose metadata are stored in the database but whose data are stored outside the database. Among other capabilities, external tables let you query data without first loading them into the database.

Table properties - External

The following type-specific properties can be set for External tables:

Type

This value indicates the access driver of the external table. The access driver is the API that interprets the external data for the database. Use the drop-down list to select one of the two access drivers provided by Oracle Database:

ORACLE_LOADER (lets you read table data from an external table and load it into a database);

ORACLE_DATAPUMP (lets you unload data, i.e. read data from a table in the database and insert it into an external table, and then reload it into an Oracle database)

Default directory name

Specify a default directory object corresponding to a directory on the file system where the external data sources may reside.

Reject limit

Specify how many conversion errors can occur during a query of the external data before an Oracle Database error is returned and the query is aborted, or select DEFAULT from the drop-down list.

Parallel

Use this group to specify the degree of parallel access to the external table.

RadioButton Default

RadioButton No parallel (serial execution)

RadioButton Parallel (select a degree of parallelism equal to the number of CPUs available on all participating instances)

Degree

Indicates the degree of parallelism, which is the number of parallel threads used in the parallel operation.

Locations

Use the Add location btnAddItem and Delete location btnRemoveItem buttons to manage external data sources. Normally, a data source is a file, but not necessarily. It is subject to the access driver to interpret this information in the context of the external data.

Click the Access parameters button to call the Access Parameters dialog that allows you to modify the default behavior of the access driver by setting values to the parameters of the access driver for this external table: record and field parameters.

See also:

Physical Attributes


Record parameters

The Records tab of the Access Parameters dialog allows you to define a number of options pertaining to the data records of the external table.

Table properties - External - Access parameters - Records

Character set

Identifies the character set of the datafile.

Data endian

Use the drop-down list to specify the endianness of data whose byte order may vary depending on the platform that generated the datafile. Possible values are: DEFAULT, LITTLE, BIG.

String size in

Use the drop-down list to specify whether the lengths specified for character strings are in bytes or characters.

Byte order mark

Use the drop-down list to specify whether or not the datafile should be checked for the presence of a byte-order mark (BOM):

UNCHECK indicates that the datafile should not be checked for a BOM and that all the data in the datafile should be read as data;

CHECK indicates that the datafile should be checked for a BOM; this is the default behavior for a datafile in a Unicode character set.

Skip

Specify the number of records skipped in the datafile before loading. This value can only be specified when non-parallel access is made to the data.

Record length

This group allows you to specify record length for the external table.

RadioButton Fixed

If this option is selected, all records have a fixed size of length bytes specified in the spinner control.

RadioButton Variable

If this option is selected, the records have a variable length and each record is preceded by a character string containing a number with the count of bytes for the record specified in the spinner control.

RadioButton Delimited by

If this option is selected, the end of a record is identified by the characters specified in the edit box.

RadioButton Delimited by newline

If this option is selected, the end of a record is identified by the line feed.

Note: The actual value used is platform-specific. On UNIX platforms, NEWLINE is assumed to be "\n". On Windows NT, NEWLINE is assumed to be "\r\n".

Files

CheckBox Badfile

This option allows you to specify the file to which records are written when they cannot be loaded because of errors. The purpose of the badfile is to have one file where all rejected data can be examined and fixed, so that it can be loaded.

Directory

Use the drop-down list to specify a directory object corresponding to a directory on the file system where the badfile will reside.

File

Use the edit box to specify a name for the badfile.

CheckBox Discard file

This option allows you to specify the file to which records are written that fail the condition in the Load when clause.

Directory

Use the drop-down list to specify a directory object corresponding to a directory on the file system where the discard file will reside.

File

Use the edit box to specify a name for the discard file.

CheckBox Log file

This option allows you to specify the file that contains messages generated by the external tables utility while it is accessing data in the datafile.

Directory

Use the drop-down list to specify a directory object corresponding to a directory on the file system where the log file will reside.

File

Use the edit box to specify a name for the log file.

Storage

CheckBox Read size

This option allows you to specify the size of the read buffer. The size of the read buffer is a limit on the size of the largest record the access driver can handle.

CheckBox Data cache

This option allows you to specify the data cache size (in entries). By default, the data cache feature is enabled (for 1000 elements). To completely disable the data cache feature, set it to 0. The data cache feature is only available for direct path loads.

Load when

This area allows you to identify the records that should be passed to the database, e.g.

empid != BLANKS

(dept_id = "SPORTING GOODS" OR dept_id = "SHOES") AND total_sales != 0


Field parameters

The Fields tab of the Access Parameters dialog allows you to define a number of options pertaining to the fields of the external table.

Default field delimiter

Terminated by

Define the delimiter to show that everything between the current position in the record and the next occurrence of the termination string is considered part of the field, or select WHITESPACE from the drop-down list.

Start / End

If you set these parameters, the access driver starts at the current position in the record and skips over all whitespace looking for the first delimiter. All whitespace between the current position and the first delimiter is ignored. Next, the access driver looks for the second enclosure delimiter (or looks for the first one again if a second one is not specified). Everything between those two delimiters is considered part of the field.

CheckBox Optionally

This option determines whether the Start / End delimiters can be either both present or both absent.

Field definitions

Trim

This option is used to specify that spaces should be trimmed from the beginning of a text field, the end of a text field, or both. Spaces include blanks and other nonprinting characters such as tabs, line feeds and carriage returns. Use the drop-down list to select one of the following values: DEFAULT, LDTRIM, LTRIM, RTRIM, LRTRIM, NOTRIM.

CheckBox Missing field values are null

Indicates that if there is not enough data in a record for all fields, then those fields with missing data values are set to NULL.

CheckBox Reject rows with all null fields

Indicates that a row will not be loaded into the external table if all referenced fields in the row are null.

Table properties - External - Access parameters - Fields

The Field list area identifies the fields in the datafile and their data types.

Field Name

Identifies the name of a field in the datafile.

Data Type

Indicates the data type of the field. If no data type is selected, the access driver assumes the data type is CHAR(255).

Size

Defines the maximum size for the Data type.

StartPos

Number of bytes or characters from the beginning of the record to where the field begins. It positions the start of the field at an absolute spot in the record rather than relative to the position of the previous field.

EndPos

Indicates the absolute byte or character offset into the record for the last byte of the field.

Note that the Position parameter should be specified if you use StartPos / EndPos parameters.

Date format

Use this group to specify the date format and date mask (for date/time fields).

Default value

Use this group to specify the defaultlf and nulllf parameters.

Field delimiter

Use this group to specify the delimiter parameters for each field selected in the Field list, if necessary: Terminated by, Start / End, Trim, Max value, Optionally.

Default value

DefaultIf

Set the value to specify when the field is set to its default value.

NullIf

Set the value that specifies when the column associated with the field is set to NULL.

Field delimiter

Terminated by

Define the delimiter to show that everything between the current position in the record and the next occurrence of the termination string is considered part of the field, or select WHITESPACE from the drop-down list.

Start / End

If you set these parameters, the access driver starts at the current position in the record and skips over all whitespace looking for the first delimiter. All whitespace between the current position and the first delimiter is ignored. Next, the access driver looks for the second enclosure delimiter (or looks for the first one again if a second one is not specified). Everything between those two delimiters is considered part of the field.

Trim

Select the type of whitespace trimming for character fields.

Scale

Set the location of the decimal point in the number.

CheckBox Optionally

This option determines whether the Start / End delimiters can be either both present or both absent.


Fields

Table/view/materialized view fields are managed within the Fields tab of Table Editor/View Editor/Materialized View Editor.

Creating Fields

  • open the table in Table Editor ;
  • proceed to the Fields tab there;
  • right-click the tab area and select the New Field context menu item, or press the Ins key;
  • define the field properties using the Field Editor dialog.

Editing Fields

To edit an existing table field:

  • open the table in Table Editor ;
  • proceed to the Fields tab there;
  • right-click the field and select the Edit Field <field_name> context menu item, or simply double-click the field;
  • edit the field properties using the Field Editor dialog.

To change the name of a table field:

  • open the table in Table Editor ;
  • proceed to the Fields tab there;
  • right-click a field and select the Rename Object... context menu item;
  • specify a new name for the field in the Rename Object... dialog.

Dropping Fields

  • open the table in Table Editor ;
  • proceed to the Fields tab there;
  • right-click the field and select the Drop Field <field_name> context menu item;
  • confirm dropping in the dialog window.


Field Editor

Field Editor allows you to specify field definition and set field properties. It opens automatically when you create a new field and is available on editing an existing one (see Create field and Edit field for details).

To open a field in Field Editor, double-click it in the DB Explorer tree, or use the Edit Check... item of the context menu within the Fields tab of Table Editor.

  • Setting field name and type
  • Setting default value and comment


Setting field name and type

Column name

Enter a name for the new field, or modify the name of the field being edited. Note that the name of a field must be unique among all the field names in the table.

The Data type tab defines the type of the field data.

Field Editor - Setting field name and type

Column type kind

This group allows you to select whether the field being create/edited is based on a standard (built-in) data type, an ANSI SQL data type, or a user-defined type.

RadioButton Oracle built-in datatype

Specifies that the field is based on a built-in Oracle data type.

Type

Here you can set the field type by selecting it from the drop-down list of built-in Oracle data types.

RadioButton Ansi SQL datatype

Specifies that the field is based upon a user-defined data type.

Type

Here you can set the field type by selecting it from the drop-down list of ANSI SQL data types.

Size

Specify the length of the field value (for certain types).

Scale

Defines the maximum number of decimal digits that can be stored to the right of the decimal point of the value (for numeric and decimal data types).

CheckBox Not NULL

Check this option to specify that the values for the column should never contain a null value. NOT NULL affects all INSERT and UPDATE operations on a column.

CheckBox Unique

Check this option to create a unique key on the field that provides entity integrity for a particular column or columns using a unique index.

CheckBox Autoincrement

Enable the option to create an autoincremental field using trigger and sequence for Oracle Database 11g and lower.

For Oracle Database 12c use the Identity tab to configure autoincrement properties.

CheckBox Virtual

Enable the option to create a calculated field. Use the Column Expression tab to define expression that will be used to calculate this field's values.

CheckBox Default On Null

Check this option to set default column value when it is explicitly set to NULL.

RadioButton User-defined data type

Specifies that the field is based upon a user-defined data type.

Schema

Use the drop-down list to select the schema containing the user-defined type.

Type

Use the drop-down list to select the user-defined type (Array Type, Index Type or Object Type) for the field being created/edited.


Setting autoincrement options

If the field type is set to NUMBER and the CheckBox Autoincrement option is checked then you can directly set options for creating an autoincrement field. The sequence with the specified options is created on creating such field.

This feature is enabled in Oracle Database 12c.

Field Editor - Setting autoincrement

You can select an existing sequence for generating field values. Use the Schema and Sequence drop-down lists for this purpose.

If you want to configure new sequence manually then check the CheckBox Manual option.

Check the CheckBox Generate always option to increment the default value on every insertion and store the incremented value into the column.

For details on configuring other options see Sequences.


Setting default value and comment

Use the Default and the Comment tabs of Field Editor to set values taken by default and optional text as a comment for the field.

Field Editor - Setting default value and description


Keys

An integrity constraint is a rule that restricts the values in a database.

A unique constraint prohibits multiple rows from having the same value in the same column or combination of columns but allows some values to be null. A unique constraint designates a column as a unique key.

A primary key constraint combines a NOT NULL constraint and a unique constraint in a single declaration. It prohibits multiple rows from having the same value in the same column or combination of columns and prohibits values from being null. A Primary key constraint designates a column as the primary key of a table.

Table/view keys are managed within the Keys tab of Table Editor/View Editor.

Creating Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Keys tab there;
  • right-click the tab area and select the New Primary/Unique context menu item;
  • edit the key properties using Key Editor.

Editing Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Keys tab there;
  • right-click the key and select the Edit Primary/Unique Key context menu item, or simply double-click the key;
  • view the key properties using Key Editor.

Dropping Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Keys tab there;
  • right-click the key and select the Drop Primary/Unique Key context menu item;
  • confirm dropping in the dialog window.


Key Editor

Key Editor allows you to specify primary/unique key definition and set key options. It opens automatically when you create a new primary or unique key and is available on editing an existing one (see Create key and Edit key for details).

To open a primary/unique key constraint in Key Editor, double-click it in the DB Explorer tree, or use the Edit Foreign Key... item of the context menu within the Keys tab of Table Editor (or the Keys tab of View Editor).

  • Creating/editing key
  • Setting storage attributes
  • Setting key options
  • Viewing DDL definition


Creating/editing key

Use the Primary/Unique Key tab of Key Editor to create/edit a primary or unique key constraint and specify its properties.

Name

Specify the name of the key to be created, or view the name of the key being edited. Note that the key name must be unique within its schema.

CheckBox System named

If this option is selected, Oracle will generate the key name automatically when compiling the key definition.

Schema

Use the drop-down list to specify the schema in which the key will be created.

Key Editor - Editing key definition

Table or View

Use the drop-down list to select the table or view for which the key is created.

The Key fields area allows you to specify one or more table/view columns for the key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

CheckBox Create as unique key

Designates the key as a unique key.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar.


Storage options

The Physical Attributes / Storage tab available in object editors lets you specify how a database object should be stored in the database. Storage parameters affect both how long it takes to access data stored in the database and how efficiently space in the database is used.

Key Editor - Setting storage options

Physical attributes

Tablespace

Use the drop-down list to select the tablespace where the object will be stored.

Buffer pool

This option allows you to specify a default buffer pool or cache for the object. All blocks for the object are stored in the specified cache. Use the drop-down list to select one of the following values:

KEEP: the buffer pool retains the schema object's data blocks in memory;

RECYCLE: the buffer pool eliminates data blocks from memory as soon as they are no longer needed.

DEFAULT: the buffer pool contains data blocks from schema objects that are not assigned to any buffer pool, as well as schema objects that are explicitly assigned to the DEFAULT pool.

Initial number of transactions

Specify the initial number of concurrent transaction entries allocated within each data block allocated to the database object, or select DEFAULT from the drop-down list.

Extents

An extent is a logical unit of database storage space allocation made up of a number of contiguous data blocks. One or more extents in turn make up a segment. When the existing space in a segment is completely used, Oracle allocates a new extent for the segment.

Initial extent

Specify the size (in bytes) of the first extent of the object. Oracle allocates space for this extent when you create the schema object, or select DEFAULT from the drop-down list.

Next extent

Specify the size (in bytes) of the next extent to be allocated to the object, or select DEFAULT from the drop-down list.

Percent increase

Specify the percent by which the third and subsequent extents grow over the preceding extent, or select DEFAULT from the drop-down list (the default value is 50, meaning that each subsequent extent is 50 per cent larger than the preceding extent)

Minimum extents

Specify the total number of extents to allocate when the object is created, or select DEFAULT from the drop-down list. This parameter lets you allocate a large amount of space when you create an object, even if the space available is not contiguous.

Maximum extents

Specify the total number of extents, including the first, that Oracle can allocate for the object, or select DEFAULT or UNLIMITED from the drop-down list.

Space usage

Parameters of this group allow you to control the use of free space for inserts and updates to the rows in all the data blocks of a particular segment.

Percent free

This parameter sets the minimum percentage of a data block to be reserved as free space for possible updates to rows that already exist in that block. Specify a value, or select DEFAULT from the drop-down list.

Free lists

Free lists

Specify the number of free lists that can be contained in each free list group, or select DEFAULT from the drop-down list (the default and minimum value for this parameter is 1, meaning that each free list group contains one free list).

Groups

Specify the number of groups of free lists for the database object being created, or select DEFAULT from the drop-down list (the default and minimum value for this parameter is 1).


Setting key options

Use the Options tab of Key Editor to specify the primary/unique key constraint options.

Key Editor - Setting key options

Status

Use this group to toggle the constraint status:

RadioButton Disabled (disables the integrity constraint)

RadioButton Enabled (applies the constraint to the data in the table or view)

Validation

Options of this group correlate with the corresponding server constraint behaviour parameters - VALIDATE and NOVALIDATE:

RadioButton No validate (ensures that all new DML operations on the constrained data comply with the constraint)

RadioButton Validate (specifies that all old and new data also complies with the constraint)

CheckBox Deferrable

Select this option to enable the deferrable group which allows you to specify one of the following:

RadioButton Initially immediate (indicates that Oracle should check this constraint at the end of each subsequent SQL statement)

RadioButton Initially deferred (indicates that Oracle should check this constraint at the end of subsequent transactions)

Rely

Use this group to specify whether a constraint in NOVALIDATE mode is to be taken into account for query rewrite:

RadioButton No rely

RadioButton Rely (activate an existing constraint in NOVALIDATE mode for query rewrite in an unenforced query rewrite integrity mode)

Note: This group is only available on editing an existing primary/unique constraint.

Exceptions processing

This group lets you define exception handling, i.e. specify a table into which Oracle places the rowids of all rows violating the primary/unique constraint. Use the Schema and Table or view drop-down lists to specify the table into which exceptions will be stored.


Foreign Keys

An integrity constraint is a rule that restricts the values in a database.

A foreign key constraint requires values in one table to match values in another table. A Foreign key constraint (also called a referential integrity constraint) designates a column as the Foreign key and establishes a relationship between that foreign key and a specified Primary or Unique key called the referenced key.

Table/view foreign keys are managed within the Foreign Keys tab of Table Editor/View Editor.

Creating Foreign Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Foreign Keys tab there;
  • right-click the tab area and select the New Foreign Key context menu item, or press the Ins key;
  • define the Foreign key properties using Foreign Key Editor.

Editing Foreign Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Foreign Keys tab there;
  • right-click the Foreign key to edit and select the Edit Foreign Key <foreign_key_name> context menu item, or simply double-click the Foreign key;
  • edit the Foreign key properties using Foreign Key Editor.

Dropping Foreign Keys

  • open the table/view in Table Editor/View Editor;
  • proceed to the Foreign Keys tab there;
  • right-click the Foreign key and select the Drop Foreign Key <foreign_key_name> context menu item;
  • confirm dropping in the dialog window.


Foreign Key Editor

Foreign Key Editor allows you to specify foreign key definition and set foreign key options. It opens automatically when you create a new foreign key and is available on editing an existing one (see Create foreign key and Edit foreign key for details).

To open a foreign key constraint in Foreign Key Editor, double-click it in the DB Explorer tree, or use the Edit Foreign Key... item of the context menu within the Foreign keys tab of Table Editor (or the Foreign keys tab of View Editor).

  • Creating/editing foreign key
  • Setting foreign key options
  • Viewing DDL definition


Creating/editing foreign key

Use the Foreign Key tab of Foreign Key Editor to create/edit a foreign key constraint and specify its properties.

Name

Specify the name of the foreign key to be created, or view the name of the foreign key being edited. Note that the foreign key name must be unique within its schema.

CheckBox System named

If this option is selected, Oracle will generate the foreign key name automatically when compiling the foreign key definition.

Schema

Use the drop-down list to specify the schema in which the foreign key will be created.

Foreign Key Editor - Editing foreign key definition

Table or View

Use the drop-down list to select the table or view for which the foreign key is created.

The Key fields area allows you to specify one or more table/view columns for the foreign key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

The Referenced fields area allows you to specify one or more table columns to be referenced by the foreign key.

Schema / Table

Use the drop-down lists to select the schema and the foreign table.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Delete rule

RadioButton None

Produce an error indicating that the deletion would create a foreign key constraint violation.

RadioButton Set NULL

Set the referencing column(s) to null.

RadioButton Delete cascade

Delete any rows referencing the deleted row.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar.


Setting foreign key options

Use the Options tab of Foreign Key Editor to specify the foreign key constraint options.

Foreign Key Editor - Setting foreign key options

Status

Use this group to toggle the constraint status:

RadioButton Disabled (disables the integrity constraint)

RadioButton Enabled (applies the constraint to the data in the table or view)

Validation

Options of this group correlate with the corresponding server constraint behaviour parameters - VALIDATE and NOVALIDATE:

RadioButton No validate (ensures that all new DML operations on the constrained data comply with the constraint)

RadioButton Validate (specifies that all old and new data also complies with the constraint)

CheckBox Deferrable

Select this option to enable the deferrable group which allows you to specify one of the following:

RadioButton Initially immediate (indicates that Oracle should check this constraint at the end of each subsequent SQL statement)

RadioButton Initially deferred (indicates that Oracle should check this constraint at the end of subsequent transactions)

Rely

Use this group to specify whether a constraint in NOVALIDATE mode is to be taken into account for query rewrite:

RadioButton No rely

RadioButton Rely (activate an existing constraint in NOVALIDATE mode for query rewrite in an unenforced query rewrite integrity mode)

Note: This group is only available on editing an existing foreign key constraint.

Exceptions processing

This group lets you define exception handling, i.e. specify a table into which Oracle places the rowids of all rows violating the foreign key constraint. Use the Schema and Table or view drop-down lists to specify the table into which exceptions will be stored.


Checks

An integrity constraint is a rule that restricts the values in a database.

A check constraint requires a value in the database to comply with a specified condition. A check specifies an expression producing a Boolean result which new or updated rows must satisfy for an insert or update operation to succeed. Expressions evaluating to TRUE or UNKNOWN succeed. Should any row of an insert or update operation produce a FALSE result an error exception is raised and the insert or update does not alter the database.

Table checks are managed within the Checks tab of Table Editor.

Creating Checks

  • open the table in Table Editor ;
  • proceed to the Checks tab there;
  • right-click the tab area and select the New Check Constraint context menu item, or press the Ins key;
  • define the check properties using Check Editor.

Editing Checks

  • open the table in Table Editor ;
  • proceed to the Checks tab there;
  • right-click the check and select the Edit Check <check_name> context menu item, or simply double-click the check;
  • edit the check properties using Check Editor.

Dropping Checks

  • open the table in Table Editor ;
  • proceed to the Checks tab there;
  • right-click the check and select the Drop Check <check_name> context menu item;
  • confirm dropping in the dialog window.


Check Editor

Check Editor allows you to specify check definition and set check options. It opens automatically when you create a new check and is available on editing an existing one (see Create check and Edit check for details).

To open a check constraint in Check Editor, double-click it in the DB Explorer tree, or use the Edit Check... item of the context menu within the Checks tab of Table Editor.

  • Creating/editing check
  • Setting check options
  • Viewing DDL definition


Creating/editing check

Use the Check tab of Check Editor to create/edit a check constraint and specify its properties.

Name

Specify the name of the check to be created, or view the name of the check being edited. Note that the check name must be unique within its schema.

CheckBox System named

If this option is selected, Oracle will generate the check name automatically when compiling the check definition.

Schema

Use the drop-down list to specify the schema in which the check will be created.

Check Editor - Editing check definition

Table

Use the drop-down list to select the table for which the check is created.

The lower area represents the condition implied by the check constraint.

You can specify any logical expression that returns TRUE or FALSE based on the logical operators.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar.


Setting check options

Use the Options tab of Key Editor to specify the primary/unique key constraint options.

Check Editor - Setting check options

Status

Use this group to toggle the constraint status:

RadioButton Disabled (disables the integrity constraint)

RadioButton Enabled (applies the constraint to the data in the table)

Validation

Options of this group correlate with the corresponding server constraint behaviour parameters - VALIDATE and NOVALIDATE:

RadioButton No validate (ensures that all new DML operations on the constrained data comply with the constraint)

RadioButton Validate (specifies that all old and new data also complies with the constraint)

CheckBox Deferrable

Select this option to enable the deferrable group which allows you to specify one of the following:

RadioButton Initially immediate (indicates that Oracle should check this constraint at the end of each subsequent SQL statement)

RadioButton Initially deferred (indicates that Oracle should check this constraint at the end of subsequent transactions)

Rely

Use this group to specify whether a constraint in NOVALIDATE mode is to be taken into account for query rewrite:

RadioButton No rely

RadioButton Rely (activate an existing constraint in NOVALIDATE mode for query rewrite in an unenforced query rewrite integrity mode)

Note: This group is only available on editing an existing check constraint.

Exceptions processing

This group defines exception handling for integrity constraints. The group is not available for check constraints.


Views

A view is a logical table based on one or more tables or views. A view contains no data itself. The tables upon which a view is based are called base tables.

Views are useful for allowing users to access a set of relations (tables) as if it were a single table, and limiting their access to just that. Views can also be used to restrict access to rows (a subset of a particular table).

View Editor allows you to create new views and define their properties (view name and the SELECT statement it implements). It opens automatically when you create a new view and is available on editing an existing one.

To open a view in View Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing view
  • Managing fields
  • Managing keys
  • Managing foreign keys
  • Managing triggers
  • Working with data
  • Browsing object dependencies
  • Editing object description
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in View Editor.

View Editor - Using Navigation bar

Object

iconDB select a database

select a view for editing

General

iconCompile compile the view (if it is being created/modified)

iconPrint set printing options to print metadata of the view

edit the view query using Design Query

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

View

view the dependency tree for the view

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the view:

Keys

add a new primary/unique key

edit selected primary/unique key

drop selected primary/unique key

Foreign Keys

add a new foreign key

edit selected foreign key

drop selected foreign key(s)

Triggers

add a new trigger

edit selected trigger

drop selected trigger(s)

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export data from the view using Export Data Wizard

export data from the view as Execute Script using Export as SQL Script Wizard

import data into the base table

iconAddRestorePoint add restore point

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing view

Use the View tab of View Editor to create/edit a view and specify its properties.

Name

Specify the name of the view to be created. Note that the view name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the view will be created.

View Editor - Editing view definition

CheckBox Force

Select this option if you want to create the view regardless of whether the base tables of the view or the referenced object types exist or the owner of the schema containing the view has privileges on them.

CheckBox Read only

This option indicates that the view cannot be updated.

CheckBox With check option

When enabled, this option indicates that Oracle prohibits any changes to the table or view that would produce rows that are not included in the subquery.

Constraint name

Use this edit box to specify the name of the CHECK OPTION constraint.

Fields

Specify names for the expressions selected by the defining query of the view, i.e. give new names to the view fields separating them with a comma. The number of aliases must match the number of expressions selected by the view.

The lower area of the editor window allows you to specify the SELECT statement implemented by the view, i.e. specify a subquery that identifies columns and rows of the table(s) that the view is based on. The DDL tab will display the changes made to the view specification.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Managing fields

The Fields tab is provided for viewing fields represented in the view. Note that the tab is only available when you edit an existing view.

Right-click a field to display the context menu allowing you to export field name list or copy it to clipboard.

View Editor - Viewing fields

The Fields list provides the following attributes of each field of the view:

Field Name

Field Type

Not Null

Description

For details see Fields.

If necessary, you can also use the Field Description area to supply a description for each field.


Managing keys

The Keys tab is provided for managing view keys. Note that the tab is only available when you edit an existing view.

Double-click a key to open the Key Editor for editing the key.

Right-click a key to display the context menu allowing you to create new, edit, or drop the selected key. Using the menu you can also export the list of the view keys to any of supported formats.

View Editor - Managing keys

The Keys list provides the following attributes of each key of the view:

Key Name

Columns

Primary

Disabled

For details see Keys.


Managing foreign keys

The Foreign Keys tab is provided for managing view foreign keys. Note that the tab is only available when you edit an existing view.

Double-click a foreign key to open the Foreign Key Editor for editing the foreign key.

Right-click a foreign key to display the context menu allowing you to create new, edit, or drop the selected foreign key. Using the menu you can also export the list of the view foreign keys to any of supported formats.

View Editor - Managing foreign keys

The Foreign Keys list provides the following attributes of each foreign key of the view:

Foreign Key Name

Columns

Foreign Table

Foreign Columns

Disabled

For details see Foreign Keys.


Managing triggers

The Triggers tab is provided for managing view triggers. Note that the tab is only available when you edit an existing view.

Double-click a trigger to open the Trigger Editor for editing the trigger.

Right-click a trigger to display the context menu allowing you to create new, edit, drop, duplicate, enable/disable the selected trigger, or enable/disable all triggers. Using the menu you can also export the list of the view triggers to any of supported formats.

View Editor - Managing triggers

The Triggers list provides the following attributes of each trigger of the view:

Name

For Each Row

Type

Insert

Update

Delete

Disabled

For details see Triggers.


Working with data

The Data tab displays the view data as a grid by default (see Data View for details). The context menu of this tab and the Navigation bar allow you to Export Data, Import Data, Export as SQL Script.

While working with view data, you are provided with a number of filtering and grouping facilities.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Data management tools are also available through the Navigation bar and toolbar of View Editor.

View Editor - Working with data

Note: You can add a restore point before changing data, to get an opportunity to flash back to the current data state.

Click iconAddRestorePoint Add restore point on the Navigation bar or toolbar to open the Add restore point dialog. For details see Adding restore point.

See also:

Working with table data

Data View


Procedures

A procedure is a group of PL/SQL statements that you can call by name. A call specification (sometimes called call spec) declares a Java method or a third-generation language (3GL) routine so that it can be called from SQL and PL/SQL. The call spec tells Oracle which Java method to invoke when a call is made. It also tells the database what type conversions to make for the arguments and return value.

=

Procedure Editor allows you to create a new procedure, execute the existing procedure or edit its definition. It opens automatically when you create a new procedure and is available on editing an existing one.

To open a procedure in Procedure Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing procedure
  • Browsing procedure parameters
  • Specifying input parameters
  • Executing procedure/function
  • Browsing object dependencies
  • Viewing DDL definition

See also:

Using PL/SQL Code Debugger


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Procedure Editor.

Procedure Editor - Using Navigation bar

The Navigation bar of Procedure Editor allows you to:

Object

iconDB select a database

select a procedure for editing

General

iconCompile compile the procedure (if it is being created/modified)

iconExecute execute the procedure

iconDebug debug the procedure

iconPrint set printing options to print metadata of the procedure

view the dependency tree for the procedure

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the procedure:

Data Management

iconCommit commit transaction

iconRollback rollback transaction

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing procedure

Use the Procedure tab of Procedure Editor to create/edit a stored procedure and specify its properties.

Procedure Editor - Editing procedure definition

Name

View the name of the procedure being edited or created.

Schema

View schema in which the procedure will be created.

The lower area of the editor window allows you to specify the procedure definition. The DDL tab will display the changes made to the procedure specification.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Browsing procedure parameters

The Parameters tab is provided for browsing the list of parameters of the stored procedure.

Right-click the list to display the popup menu allowing you to export this list to any of supported formats.

Procedure Editor - Browsing procedure parameters

The parameter list provides the following attributes of each parameter used in the procedure:

Name

Data Type

Length

Scale

Precision

Default Value

Output

To execute a procedure, you can use the btnExecuteQuery Execute item available within the Navigation bar.


Specifying input parameters

If the stored procedure (or user-defined function) has parameters, the Input Parameter dialog appears before the procedure execution. It allows you to specify the data type, ANSI/Unicode string and values for all procedure parameters. After changes are done, click the OK button to execute the stored procedure, or the Cancel button to abort the execution.

Procedure Editor - Specifying input parameters

See also:

Executing procedure/function


Executing procedure/function

Procedure Editor / Function Editor provide an ability to execute procedures and functions. Click the btnExecuteQuery Execute item of the Navigation bar or use the corresponding toolbar button to execute the procedure/function.

If the procedure/function has input parameters, SQL Manager allows you to specify the values for these parameters in the Input Parameters dialog which appears just before execution.

The result of the successfully executed procedure/function, as well as the error message in case of execution failure, appears in the message panel at the bottom of the Procedure Editor / Function Editor window.

Procedure Editor - Executing procedure

Note: If any unsaved changes are applied to the procedure being currently edited, the execution of the procedure is impossible unless changes are saved through the Compile item of the Navigation bar.

See also:

Specifying input parameters

Procedure Editor

Function Editor


Functions

A stored function (also called a user function or user-defined function) is a set of PL/SQL statements you can call by name. Stored functions are very similar to procedures, except that a function returns a value to the environment in which it is called. User functions can be used as part of a SQL expression.

Function Editor allows you to define function properties. It opens automatically when you create a new function and is available on editing an existing one.

To open a function in Function Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing function
  • Browsing function parameters
  • Executing procedure/function
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition

See also:

Using PL/SQL Code Debugger


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Function Editor.

Function Editor - Using Navigation bar

The Navigation bar of Function Editor allows you to:

Object

iconDB select a database

select a function for editing

General

iconCompile compile the function (if it is being created/modified)

iconExecute execute the function

iconDebug debug the function

iconPrint set printing options to print metadata of the function

view the dependency tree for the function

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the function:

Data Management

iconCommit commit transaction

iconRollback rollback transaction

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing function

Use the Function tab of Function Editor to create/edit a user-defined function and specify its properties.

Function Editor - Editing function definition

Name

Specify the name of the function to be created, or view the name of the function being edited. Note that the function name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the function will be created.

The lower area of the editor window allows you to specify the function definition. The DDL tab will display the changes made to the function specification.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Browsing function parameters

The Parameters tab is provided for browsing the list of parameters of the user-defined function.

Right-click the list to display the popup menu allowing you to export this list to any of supported formats.

Function Editor - Browsing function parameters

The parameter list provides the following attributes of each parameter used in the function:

Name

Data Type

Length

Scale

Precision

Default Value

Output

To execute a function, you can use the btnExecuteQuery Execute item available within the Navigation bar.


Triggers

A trigger is an anonymous PL/SQL block or a call to a procedure implemented in PL/SQL or Java.

Oracle automatically executes a trigger when specified conditions occur.

Trigger Editor allows you to define trigger properties. It opens automatically when you create a new trigger and is available on editing an existing one.

To open a trigger in Trigger Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing trigger
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Trigger Editor.

Trigger Editor - Using Navigation bar

The Navigation bar of Trigger Editor allows you to:

Object

iconDB select a database

select a trigger for editing

General

iconCompile compile the trigger (if it is being created/modified)

iconPrint set printing options to print metadata of the trigger

view the dependency tree for the trigger

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the trigger:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing trigger

Use the Trigger tab of Trigger Editor to create/edit a trigger and specify its properties.

Note: Trigger can be launched/stopped within the appropriate object context menu item in the DB Explorer.

Name

Specify the name of the trigger to be created, or view the name of the trigger being edited. Note that the trigger name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the trigger will be created.

Trigger Editor - Editing trigger definition

Object schema

Use the drop-down list to specify the schema containing the table/view for which the trigger is defined.

Object name

Use the drop-down list to identify the table/view for which the trigger is created.

The FOLLOWS group is available for Oracle 11.

This group allows you to specify the relative firing order of triggers of the same type.

Follow schema

Use the drop-down list to specify the schema containing the trigger to be fired before the trigger being created/edited.

Follow trigger

Use the drop-down list to select the trigger after which the trigger being created/edited should fire.

CheckBox Disabled

Disables the trigger immediately after it is created. A disabled trigger still exists as an object in the database, but does not fire.

Trigger on

This group allows you to specify the database object on which the trigger is defined:

RadioButton Table

RadioButton View

For each

Specify whether a row trigger or statement trigger is to be defined:

RadioButton Row

Designates the trigger as a row trigger. Oracle fires a row trigger once for each row that is affected by the triggering statement and meets the optional trigger constraint defined in the WHEN condition.

RadioButton Statement

Designates the trigger as a statement trigger. Oracle fires a statement trigger only once when the triggering statement is issued if the optional trigger constraint is met.

Trigger type

This group allows you to specify when the trigger should fire:

RadioButton Before (indicates that the trigger will fire before executing the triggering event; for row triggers, the trigger is fired before each affected row is changed)

RadioButton After (indicates that the trigger will fire after executing the triggering event, for row triggers, the trigger is fired after each affected row is changed)

RadioButton Instead of (only available for views; indicates that the trigger will fire instead of executing the triggering event)

RadioButton Compound (defines a compound trigger on a DML event; the body of a COMPOUND trigger can have up to four sections, so that you can specify a before statement, before row, after row, or after statement operation in one trigger)

On Event

Use this group to specify DML statements that can cause the trigger to fire. Oracle fires the trigger in the existing user transaction.

CheckBox Insert

The trigger is fired whenever an INSERT statement adds a row to a table or adds an element to a nested table.

CheckBox Delete

The trigger is fired whenever a DELETE statement removes a row from the table or removes an element from a nested table.

CheckBox Update

The trigger is fired whenever an UPDATE statement changes a value in one of the columns of the table or nested table.

References

Use this group to specify the correlation names. You can use correlation names in the PL/SQL block and WHEN condition of a row trigger to refer specifically to old and new values of the current row.

If your row trigger is associated with a table named OLD or NEW, use the Old as and New as boxes to specify different correlation names to avoid confusion between the table name and the correlation name. If the trigger is defined on a nested table, then OLD and NEW refer to the row of the nested table, and PARENT refers to the current row of the parent table.

Fields

This section allows you to select fields for which trigger will fire. Use the navigation buttons to fill Selected area with required fields. Note that this feature is available only with CheckBox Update option checked in the On event section.

Body

Use this tab to specify the trigger body which consists of an optional list of local variables and their data types and a block of statements in Oracle procedure and trigger language, bracketed by BEGIN and END. These statements are executed when the trigger fires.

Select the trigger code source: it can be a PL/SQL block or a stored procedure call.

RadioButton PL/SQL Block

Specify the PL/SQL block or PL/SQL compound trigger block that Oracle executes to fire the trigger.

RadioButton Use existing procedure

This option allows you to call a stored procedure rather than specifying the trigger code inline as a PL/SQL block.

When

Use this tab to specify the trigger condition, which is a SQL condition that must be satisfied for the database to fire the trigger. This condition must contain correlation names and cannot contain a query.

qiery

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


DB and Schema Triggers

A database trigger is:

  • a stored PL/SQL block associated with a schema, or the database or
  • an anonymous PL/SQL block or a call to a procedure implemented in PL/SQL or Java

Oracle automatically executes a trigger when specified conditions occur.

DB/Schema Trigger Editor allows you to define database and schema trigger properties. It opens automatically when you create a new database or schema trigger and is available on editing an existing one.

To open a database or schema trigger in DB/Schema Trigger Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing DB/schema trigger
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in DB/Schema Trigger Editor.

DB and Schema Trigger Editor - Using Navigation bar

The Navigation bar of DB/Schema Trigger Editor allows you to:

Object

iconDB select a database

select a database/schema trigger for editing

General

iconCompile compile the trigger (if it is being created/modified)

iconPrint set printing options to print metadata of the trigger

view the dependency tree for the trigger

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the trigger:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing DB/schema trigger

Use the Trigger tab of DB/Schema Trigger Editor to create/edit a database or schema trigger and specify its properties.

Name

Specify the name of the database or schema trigger to be created, or view the name of the trigger being edited. Note that the trigger name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the trigger will be created.

DB and Schema Trigger Editor - Editing trigger definition

CheckBox Disabled

Disables the database/schema trigger immediately after it is created. A disabled trigger still exists as an object in the database, but does not fire.

Trigger type

This group allows you to specify when the trigger should fire:

RadioButton Before (indicates that the trigger will fire before executing the triggering event)

RadioButton After (indicates that the trigger will fire after executing the triggering event)

Trigger on

This group allows you to specify whether a database or schema trigger is defined:

RadioButton Database (defines the trigger on the entire database; the trigger fires whenever any database user initiates the triggering event)

RadioButton Schema (defines the trigger on the current schema; the trigger fires whenever any user connected as the specified schema initiates the triggering event; use the drop-down list to select the schema)

On Event

Specify whether the type of event for the trigger:

RadioButton DDL

Indicates that the trigger will fire whenever any of specified DDL statements is issued.

Specify one or more types of DDL statements that can cause the trigger to fire. Oracle fires the trigger in the existing user transaction.

RadioButton Database

Indicates that the trigger will fire when a specified database event occurs.

Specify one or more particular states of the database that can cause the trigger to fire. For each of the triggering events, Oracle opens an autonomous transaction scope, fires the trigger, and commits any separate transaction (regardless of any existing user transaction).

Body

Use this tab to specify the trigger body which consists of an optional list of local variables and their data types and a block of statements in Oracle procedure and trigger language, bracketed by BEGIN and END. These statements are executed when the trigger fires.

Select the trigger code source: it can be a PL/SQL block or a stored procedure call.

RadioButton Use PL/SQL block

Specify the PL/SQL block that Oracle executes to fire the trigger.

RadioButton Use existing procedure

This option allows you to call a stored procedure rather than specifying the trigger code inline as a PL/SQL block.

When

Use this tab to specify the trigger condition, which is a SQL condition that must be satisfied for the database to fire the trigger. This condition must contain correlation names and cannot contain a query.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Indexes

An index is a schema object that contains an entry for each value that appears in the indexed column(s) of the table or cluster and provides direct, fast access to rows.

Index Editor allows you to define index properties. It opens automatically when you create a new index and is available on editing an existing one.

To open an index in Index Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing index
  • Partitions
  • Setting storage attributes
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Index Editor.

Index Editor - Using Navigation bar

The Navigation bar of Index Editor allows you to:

Object

iconDB select a database

select an index for editing

General

iconCompile compile the index (if it is being created/modified)

iconPrint set printing options to print metadata of the index

view the dependency tree for the index

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the index:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing index

Use the Index tab of Index Editor to create/edit an index and specify its properties.

Name

Specify the name of the index to be created, or view the name of the index being edited. Note that the index name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the index will be created.

Index Editor - Editing index definition

Table schema / Cluster schema

Use the drop-down list to specify the schema containing the table/cluster on which the index is defined.

Table name / Cluster name

Use the drop-down list to identify the table/cluster for which the index is created.

Specify partitioning

Use the drop-down list to select the partitioning of the index:

GLOBAL (indicates that the partitioning of the index is user defined and is not equipartitioned with the underlying table)

LOCAL (indicates that the index is partitioned on the same columns, with the same number of partitions and the same partition bounds as the table)

NON-PARTITIONED

Options

CheckBox Logging

Specify whether the creation of the index will be logged or not in the redo log file.

CheckBox Reverse

Enable this option to store the bytes of the index block in reverse order, excluding the rowid.

CheckBox No sort

Select this option to indicate to the database that the rows are already stored in the database in ascending order, so that Oracle does not have to sort the rows when creating the index.

CheckBox Invisible

Check this option to set the index invisible for the cost-based optimizer.This option is only supported in Oracle version 11.0 and higher.

Index type

This group allows you to specify the index type:

RadioButton Table index

RadioButton Cluster index

Uniqueness

This group allows you to specify the uniqueness property for the index:

RadioButton Unique (indicates that the value of the column(s) upon which the index is based must be unique)

RadioButton Non-Unique

Key compress

RadioButton No Compress

Disables key compression.

RadioButton Compress ... columns

Enables key compression, which eliminates repeated occurrence of key column values and may substantially reduce storage. Use the spinner control to specify the prefix length (number of prefix columns to compress).

The Columns area allows you to specify one or more table columns for the index.

To select a column, you need to move it from the Table Columns list to the Index Columns list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Use the [image] [image] buttons to move the columns up an down within the Index Columns list.

Use the btnAddExpression Add expression and btnDeleteExpression Delete expression buttons to add/delete the expression built from columns of table, constants, SQL functions, and user-defined functions.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Packages

A package is an encapsulated collection of related procedures, functions, and other program objects stored together in the database. The package specification declares these objects. The package body, specified subsequently, defines these objects.

Packages are an alternative to creating procedures and functions as standalone schema objects.

Package Editor allows you to define package properties. It opens automatically when you create a new package and is available on editing an existing one.

To open a package in Package Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing package
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Package Editor.

Package Editor - Using Navigation bar

The Navigation bar of Package Editor allows you to:

Object

iconDB select a database

select a package for editing

General

iconCompile compile the package (if it is being created/modified)

iconPrint set printing options to print metadata of the package

view the dependency tree for the package

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the package:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing package

Use the Package tab of Package Editor to create/edit the specification of a package.

Name

Specify the name of the package to be created, or view the name of the package being edited. Note that the package name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the package will be created.

The lower area of the editor window allows you to specify the package definition, which can contain type definitions, cursor declarations, variable declarations, constant declarations, exception declarations, PL/SQL subprogram specifications, and call specifications, which are declarations of a C or Java routine expressed in PL/SQL. The DDL tab will display the changes made to the package specification.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

Package Editor - Editing package definition

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Package Bodies

Package body is a body of a stored package, which is an encapsulated collection of related procedures, stored functions, and other program objects stored together in the database. The package body defines these objects. The package specification, defined while creating package, declares these objects.

Package Body Editor allows you to define package body properties. It opens automatically when you create a new package body and is available on editing an existing one.

To open a package body in Package Body Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing package body
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Package Body Editor.

Package Body Editor - Using Navigation bar

The Navigation bar of Package Body Editor allows you to:

Object

iconDB select a database

select a package body for editing

General

iconCompile compile the package body (if it is being created/modified)

iconPrint set printing options to print metadata of the package body

view the dependency tree for the package body

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the package body:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing package body

Use the Package Body tab of Package Body Editor to create/edit the specification of a package body.

Name

Specify the name of the package body to be created, or view the name of the package body being edited. Note that the package body name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the package body will be created.

The lower area of the editor window allows you to specify the package body definition, which can contain PL/SQL subprogram bodies or call specifications, which are declarations of a C or Java routine expressed in PL/SQL. The DDL tab will display the changes made to the package body specification.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

Package Body Editor - Editing Package Body definition

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Sequences

A Sequence is a database object from which multiple users may generate unique integers. You can use sequences to automatically generate primary key values. When a sequence number is generated, the sequence is incremented, independent of the transaction committing or rolling back. If two users concurrently increment the same sequence, then the sequence numbers each user acquires may have gaps, because sequence numbers are being generated by the other user. One user can never acquire the sequence number generated by another user. After a sequence value is generated by one user, that user can continue to access that value regardless of whether the sequence is incremented by another user.

Sequence Editor allows you to define sequence properties. It opens automatically when you create a new sequence and is available on editing an existing one.

To open a sequence in Sequence Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing sequence
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Sequence Editor.

Sequence Editor - Using Navigation bar

The Navigation bar of Sequence Editor allows you to:

Object

iconDB select a database

select a sequence for editing

General

iconCompile compile the sequence (if it is being created)

iconPrint set printing options to print metadata of the sequence

view the dependency tree for the sequence

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the sequence:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing sequence

Use the Sequence tab of Sequence Editor to create/edit a sequence and specify its properties.

Name

Specify the name of the sequence to be created, or view the name of the sequence being edited. Note that the sequence name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the sequence will be created.

Sequence Editor - Editing sequence definition

Start with

Specify the first sequence number to be generated, or select DEFAULT from the drop-down list. Use this setting to start an ascending sequence at a value greater than its minimum or to start a descending sequence at a value less than its maximum.

Increment

Specify which value is added to the current sequence value to create a new value, or select DEFAULT from the drop-down list. A positive value will make an ascending sequence, a negative one - a descending sequence. The default value is 1.

Min value

Specify the minimum value of the sequence, or select DEFAULT from the drop-down list.

Max value

Specify the maximum value for the sequence, or select DEFAULT from the drop-down list.

Cache

Specify how many sequence numbers are to be preallocated and stored in memory for faster access, or select DEFAULT or NOCACHE from the drop-down list.

CheckBox Cycle

This option indicates that the sequence continues to generate values after reaching either its maximum or minimum value. After an ascending sequence reaches its maximum value, it generates its minimum value. After a descending sequence reaches its minimum, it generates its maximum value.

CheckBox Order

Use this option to guarantee that sequence numbers are generated in order of request.

CheckBox Keep

Check this option if you want NEXTVAL to retain its original value during replay for Application Continuity.

CheckBox Session

Check this option to create a session sequence, which is a special type of sequence that is specifically designed to be used with global temporary tables that have session visibility. A session sequence returns a unique range of sequence numbers only within a session, but not across sessions.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Clusters

A Cluster is a schema object that contains data from one or more tables, all of which have one or more columns in common. Oracle stores together all the rows from all the tables that share the same cluster key.

Cluster Editor allows you to define cluster properties. It opens automatically when you create a new cluster and is available on editing an existing one.

To open a cluster in Cluster Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing cluster
  • Setting storage attributes
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Cluster Editor.

Cluster Editor - Using Navigation bar

The Navigation bar of Cluster Editor allows you to:

Object

iconDB select a database

select a cluster for editing

General

iconCompile compile the cluster (if it is being created)

iconPrint set printing options to print metadata of the cluster

view the dependency tree for the cluster

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

call Truncate Wizard to truncate the cluster

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the cluster:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing cluster

Use the Cluster tab of Cluster Editor to create/edit a cluster and specify its properties.

Name

Specify the name of the cluster to be created, or view the name of the cluster being edited. Note that the cluster name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the cluster will be created.

Cluster Editor - Editing cluster definition

Cluster size

Specify the amount of space (in bytes) reserved to store all rows with the same cluster key value or the same hash value, or select DEFAULT from the drop-down list. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

Define the type of the cluster:

RadioButton Index cluster

Specifies an Index cluster. Oracle stores together rows having the same cluster key value. Each distinct cluster key value is stored only once in each data block, regardless of the number of tables and rows in which it occurs.

RadioButton Hash cluster

Specifies a Hash cluster. Oracle stores together rows that have the same hash key value. The hash value for a row is the value returned by the hash function of the cluster.

RadioButton Hash Single-Table

Specifies a Hash Single-Table, i.e. the cluster is a type of hash cluster containing only one table. This cluster type can provide faster access to rows than would result if the table were not part of a cluster.

If you choose to create a hash cluster, you should specify Hash Cluster options.

Number of hash keys

Use the spinner control to specify the number of hash values for the hash cluster. The minimum value for this parameter is 2.

Hash Function

Specify the hash function for the hash cluster:

RadioButton Default

Indicates that an internal hash function will be used for the hash cluster.

RadioButton Expression

Specify an expression to be used as the hash function for the hash cluster.

Cluster columns

The list displays columns in the cluster key as a grid with the following columns: Name, Type, Size, Scale. You can specify up to 16 cluster key columns. These columns must correspond in both datatype and size to columns in each of the clustered tables, although they need not correspond in name.

Right-click an item within the list to call the context menu allowing you to add a new column, insert a column, or delete the selected column from the list.

Column management tools are also available through the Navigation bar of Cluster Editor.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Materialized Views

A Materialized view is a database object that contains the results of a query. The FROM clause of the query can name tables, views, and other materialized views. Collectively these objects are called master tables (a replication term) or detail tables (a data warehousing term).

Materialized View Editor allows you to define materialized view properties. It opens automatically when you create a new materialized view and is available on editing an existing one.

To open a materialized view in Materialized View Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing materialized view
  • Managing fields
  • Setting Refresh parameters
  • Setting storage attributes
  • Setting USING INDEX parameters
  • Working with data
  • Browsing object dependencies
  • Editing object description
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Materialized View Editor.

Materialized View Editor - Using Navigation bar

The Navigation bar of Materialized View Editor allows you to:

Object

iconDB select a database

select a materialized view for editing

General

iconCompile compile the materialized view (if it is being created/modified)

iconPrint set printing options to print metadata of the materialized view

edit the materialized view query using Design Query

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

View

view the dependency tree for the materialized view

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the materialized view:

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export data from the materialized view using Export Data Wizard

export data from the materialized view as Execute Script using Export as SQL Script Wizard

import data

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing materialized view

Use the Materialized view tab of Materialized View Editor to create/edit a materialized view and specify its properties.

Name

Specify the name of the materialized view to be created, or view the name of the materialized view being edited. Note that the materialized view name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the materialized view will be created.

Materialized View Editor - Editing Materialized View definition

CheckBox On prebuilt table

The option lets you register an existing table as a preinitialized materialized view. This option is particularly useful for registering large materialized views in a data warehousing environment.

CheckBox Updatable

Select this option to allow a subquery, primary key, object, or rowid materialized view to be updated.

CheckBox Reduced precision

Select this option to authorize the loss of precision, if the precision of the table or materialized view columns do not exactly match the precision returned by subquery.

CheckBox Partitioning

Select this option to create a partitioned materialized view.

Materialized view type

Select the type of index organization for the materialized view:

RadioButton Default

RadioButton Organization index

Specifies an index-organized materialized view. In such a materialized view, data rows are stored in an index defined on the primary key of the materialized view.

Compress

Use these options to instruct the database whether to compress data segments to reduce disk and memory use:

RadioButton None

RadioButton Compress

RadioButton Nocompress

Rewrite query

This group allows you to specify whether the materialized view is eligible to be used for query rewrite:

RadioButton None

RadioButton Enabled

RadioButton Disabled

Logging

Use this group to establish the logging characteristics for the materialized view (the default is the logging characteristic of the tablespace in which the materialized view resides):

RadioButton Logging

RadioButton Nologging

Cache

These attributes can be used for data that will be accessed frequently:

RadioButton Cache

Specifies that the blocks retrieved for this table are placed at the most recently used end of the least recently used (LRU) list in the buffer cache when a full table scan is performed. This attribute is useful for small lookup tables.

RadioButton Nocache

Specifies that the blocks are placed at the least recently used end of the LRU list.

Cluster schema / Cluster name / Subquery cluster fields

This group of controls allows you create the materialized view as part of the specified cluster. A cluster materialized view uses the space allocation of the cluster.

The Subquery area of the editor window allows you to specify the defining query of the materialized view. When you create the materialized

view, Oracle Database executes this subquery and places the results in the materialized view. This subquery is any valid SQL subquery.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Managing fields

The Fields tab is provided for viewing fields represented in the materialized view. Note that the tab is only available when you edit an existing materialized view.

Right-click a field to display the context menu allowing you to export field name list or copy it to clipboard.

Materialized View Editor - Viewing fields

The Fields list provides the following attributes of each field of the materialized view:

Field Name

Field Type

Not Null

Unique

Default Value

Description

For details see Fields.

If necessary, you can also use the Field Description area to supply a description for each field.


Setting refresh parameters

The Refresh tab allows you to specify the default methods, modes, and times for the database to refresh the materialized view. If the master tables of a materialized view are modified, then the data in the materialized view must be updated to make the materialized view accurately reflect the data currently in its master tables. Here you can schedule the times and specify the method and mode for the database to refresh the materialized view.

Refresh

This group allows you to enable/disable refresh for the materialized view:

RadioButton Do not define refresh options

RadioButton Define refresh options

Materialized View Editor - Setting Refresh parameters

Refresh type

Specify the preferable refresh type:

RadioButton None

RadioButton Never (prevents the materialized view from being refreshed with any Oracle Database refresh mechanism or packaged procedure)

RadioButton Fast (indicates the incremental refresh method, which performs the refresh according to the changes that have occurred to the master tables)

RadioButton Complete (indicates the complete refresh method, which is implemented by executing the defining query of the materialized view)

RadioButton Force (indicates that when a refresh occurs, Oracle Database will perform a fast refresh if one is possible or a complete refresh if fast refresh is not possible)

Refresh time type

Specify the preferable refresh time type:

RadioButton None

RadioButton On commit (indicates that a fast refresh is to occur whenever the database commits a transaction that operates on a master table of the materialized view)

RadioButton On demand (indicates that the materialized view will be refreshed on demand by calling one of the refresh procedures)

RadioButton Automatic (indicates that the materialized view will be refreshed automatically at the specified time)

Refresh method

Specify the preferable refresh method:

RadioButton None

RadioButton Primary key (specifies a primary key materialized view which allows materialized view master table to be reorganized without affecting the eligibility of the materialized view for fast refresh)

RadioButton RowID (specifies a rowid materialized view which is useful if the materialized view does not include all primary key columns of the master table)

Specify the START WITH and NEXT values for automatic refresh using the corresponding controls. For your convenience the date editor is implemented: click the arrow-down button to call the date editor popup window.

Start with

Specify a datetime expression for the first automatic refresh time.

Next

Specify a datetime expression for calculating the interval between automatic refreshes.


Setting USING INDEX parameters

The Using index tab allows you to establish parameters for the default index Oracle uses to maintain the materialized view data.

Using index

This group allows you to enable/disable using index and setting index storage attributes for the materialized view:

RadioButton Do not define index storage

RadioButton Using index

RadioButton Using no index

If Using index is not specified, then default values are used for the index. Oracle uses the default index to speed up incremental (FAST) refresh of the materialized view.

Materialized View Editor - Setting index parameters

Specify Physical attributes, Extents, Space usage and Free lists for the index. For details refer to the Storage attributes page.


Working with data

The Data tab displays the materialized view data as a grid by default (see Data View for details). Note that the tab is only available when you edit an existing materialized view. The context menu of this tab allows you to Export Data, Import Data, Export as SQL Script.

Data management tools are also available through the Navigation bar of Materialized View Editor.

Materialized View Editor - Working with data

See also:

Working with table data


Partitioning

The Partitioning tab is provided for setting up partitioning parameters for a partitioned materialized view. It appears when the CheckBox Partitioning option is enabled at the main tab of the editor.

Materialized View Editor - Partitioning

Partitioning by

Range

Select this item to partition the materialized view on ranges of values from the column list. For an index-organized materialized view, the column list must be a subset of the primary key columns of the materialized view.

Hash

Select this item to specify that the materialized view is to be partitioned using the hash method. Oracle Database assigns rows to partitions using a hash function on values found in columns designated as the partitioning key.

List

Select this item to partition the materialized view on lists of literal values from column. List partitioning is useful for controlling how individual rows map to specific partitions.

Partition keys

Use this group to specify an ordered list of columns used to determine into which partition a row belongs. These columns are the partitioning key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

CheckBox Composite

If this option is selected, the materialized view is first partitioned by range, and then the partitions are further partitioned into range, hash, or list sub-partitions.

Sub-partition keys

Use this group to specify an ordered list of columns used to determine into which sub-partition a row belongs. These columns are the sub-partitioning key.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Sub-partitioning by

Use the drop-down list to indicate the type of sub-partitioning you want for each composite range partition: hash or list.

Partitions

This area allows you to specify individual partitions. Right-click within the list area to call the context menu allowing you to create a new partition, edit or delete the selected partition.

Values

Specify the non-inclusive upper bound for the current partition. The value list is an ordered list of literal values corresponding to the column list.


Materialized View Logs

A Materialized view log is a table associated with the master table of a materialized view.

When DML changes are made to master table data, Oracle Database stores rows describing those changes in the materialized view log and then uses the materialized view log to refresh materialized views based on the master table.

Materialized View Log Editor allows you to define materialized view log properties. It opens automatically when you create a new materialized view log and is available on editing an existing one.

To open a materialized view log in Materialized View Log Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing materialized view log
  • Setting storage attributes
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Materialized View Log Editor.

Materialized View Log Editor - Using Navigation bar

The Navigation bar of Materialized View Log Editor allows you to:

Object

iconDB select a database

select a materialized view log for editing

General

iconCompile compile the materialized view log (if it is being created/modified)

iconPrint set printing options to print metadata of the materialized view log

edit the materialized view log query using Design Query

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

View

view the dependency tree for the materialized view log

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the materialized view log:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing materialized view log

Use the Materialized view log tab of Materialized View Log Editor to create/edit a materialized view log and specify its properties.

Log table name

Displays the name of the materialized view log table.

Schema

Use the drop-down list to specify the schema containing the materialized view log master table.

Master table

Use the drop-down list to specify the name of the master table for which the materialized view log is to be created.

Materialized View Log Editor - Editing Materialized View Log definition

Cache

These attributes can be used for data that will be accessed frequently:

RadioButton Cache

Specifies that the blocks retrieved for this log are placed at the most recently used end of the least recently used (LRU) list in the buffer cache when a full table scan is performed. This attribute is useful for small lookup tables.

RadioButton Nocache

Specifies that the blocks are placed at the least recently used end of the LRU list.

Logging

This group allows you to establish the logging characteristics for the materialized view log:

RadioButton Logging

RadioButton Nologging

New values

This group allows you to determine whether Oracle saves both old and new values for update DML operations in the materialized view log.

RadioButton Default

Specifies the default behavior for new values.

RadioButton Including

Specifies that both new and old values are saved in the log.

RadioButton Excluding

Disables the recording of new values in the log. You can use this option to avoid the overhead of recording new values.

With ...

Use the With group to indicate whether the materialized view log should record the primary key, rowid, object ID, or a combination of these row identifiers when rows in the master are changed.

CheckBox With object ID

Indicates that the system-generated or user-defined object identifier of every modified row should be recorded in the materialized view log.

CheckBox With primary key

Indicates that the primary key of all rows changed should be recorded in the materialized view log.

CheckBox With ROWID

Indicates that the rowid of all rows changed should be recorded in the materialized view log.

CheckBox With sequence

Indicates that a sequence value providing additional ordering information should be recorded in the materialized view log. Sequence numbers are necessary to support fast refresh after some update scenarios.

CheckBox With filter columns

Select this option to include the filter columns whose values you want to be recorded in the materialized view log.

Fields for materialized view log

This group allows you to specify the fields whose values should be recorded in the materialized view log for all rows that are changed.

To select a field, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Synonyms

A Synonym is an alternative name for a table, view, sequence, procedure, stored function, package, materialized view, Java class schema object, user-defined object type, or another synonym. Synonyms can be used in place of their referenced base object in a number of SQL statements and expression contexts.

Synonym Editor allows you to define synonym properties. It opens automatically when you create a new synonym and is available on editing an existing one.

To open a synonym in Synonym Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing synonym
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Synonym Editor.

Synonym Editor - Using Navigation bar

The Navigation bar of Synonym Editor allows you to:

Object

iconDB select a database

select a synonym for editing

General

iconCompile compile the synonym (if it is being created/modified)

iconPrint set printing options to print metadata of the synonym

view the dependency tree for the synonym

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the synonym:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing synonym

Use the Synonym tab of Synonym Editor to create/edit a synonym and specify its properties.

Name

Specify the name of the synonym to be created, or view the name of the synonym being edited. Note that the synonym name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the synonym will be created.

Synonym Editor - Editing synonym definition

CheckBox Public synonym

Select this option to create a public synonym. Public synonyms are accessible to all users. However, each user must have appropriate privileges on the underlying object in order to use the synonym.

DB Link name

You can use this drop-down list to specify a complete or partial database link to create a synonym for a schema object on a remote database where the object is located.

Object schema

Use the drop-down list to select the schema where the base object resides.

Object name

Type in the name of the base object to be referenced by the synonym, or click the Select object button to specify an object using the Select object dialog.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Database Links

A Database link is a schema object in one database that enables you to access objects on another database. The other database need not be an Oracle system. However, to access non-Oracle systems, you must use Oracle Heterogeneous Services.

After you have created a database link, you can use it to refer to tables and views on the other database.

Database Link Editor allows you to define database link properties. It opens automatically when you create a new database link and is available on editing an existing one.

To open a database link in Database Link Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing database link
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Link Editor.

Database Link Editor - Using Navigation bar

The Navigation bar of Database Link Editor allows you to:

Object

iconDB select a database

select a database link for editing

General

iconCompile compile the database link (if it is being created/modified)

iconPrint set printing options to print metadata of the database link

view the dependency tree for the database link

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the database link:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing database link

Use the Database Link tab of Database Link Editor to create/edit a database link and specify its properties.

Name

Displays the unique name to be used across the database to represent the DB link.

Database Link Editor - Editing Database Link definition

CheckBox Public DB link

Use this option to create a public database link available to all users.

CheckBox Shared DB link

Select the option to use a single network connection to create a public database link that can be shared among multiple users.

CheckBox Use CURRENT_USER

Use this option to create a current user database link.

The current user must be a global user with a valid account on the remote database. If the database link is used directly, i.e. not from within a stored object, the current user is the same as the connected user.

Remote database connection

This group allows you to specify connection parameters for the remote database.

User name / Password

Specify the username and password used to connect to the remote database.

Remote database

Specify the service name of a remote database.

Authenticated by

Parameters of this group authenticate the user to the remote server and are required for security.

Schema / Password

Specify the username and password on the target instance.

The specified username and password must be a valid username and password on the remote instance. The username and password are used only for authentication.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Object Types

An Object type defines the name of the object type, its attributes (the variables that form the data structure), methods (the member subprograms that define the behavior of the object), and other properties.

Object Type Editor allows you to specify user-defined object type properties. It opens automatically when you create a new object type and is available on editing an existing one.

To open an object type in Object Type Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing object type
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Object Type Editor.

Object Type Editor - Using Navigation bar

The Navigation bar of Object Type Editor allows you to:

Object

iconDB select a database

select an object type for editing

General

iconCompile compile the object type (if it is being created/modified)

iconPrint set printing options to print metadata of the object type

view the dependency tree for the object type

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the object type:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing object type

Use the Object Type tab of Object Type Editor to create/edit the specification of an object type, a SQLJ object type, or an incomplete object type.

Name

Specify the name of the object type to be created, or view the name of the object type being edited. Note that the object type name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the object type will be created.

The lower area of the editor window allows you to specify the object type definition. The variables that form the data structure are called attributes. The member subprograms that define the behavior of the object are called methods. The keywords AS OBJECT are required when creating an object type. The DDL tab will display the changes made to the object type definition.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query Data area and Using the context menu.

Object Type Editor - Editing Object Type definition

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.

For more information on object types refer to the official Oracle documentation.


Object Type Bodies

You can create an Object type body to define or implement the member methods defined in the object type specification. The object type defines the name of the object type, its attributes, methods, and other properties. The object type body contains the code for the methods that implement the type.

Object Type Body Editor allows you to define object type body properties. It opens automatically when you create a new object type body and is available on editing an existing one.

To open an object type body in Object Type Body Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing object type body
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Object Type Body Editor.

Object Type Body Editor - Using Navigation bar

The Navigation bar of Object Type Body Editor allows you to:

Object

iconDB select a database

select an object type body for editing

General

iconCompile compile the object type body (if it is being created/modified)

iconPrint set printing options to print metadata of the object type body

view the dependency tree for the object type body

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompileWithDebugInfo compile with debug info

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the object type body:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing object type body

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Editing partition scheme definition

Use the Object Type Body tab of Object Type Body Editor to create/edit an object type body and specify its definition.

The object type body contains the code for the methods that implement the object type. For each method specified in an object type specification for which you did not specify the call specification, you must specify a corresponding method body in the object type body.

For your convenience the code folding, syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query data editor and Using the context menu.

Object Type Body Editor - Editing Object Type Body definition

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.

For more information on object type bodies refer to the official Oracle documentation.


Array Types

Oracle provides varying array (varray) type as an ordered set of elements, each of which has the same datatype, and the nested table type. Array Type Editor allows you to create the specification of a varray type or a named nested table type easily and quickly.

Array Type Editor allows you to define array type properties. It opens automatically when you create a new array type and is available on editing an existing one.

To open an array type in Array Type Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing array type
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Array Type Editor.

Array Type Editor - Using Navigation bar

The Navigation bar of Array Type Editor allows you to:

Object

iconDB select a database

select an array type for editing

General

iconCompile compile the array type (if it is being created/modified)

iconPrint set printing options to print metadata of the array type

view the dependency tree for the array type

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the array type:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing array type

Use the Array Type tab of Array Type Editor to create/edit an array type and specify its properties.

Name

Specify the name of the new array type or nested table type, or view the name of the array type / nested table type being edited. Note that the type name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the array type or nested table type will be created.

Array Type Editor - Editing Array Type definition

RadioButton Varray

Specifies the varray type (a type composed of an ordered set of elements, each of which has the same datatype).

Array size

Use the spinner control to specify a maximum limit for the array.

RadioButton Nested table

Specifies the nested table type.

Data type

Type

Use the drop-down list to select a built-in datatype, REF or <nested_object>.

If data type is an object type, then the nested table type describes a table whose columns match the name and attributes of the object type. If defined data type is a scalar type, then the nested table type describes a table with a single, scalar type column called COLUMN_VALUE.

Object schema

Use the drop-down list to select the schema containing the REF or object type.

Object

Use the drop-down list to select the REF or object type.

Size / Scale

Use the spinner controls to specify the size and/or scale (for numeric data types).

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Libraries

A Library is a schema object associated with an operating system shared library.

Library Editor allows you to define library properties. It opens automatically when you create a new library and is available on editing an existing one.

To open a library in Library Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing library
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Library Editor.

Library Editor - Using Navigation bar

The Navigation bar of Library Editor allows you to:

Object

iconDB select a database

select a library for editing

General

iconCompile compile the library (if it is being created/modified)

iconPrint set printing options to print metadata of the library

view the dependency tree for the library

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the library:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing library

Use the Library tab of Library Editor to create/edit a library and specify its properties.

Name

Specify the name that will represent the library to be created, or view the name of the library being edited. Note that the library name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the library will be created.

Library Editor - Editing library definition

Library filename

Specify the path and name of the shared library recognized by the operating system.

DB Link name

Use the drop-down list to specify a DB link (AGENT) if you want external procedures to be run from a database link other than the server.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Java Sources

Oracle allows you to use the CREATE JAVA statement to create specific schema objects containing Java sources, Java classes, or Java resources. Java Source Editor provides you with an ability to create a schema object containing a Java source easily and quickly.

Java Source Editor allows you to define Java source properties. It opens automatically when you create a new Java source and is available on editing an existing one.

To open a Java source in Java Source Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing Java source
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Java Source Editor.

Java Source Editor - Using Navigation bar

The Navigation bar of Java Source Editor allows you to:

Object

iconDB select a database

select a Java source for editing

General

iconCompile compile the Java source (if it is being created/modified)

iconPrint set printing options to print metadata of the Java source

view the dependency tree for the Java source

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the Java source:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing Java source

Use the Java Source tab of Java Source Editor to specify Java source properties.

Name

This field specifies the name of the schema object in which the source code is held. Upon successful creation of the Java source Oracle creates additional schema objects to hold each of the Java classes defined by the source.

Schema

This field specifies the schema in which the object containing the Java source code resides.

Java Source Editor - Editing Java Source definition

CheckBox Auto compile

If this option is selected, Java source compilation occurs automatically.

Resolver

Specify a mapping of the fully qualified Java name to the Java source schema object.

The lower area of the editor window allows you to specify a sequence of characters for the Java source. The DDL tab will display the changes made to the Java source code within the AS clause.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Java Classes

Oracle allows you to use the CREATE JAVA statement to create specific schema objects containing Java sources, Java classes, or Java resources. Java Class Editor provides you with an ability to create a schema object containing a Java class easily and quickly.

Java Class Editor allows you to define Java class properties. It opens automatically when you create a new Java class and is available on editing an existing one.

To open a Java class in Java Class Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing Java class
  • Browsing object dependencies


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Java Class Editor.

Java Class Editor - Using Navigation bar

The Navigation bar of Java Class Editor allows you to:

Object

iconDB select a database

select a Java class for editing

General

iconCompile compile the Java class (if it is being created/modified)

iconPrint set printing options to print metadata of the Java class

view the dependency tree for the Java class

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the Java class:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing Java class

Use the Java Class tab of Java Class Editor to specify Java class properties.

Name

This field displays the name of the Java class.

Java Class Editor - Editing Java Class definition

Server file name

Specify the name of a previously created server file on the operating system.

Directory

Use the drop-down list to specify the directory object for the file containing the binary sequence.

Resolver

Specify a mapping of the fully qualified Java name to the Java class schema object.

CheckBox Force

With this option deselected, the results of this CREATE command will be rolled back if Auto compile (RESOLVE or COMPILE) is specified and the resolution or compilation fails. With the option selected, no action is taken if the resolution or compilation fails; therefore, the created schema object remains.

CheckBox Auto compile

If this option is selected, resolution of referenced names to other class schema objects occurs automatically.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Java Resources

Oracle allows you to use the CREATE JAVA statement to create specific schema objects containing Java sources, Java classes, or Java resources. Java Resource Editor provides you with an ability to create a schema object containing a Java resource easily and quickly.

Java Resource Editor allows you to define Java resource properties. It opens automatically when you create a new Java resource and is available on editing an existing one.

To open a Java resource in Java Resource Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing Java resource
  • Browsing object dependencies


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Java Resource Editor.

Java Resource Editor - Using Navigation bar

The Navigation bar of Java Resource Editor allows you to:

Object

iconDB select a database

select a Java resource for editing

General

iconCompile compile the Java resource (if it is being created/modified)

iconPrint set printing options to print metadata of the Java resource

view the dependency tree for the Java resource

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the Java resource:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing Java resource

Use the Java Resource tab of Java Resource Editor to specify Java resource properties.

Name

This field specifies the name of the schema object to hold the Java resource.

Schema

This field specifies the schema in which the object containing the Java resource file resides.

Java Resource Editor - Editing Java Resource definition

Server file name

Specify the name of a previously created server file on the operating system.

Directory

Use the drop-down list to specify the directory object for the file containing the binary sequence.

Resolver

Specify a mapping of the fully qualified Java name to the Java resource schema object.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Index Types

Index type is an object that specifies the routines that manage a domain (application-specific) index. Index types reside in the same namespace as tables, views, and other schema objects. The index type name is bound to an implementation type, which in turn specifies and refers to user-defined index functions and procedures that implement the index type.

Index Type Editor allows you to define index type properties. It opens automatically when you create a new index type and is available on editing an existing one.

To open an index type in Index Type Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing index type
  • Browsing object dependencies
  • Editing object description
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Index Type Editor.

Index Type Editor - Using Navigation bar

The Navigation bar of Index Type Editor allows you to:

Object

iconDB select a database

select an index type for editing

General

iconCompile compile the index (if it is being created/modified)

iconPrint set printing options to print metadata of the index type

view the dependency tree for the index type

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the index type:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing index type

Use the Index type tab of Index Type Editor to create/edit an index type and specify its properties.

Name

Specify the name of the index type to be created, or view the name of the index type being edited. Note that the index type name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the index type will be created.

Index Type Editor - Editing Index Type definition

For operators

This group allows you to specify the list of operators supported by the index type.

Operator schema

Use the drop-down list to select the schema containing operator(s) for the index type.

To select an operator, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the operators from one list to another.

Implementation schema

Displays the schema containing the implementation type (must reside in the same schema as the index type).

Implementation object

Type in the name of the type that provides the implementation for the new index type.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Operators

Operators can be referenced by index types and by SQL queries and DML statements. The operators, in turn, reference functions, packages, types and other user-defined objects.

Operator Editor allows you to define operator properties. It opens automatically when you create a new operator and is available on editing an existing one.

To open an operator in Operator Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing operator
  • Adding operator binding
  • Browsing object dependencies
  • Editing object description
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Operator Editor.

Operator Editor - Using Navigation bar

The Navigation bar of Operator Editor allows you to:

Object

iconDB select a database

select an operator for editing

General

iconCompile compile the operator (if it is being created/modified)

iconSaveDescription save the operator description (if it has been modified)

iconPrint set printing options to print metadata of the operator

view the dependency tree for the operator

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the operator:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing operator

Use the Operator tab of Operator Editor to create/edit an operator and specify its properties.

Name

Specify the name of the operator to be created, or view the name of the operator being edited. Note that the operator name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the operator will be created.

Operator Editor - Editing Operator definition

Bindings

The list displays the existing operator bindings as a grid with the following columns: Parameter List, Return Type, Ancillary/Context, Using.

Right-click an item within the list to call the context menu allowing you to add a new binding and specify its properties using the Add Operator Binding dialog or delete the selected binding from the list.

Binding management tools are also available through the Add binding btnAddItem and Delete binding btnRemoveItem buttons.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Adding operator binding

The Add Operator Binding dialog allows you to define operator binding parameters in groups: Argument types, Implementation, Implementation type.

Operator Editor - Operator binding

Argument types

This group allows you to add/remove parameter data types for binding the operator to a function.

Object types schema name

Use the drop-down list to specify the schema containing object types.

To select an object type, you need to move it from the Available list to the Selected list. Use the Move to Selected Move to Available buttons or drag-and-drop operations to move the types from one list to another.

Return type

Use the drop-down list to specify the return data type for the binding.

Implementation

Use this group to describe the implementation of the binding.

Implementation object schema

Use the drop-down list to specify the schema containing the binding implementation object.

Implementation object name

Type in the name of the function that provides the implementation for the binding, or click the Select object button to specify a function, a package body or an object type using the Select object dialog.

Implementation type

RadioButton Ancillary

Use this type to indicate that the operator binding is ancillary to the specified primary operator binding. In this case you should fill the Ancillary operator schema and Ancillary operator fields.

RadioButton Context

Use this type to describe the functional implementation of a binding that is not ancillary to a primary operator binding. In this case you should fill the Scan context schema and Scan context fields.


Dimensions

A Dimension defines a parent-child relationship between pairs of column sets, where all the columns of a column set must come from the same table. However, columns in one column set (called a level) can come from a different table than columns in another set. The optimizer uses these relationships with materialized views to perform query rewrite.

Dimension Editor allows you to define dimension properties. It opens automatically when you create a new dimension and is available on editing an existing one.

To open a dimension in Dimension Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing dimension
  • Adding dimension level
  • Adding dimension hierarchy
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Dimension Editor.

Dimension Editor - Using Navigation bar

The Navigation bar of Dimension Editor allows you to:

Object

iconDB select a database

select a dimension for editing

General

iconCompile compile the dimension (if it is being created/modified)

iconPrint set printing options to print metadata of the dimension

view the dependency tree for the dimension

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the dimension:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing dimension

Use the Dimension tab of Dimension Editor to create/edit a dimension and specify its properties.

Name

Specify the name of the dimension to be created, or view the name of the dimension being edited. Note that the dimension name must be unique within its schema.

Schema

Use the drop-down list to specify the schema in which the dimension will be created.

Dimension Editor - Editing Dimension definition

Levels

A level defines dimension hierarchies and attributes. The list displays the existing levels as a grid with the following columns: Level Name, Level Columns, Attributes.

Right-click an item within the list to call the context menu allowing you to add a new level and specify its properties using the Add Dimension Level dialog or delete the selected level from the list.

Level management tools are also available through the Add level btnAddItem and Delete level btnRemoveItem buttons.

Hierarchies

The list displays the dimension hierarchies as a grid with the following columns: Hierarchy Name, Child Level, Parent Level, Joins.

Right-click an item within the list to call the context menu allowing you to add a new hierarchy and specify its properties using the Add Dimension Hierarchy dialog or delete the selected hierarchy from the list.

Hierarchy management tools are also available through the Add hierarchy btnAddItem and Delete hierarchy btnRemoveItem buttons.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Adding dimension level

The Add Dimension Level dialog allows you to specify dimension level properties.

Dimension Editor - Adding dimension level

Level name

Specify the name of the level to be added.

Level column(s)

This group allows you to specify the column(s) in the level. You can specify up to 32 columns.

Table schema / Table name

Use the drop-down lists to select the schema and the table to select columns for the level.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Attribute column(s)

This group allows you to specify the columns that are uniquely determined by a hierarchy level. The columns in level must all come from the same table as the dependent columns.

To select a column, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.


Adding dimension hierarchy

The Add Dimension Hierarchy dialog allows you to define a linear hierarchy of levels in the dimension. Each hierarchy forms a chain of parent-child relationships among the existing levels in the dimension. Hierarchies in a dimension are independent of each other.

Dimension Editor - Adding dimension hierarchy

Hierarchy name

Specify the name of the hierarchy. This name must be unique in the dimension.

Hierarchy levels

Specify the name of a level that has a n:1 relationship with a parent level:

  • select a child level in the Level as Child list;
  • select the corresponding parent level in the Level as Parent list;
  • click the Add button to set relationship between the selected levels;
  • the pair of levels appears in the list below;
  • repeat the operation for all the necessary levels.

To remove a relationship, select the pair of levels in the list below and press the Remove button.

Join keys

Here you can specify an inner join relationship for a dimension whose columns are contained in multiple tables. Setting this relationship is required and permitted only when the columns specified in the hierarchy are not all in the same table.

Table schema / Table name

Use the drop-down lists to select the schema and the table to select columns for the join relationship.

Level to reference

Use the drop-down list to specify the name of a parent level.

To select a column, you need to move it from the Available Columns list to the Selected Columns list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the columns from one list to another.

Specify one or more columns that are join-compatible with columns in the parent level and press the Add button. To remove a column, select it in the Join key column(s) list and press the Remove button.


Queue

Queue is an abstract storage unit used by a messaging system to store messages.

Queue Editor allows you to define queue properties. It opens automatically when you create a new queue and is available on editing an existing one.

To open a queue in Queue Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing queue
  • Adding Subscribers
  • Schedules
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Queue Editor.

Queue Editor - Using Navigation bar

The Navigation bar of Queue Editor allows you to:

Object

iconDB select a database

select a queue for editing

General

iconCompile compile the queue (if it is being created/modified)

iconPrint set printing options to print metadata of the queue

view the dependency tree for the queue

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the Java resource:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing queue

Use the Queue tab of Queue Editor to create/edit a queue and specify its properties.

Name

Name of the queue that is to be created.

Schema

Use the drop-down list to specify the schema in which the queue will be created.

Queue Editor - Editing Queue definition

Queue table name

Name of the queue table that will contain the queue.

Queue type

Use this drop-down list to define queue type: normal queue, exception queue or non-persistent queue.

Max retries

Limits the number of times a dequeue with the REMOVE mode can be attempted on a message.

Retry delay

Delay time, in seconds, before this message is scheduled for processing again after an application rollback.

Retention time

Number of seconds for which a message is retained in the queue table after being dequeued from the queue.

CheckBox Enqueue enabled

Check the option to enable enqueue operations with this queue.

CheckBox Dequeue enabled

Check the option to enable dequeue operations with this queue.


Adding Subscribers

This tab allows you to define subscribers.

Queue Editor - Subscribers

Table contains the list of persons who will receive queue messages.

To create a subscriber use the iconPlus Add subscriber item of the context menu.

Queue Editor - Subscribers - Add subscriber

Name

Defines subscriber's name.

Address

Protocol-specific address of the recipient. If the protocol is 0, then the address is of the form [schema.]queue[@dblink]. For example, a queue named emp_messages in the HR queue at the site dbs1.net has the address: hr.emp_messages@dbs1.net

Protocol

Protocol to interpret the address and propagate the message. Protocols 1-127 are reserved for internal use. If the protocol number is in the range 128 - 255, the address of the recipient is not interpreted by Oracle Streams AQ.

Transformation name

Specifies a transformation that will be applied when this subscriber dequeues the message. The source type of the transformation must match the type of the queue. If the subscriber is remote, then the transformation is applied before propagation to the remote queue.

Rule

A conditional expression based on the message properties, the message data properties and PL/SQL functions. A rule is specified as a Boolean expression using syntax similar to the WHERE clause of a SQL query.

It is possible to iconCommit Edit and iconMinus Delete subscribers. Select the needed subscriber and use the corresponding context menu item.


Schedules

This tab displays detailed information about queue events.

Queue Editor - Schedules


Queue Table

Queue table is a database table where queues are stored. Each queue table contains a default exception queue.

Queue Table Editor allows you to define queue properties. It opens automatically when you create a new queue and is available on editing an existing one.

To open a queue in Queue Table Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing queue table
  • Defining Physical Attributes
  • Statistics
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Queue Table Editor.

Queue Table Editor - Using Navigation bar

The Navigation bar of Queue Table Editor allows you to:

Object

iconDB select a database

select a queue table for editing

General

iconCompile compile the queue table (if it is being created/modified)

iconPrint set printing options to print metadata of the queue table

view the dependency tree for the queue table

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing queue table

Use the Queue Table tab of Queue Table Editor to create/edit a queue and specify its properties.

Name

Name of a queue table to be created

Schema

Use the drop-down list to specify the schema in which the queue table will be created.

Queue Table Editor - Editing Queue Table definition

Payload type

Use this section to specify type of the user data to be stored.

RadioButton Row

Indicates that RAW type will be used to store data in the queue table.

RadioButton Object type

Select this option to use an object type to store data in the queue table. Use the Schema and Name drop down lists to define the object type.

Compatible

Specify the lowest database version with which the queue is compatible.

Primary instance

The primary owner of the queue table. Queue monitor scheduling and propagation for the queues in the queue table are done in this instance. The default value for primary instance is 0, which means queue monitor scheduling and propagation will be done in any available instance.

Secondary instance

The queue table fails over to the secondary instance if the primary instance is not available. The default value is 0, which means that the queue table will fail over to any available instance.

Sort list

The columns to be used as the sort key in ascending order. This parameter has the following format: 'sort_column_1,sort_column_2'.

CheckBox Multiple consumers

If the option is enabled then queues created in the table can have multiple consumers for each message.

CheckBox Message grouping

Defines message grouping behavior for queues created in the table. If the option is disabled each message will be treated individually. If the option is enabled, messages enqueued as part of one transaction are considered part of the same group and can be dequeued as a group of related messages.

CheckBox Secure

Enable this option if you want to use the queue table for secure queues. This option is available only for server version 8.1 or higher.


Defining Physical Attributes

The Physical attributes tab is provided for setting up physical attributes for the new queue table.

The physical properties relate to the treatment of extents and segments and to the storage characteristics of the table.

Queue Table Editor - Defining physical attributes

For more information refer to the Storage attributes page.


Statistics

At this tab you can view statistics of queues belonging to this queue table.

Table contains queue Name, number of messages waiting, ready, expired and total/average time messages in this queue were waiting.

Queue Table Editor - Statistics


Non-schema objects

Other types of objects are also stored in the database and can be created and manipulated with SQL, but are not contained in a schema:

  • Contexts
  • Profiles
  • Consumer Groups
  • Resource Plans
  • Directories
  • Tablespaces
  • Rollback Segments
  • Redo Log Groups
  • Scheduler Schedules
  • Scheduler Programs
  • Scheduler Chains
  • Scheduler Job Classes
  • Scheduler Jobs
  • Scheduler Window Groups
  • Scheduler Windows

Use the DB Explorer tree to navigate within the database(s) and the objects.

See also:

Operations with database objects

New Object dialog

Duplicate Object Wizard

Schema Objects

Users and Roles


Contexts

A Context is a set of application-defined attributes that validates and secures an application.

Using Context Editor you can create a namespace for a context and associate the namespace with the externally created package that sets the context.

Context Editor allows you to define context properties. It opens automatically when you create a new context and is available on editing an existing one.

To open a context in Context Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing context
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Context Editor.

Context Editor - Using Navigation bar

The Navigation bar of Context Editor allows you to:

Object

iconDB select a database

select a context for editing

General

iconCompile compile the context (if it is being created/modified)

iconPrint set printing options to print metadata of the context

view the dependency tree for the context

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the context:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing context

Use the Context tab of Context Editor to create/edit a context namespace and specify its properties.

Name

Specify the name of the context namespace to create or modify. Context namespaces are always stored in the SYS schema.

Context Editor - Editing Context definition

Package schema

Use the drop-down list to specify the schema owning package.

Package name

Use the drop-down list to specify the PL/SQL package that sets or resets the context attributes under the namespace for a user session.

Context type

Use this group to specify an entity other than Oracle Database that can initialize the context namespace.

RadioButton Accessed locally

Indicates that the namespace can be accessed locally.

RadioButton Accessed globally

Indicates that any application context set in the namespace is accessible throughout the entire instance. This setting lets multiple sessions share application attributes.

RadioButton Initialized externally

Indicates that the namespace can be initialized using an OCI interface when establishing a session.

RadioButton Initialized globally

Indicates that the namespace can be initialized by the LDAP directory when a global user connects to the database. After the session is established, only the designated PL/SQL package can issue commands to write to any attributes inside the namespace.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Profiles

A Profile is a set of limits on database resources. If a profile is assigned to a user, then that user cannot exceed these limits.

Profile Editor allows you to define profile properties. It opens automatically when you create a new profile and is available on editing an existing one.

To open a profile in Profile Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing profile
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Profile Editor.

Profile Editor - Using Navigation bar

The Navigation bar of Profile Editor allows you to:

Object

iconDB select a database

select a profile for editing

General

iconCompile compile the profile (if it is being created/modified)

iconPrint set printing options to print metadata of the profile

view the dependency tree for the profile

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the profile:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing profile

Use the Profile tab of Profile Editor to create/edit a profile and specify its properties.

Name

Specify the name of the profile to be created, or view the name of the profile being edited.

Profile Editor - Editing Profile definition

Specify resource and password parameters using the corresponding groups.

Select DEFAULT from the drop-down list if you want to omit a limit for this resource in this profile. A user assigned this profile is subject to the limit for this resource specified in the DEFAULT profile.

When specified with a resource parameter, UNLIMITED indicates that a user assigned this profile can use an unlimited amount of this resource. When specified with a password parameter, UNLIMITED indicates that no limit has been set for the parameter.

Resource parameters

Sessions per user

Specify the number of concurrent sessions to which you want to limit the user, or select DEFAULT or UNLIMITED from the drop-down list.

CPU per session

Specify the CPU time limit (in milliseconds) for a session, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

CPU per call

Specify the CPU time limit (in milliseconds) for a call (a parse, execute, or fetch), or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Connect time

Specify the total elapsed time limit (in minutes) for a session, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Idle time

Specify the permitted periods of continuous inactive time (in minutes) during a session, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Logical reads per session

Specify the permitted number of data blocks read in a session, including blocks read from memory and disk, or select DEFAULT or UNLIMITED from the drop-down list.

Logical reads per call

Specify the permitted number of data blocks read for a call to process a SQL statement (a parse, execute, or fetch), or select DEFAULT or UNLIMITED from the drop-down list.

Composite limit

Specify the total resource cost for a session (expressed in service units), or select DEFAULT or UNLIMITED from the drop-down list.

Private SGA

Specify the amount of private space a session can allocate in the shared pool of the system global area (SGA), or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

Password parameters

Failed login attempts

Specify the number of failed attempts to log in for the user account before the account is locked, or select DEFAULT or UNLIMITED from the drop-down list.

Password lifetime

Specify the number of days the same password can be used for authentication, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Password reuse time

Specifies the number of days before which a password cannot be reused, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Password reuse max

Specifies the number of password changes required before the current password can be reused, or select DEFAULT or UNLIMITED from the drop-down list.

Password lock

Specify the number of days an account will be locked after the specified number of consecutive failed login attempts, or select DEFAULT or UNLIMITED from the drop-down list. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Password grace time

Specify the number of days after the grace period begins during which a warning is issued and login is allowed, or select DEFAULT or UNLIMITED from the drop-down list. If the password is not changed during the grace period, the password expires. For your convenience the Time calculator is implemented: click the arrow-down button to call the Time calculator popup window.

Password verify function

Lets a PL/SQL password complexity verification script be passed as an argument to the CREATE PROFILE statement, or select DEFAULT or NULL from the drop-down list.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Consumer Groups

Consumer groups let you group user sessions together by resource requirements. Resource consumer groups are different from user roles; one database user can have different sessions assigned to different resource consumer groups.

Consumer Group Editor allows you to define consumer group properties. It opens automatically when you create a new consumer group and is available on editing an existing one.

To open a consumer group in Consumer Group Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing consumer group
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Consumer Group Editor.

Consumer Group Editor - Using Navigation bar

The Navigation bar of Consumer Group Editor allows you to:

Object

iconDB select a database

select a consumer group for editing

General

iconCompile compile the consumer group (if it is being created/modified)

iconSaveDescription save the consumer group description (if it has been modified)

iconPrint set printing options to print metadata of the consumer group

view the dependency tree for the consumer group

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the consumer group:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing consumer group

Use the Consumer Group tab of Consumer Group Editor to create/edit a consumer group and specify its properties.

Name

Specify the name of the consumer group to be created, or view the name of the consumer group being edited.

Consumer Group Editor - Editing Consumer Group definition

CPU method

This control is not editable as it is not currently supported by the server.

This box indicates the resource allocation method for distributing CPU among sessions in the consumer group:

ROUND-ROBIN (uses a round-robin scheduler to ensure sessions are fairly executed) - applied by default;

RUN-TO-COMPLETION (specifies that sessions with the largest active time are scheduled ahead of other sessions) - not supported yet.

CheckBox Mandatory indicates whether the consumer group being edited is mandatory or not.

The Users and Roles groups allow you to form the consumer group by selecting its users and roles.

To select a user/role, you need to move it from the Available Users / Available Roles list to the Selected Users / Selected Roles list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the users and roles from one list to another.

CheckBox Admin opt

If this flag is set for a user, the user granted a switch privilege for the consumer group may also grant the switch privilege for that consumer group to others.

CheckBox Init group

The initial consumer group of a user is the consumer group to which any session created by that user initially belongs.

If this flag is set for a user, the consumer group is set as initial resource consumer group for the user.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Resource Plans

Resource plans are used in Oracle to determine allocation of processing resources.

One of the advantages of plans is that they can refer to each other. The entries in a plan can either be consumer groups or subplans.

Resource Plan Editor allows you to define resource plan properties. It opens automatically when you create a new resource plan and is available on editing an existing one.

To open a resource plan in Resource Plan Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing resource plan
  • Directive Options
  • Directive Comments
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Resource Plan Editor.

Resource Plan Editor - Using Navigation bar

The Navigation bar of Resource Plan Editor allows you to:

Object

iconDB select a database

select a resource plan for editing

General

iconCompile compile the resource plan (if it is being created/modified)

iconSaveDescription save the resource plan description (if it has been modified)

iconPrint set printing options to print metadata of the resource plan

view the dependency tree for the resource plan

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the resource plan:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing resource plan

Use the Resource Plan tab of Resource Plan Editor to create/edit a resource plan and specify its properties.

Name

Specify the name of the resource plan to be created, or view the name of the resource plan being edited.

Resource Plan Editor - Editing Resource Plan definition

CPU method

Use this box to view the resource allocation method for specifying how much CPU each consumer group or sub plan gets:

EMPHASIS (the default method, for multilevel plans that use percentages to specify how CPU is distributed among consumer groups);

RATIO (for single-level plans that use ratios to specify how CPU is distributed).

Active session pool

Use this box to view the active session pool resource allocation method which limits the number of active sessions. All other sessions are inactive and wait in a queue to be activated. ACTIVE_SESS_POOL_ABSOLUTE used by default is the only available method.

Parallel degree

Use this box to view the resource allocation method for specifying a limit on the degree of parallelism of any operation. PARALLEL_DEGREE_LIMIT_ABSOLUTE used by default is the only available method.

Queueing

Use this box to view the queuing resource allocation method which controls the order in which queued inactive sessions will execute. FIFO_TIMEOUT used by default is the only available method.

CheckBox Active

Select this option to activate the resource plan immediately after compiling.

CheckBox Mandatory

Indicates whether the resource plan being edited is mandatory or not.

Available groups and subplans

This area allows you to select existing consumer groups and resource plans as subplans for resource plan being created/edited.

To select a group/subplan, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Directives options

Use the Directives Options tab of Resource Plan Editor to set a number of parameters (directives options) for each of the previously added consumer groups / subplans.

Resource Plan Editor - Directive options

Name

The name of the consumer group or subplan.

Level 1 - Level 8

Specify the CPU percentage at the corresponding level (for EMPHASIS CPU method).

Degree Of Parallelism

Specify a limit on the degree of parallelism for any operation.

Active Session Pool

Specify the maximum number of concurrently active sessions for the consumer group.

Timeout

Specify time (in seconds) after which a job in the inactive session queue (waiting for execution) will time out.

Max Undo Pool

Set a maximum in kilobytes (K) on the total amount of undo generated by the consumer group.

Max Execution Time

Specify the maximum execution time (in seconds) allowed for a session.

Switch Group

Specify the consumer group to which this session is switched if other switch criteria are met.

Switch Time

Specify time (in seconds) that a session can execute before an action is taken.

Switch Estimate

If checked, Oracle uses its execution time estimate to automatically switch the consumer group of an operation before beginning its execution.


Directive comments

Use the Directives Comments tab of Resource Plan Editor to set optional comments to consumer group / subplan directives of the resource plan.

Resource Plan Editor - Directive Comments


Directories

A Directory database object specifies an alias for a directory on the server file system where external binary file LOBs (BFILEs) and external table data are located. You can use directory names when referring to BFILEs in your PL/SQL code and OCI calls, rather than hard coding the operating system path name, for management flexibility.

Directory Editor allows you to define directory properties. It opens automatically when you create a new directory and is available on editing an existing one.

To open a directory in Directory Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing directory
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Directory Editor.

Directory Editor - Using Navigation bar

The Navigation bar of Directory Editor allows you to:

Object

iconDB select a database

select a directory for editing

General

iconCompile compile the directory (if it is being created/modified)

iconPrint set printing options to print metadata of the directory

view the dependency tree for the directory

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the directory:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing directory

Use the Object tab of Directory Editor to create/edit a directory database object and specify its properties.

Directory Editor - Editing Directory definition

Name

Specify the name of the directory to be created, or view the name of the directory being edited. The maximum length of a directory is 30 bytes.

Directory path

Specify the full path name of the operating system directory of the server where the files are located. Note that the path name is case sensitive.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Tablespaces

A Tablespace is an allocation of space in the database that can contain schema objects.

Tablespace Editor allows you to define tablespace properties. It opens automatically when you create a new tablespace and is available on editing an existing one.

To open a tablespace in Tablespace Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing tablespace
  • Managing files
  • Managing objects
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Tablespace Editor.

Tablespace Editor - Using Navigation bar

The Navigation bar of Tablespace Editor allows you to:

Object

iconDB select a database

select a tablespace for editing

General

iconCompile compile the tablespace (if it is being created/modified)

iconPrint set printing options to print metadata of the tablespace

view the dependency tree for the tablespace

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the tablespace:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing tablespace

Use the Tablespace tab of Tablespace Editor to create/edit a tablespace and specify its properties.

Name

Specify the name of the tablespace to be created, or view the name of the tablespace being edited.

Tablespace type

RadioButton Permanent

Contains persistent schema objects. Objects in permanent tablespaces are stored in datafiles.

RadioButton Temporary

Contains schema objects only for the duration of a session. Objects in temporary tablespaces are stored in tempfiles.

RadioButton Undo

A type of permanent tablespace used by Oracle Database to manage undo data if you are running your database in automatic undo management mode.

Tablespace Editor - Editing Tablespace definition

Options

CheckBox Logging

Check the option to set the default logging attributes of all tables, indexes, materialized views, materialized view logs, and partitions within the tablespace.

CheckBox Force logging

Use this option to put the tablespace into FORCE LOGGING mode. Oracle Database will log all changes to all objects in the tablespace except changes to temporary segments, overriding any NOLOGGING setting for individual objects.

CheckBox Big file

Use this option to specify that the tablespace is a bigfile tablespace. A bigfile tablespace contains only one datafile or tempfile, which can contain up to approximately 4 billion (232) blocks with the maximum size of the single datafile or tempfile is 128 terabytes (TB) (for a tablespace with 32K blocks).

CheckBox Online

If this option is selected, the tablespace is available immediately after creation to users who have been granted access to the tablespace.

CheckBox Compress

This option allows you to specify the default compression of data for all tables created in the tablespace (not valid for a temporary tablespace).

CheckBox Flashback on

This option reflects the flashback mode value and can't be modified.

Default storage

Valid only for a dictionary-managed tablespace. This group lets you specify default storage parameters for all objects created in the tablespace: Initial extent, Next extent, Percent increase, Minimum extents, Maximum extents, Minimum extent size.

For more information see Storage attributes.

Block size

This box allows you to specify a nonstandard block size (in bytes) for the tablespace. The following values are available in the drop-down list: DEFAULT, 2048, 4096, 8192, 16384, 32768. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

Extent management

RadioButton Dictionary

Use this option if you want the tablespace to be managed using dictionary tables. In this case you should set the Default storage parameters.

RadioButton Locally

Select this option if you want the tablespace to be locally managed. Locally managed tablespaces have some part of the tablespace set aside for a bitmap.

Note: Oracle strongly recommends that you create only locally managed tablespaces which are more efficiently managed than dictionary-managed tablespaces.

Allocation

RadioButton Auto

Specifies that the tablespace is system managed. Users cannot specify an extent size.

RadioButton Uniform

Specifies that the tablespace is managed with uniform extents of amount of bytes set in the Block size field of the Default storage group.

RadioButton Default

Check the option to use default settings for tablespace management.

CheckBox Auto segment

Use the option if you want the database to manage the free space of segments in the tablespace using a bitmap. If you check this option, the database will ignore any specification for PCTUSED, FREELIST, and FREELIST GROUPS in subsequent storage specifications for objects in this tablespace.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Managing files

Use the Files tab of Tablespace Editor to manage the list of datafiles (for the permanent tablespace) or tempfiles (for the temporary tablespace).

Tablespace Editor - Files

The list displays the files as a grid with the following columns: Name, Size, Reuse, Autoextend, Next, Max unlimited, Max size. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to add a new file and specify its properties using the New File dialog, edit the selected file using the Edit File dialog, or delete the selected file.

File management tools are also available through the Navigation bar of Tablespace Editor.

Adding / editing a file

The New File / Edit File dialog allows you to specify datafile and tempfile attributes.

Tablespace Editor - Files - New File

File Name

Specifies the name of either a datafile or tempfile.

Size

Specify the size of the file (in bytes). For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

CheckBox Reuse

Select this option to allow Oracle to reuse an existing file.

Auto extend property

CheckBox Auto extend

Enables or disables the automatic extension of a new or existing datafile or tempfile.

Next size

Specify the size (in bytes) of the next increment of disk space to be allocated automatically when more extents are required. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

CheckBox Unlimited maximum size

Check the option if you do not want to limit the disk space that Oracle can allocate to the datafile or tempfile.

Maximum size

Specify the maximum disk space allowed for automatic extension of the datafile. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.


Managing objects

Use the Objects tab of Tablespace Editor to manage the list of database objects allocated in the tablespace.

Tablespace Editor - Objects

The list displays the objects as a grid with the following columns: Owner, Name, Object type, Size(Mb), Created, Last DDL. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to edit the selected object using its editor, or drop the selected object from the database.


Rollback Segments

A Rollback Segment is an object that Oracle Database uses to store data necessary to reverse, or undo, changes made by transactions.

Note: Oracle recommends that you run your database in automatic undo management mode instead of using rollback segments.

Rollback Segment Editor allows you to define rollback segment properties. It opens automatically when you create a new rollback segment and is available on editing an existing one.

To open a rollback segment in Rollback Segment Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing rollback segment
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Rollback Segment Editor.

Rollback Segment Editor - Using Navigation bar

The Navigation bar of Rollback Segment Editor allows you to:

Object

iconDB select a database

select a rollback segment for editing

General

iconCompile compile the rollback segment (if it is being created/modified)

iconPrint set printing options to print metadata of the rollback segment

view the dependency tree for the rollback segment

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the rollback segment:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing rollback segment

Use the Rollback Segment tab of Rollback Segment Editor to create/edit a rollback segment and specify its properties.

Name

Specify the name of the rollback segment to be created, or view the name of the rollback segment being edited.

Tablespace

Use the drop-down list to select the tablespace in which the rollback segment is created.

Rollback Segment Editor - Editing Rollback Segment definition

CheckBox Public

Enable the option to indicate that the rollback segment is public and is available to any instance.

CheckBox Online

Check the option to bring the rollback segment online, making it available for transactions by your instance.

Storage

The Storage group lets you specify storage characteristics for the rollback segment: Initial size, Next size, Optimal size, Minimal number, Maximum number.

For more information see Storage attributes.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Redo Log Groups

One or more Redo log file groups can be added to the specified thread or instance, making them available to the instance to which the thread is assigned.

Redo Log Group Editor allows you to define redo log group properties. It opens automatically when you create a new redo log group and is available on editing an existing one.

To open a redo log group in Redo Log Group Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing redo log group
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Redo Log Group Editor.

Redo Log Group Editor - Using Navigation bar

The Navigation bar of Redo Log Group Editor allows you to:

Object

iconDB select a database

select a redo log group for editing

General

iconCompile compile the redo log group (if it is being created/modified)

iconPrint set printing options to print metadata of the redo log group

view the dependency tree for the redo log group

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the redo log group:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing redo log group

Use the Redo Log Group tab of Redo Log Group Editor to create/edit a redo log group containing one or more members and specify its properties.

Name

Displays the name of the redo log group being created or edited. The group number uniquely identifies the redo log group. The the default value is generated automatically.

Redo Log Group Editor - Editing Redo Log Group definition

Status

Displays the status of the redo log group: Current, Active, or Inactive.

Sequence

Displays the sequence number of the redo log group.

File size

Specify the size of the redo log group file(s), or select DEFAULT from the drop-down list. For your convenience the Byte calculator is implemented: click the arrow-down button to call the Byte calculator popup window.

CheckBox Reuse

Select this option to allow Oracle to reuse an existing file.

Members

The list displays the members included into the redo log group as a grid with the following columns: File Name, Directory.

Right-click an item within the list to call the context menu allowing you to add a new member or delete the selected member from the list.

Member management tools are also available through the btnAddItem Add member and btnRemoveItem Delete member buttons.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Schedules

Use scheduler schedule to define period and frequency of task execution.

Scheduler Schedule Editor allows you to define scheduler schedule properties. It opens automatically when you create a new scheduler schedule and is available on editing an existing one.

To open the Scheduler Schedule Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler schedule
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Schedule Editor.

Scheduler Schedule Editor - Using Navigation bar

The Navigation bar of Scheduler Schedule Editor allows you to:

Object

iconDB select a database

select a scheduler schedule for editing

General

iconCompile compile the scheduler schedule (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler schedule

view the dependency tree for the scheduler schedule

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler schedule:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing scheduler schedule

Use the Scheduler Schedule tab of Scheduler Schedule Editor to create/edit a scheduler schedule and specify its properties.

Name

Displays the name of the scheduler schedule being created or edited.

Scheduler Schedule Editor - Editing scheduler schedule definition

Owner

This field displays the object owner.

Start date

Use this field to define the schedules start date.

End date

Schedules end date should be specified here.

Note: You should use the following data format for the preceding fields: 'yyyy/mm/dd hh24:mi:ss.ff tzr'.

Repeat interval

The statement in this field defines the regularity and periodicity of task execution and should correspond to Oracle Calendaring Syntax.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Programs

Scheduler program is a database object that indicates the action to be performed by scheduler.

Scheduler Program Editor allows you to define scheduler program properties. It opens automatically when you create a new scheduler program and is available on editing an existing one.

To open the Scheduler Program Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler program
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Program Editor.

Scheduler Program Editor - Using Navigation bar

The Navigation bar of Scheduler Program Editor allows you to:

Object group

iconDB select a database

select a scheduler program for editing

General group

iconCompile compile the scheduler program (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler program

view the dependency tree for the scheduler program

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler program:

DDL group

iconSaveToFile save DDL to file

open DDL in Query Data

Items of the Navigation bar are also available on the ToolBar of Scheduler Program Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/Editing scheduler program

Use the Scheduler Program tab of Scheduler Program Editor to create/edit a scheduler program and specify its properties.

Name

Displays the name of the scheduler program being created or edited.

Scheduler Program Editor - Editing scheduler program definition

Owner

This field displays the object owner.

Program type

Select the needed program type using the drop-down list:

PLSQL block - this specifies that the program is a PL/SQL block. Job or program arguments are not supported when the job or program type is PLSQL Block.

Stored procedure - this specifies that the program is a PL/SQL or Java stored procedure, or an external C subprogram. Only procedures, not functions with return values, are supported. PL/SQL procedures with INOUT or OUT arguments are not supported.

Executable - this specifies that the program is external to the database. External programs implies anything that can be executed from the operating system's command line.

The fields below are available only if the Stored Procedure is set as Program Type.

Stored procedure type

Use this field to define the stored procedure type that should be used as program.

Object schema

Use this field to select the stored procedure or package schema.

Object name

Select the needed program or package from the drop-down list.

Object subname

This field is enabled, when Package was selected as Stored Procedure Type. You can select the needed procedure from the package within the drop-down list.

CheckBox Enabled

This flag specifies whether the program should be created enabled or not. If the flag is checked, then validity checks will be made and the program will be created enabled should all the checks be successful. By default, this flag is unchecked, which means that the program is not created enabled.

If the stored procedure with parameters was specified as the program type, you can define its arguments within the Arguments tab.

You can change argument's data type and default value at the corresponding columns.

Scheduler Program Editor - Editing scheduler program definition - Arguments

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Chains

Scheduler chain can be useful in combining tasks scheduled for execution.

Scheduler Chain Editor allows you to define scheduler chain properties. It opens automatically when you create a new scheduler chain and is available on editing an existing one.

To open the Scheduler Chain Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler chain
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Chain Editor.

Scheduler Chain Editor - Using Navigation bar

The Navigation bar of Scheduler Chain Editor allows you to:

Object

iconDB select a database

select a scheduler chain for editing

General

iconCompile compile the scheduler chain (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler chain

view the dependency tree for the scheduler chain

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler chain:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing scheduler chain

Use the Scheduler Chain tab of Scheduler Chain Editor to create/edit a scheduler chain and specify its properties.

Name

Displays the name of the scheduler chain being created or edited.

Scheduler Chain Editor - Editing scheduler chain definition

Owner

This field displays the object owner.

Ruleset owner

Depending on the specified rule set owner, the appropriate rule set list will be available at the corresponding drop-down list.

Ruleset

Define the rule set within this drop-down list. Note that the scheduler creates the rule set automatically, and in the normal case no rule set should be passed in.

Evaluation interval

If this field is left empty, rule evaluation will be performed when the job starts and completes. If the value is specified, then rule evaluations will be performed periodically at the specified interval.

CheckBox Enabled

This flag specifies whether the chain should be created enabled or not. If the flag is checked, then validity checks will be made and the chain will be created enabled should all the checks be successful. By default, this flag is unchecked, which means that the chain is not created enabled.

Use the btnAddItem btnRemoveItem buttons to add or remove rule.

Rules

Scheduler Chain Editor - Schedule Chain Rule

Rule name

You should define the rule name at this field.

Condition

The condition is expressed using either SQL or the Scheduler chain condition syntax, and indicates the prerequisites for the action to occur.

Action

This field specifies what is to be done as a result of the condition being met.

Comment

You can describe the rule using this field if needed.

Steps

Scheduler Chain Editor - Schedule Chain Step

Step name

Specify step name at this field.

Schedule

This field indicates according to which schedule this step will be performed.

Note: If the schedule is defined for the step, then other fields are unavailable for editing.

Program owner

Specify the program owner within this drop-down list to get the list of the available programs at the Program name drop-down list.

Note: If the program owner is defined for the step, then other fields except Program name are unavailable for editing.

Program name

Define the name of a program to run during this step.

Subchain

Select the name of a chain to run during this step.

Note: If the subchain is defined for the step, then other fields are unavailable for editing.

Event queue owner

Define the queue owner within this drop-down list to get the list of the available queues at the Program name field.

Event queue name

This field indicates the queue into which events that start this particular step will be enqueued (the source queue).

Event queue agent

In the case of secure queues, the agent name should be provided (the agent should belong to a valid agent that is currently subscribed to the queue).

Event condition

This expression is used as the subscription rule for an event on the source queue. The expression must have the syntax of an Advanced Queuing rule.

CheckBox Skip

Enable this option to skip the step when it's condition is met. In this case the step is treated as if it has immediately succeeded, instead of being run.

CheckBox Pause

If this option is enabled, the step state will be changed to PAUSED after it has run.

CheckBox Restart on recovery

With this option enabled the step stopped by a database shutdown is restarted when the database is recovered.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Job Classes

Before creating a job you need to create a scheduler job class. Job inherits basic properties defined for the class.

Scheduler Job Class Editor allows you to define scheduler job class properties. It opens automatically when you create a new scheduler job class and is available on editing an existing one.

To open the Scheduler Job Class Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler job class
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Job Class Editor.

Scheduler Job Class Editor - Using Navigation bar

The Navigation bar of Scheduler Job Class Editor allows you to:

Object

iconDB select a database

select a scheduler job class for editing

General

iconCompile compile the scheduler job class (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler job class

view the dependency tree for the scheduler job class

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler job class:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing scheduler job class

Use the Scheduler Job Class tab of Scheduler Job Class Editor to create/edit a scheduler job class and specify its properties.

Name

Displays the name of the scheduler job class being created or edited.

Scheduler Job Class Editor - Editing scheduler job class definition

Consumer group

Specify the resource consumer group this class is associated with.

Service

Define the database service that the jobs in this class will have affinity to.

Logging level

This attribute specifies how much information is logged.

Off - No logging will be performed for any jobs in this class.

Runs - The Scheduler will write detailed information to the job log for all runs of each job in this class.

Full - In addition to recording every run of a job, the Scheduler will record all operations performed on all jobs in this class. In other words, every time a job is created, enabled, disabled, altered, and so on will be recorded in the log.

Log history

Use this field to specify how much history (in days) to keep.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Jobs

Scheduler job is a database object that assigns a specific task to a specific schedule.

Scheduler Job Editor allows you to define scheduler job properties. It opens automatically when you create a new scheduler job and is available on editing an existing one.

To open the Scheduler Job Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler job
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Job Editor.

Scheduler Job Editor - Using Navigation bar

The Navigation bar of Scheduler Job Editor allows you to:

Object

iconDB select a database

select a scheduler job for editing

General

iconCompile compile the scheduler job (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler job

view the dependency tree for the scheduler job

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler job:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing scheduler job

Use the Scheduler Job tab of Scheduler Job Editor to create/edit a scheduler job and specify its properties.

Name

Displays the name of the scheduler job being created or edited.

Scheduler Job Editor - Editing scheduler job definition

Owner

This field displays the object owner.

Schedule limit

If the job hasn't started at scheduled time it is naturally skipped. Using this field you can restrict the extra time for the job to start (from 1 minute to 99 days).

Logging level

This attribute specifies how much information is logged.

Off - No logging will be performed for any jobs in this class.

Runs - The Scheduler will write detailed information to the job log for all runs of each job in this class.

Full - In addition to recording every run of a job, the Scheduler will record all operations performed on all jobs in this class. In other words, every time a job is created, enabled, disabled, altered, and so on will be recorded in the log.

Max failures

Use this field to set the maximum number of times job can fail on consecutive scheduled runs before it is automatically disabled. If the value is '0' then the new job instances will be started regardless of how many previous instances have failed.

Max runs

This field allows you to define the maximum number of consecutive scheduled runs of the job. Once the value is reached, the job is disabled and its state is changed to COMPLETE.

Job priority

This field can be used to specify job priority. If multiple jobs within a class are scheduled to be executed at the same time, then job priority determines the order of execution. The default priority value is '3'.

Raise events

This field indicates at what stages of the job's execution events should be raised.

Schedule name

The name of a schedule or window group to use as the name schedule for this job.

Start date

Define the date on which this job started or will be scheduled to start.

End date

Specify the date after which the job will no longer run.

Repeat interval

At this field you should specify either a PL/SQL function returning the next date on which to run, or calendaring syntax expression.

Queue/Queue agent

This fields specify the queue into which events that start this particular job will be enqueued (the source queue). If the source queue is a secure queue both queue and queue agent should be specified. For non-secure queues, only the queue name need be provided.

Job type

Select the appropriate type of the job: PLSQL block, Chain, Stored procedure, Executable or Schedule job program.

Stored procedure type

Use this field to define the stored procedure type that should be used as job.

Object schema

Use this field to select the scheduler program, stored procedure or package schema.

Object name

Select the needed chain, scheduled program, stored procedure or package from the drop-down list.

Procedure subname

This field is enabled, when Package was selected as Stored Procedure Type. You can select the needed procedure from the package within the drop-down list.

CheckBox Enabled

This option indicates whether the job is created enabled or not.

CheckBox Restartable

This option specifies whether a job can be restarted in case of failure.

CheckBox Autodrop

Enabling this option causes a job to be automatically dropped after it has completed or has been disabled.

CheckBox Stop on window close

This option only applies if the schedule of a job is a window or a window group. Enabling this option implies that the job should be stopped once the associated window is closed.

Body

Use this tab to specify the scheduler job body which represents the task that will be executed when on the Start date.

Queue event condition

A conditional expression based on message properties that must evaluate to TRUE for the message to start the job. The expression must have the syntax of an Oracle Streams Advanced Queuing rule. Accordingly, you can include user data properties in the expression, provided that the message payload is an object type, and that you prefix object attributes in the expression with tab.user_data.

If the stored procedure with parameters was specified as the Job Type, you can define its arguments within the Arguments tab.

You can change argument's data type and default value at the corresponding columns.

Scheduler Job Editor - Editing scheduler job definition - Arguments

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Window Groups

Scheduler window groups provide an easy way to schedule jobs that must run during multiple time periods throughout the day, week, and so on.

Scheduler Window Group Editor allows you to define scheduler window group properties. It opens automatically when you create a new scheduler window group and is available on editing an existing one.

To open the Scheduler Window Group Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler window group
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Window Group Editor.

Scheduler Window Group Editor - Using Navigation bar

The Navigation bar of Scheduler Window Group Editor allows you to:

Object

iconDB select a database

select a scheduler window group for editing

General

iconCompile compile the scheduler window group (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler window group

view the dependency tree for the scheduler window group

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler window group:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing scheduler window group

Use the Scheduler Window Group tab of Scheduler Window Group Editor to create/edit a scheduler window group and specify its properties.

Name

Displays the name of the scheduler window group being created or edited.

Scheduler Window Group Editor - Editing scheduler window group definition

Next Start Date

This field indicates the date window start next time. The field value is assigned automatically and can't be changed.

CheckBox Enabled

This option indicates whether the window group is created enabled or not.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Scheduler Windows

Scheduler window associates the resource plan with a manually defined time interval or an existing schedule.

Scheduler Window Editor allows you to define scheduler window properties. It opens automatically when you create a new scheduler window and is available on editing an existing one.

To open the Scheduler Window Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/Editing scheduler window
  • Editing object description
  • View DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Scheduler Window Editor.

Scheduler Window Editor - Using Navigation bar

The Navigation bar of Scheduler Window Editor allows you to:

Object

iconDB select a database

select a scheduler window for editing

General

iconCompile compile the scheduler window (if it is being created/modified)

iconPrint set printing options to print metadata of the scheduler window

view the dependency tree for the scheduler window

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the scheduler window:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/Editing window

Use the Scheduler Window tab of Scheduler Window Editor to create/edit a scheduler window and specify its properties.

Name

Displays the name of the scheduler window being created or edited.

Scheduler Window Editor - Editing scheduler window definition

Resource plan

Select the resource plan that is automatically activated when the window opens.

Schedule

Specified schedule will be associated with the window.

Duration

This field indicates how long the window will be open for.

Window priority

This attribute is only relevant when two windows overlap. Because only one window can be in effect at one time, the window priority will be used to determine which window will be opened.

Start date

Use this field to specify the first date on which this window is scheduled to open.

End date

At this field you should specify the date after which the window will no longer open.

Repeat interval

Define the frequency of window repetition. The value should be expressed using the Scheduler's calendaring syntax.

CheckBox Enabled

This option indicates whether the window group is created enabled or not.

CheckBox Active

Use this option to open a window immediately independent of its schedule. This window will open and the resource plan associated with it, will take effect immediately for the duration specified or for the normal duration of the window if no duration is given. Only an enabled window can be manually opened.

You can find the detailed window log at the Schedule Window Logs tab.

Scheduler Window Editor - Editing scheduler window definition - Scheduler Window Log

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Users and Roles

SQL Manager for Oracle provides management tools for the following Oracle principals:

Users

Provides tools allowing you to manage Oracle users.

Roles

Provides tools allowing you to manage Oracle roles.

See also:

New Object dialog

Duplicate Object Wizard

Schema objects

Non-schema objects


Users

A User is an account through which one can login to the database.

Creating Users

To create a new user:

  • select the Database | New Object... main menu item;
  • select User in the Create New Object dialog;
  • define user properties using the appropriate tabs of User Editor.

Hint: To create a new user, you can also right-click the Users node or any object within this node in the DB Explorer tree and select the New User item from the context menu.

To create a new user with the same properties as one of existing users has:

  • select the Database | Duplicate Object... main menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a user in the DB Explorer tree and select the Duplicate User <user_name>... context menu item.

Duplicate Object Wizard allows you to select the database to create a new user in, and to edit the result SQL statement for creating the user.

Editing Users

  • select the user for editing in the DB Explorer tree (type the first letters of the user name for quick search);
  • right-click the object and select the Edit User <user_name> context menu item, or simply double-click the user;
  • edit user properties using the appropriate tabs of User Editor.

Dropping Users

  • select the user to drop in the DB Explorer tree;
  • right-click the object and select the Drop User <user_name>... context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new user;

Ctrl+O to edit the selected user;

Shift+Del to drop the object from the database.

See also:

Roles


User Editor

User Editor allows you to define user properties and membership. It opens automatically when you create a new user and is available on editing an existing one (see Create user and Edit user for details).

To open a user in User Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing user
  • Tablespace parameters
  • Setting quotas
  • Proxy Users
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in User Editor.

User Editor - Using Navigation bar

The Navigation bar of User Editor allows you to:

Object

iconDB select a database

select a user for editing

General

iconCompile compile the user (if it is being created/modified)

iconPrint set printing options to print metadata of the user

view the dependency tree for the user

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the user:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing user

Use the User tab of User Editor to create/edit a user and specify its properties.

Name

Specifies the name by which the user is identified inside this database. This name can contain only characters from the database character set and comply with the naming rules.

User Editor - Editing user definition

Authentication method

RadioButton Password authentication

Indicates that the user must specify a password to log on to the database.

CheckBox Expire password now

This setting forces the user or the DBA to change the password before the user can log in to the database.

RadioButton Operating system authentication

The user must be authenticated by an external service - operating system. In this case, Oracle relies on authentication by the operating system to ensure that a specific external user has access to a specific database user.

RadioButton Global authentication

The user must be authorized by the enterprise directory service (Oracle Internet Directory). In this case you are to fill all necessary fields below as follows: common name, locality, country, state, organization, unit, X.500 name.

Resource profile

Use the drop-down list to specify the profile you want to assign to the user. The profile limits the amount of database resources the user can use.

CheckBox Lock account now

Use this option to lock the user's account and disable access.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Tablespace parameters

Use the Tablespace tab of User Editor to specify tablespace properties for the user.

User Editor - Tablespace parameters

Default tablespace

Use the Name drop-down list to specify the default tablespace for objects created by the user.

Temporary tablespace

Use the Name drop-down list to specify the tablespace or tablespace group for the user's temporary segments.

Quota on default / temporary tablespace

Specify the maximum amount of space the user can allocate in the default/temporary tablespace, or select UNLIMITED from the drop-down list. For your convenience the built-in Byte calculator is implemented: click on the right arrow-down button to call the Byte calculator popup window.


Setting quotas

Use the Quotas tab of User Editor to view and set the quotas for existing tablespaces.

User Editor - Setting quotas

Select a tablespace in the list and specify the maximum amount of space that can be allocated in the tablespace, or select UNLIMITED from the drop-down list. For your convenience the built-in Byte calculator is implemented: click on the right arrow-down button to call the Byte calculator popup window.


Proxy users

The Proxy Users tab of User Editor allows you to expose user to proxy use by database user, activate all, some, or none of the roles of the user, and specify whether authentication is required.

User Editor - Proxy Users

Proxy users

To select a user, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the users from one list to another.

Proxy user roles

Use this group to correlate selected users with the roles listed in the Available list.

To select a role, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the roles from one list to another.


Roles

A Role is a set of privileges that can be granted to users or to other roles. You can use roles to administer database privileges. You can add privileges to a role and then grant the role to a user. The user can then enable the role and exercise the privileges granted by the role.

Creating Roles

  • select the Database | New Object... main menu item;
  • select Role in the Create New Object dialog;
  • define role properties using the appropriate tabs of Role Editor.

Hint: To create a new role, you can also right-click the Roles node or any object within this node in the DB Explorer tree and select the New Role item from the context menu.

To create a new role with the same properties as one of existing roles has:

  • select the Database | Duplicate Object... main menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a role in the DB Explorer tree and select the Duplicate Role <role_name>... context menu item.

Duplicate Object Wizard allows you to select the database to create a new role in, and to edit the result SQL statement for creating the role.

Editing Roles

  • select the role for editing in the DB Explorer tree (type the first letters of the role name for quick search);
  • right-click the object and select the Edit Role <role_name> context menu item, or simply double-click the role;
  • edit role properties using the appropriate tabs of Role Editor.

Dropping Roles

  • select the role to drop in the DB Explorer tree;
  • right-click the object and select the Drop Role <role_name>... context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new role;

Ctrl+O to edit the selected role;

Shift+Del to drop the object from the database.

See also:

Users


Role Editor

Role Editor allows you to define role properties and membership. It opens automatically when you create a new role and is available on editing an existing one (see Create role and Edit role for details).

To open a role in Role Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing role
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Role Editor.

Role Editor - Using Navigation bar

The Navigation bar of Role Editor allows you to:

Object

iconDB select a database

select a role for editing

General

iconCompile compile the role (if it is being created/modified)

iconPrint set printing options to print metadata of the role

view the dependency tree for the role

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the role:

DDL

iconSaveToFile save DDL to file

open DDL in Query Data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Creating/editing role

Use the Role tab of Role Editor to create/edit a role and specify its properties.

Name

Specify the name of the new role, or view the name of the role being edited.

Role Editor - Editing role definition

Authentication method

RadioButton Password authentication

Indicates that a password must be specified to log on to the database. Set the password and confirm it using the corresponding boxes.

RadioButton Operating system authentication

The role must be authenticated by an external service - operating system. In this case, Oracle relies on authentication by the operating system to ensure that a specific external user has access to a specific database role.

RadioButton Global authentication

The role must be authorized by the enterprise directory service (Oracle Internet Directory).

RadioButton Not identified

Indicates that this role is authorized by the database and that no password is required to identify the role.

RadioButton Application

Creates an application role, which is a role that can be enabled only by applications using an authorized package. In this case you need to specify the Schema and Package used for authentication.

To compile the object, use the corresponding iconCompile Compile item of the Navigation bar or toolbar.


Query Management Tools

When using SQL Manager for Oracle, you are provided with two basic tools you may need to manage your SQL queries: Query data for editing SQL query text directly and Design query for building queries visually. Find the list of common SQL query management operations below.

Creating New Queries

In order to create a new query in Query data editor:

  • select the Tools | Query data main menu item or use the corresponding btnNewSQLEditor toolbar button (F12);
  • click the Add new query item of the Navigation bar;
  • edit the query text within the Query tab.

In order to create a new query visually in Design Query editor:

  • select the Tools | Design query main menu item or use the corresponding btnNewQueryBuilder toolbar button;
  • build the query visually within the Builder tab.

Editing Queries

In order to open a query in Query data editor:

  • select the Tools | Query Data main menu item or use the corresponding btnShowSQLEditor toolbar button;
  • use the numbered tabs at the bottom of the editor window to switch between previously edited queries. The last edited query is displayed automatically on opening the editor;
  • edit the query text within the Query tab of Query Data.

In order to open a query in Design query:

  • select the Tools | Design query main menu item or use the corresponding btnShowQueryBuilder toolbar button;
  • the last edited query is displayed automatically on opening Design Query editor;
  • to load a previously saved diagram, click the Load diagram item of the Navigation bar;
  • to load a query from an *.sql file, open the Edit tab and click the Load SQL button of the Navigation bar;
  • edit the query visually within the Builder and/or the Query tabs.

In order to load a query from an *.sql file:

  • select the Tools | Query data main menu item or use the corresponding btnNewSQLEditor toolbar button;
  • click the Load from file item of the Navigation bar;
  • browse for the query file using the Open SQL File dialog;
  • edit the query text within the Query tab.

Executing Queries

  • create a new query or open an existing one;
  • click the btnExecuteQuery Execute item of the Navigation bar or use the F9 hot-key to execute the query;
  • view/edit the returned data within the Results tab of Query Data.

Saving Queries

  • create a new query or open an existing one;
  • click the Save to file Navigation bar item (in Query data) or the Save SQL Navigation bar item (in Design Query) or use the Ctrl+S shortcut to save the query using the Save as... dialog;
  • click the Save diagram Navigation bar item in Design Query to save the designed diagram;

or

  • use the Save all Navigation bar item in Query data if you need to save all the queries to one file.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Data Management

Import/Export Tools

Database Tools

Services

Options

How To...


Query data

Query data is the basic tool of SQL Manager for Oracle for creating and executing queries. The tool allows you to create and edit the SQL text of a query, prepare and execute queries and view the results of query execution.

To open Query data tool select the Tools | Query Data main menu item or use the corresponding btnShowSQLEditor toolbar button. You can also use F12 shortcut for the same purpose.

  • Using Navigation bar and Toolbar
  • Working with Query data
  • Using the context menu
  • Viewing query plan
  • Using object links
  • Executing queries and viewing results
  • Viewing query logs
  • Using PL/SQL Code Debugger
  • Favorites editor

See also:

Design query

Query parameters

Execute script

Editor options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Query data.

Query data - Using Navigation bar

Database

iconDB select a database for the query

General

iconExecute execute the current query

view estimated query execution plan

run Design Query to design the query as a diagram

switch the results representation mode: on Edit tab or on separate tab

iconOptions configure Query Data within the Tools | Query Data page of the Environment Options dialog

iconAddRestorePoint add restore point

iconRestoreDefaultSize restore the default size and position of the editor window

Queries

add a new query (note that the current query text will not be lost)

rename the current query

remove the query

remove all queries from the editor

edit the query text using Favorites editor and add the query to the Favorite Queries list

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with queries:

Edit

iconFindText activate the Find Text dialog

iconLoadFromFile load a query from an *.sql file using the Open SQL File dialog

iconSaveToFile save the query to an *.sql file

iconSaveAll save all queries to an *.sql file

Logs group

iconFindText activate the Find Text dialog

iconSaveToFile save the query log to a file

clear logs

Debug group

iconDebug debug the PL/SQL code using PL/SQL Debugger

Data Management group

iconCommit commit transaction

iconRollback rollback transaction

export the returned dataset using Export Data Wizard

export the returned dataset as Execute Script using the Export as SQL Script wizard

import data

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

See also:

Working with Query Data

Viewing query plan

Executing queries

Viewing query logs

Favorites editor


Working with Query Data

The Query tab is provided for working with SQL queries in text mode.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented:

  • using object links allowing you to open the object in the associated editor;
  • ability to display line numbers;
  • code folding for statements and clauses;
  • customizable margins and gutters;
  • formatting code for better representation

and more.

If necessary, you can enable/disable or customize most of Query Data features using the Query Data Options dialog.

The example of code completion is illustrated in the picture below. You can set the delay within the Quick code section of the Query Data Options dialog or activate the completion list manually by pressing the Ctrl+Space shortcut.

SQL Editor - Working with SQL Editor area

For your convenience the possibility to use macros is implemented.

To start recording a macro, click the btnRecordMacro Record button available in the status bar area, or use the Shift+Ctrl+R shortcut.

To stop recording, click the btnStopRecordMacro Stop button, or use the Shift+Ctrl+R shortcut.

To call the recorded macro, use the btnPlayMacro Play button, or use the Shift+Ctrl+P shortcut.

Hint: To paste input parameters of a procedure quickly, use the Shift+Alt+P shortcut after the procedure name.

Hint: To use a keyboard template, type the template name and press the Ctrl+J shortcut: the text associated with the template will be inserted automatically.

If necessary, you can print the SQL text of your query using the corresponding item of the context menu.

See also:

Using Navigation bar and Toolbar

Using the context menu

Editor Options

Keyboard Templates

Favorites editor

Find Text dialog

Replace Text dialog


Using the context menu

The context menu of Query Data area contains execution commands, most of the standard text-processing functions (Cut, Copy, Paste, Select All) and functions for working with the query as a whole, e.g. you can move the cursor to a particular line, change the case of selected text, view the query properties or print the text of the query. Each of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text / Replace Text dialogs and Incremental search bar contributes to more efficient work with the SQL code.

Find the complete list of Query Data context menu items below. The context menu allows you to:

  • add the selected text to dictionary or correct text (see Spell checking for details);
  • execute the query/selected text/text under cursor, and reset execution point (if necessary);
  • manage markers: Drop Marker, Collect Marker, Swap Marker;
  • toggle bookmarks allowing you to navigate through the query text and jump to a line with a particular number;
  • perform editing operations: Undo/Redo, Cut, Copy, Paste, Select all;
  • perform search and replace operations;
  • save/load a query to/from an external *.sql file;
  • perform preview/print operations;
  • use the Quick code group allowing you to format the selected code using SQL Formatter to make the code easier to read, toggle comments for code fragments, change case of the selected text, indent/unindent code lines;
  • toggle a comment for a code fragment;
  • open the Editor Options dialog.

SQL Editor - Using the context menu

See also:

Working with Query Data area

Executing queries


Viewing query plan

Using SQL Manager for Oracle, you can view the plan for each of the queries created and executed in the application. The query plan is available within the corresponding Plan tab.

To view the Plan of a query, open the query in Query Data and use the btnExplainQuery Explain query item of the Navigation bar or toolbar.

The Plan tab allows you to view the sequence of actions performed by the database server in the process of the query execution, and the amount of system resources used for the query execution.

SQL Editor - Viewing query plan

The Operation panel below displays the operations as a tree list with the following columns: Operation (Operation, Options), Cost (Cost, CPU Cost, IO Cost, Est. Rows, Est. Bytes, Temp Space, bytes), Object (Database Link, Schema, Object Name, Alias, Object Type, Object Ord. Pos.), Other (Optimizer, Distribution, Start Position, Stop Position, Position ID, Search Columns, Access Predicates, Filter Predicates, Projection, Time, QB Lock Name, Data Tag, Data).

Right-click within the panel to display the context menu allowing you to configure the set of visible bands/columns or export the plan to any of supported formats.

If necessary, you can specify that the Plan tab appears automatically upon query execution in Query Data: select the CheckBox Explain query on execution option available within the Tools | Query Data section of the Environment Options dialog.

See also:

Query Data options

Executing queries


Using object links

Objects that exist in the database are highlighted in the text as hyperlinks. You can open an object in the appropriate editor by clicking the object name in the text with the Ctrl key pressed.

SQL Editor - Using object links

Please note that you can change the way highlighted objects look in the editor: use the Display | Highlight section of the Editor Options dialog.

See also:

Working with Query Data area

Editor Options


Executing queries

When all the query parameters are set, you can immediately execute the query in Query Data.

To execute a query, click the btnExecuteQuery Execute item of the Navigation bar. You can also use the context menu or F9 hot key for the same purpose.

If the SQL syntax is correct, the query is executed and, in case the query statement is supposed to return data (e.g. as SELECT statement), the returned dataset appears within the Results tab. The position of the tab depends on the Results on Edit tab / Results on separate tab selection in the Navigation bar.

If SQL syntax of the query contains any errors, the query execution is stopped and the corresponding error message is displayed in the status bar area at the bottom of the editor window.

SQL Editor - Executing queries

By default, data returned by a query are displayed as a grid (see Data View for details). The context menu of the grid allows you to Export Data, Export as SQL Script.

SQL Editor - Viewing results

Note: You can add a restore point before changing data, to get an opportunity to flash back to the current data state.

Click iconAddRestorePoint Add restore point on the Navigation bar or toolbar to open the Add restore point dialog. For details see Adding restore point.

See also:

Data View

Export Data

Export as SQL Script


Viewing query logs

This tab allows you to view the query log. The log is available within the Logs tab of Query Data.

Using this tab you can view log entries containing the following details:

  • date and time of the query execution;
  • text of the query;
  • number of rows fetched and fetch time, or the text of the error (if any).

Date/time and the execution result information are embedded as code comments conforming with the rules of SQL.

With the help of the context menu the log can be printed, saved to file or cleared. You can also use a number of Query Data context menu generic functions.

SQL Editor - Viewing query logs

See also:

Executing queries

Using the context menu


Using PL/SQL code debugger

PL/SQL Code Debugger is the cutting edge feature of SQL Manager for Oracle. This tool is provided for step-by-step code debugging: anonymous blocks, procedures, functions, packages, triggers, object types. Much of the power of the debugger comes from toggling breakpoints, getting variables' values, and fetching call stacks.

The Edit tab of the PL/SQL Code Debugger window contains the following areas:

  • the Debug panel of the Navigation bar;
  • the Watches list;
  • the PL/SQL code area;
  • the Call stack box;
  • the Breakpoints list.

Note: All areas within the Edit tab of the PL/SQL Code Debugger window are dockable, i.e. you can drag an area to any location within the parent form.

The Logs tab of the PL/SQL Code Debugger window displays the debug log.

SQL Editor - Using Code Debugger

The Debug panel of the Navigation bar provides several debug commands:

iconDebug Start: this command is used to start the debugging session;

Break: this command stops the current debugging session;

iconExecute Continue: use this command to continue execution up to the next breakpoint;

Step over: traces the code disregarding the object body (procedure, function);

Trace into: traces the code using the object body (procedure, function);

Trace out: traces the code up to the point of leaving the object body (procedure, function);

Run to exception: traces the code up to the nearest exception point;

Toggle breakpoint: use this command to add/remove breakpoints;

iconClear Clear watches: allows you to clear the variables added to the Watches list.

The Watches list allows you to watch the variables that have been declared in the code, and the value of each variable. The following attributes are listed for each watched variable:

Watch name

Value

You can delete the selected watch by pressing the Del button.

The PL/SQL code area presents the statement being debugged. All points that have been set within the code are marked with corresponding signs. Active breakpoints are highlighted red, and inactive breakpoints are highlighted green.

The Call stack box lists the call stacks, if applicable.

The Breakpoints list displays the currently toggled breakpoints. The following attributes are listed for each breakpoint:

Line

Status

Unit owner

Unit name

Compile with debug info

To debug a PL/SQL object you need it to compile it with debug info. PL/SQL objects are: packages, package bodies, procedures, functions, triggers, object types, object type bodies.


Favorites editor

For your convenience the Favorite Queries list is implemented in SQL Manager for Oracle. This list is available within the iconFavoriteQueries Favorite Queries node of Database Explorer and allows you to store the most frequently used SQL queries in one location.

To add a query to the Favorite Queries list, use the [image] Add to Favorite Queries Navigation bar item in Query Data. The corresponding item is also available in the context menu of Query Data working area.

You can edit any of your Favorite Queries using Favorites editor.

SQL Editor - Favorites editor

Name

Set the name of the Favorite query.

Storage

Specify where the Favorite query will be stored: in Windows Registry or in the Database.

Note: If you store Favorite queries in the Windows Registry then they can be lost after the Windows reinstall. To avoid this problem save the registry branch or store Favorite queries in a database.

See also:

Managing Favorite queries

Working with Query Data area


Design query

Design Query is implemented in SQL Manager for Oracle for building queries visually. The tool allows you to create and edit queries without deep knowledge of SQL. You can also prepare and execute queries, and view the results of their execution.

To open Design Query, select the Tools | Design Query main menu items or use the corresponding btnShowQueryBuilder toolbar buttons.

  • Using Navigation bar and Toolbar
  • Working with diagram area
  • Joining two database objects by fields
  • Setting the selection criteria
  • Setting output fields for selection
  • Setting the grouping criteria
  • Setting parameters of sorting
  • Working with editor area
  • Executing queries and viewing results
  • Viewing query plan

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Query Data

Query parameters


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Design Query.

Query Builder - Using Navigation bar

Database

iconDB select a database for executing the query

General

iconExecute execute the current query

view estimated query execution plan

clear the query

create a view based on the query

create a procedure based on the query

iconShowSQLHelp show SQL help

iconOptions configure Design Query settings in the Design Query options tab of Environment Options dialog

iconRestoreDefaultSize restore the default size and position of the builder window

Objects

iconDBExplorer browse objects of the database; you can also add tables, views and procedures to the diagram using drag-and-drop operations

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with queries:

Visual Builder

iconLoadFromFile load a diagram from a *.vqb file using the Open diagram dialog

iconSaveToFile save the diagram to a *.vqb file using the Save diagram as... dialog

Edit

iconLoadFromFile load a query from an *.sql file using the Open SQL File dialog

iconSaveToFile save the query to an *.sql file

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export the returned dataset using Export Data Wizard

export the returned dataset as Execute Script using the Export as SQL Script wizard

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

See also:

Working with diagram area

Query execution


Working with diagram area

The main working area of Design Query is the diagram area available within the Builder tab. Here you can create a query by placing the database tables and views onto the area, and edit it by selecting the required data fields and setting links between objects.

To add an object to the query, you can simply drag it from the DB Explorer tree to the diagram area.

To include a field in the query, check the corresponding box located to the left from the field name in the list, or just double-click it. To include all fields of the table/view, check the box located to the left of the table/view caption. If you do not check any fields, the SQL statement is generated as SELECT * FROM <table/view_name>, i.e. all the fields are included in the query.

To collapse/expand the list of table/view fields, click the minimize/maximize button at the object caption.

To exclude a field from the query, uncheck the respective box. In order to remove the entire table/view from the query, close it by clicking the corresponding cross-button at the object caption, or right-click the object and select Delete from the context menu. You can also select the object and press the Del key.

To edit the alias of a table/view, double-click the object caption and enter the new name, or right-click the object and select Rename from the context menu.

Query Builder - Working with diagram area

Design Query allows you to create complex queries consisting of two or more queries combined in one with the UNION operator, or add nested queries. The panel to the left of the diagram area displays the tree of subqueries.

To add a query, right-click within the tree of subqueries area and select Add union from the context menu. A tab for the new query will appear in the diagram area.

To remove a query from the tree, right-click the query and select Delete union from the context menu.

To add the UNION ALL operator to the query, right-click the newly added query and select the corresponding context menu item.

Visual Query Builder - Union

Note: Depending on which query type you need to execute, you can select one from the drop-down list above the tree of subqueries: Select, Insert, Update, or Delete.

Visual Query Builder - Selecting query type

See also:

Joining two objects

Working with the editor area

Query execution


Joining two objects

The diagram area allows you to associate two objects by their fields: this operation is performed by dragging a field from one object list to another. This will set a link between these objects by the selected fields. It is indicated by a bidirectional arrow between the linked fields.

Query Builder - Joining two objects

You can view the link properties of objects association: set the mouse cursor over the linking arrow, and a hint containing the association condition will popup after a short delay.

To edit the link properties, double-click the linking arrow or right-click it and select the Property popup menu item. The Link properties dialog allows you to change the association condition by choosing it from the drop-down list (=, >, <, >=, <=, <>).

Query Builder - Link properties

For your convenience the CheckBox Include all option is available for each object of the association:

if the option is enabled for the left table, the LEFT JOIN operator will be used for the association;

if the option is enabled for the right table, the RIGHT JOIN operator is used for the association;

if the option is enabled for neither of the tables, the INNER JOIN operator is used for the association.

Click OK to apply the changes you have made.

To remove a link between objects, right-click the linking arrow and select the Delete link popup menu item.

To add a point to the link line, right-click the linking arrow and select the Insert point popup menu item. Using the point you can move the link line easily. The point does not cause any changes to the query, it is only used for the diagram representation and makes visual building handy and more comprehensible.

Visual Query Builder - Link menu

See also:

Working with diagram area

Setting criteria


Setting criteria

Use the Criteria tab to set the selection conditions.

The way the conditions are used is set in the upper string of the area (All, Any, None or Not all of the following are met). Click the green link to change it.

Visual Query Builder - Criteria menu

To add a condition, click the ellipsis EllipsisButton button on the left, and select the Add condition popup menu item.

Edit the condition by clicking the elements of the condition pattern and setting the necessary values. Clicking the numbered button to the left of the condition string activates the popup menu which allows you to add a new condition at the same enclosure level, make composite condition by adding a new enclosure level, delete the current condition, expand or collapse enclosure levels of the condition (if the condition is composite).

Visual Query Builder - Condition menu

A simple condition pattern contains three elements: an argument, a condition operator and a second argument (if required for the condition).

Clicking each element field allows you to set its value. You can add a field by drag-and-dropping it from the working area to Criteria, Selection, Grouping criteria or Sorting tabs. When clicking an argument field, you can edit the argument as a text string: set an object name or a certain value in this field. Right-clicking the field in the edit mode activates the popup menu with the Insert field (also called by the Shift+Enter shortcut; this item allows you to select a field from the list of all the table fields) and Insert query (this item adds a nested query) items.

Query Builder - Setting criteria

Clicking the condition operator field activates the popup menu from which you can select the operator you need.

See also:

Setting output fields

Setting grouping criteria

Setting sorting parameters


Setting output fields

The Selection tab displays the output fields of the query as a grid.

The grid allows you to edit the names of the query output fields, specify their display order and set the aggregate functions for each field. To remove a field from the list, right-click the field row and select the Delete current row popup menu item.

Visual Query Builder - Selection field menu

The popup menu also allows you to insert a nested query and add a CASE clause. To edit the CASE clause, use the CASE END AS dialog.

Query Builder - Setting output fields - CASE

To change the input query field, click it and then type the field name or select it from the drop-down list.

To change the output query field name, set the cursor at the corresponding column and type the required field name.

To reorder fields in the list, use the [image] [image] buttons.

Query Builder - Setting output fields

To set an aggregate function for a field, click the field row within the Aggregate column, and then type in the function name or select one from the drop-down list (SUM, MIN, MAX, AVG, or COUNT).

The Grouping column displays the grouping state for each of the output fields.

CheckBox2 Select only unique records

If you check this option, the duplicate records (if any) are not included into the query result (i.e. the DISTINCT keyword is added to the SQL query text).

See also:

Setting criteria

Setting grouping criteria

Setting sorting parameters


Setting grouping criteria

The Grouping criteria tab allows you to set conditions for grouping query records.

The grouping condition pattern fields are set in the same way as those of the Criteria pattern.

Query Builder - Setting grouping criteria

These conditions will be included in the HAVING statement of the generated SQL query.

See also:

Setting criteria

Setting output fields

Setting sorting parameters


Setting sorting parameters

The Sorting tab allows you to set sorting parameters for the records returned by the query.

The working area contains the Output fields list (at the left) which represents all fields of the objects used in the query, and the Sorted fields list (at the right) which contains the fields to sort records by.

To move a field from one list to another, drag the selected field or use the Add and Remove buttons: Items - Move to Selected Items - Move all to Selected Items - Move to Available Items - Move all to Available .

To change the sorting order for a sorted field, select the field in the Sorted fields list and move it using the Up and Down buttons.

To change the sorting direction, select the field in the Sorted fields list and switch the direction (Ascending, Descending) using the corresponding A..Z/Z..A button.

Query Builder - Setting sorting parameters

See also:

Setting criteria

Setting output fields

Setting grouping criteria


Working with the editor area

The Query tab is provided for working directly with the SQL query text which is generated automatically while you build the query visually.

You can edit this text according to the rules of SQL, and all the changes will be displayed within the Builder tab respectively.

To learn more about the Query Data features available within the Query tab see Working with Query Data area.

Query Builder - Working with the editor area

See also:

Working with diagram area

Query execution

Query Data


Query execution

When all the query parameters are set, you can immediately execute the query in Design Query.

To execute a query, click the btnExecuteQuery Execute query item of the Navigation bar. You can also use the F9 hot key for the same purpose.

If the query parameters are specified correctly, the query is executed and, in case the query statement is supposed to return data (e.g. as SELECT statement), the returned dataset appears within the Result tab.

If SQL syntax of the query contains any errors, the query execution is stopped and the corresponding error message is displayed in the status bar area at the bottom of the Design Query window.

Query Builder - Query execution

By default, data returned by a query are displayed as a grid (see Data View for details). The context menu of the grid allows you to Export Data, Export as SQL Script.

Query Builder - Viewing results

See also:

Working with diagram area

Working with the editor area

Data View


Viewing query plan

Using SQL Manager for Oracle, you can view the plan for each of the queries created and executed in the application. The query plan is available within the corresponding Plan tab.

To view the Plan of a query, open Design Query and use the btnExplainQuery Explain query item of the Navigation bar.

The Plan tab allows you to view the sequence of actions performed by the database server in the process of the query execution, and the amount of system resources used for the query execution.

Query Builder - Viewing query plan

If necessary, you can specify that the Plan tab appears automatically upon query execution in Design Query: select the CheckBox Explain query on execution option available within the Tools | Design Query section of the Environment Options dialog.

See also:

Query execution


Query parameters

Both Query Data and Design Query support parameters usage inside the query text. A parameter is a kind of variable for which a value can be specified just before the query execution. In the query text the parameter should appear as an identifier with a colon (':') at the beginning, e.g.

SELECT * FROM MYTABLE WHERE ID = :param1;

Note: The Allow using of parameters in query text option should be checked on the Tools page of the Environment Options dialog for this feature to be enabled.

See also:

Query Data

Design Query


Input parameters dialog

The Input Parameters dialog is used to specify the query parameters as well as values of the input parameters of the query before execution.

Query parameters - Input parameters dialog

The edit field for input parameters varies according to the field data type. For your convenience the Calculator and Date editor are implemented for Numeric and Date and Time types respectively: click the arrow-down button to call the Calculator / Date editor popup window.

Click OK button to apply the values and execute the query or click Cancel button to abort execution.


Data Management

Table data and query results are displayed on the Data or Results tab of Table Editor, Query Data, Design Query etc.

Data can be displayed in one of the following modes: Grid View, Form View, Print Data, BLOB View. See Data View to learn more about these modes. You are also provided with a number of filtering tools when working with your data.

  • Data View
  • Custom Filter
  • Filter Builder dialog

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Import/Export Tools

Database Tools

Services

Options

How To...


Data View

SQL Manager for Oracle provides you with powerful tools for viewing, editing and printing data from tables and queries:

  • table / materialized view / view data are available within the Data tab of Table Editor / Materialized View Editor / View Editor correspondingly;
  • upon a query execution the returned dataset appears within the Result(s) tab of Query Data / Design Query (in Query Data the position of the tab depends on the Results on Edit tab / Results on separate tab selection in the Navigation bar).

The data can be displayed in one of four available modes: Grid View, Form View, Print Data and BLOB View. The status bar at the bottom displays the number of records in the current dataset, the time the records were fetched by the application and the status of the records (whether the data are read-only or editable).

Please see the succeeding chapters to learn how to work with your data in the simplest and most efficient way.

  • Using Navigation bar and Toolbars
  • Grid View
  • Form View
  • Print Data
  • BLOB View
  • Applying changes

See also:

Custom Filter

Filter Builder dialog

Table Editor

View Editor


Using Navigation bar and Toolbars

When the Data tab (in Table Editor, View Editor) or the Result(s) tab (in Query Data, Design Query) is selected, the Navigation bars of these tools contain the Data Management group which allows you to:

iconCommit commit transaction

iconRollback rollback transaction

export data

export data as Execute Script

import data (in Table Editor, View Editor only)

Data View - Using Navigation bar

Items of the Navigation bar are also available on the ToolBar. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

The Navigation pane contains toolbars allowing you to:

  • go to the first record of the dataset;
  • go to the previous page;
  • go to the previous record;
  • go to the next record;
  • go to the next page;
  • go to the last record of the dataset;
  • insert a new record (in Table Editor only);
  • delete the selected record (in Table Editor only);
  • edit the selected record (in Table Editor only);
  • post edit (in Table Editor only);
  • cancel edit (in Table Editor only);
  • refresh data;
  • set bookmark;
  • go to saved bookmark;
  • call the Filter Builder dialog;
  • search for a string in the currently selected column data;
  • enable multi-level mode to display data of the table(s) related by a foreign key (in Table Editor only)
  • specify the maximum number of records (record limit) for displaying data (in Table Editor, View Editor only);.

Data View - Navigation pane

The Toolbar of the Print Data mode allows you to:

  • customize the report using Report Formatter and the Report Options dialog;
  • load a report from an external *.rps file;
  • save the current report to an external *.rps file;
  • print the report using the default printer;
  • set printing options using the standard Print dialog;
  • call the Page Setup dialog;
  • show/hide report thumbnails;
  • customize the Report Title;
  • add Date and Time, Page Numbering, show/hide empty pages;
  • shrink the report to the page;
  • specify background color;
  • zoom in/out, setup zoom, zoom page width, whole page, two/four/multiple pages;
  • select the active page of the report;
  • go to first/previous/next/last page of the report.

Data View - Print Data - Toolbar

The Toolbar of the BLOB View mode allows you to:

  • select a BLOB column;
  • select encoding (ANSI, UTF-8, UNICODE-16);
  • load BLOB content from an external file;
  • save the BLOB column content to an external file;
  • cut/copy/paste selected text to/from clipboard (enabled for the Text and Rich Text tabs only);
  • undo changes;
  • print the text (enabled for the Text, Rich Text and HTML tabs only);
  • select font to be applied to the selected text (enabled for the Rich Text tab only);
  • select font size to be applied to the selected text (enabled for the Rich Text tab only);
  • make the selected text bold/italic/underlined (enabled for the Rich Text tab only);
  • align left/center/right (enabled for the Rich Text tab only);
  • add/remove list bullets (enabled for the Rich Text tab only).

Data View - BLOB View - Toolbar

See also:

Grid View

Form View

Print Data

BLOB View

Applying changes

Customize toolbars and menus


Grid View

By default, data returned by a query are displayed as a grid. It is indicated by the Grid View tab selected on the View mode panel at the bottom of the Results area of the window.

When in the Grid View mode, the columns correspond to the fields and the rows correspond to the records.

If more convenient, you can change the order of the columns by dragging their headers horizontally. Clicking the column caption sorts data by the values of this column in the ascending or the descending mode. The navigation pane at the top of the grid allows you to browse the data quickly, to insert, update and delete records, and to set a filter for the records using the Filter Builder dialog and other tools.

The Navigation bar of the parent window, toolbars and the context menu of the grid provide you with a number of data management functions: Export Data, Import Data, Export as SQL Script and more.

  • Customizing columns
  • Grouping data within the grid
  • Filtering records
  • Using the context menu
  • Working in multi-level mode
  • Browsing data in card view
  • Column Summary
  • Copying records

Data View - Grid View

Hint: To increase the speed of opening tables and views with extremely large number of records, you can use options of the Grid mode group available in the Grid | Data Options section of the Environment Options dialog.

See also:

Using Navigation bar and Toolbars

Form View

Print Data

BLOB View

Applying changes


Customizing columns

Selecting visible columns

When working in the Grid View mode, you can specify which columns of the current dataset will be visible. Click the btnSelectVisibleColumns button available in the top left corner of the data grid and select/deselect columns in the drop-down list to specify their visibility/invisibility.

Data View - Grid View - Selecting visible columns

Changing columns order

For your convenience the possibility to change the order of the columns in the data grid is available. To reorder columns, drag a column header horizontally to a place in between two other column headers indicated with green arrows.

Data View - Grid View - Changing columns order

See also:

Grouping data

Filtering records

Working in multi-level mode

Working in card view mode

Column Summary


Grouping and sorting data

In order to sort data, do the following:

open data at the Data or Results tab, choose the column by which you need to sort data and click the column title.

If the column was not sorted, the first click will sort it in the ascending order and the second one - in the descending order.

Clear Sorting

To cancel the sorting, open the context menu by right-clicking the necessary column and choose the Clear Sorting item, or press the Ctrl button and click the column title.

If necessary, you can group the data in grid by any of the columns.

This operation is performed by dragging the column header to the gray "Group by" box area at the top. In order to display this area, select the CheckBox Show "Group by" box option available in the Grid section of the Environment Options dialog.

When grouping by a column is applied to the grid, all the records are displayed as subnodes to the grouping row value as displayed in the screenshot below. The grouping row can contain the column summary information specified in the Group header group of the Column Summary dialog.

To reverse grouping, just drag the column header back.

Hint: While dragging the column header back, you can also change the column position.

Data View - Grid View - Grouping data

If necessary, you can group data by two or more columns. In this case column headers are displayed hierarchically, and data are grouped by these columns in the order the column headers appear in the "Group by" area.

Data View - Grid View - Grouping data by two columns

See also:

Customizing columns

Filtering records

Working in multi-level mode

Working in card view mode

Column Summary


Filtering records

A number of filtering facilities are implemented in the grid for your convenience. You can filter records in the grid in either of the following ways:

  • right-click a row and select the Quick Filter context menu item to filter records by the current value of the selected column;

Data View - Grid View - Quick Filter

  • click the Arrow-Down button next to the column caption to display the drop-down list and select any of the column values to filter records by this value of the selected column;

Data View - Grid View - Filtering records

or

  • click the Arrow-Down button next to the column caption to display the drop-down list, then select the Custom item and build a simple filter using the Custom Filter dialog;
  • use the Set filter btnSetFilter button on the navigation pane to invoke the Filter Builder dialog and create a composite filter using the dialog.

After the filter is set, the gray filtering panel becomes visible at the bottom of the grid. This panel allows you to see the active filtering condition and easily enable or disable it using the checkbox on the left. The Arrow-down button opens the drop-down menu which allows you to browse the filter history for this dataset.

If necessary, you can click the Customize... button on the right to customize your filter and add more complicated filtering conditions within the Filter Builder dialog.

Data View - Grid View - Filtering records - Filtering panel

To remove the current filter, click the Close btnClose button.

See also:

Customizing columns

Grouping data

Custom Filter

Filter Builder dialog


Using the context menu

The context menu of the grid is aimed at facilitating your work with data: you can perform a variety of operations using the context menu items:

  • copy the selected cell value to Windows clipboard;
  • paste the clipboard content to the currently selected cell;
  • copy/paste multiple records;
  • data manipulation: Export Data from the table, Import Data to the table, Export Data as Execute Script;
  • set/disable Quick Filter;
  • clear sorting;
  • set a value for the selected cell: NULL, Empty string (for string fields), Now (for DATE/TIME fields);
  • edit the BLOB value or save the BLOB to file using BLOB viewer/editor;
  • expand/collapse grid levels and navigate within the tabs;
  • manage grid levels: add a new grid level, delete the current grid level (this item is enabled only when the detail level exists and is currently focused);
  • switch to the Card View mode;
  • view Column Summary;
  • select visible/invisible columns of the dataset;
  • fit column width for better representation;
  • specify the grid mode: Load All Rows, Load Visible Rows, Default;
  • view/edit grid properties.

Data View - Grid View - Using the context menu

Note: If the CheckBox Show editor immediately and CheckBox Always show editor options on the Environment options | Grid tab are checked then the context menu of a grid can be evoked by selecting the necessary cell and right-clicking the table header. Otherwise, right-clicking the cell evokes the cell editing menu.


Working in multi-level mode

One of unique features of SQL Manager for Oracle is the ability to work with data in multi-level mode to view and modify data in several related tables simultaneously.

To manage grid levels, right-click the grid and select the Grid Levels context menu group. Items of this group allow you to:

  • add a new grid level using Create Grid Level Wizard;
  • delete the current grid level;
  • switch between the ordinary Table View and the Card View modes.

Data View - Grid View - Working in multi-level mode

See also:

Using the context menu

Create Grid Level wizard


Create Grid Level wizard

Create Grid Level Wizard allows you to add a new detail level to the grid in order to get master-detail representation of your data.

To start the wizard, right-click the grid, select the Grid Levels context menu group and proceed to the Add Grid Level... item within this group.

  • Specifying master level
  • Selecting source table
  • Binding master and detail levels
  • Query parameterization
  • Setting additional parameters

Create Grid Level - Add Grid Level


Specifying master level

Use the drop-down list to select the table of the master level to which a new level will be added.

Source of new level data

Select the source type of the new level data: RadioButton Table or RadioButton Query.

Create Grid Level - Specifying master level

Click the Next button to proceed to the Defining source for detail level step to select a table for the detail level or input a query, depending on whether the RadioButton Table or the RadioButton Query option has been selected.


Defining source for detail level

If the RadioButton Table option has been selected at the previous step, you should now specify a table for the detail view using the Table name drop-down list. Set the CheckBox Show tables related by foreign keys only option to narrow the list of tables by including only tables linked by Foreign keys.

Create Grid Level - Defining source for detail level - Table

If the RadioButton Query option has been selected at the previous step, you should now enter a query that will be used as the source of the new grid level. If necessary, you can use Design Query to build the SQL query visually.

Create Grid Level - Defining source for detail level - Query

Click the Next button to proceed to the Binding master and detail levels step of the wizard.


Binding master and detail levels

Define pairs of fields to link the Master Level and the Detail Level data sources:

  • select a field in the Master Level Key Fields list;
  • select a corresponding field in the Detail Level Key Fields list;
  • click Add to set correspondence between the selected fields.

The newly created correspondences are listed in the Links Between Master and Detail Levels area. If necessary, you can delete any correspondence using the Remove button.

The From Foreign Key... menu is available if the CheckBox Show tables related by foreign keys only option has been selected at the previous step. This menu allows you to select the foreign key to be used for identifying master-detail levels (if the table has more than one foreign key relation).

Create Grid Level - Binding master and detail levels

Click the Next button to proceed to the Setting additional parameters step or to the Query parameterization step of the wizard if RadioButton Query was selected at the Specifying master level step of the wizard.


Query parameterization

If RadioButton Query was selected at the Specifying master level step of the wizard, you should now transform the query to a parameterized form that will be used in the 'Load visible rows' Grid Mode (see the Grid | Data Options section of the Environment Options dialog to get more information about grid modes offered by SQL Manager).

Create Grid Level - Query parameterization

Click the Next button to proceed to the Setting additional parameters step of the wizard.


Setting additional parameters

Level caption

Set the caption to be used for the new level in the grid.

Level type

Select the type of view you wish to be applied to the grid level: RadioButton Table view or RadioButton Card view.

Create Grid Level - Setting additional parameters

When you are done, click the Run button to complete the operation.


Working in card view mode

Depending on your preferences, you can represent data in the Table View or in the Card View modes.

To switch to the Card View mode of data representation, right-click the grid, expand the Grid Levels context menu group and select the Card View item within this group.

Data View - Grid View - Working in card view mode

See also:

Using the context menu


Column Summary

If necessary, you can select the Column Summary... context menu item to open the Column Summary dialog which allows you to set the summary for each particular column that will be displayed in the grid footer, group header and group footer areas.

Data View - Grid View - Column Summary

The Column list displays all columns of the dataset. Select a column and specify which information should be displayed in the grid as summary for this column:

RadioButton None

RadioButton Sum (for numeric types only)

RadioButton Minimum (for numeric and date/time types only)

RadioButton Maximum (for numeric and date/time types only)

RadioButton Count

RadioButton Average (for numeric types only)

Use the Number format edit boxes in each group to specify the preferable format for summary info representation.

See also:

Using the context menu


Copying records

When you copy several records to clipboard and paste them into the grid, you are offered to set correspondence between columns of the clipboard and fields of the target Oracle table using the Associate Columns dialog.

Data View - Grid View - Associate columns

The Clipboard Columns and Grid Columns lists display the source and target dataset columns respectively. Set correspondence between the source clipboard columns and the table columns:

  • select a source clipboard column in the Clipboard Columns list;
  • select the corresponding field the target table in the Grid Columns list;
  • click the Add button to set correspondence between the selected columns;
  • the pair of columns appears in the Links between... list below;
  • repeat the operation for all the columns you need copy.

Use the Add All button to add all columns to the Links between... list on the basis of their order.

To remove a correspondence, select the pair of columns in the Links between... list and press the Remove button.

To remove all correspondences, press the Remove All button.

CheckBox First row is a header

This option specifies that the first row of the associated columns will be taken as the column header.


Form View

The Form View tab allows you to view data as a form. To activate this type of data view, select the Form View tab on the View mode panel at the bottom of the window.

The form displays the current record: field names on the left and the corresponding values on the right. If the fields are available for editing, you can edit the record directly on this form. The navigation pane at the top of the form allows you to browse the data quickly, to insert, update and delete records, and to set a filter for the records using the Filter Builder dialog.

Data View - Form View

Each field has a CheckBox Null checkbox which allows you to clear the field value and set it to NULL (if the field is nullable).

See also:

Using Navigation bar and Toolbars

Grid View

Print Data

BLOB View

Applying changes


Print Data

Using the Print Data tab you can view data in the way they are printed, in WYSIWYG mode.

When in Print Data mode, you are provided with a powerful context menu and toolbar allowing you to design a report, change the view scope, save reports and load previously saved ones, set report options, and specify a number of printing parameters using Report Formatter and the Page Setup dialog.

Data View - Print Data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using Navigation bar and Toolbars

Grid View

Form View

BLOB View

Applying changes


Page Setup

The Page Setup dialog allows you to specify a number of settings pertaining to the report page.

To open the dialog, use the Page Setup [image] button available on the toolbar.

Use the following tabs of the Page Setup dialog:

  • Page
  • Margins
  • Header/Footer
  • Scaling

When you are done, you can click the Print... button at the bottom to call the Print dialog.

See also:

Report Formatter

Setting report options

Print dialog


Page

The Page tab of the Page Setup dialog allows you to specify the paper, page orientation, print order and shading settings.

Data View - Print Data - Page Setup - Page

Paper

Select one of the standard paper types in the Type list, or specify custom width and height using the Dimension group (in inches or millimeters, depending on the unit of measure specified in the Options dialog).

Use the Paper source drop-down list to select the paper feed type.

Orientation

Select the preferable page orientation (your selection is illustrated in the chart on the left):

RadioButton Portrait

RadioButton Landscape

Print Order

Select the preferable order for printing report pages (your selection is illustrated in the chart on the left):

RadioButton Down, then over

RadioButton Over, then down

Shading

CheckBox Print using gray shading

If this option is selected, gray shading (along with black and white) will be used for printing the report.


Margins

The Margins tab of the Page Setup dialog allows you to specify the size of the margins and running titles.

Data View - Print Data - Page Setup - Margins

Use the spinner controls to specify the size of top / bottom / left / right margins and header / footer (in inches or millimeters, depending on the unit of measure specified in the Options dialog). The Preview area on the right illustrates the changes you have made.

If you have specified an improper value, you can click the Fix button to correct it.

To restore the default size values, click the Restore Original button.

Center on page

This group allows you to specify whether the text should be centered horizontally and/or vertically on the page.


Header/Footer

The Header/Footer tab of the Page Setup dialog allows you to specify properties of the header and footer running titles.

Data View - Print Data - Page Setup - Header and Footer

Header / Footer

Click the Font... button to specify font properties using the standard Font dialog. The font name and size are displayed in the gray area next to the Font... button.

Use the Background drop-down list to select the background color that will be applied to the page header/footer, or to customize the color using the Color and Fill Effects dialogs.

For each of the running titles you are provided with three separate text editing fields. You can use any, all or none of the fields to enter the header and footer text.

The Vertical Alignment group allows you to specify vertical alignment for the header/footer text according to any of the three available patterns.

Predefined Functions

This group allows you to add the following standard functions to the header and footer:

[Machine Name]

[User Name]

[Time Printed]

[Date Printed]

[Date & Time Printed]

[Page # of Pages #]

[Total Pages]

[Page #]

CheckBox Reverse on even pages

If this option is selected, the header and footer text will be reversed on even pages of the printing report.


Scaling

The Scaling tab of the Page Setup dialog allows you to specify the page scaling options.

Data View - Print Data - Page Setup - Scaling

Select the preferable scaling mode.

RadioButton Adjust to ... % normal size

Use the spinner control to set the percentage of the regular page size to which the page size will be adjusted.

RadioButton Fit to ... page(s) wide by ... tall

Use the spinner controls to set the maximum number of pages (by width and by height) on one page to fit its size.


Report Formatter

Report Formatter allows you to specify a number of settings pertaining to the printing form of the report.

To open the tool, click the Design Report [image] button available on the toolbar, or use the Ctrl+D shortcut.

Use the following tabs of the Format Report dialog:

  • View
  • Behaviors
  • Formatting
  • Styles
  • Preview
  • Cards
  • Charts

The Title Properties... button allows you to customize the report title using the Report Title dialog.

See also:

Page Setup

Setting report options

Print dialog


View

The View tab of the Format Report dialog allows you to specify report elements to show in the report.

Data View - Print Data - Report Formatter - View

Tick off the elements to show in the report (caption, bands, headers, footers, group footers, expand buttons, filter bar) and on every page of the report (caption, bands, headers, footers, filter bar).

The Preview area on the right illustrates the changes you have made.


Behaviors

The Behaviors tab of the Format Report dialog allows you to specify the way (behavior) the report elements will appear on the printing form.

Data View - Print Data - Report Formatter - Behaviors

Selection

CheckBox Process selection / CheckBox Process exact selection

Specify whether the text selection should or should not be processed (precisely) for the printing form.

Expanding

Tick off the elements to expand in the report: groups, details, cards.

Size

CheckBox Auto Width

If this option is selected, the table will be resized automatically to fit the page by width.

The Preview area on the right illustrates the changes you have made.


Formatting

The Formatting tab of the Format Report dialog allows you to specify Look and Feel, Refinements and Pagination options.

Data View - Print Data - Report Formatter - Formatting

Look and Feel

This setting determines the manner in which the cells are painted. Use the drop-down list to select the painting style that will be applied to the cells on the printing form:

Flat

Standard

UltraFlat

Refinements

Options of this group allow you to reduce the report size.

CheckBox Transparent graphics

If this option is selected, the images will be drawn transparent in the report.

CheckBox Display graphic as text

If this option is selected, text will be displayed instead of the images.

CheckBox Flat CheckMarks

If this option is selected, the checkboxes will be drawn flat.

Pagination

Specify the way pagination will be performed for the report: By TopLevel groups or One group per page.

The Preview area on the right illustrates the changes you have made.


Styles

The Styles tab of the Format Report dialog allows you to specify styles to be applied to the report elements.

Data View - Print Data - Report Formatter - Styles

CheckBox Use native styles

This option determines whether the native Windows style will be applied to the report elements.

Note: The Native style option is currently supported for the Windows® XP operating system only.

The elements list displays the names of all report elements, with background color and font properties specified by default. You can Use native styles for them or customize them according to your preferences.

To edit an element, select it in the list and use the buttons to the right to edit the style for it.

Click the Font... button to specify font properties using the standard Font dialog.

Click the Color... button to customize the background color using the standard Color dialog.

Click the Texture... button to load an image that will be used as the texture for the element.

To rollback the changes, click the Clear button.

To restore the default stylesheet properties, click the Restore Defaults button.

If you need to save the current style sheet, you can click the Save as... button.

These items are also available through the context menu of the elements list.

Style Sheets

Use the drop-down menu to select the style sheet you need. To manage the style sheets, use the corresponding buttons below: New..., Copy..., Delete..., Rename...

The Preview area on the right illustrates the changes you have made.


Preview

The Preview tab of the Format Report dialog allows you to specify report preview options.

Data View - Print Data - Report Formatter - Preview

CheckBox Visible

This option specifies visibility of the grouping rows.

CheckBox Auto height

If this option is selected, the table will be resized automatically to fit the page by height.

Max line count

Use the spinner control to specify the maximum possible number of lines.

The Preview area on the right illustrates the changes you have made.


Cards

The Cards tab of the Format Report dialog allows you to specify properties for the card view.

Data View - Print Data - Report Formatter - Cards

Sizes

CheckBox Auto Width

If this option is selected, the cards will be resized automatically to fit the page by width.

CheckBox Keep same width

Select this option to keep the card width fixed.

CheckBox Keep same height

Select this option to keep the card height fixed.

Spacing

This group allows you to specify horizontal and vertical spacing between cards.

Framing

CheckBox Border

This option specifies visibility of the card borders.

CheckBox Horizontal lines

This option specifies visibility of the horizontal lines (row delimiters) within cards.

CheckBox Vertical lines

This option specifies visibility of the vertical lines (column delimiters) within cards.

Shadow

Use the Color drop-down list to select the color that will be applied to the card shadows. If necessary, specify the color depth using the corresponding spinner control.

The Preview area on the right illustrates the changes you have made.


Charts

The Charts tab of the Format Report dialog allows you to specify options for the charts used in the report.

Data View - Print Data - Report Formatter - Charts

CheckBox Transparent

If this option is selected, the charts will be drawn transparent in the report.

The Preview area on the right illustrates the changes you have made.


Setting report options

Options dialog

The Options dialog allows you to specify a number of settings pertaining to the printing report.

To open the dialog, open the Design Report [image] menu available on the toolbar and select the Preferences item.

Data View - Print Data - Report options

Show

Tick off the elements to show in the printing report (margins, margins hints, margins hints while dragging).

Use the Measurement Units drop-down list to select the unit of measure that will be used in report settings: default, inches, or millimeters.

Zoom Parameters

CheckBox Zoom on roll with IntelliMouse

If this option is selected, you can zoom in/out by scrolling up/down (with a Microsoft® mouse or a compatible mouse used).

Zoom Step

Use the spinner control to specify the percentage of the original page size to be considered as one zoom step.

Use the Margins Color drop-down list to select the color that will be applied to the report margins.

Report Title dialog

The Report Title dialog allows you to specify the report title text and properties.

To open the dialog, use the Title... button available on the toolbar.

Data View - Print Data - Report options - Title

Mode

Use the drop-down list to select where the report title should be displayed on the first page, on every top page, or not displayed at all.

Text

Use the edit box to enter the text of the report title.

Properties

CheckBox Transparent

If this option is selected, the report title will be drawn transparent.

Use the Color drop-down list to select the color that will be applied to the report title (enabled if the CheckBox Transparent option is not selected).

Click the Font... button to specify title font properties using the standard Font dialog. The font name and size are displayed in the gray area next to the Font... button.

CheckBox Adjust on scale

If this option is selected, the title can be adjusted on scale.

Alignment

Use the Horizontally drop-down list to select the type of horizontal alignment to be applied to the report title: Left, Center, or Right.

Use the Vertically drop-down list to select the type of vertical alignment to be applied to the report title: Top, Center, or Bottom.

To restore the default title properties, click the Restore Defaults button.

Date and Time dialog

The Date and Time dialog allows you to specify the date/time formats to be used in the report.

To open the dialog, open the Title... menu available on the toolbar and select the Date and Time... item.

Data View - Print Data - Report options - Date and Time

Select the preferable values from the Available Date Formats and the Available Time Formats lists. If necessary, you can specify that the date/time will be updated automatically.

To apply the default date/time format, click the Default... button.

Page Number Format dialog

The Page Number Format dialog allows you to specify the formats for page numbers to be used in the report.

To open the dialog, open the Title... menu available on the toolbar and select the Page Numbering... item.

Data View - Print Data - Report options - Page Number Format

Select the preferable number format from the Number Format drop-down list.

Use the Page Numbering section to specify whether page numbering should continue from the previous section (if any) or start at the specified number.

To set the default numbering values, click the Default... button.

Zoom dialog

The Zoom dialog allows you to zoom the report page more better representation.

To open the dialog, open the Zoom [image] menu available on the toolbar and select the Setup zoom... item.

Data View - Print Data - Report options - Zoom

Select the preferable percentage of zoom value (500%, 200%, 150%, 100%, 75%, 50%, 25%, 10%) or specify one of frequently used values:

RadioButton Page Width

RadioButton Whole Page

RadioButton Two Pages

RadioButton Four Pages

RadioButton Many Pages (click the chart below and select the item you need)

If necessary, you can set a custom percent value using the Percent spinner control below.

The Preview area on the right illustrates the changes you have made.

See also:

Page Setup

Report Formatter

Print dialog


Print dialog

The standard Print dialog allows you to specify printing settings for the report in groups: printer, page range, copies.

To open the dialog, click the Print dialog btnPrintSetup button available on the toolbar, or use the Ctrl+P shortcut.

Data View - Print Data - Print dialog

When you are done, click the Print button to start printing.

If you need to change any page settings before printing, you can click the Page Setup... button at the bottom to call the Page Setup dialog.

See also:

Page Setup

Report Formatter

Setting report options


BLOB View

SQL Manager for Oracle provides BLOB Viewer/Editor to view and edit BLOB (Binary Large Object) fields content. The BLOB Viewer/Editor can be invoked from the data grid within Table Editor, Query Data, Design Query, etc.

  • Navigation within the BLOB Viewer/Editor
  • Viewing/Editing BLOB field as Hexadecimal dump
  • Viewing/Editing BLOB field as plain Text
  • Viewing/Editing BLOB field as Rich Text (RTF)
  • Viewing/Editing BLOB field as Image
  • Viewing/Editing BLOB field as HTML
  • Viewing/Editing BLOB field as XML
  • Viewing/Editing BLOB field as PDF

Data View - BLOB View

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using Navigation bar and Toolbars

Grid View

Form View

Print Data

Applying changes


Navigation within BLOB Editor

The BLOB Viewer/Editor provides an ability to navigate within the records using DB Navigation buttons on the navigation pane at the top of the viewer window.

Using items of the navigation pane and the drop-down menu you can browse the data quickly, insert, update and delete records, set a filter for the records using the Filter Builder dialog, load new BLOB content and save the current content to files.

The toolbar allows you to switch the fields and perform a number of editing operations. The set of toolbar items depends on the current selection and view mode.

Data View - BLOB View - Navigation within BLOB Editor

See also:

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML

Editing as XML

Editing as PDF


Editing as Hexadecimal

The Hexadecimal tab allows you to view/edit the BLOB data as hexadecimal.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the hexadecimal data to a file, or load data from a file.

Use the Ins key to switch between the Insert and Overwrite modes.

Data View - BLOB View - Hexadecimal

See also:

Navigation within BLOB Editor

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML

Editing as XML


Editing as Text

The Text tab allows you to view/edit the BLOB data as plain text.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the text to a *.txt file, or load text from a file. Additionally, you can use the Cut, Copy, Paste, Select All, Undo, Word Wrap context menu items for editing the text efficiently, and the Print context menu item to print the content of the Text tab.

Data View - BLOB View - Text

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Rich Text

Editing as Image

Editing as HTML

Editing as XML


Editing as Rich Text

The Rich Text tab allows you to view/edit the BLOB data in Rich Text format (RTF).

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the Rich Text to a *.rtf file, or load text from a file. Additionally, you can use the Cut, Copy, Paste, Select All, Undo context menu items for editing the text efficiently, and the Print context menu item to print the content of the Rich Text tab.

Data View - BLOB View - Rich Text

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Image

Editing as HTML

Editing as XML


Editing as Image

The Image tab allows you to view the BLOB data as image.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the image to a *.png, *.wmf, *.ico or *.jpg file, or load an image from a file.

Data View - BLOB View - Image

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as HTML

Editing as XML


Editing as HTML

The HTML tab allows you to view the BLOB data as HTML (Hyper-Text Markup Language format) - in the way this data would be displayed by your Internet browser.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the btnSave Save to file and the iconLoadFromFile Load from file toolbar buttons to save the content as a *.html, or *.htm file, or load content from a file.

Data View - BLOB View - HTML

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image

Editing as XML


Editing as XML

The XML tab allows you to view/edit the XML (eXtensible Markup Language) data.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the content as *.xml or load XML content from a file.

Data View - BLOB View - XML

The XML content is represented as a tree-like structure consisting four editable fields: Name, Unique, Attributes and Value. You can edit data and modify the structure using drag-n-drop operations and items of the context menu.

Hint: Hold the Shift key when you drag-and-drop a node to insert it as a child one.

The context menu allows you to:

  • add a node (a child node relatively to the selected one);
  • remove the selected node;
  • copy the selected node source to clipboard;
  • cut the selected node;
  • copy the selected node;
  • paste a node from clipboard.

Press the Item attributes [image] button in the editing mode of an Attribute item to add or edit attributes.

Data View - BLOB View - XML - Item attributes

Use the btnAddItem btnRemoveItem buttons to add or remove an attribute. Click the required attribute name or value to edit.

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML


Editing as PDF

The PDF tab allows you to view the BLOB data as PDF using Adobe Acrobat Reader. You need to have Adobe Acrobat Reader installed to view PDF data.

The toolbar provides additional functionality for PDF Viewer/Editor: use the btnSave Save to file and the iconLoadFromFile Load from file toolbar buttons to save or load the document from the file.

Data View - BLOB View - PDF

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML

Editing as XML


Applying changes

After changes are done, click the Post Edit btnPostEdit button on the navigation pane to apply the changes or the Cancel Edit btnCancelEdit button to discard the changes.

Data View - Applying changes

See also:

Using Navigation bar and Toolbars

Grid View

Form View

Print Data

BLOB View


Custom Filter

The Custom Filter dialog is one of the filtering facilities implemented in Data View for your convenience.

To open the dialog, click the Arrow-Down button next to the column caption, and select the Custom item from the drop-down list.

Select a logical operator for checking the column values (like, is less than, is greater than, etc.) and set a value to be checked by this operator in the corresponding box on the right.

Data management - Custom Filter

If necessary, you can set the second condition and specify the relation between the two conditions: whether both of them should be satisfied (AND) or just any of them (OR). Use the '_' character to represent any single symbol, and use the '%' character to represent any series of symbols in the condition string.

See also:

Data View

Filter Builder dialog


Filter Builder dialog

The Filter Builder dialog is a powerful filtering tool implemented in Data View for your convenience.

The dialog is aimed at facilitating the procedure of creating and applying complex filter criteria for data. In addition, the tool allows you to save filter criteria to an external *.flt file for future use.

To open the Filter Builder dialog, use the Set filter btnSetFilter button on the navigation pane available within the Data tab of Table Editor and the Result(s) tabs of Query Data and Design Query.

  • Invoking the Filter Builder dialog
  • Adding a new condition to the filter
  • Setting filter criteria
  • Setting filter operator
  • Setting filter criteria values
  • Adding a new group
  • Setting group operator
  • Applying filter conditions

See also:

Data View

Custom Filter


Invoking the Filter Builder dialog

The Filter Builder dialog can be invoked in either of the following ways:

  • if a simple filter or the Custom Filter is being used, click the Customize... button on the gray filtering panel;

Filter Builder dialog - Invoking the Filter Builder dialog

  • use the Set filter btnSetFilter button on the navigation pane and create a composite filter using the dialog.

Data View - Navigation pane

The succeeding pages of this chapter are intended to illustrate usage of the Filter Builder dialog. Please see the instructions below to learn how to perform various operations in the easiest way.

See also:

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Adding a new condition

Suppose we need to select data from the sample table EMPLOYEES to view the list of IT specialists hired after 1/15/2007. These criteria are applied to the HIRE_DATE, the DEPARTMENT_ID and the JOB_ID fields.

Click press the button to add a new condition - this will add a new condition to the criteria. Alternatively, you can click the Filter button and select the Add Condition popup menu item.

Filter Builder dialog - Adding a new condition

You can also add the filter condition from the grid with Shift button.

See also:

Invoking the Filter Builder dialog

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter criteria

As we need to apply the filter criteria to the HIRE_DATE field, we click the column box (next to the ellipsis EllipsisButton button) to open the drop-down list displaying the available column names and select the HIRE_DATE item.

Filter Builder dialog - Setting filter criteria

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter operator

Since we need the list of employees hired after 1/15/2007, we need to select the IS GREATER THAN operator from the corresponding drop-down list.

Filter Builder dialog - Setting filter operator

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter criteria values

Next, we need to specify value '1/15/2007' for the IS GREATER THAN operator.

Similarly, if, for example, we need to get the list of employees hired during the 1/15/2000 - 1/15/2007 term, we set the BETWEEN filter operator (this will add two empty value boxes to specify the inclusive range for the BETWEEN condition) and specify the range for the operator, i.e. the '1/15/2000' and the '1/15/2007' values in the corresponding value boxes.

It is possible to set the date value manually by typing it in, or via the date editor which is activated when you click the value box.

Filter Builder dialog - Setting filter criteria values

Editors used in value boxes are determined by the data type assigned to the corresponding columns.

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Adding a new group

Setting group operator

Applying filter conditions


Adding a new group

Since we also need to get the list of IT specialists (i.e. those registered in a department and having an IT-oriented job), we can add a complex filter condition combining simple conditions with the AND operator. (However, in this particular case we can just add them on the same root level as for the existing condition).

If you need to add a group of conditions, click the ellipsis EllipsisButton button for the HIRE_DATE condition and select the Add Group popup menu item.

Filter Builder dialog - Adding a new group

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Setting group operator

Applying filter conditions


Setting group operator

Conditions of complex criteria can be combined with any of the four logical operators used: AND, OR, NOT AND, NOT OR.

In our case it is enough to click the group operator box and select the AND item from the drop-down menu.

Filter Builder dialog - Setting group operator

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Applying filter conditions


Applying filter conditions

Suppose we have created a condition within the new group. If we need, we can add more conditions at the same level and specify the required values using the value boxes. When the operation is completed, the Filter Builder dialog will look like in the screenshot below.

Click the Apply button to see the result of the filtering you have made, and click OK or Cancel to close the dialog with or without saving your filter conditions respectively.

Filter Builder dialog - Applying filter conditions

The Filter Builder dialog allows you to save filter criteria to and load them from external files. Clicking the Save As… or the Open… buttons activates the corresponding dialogs. Filter settings are stored in *.flt files.

Please be informed that a column in the file is referenced by its position within a view, hence filter settings cannot be correctly restored if columns have been deleted from the view after saving the filter to a file.

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator


Import/Export Tools

Using SQL Manager for Oracle you are provided with powerful tools to import and export data to/from your Oracle database.

Export Data Wizard

Exports data to various supported formats including MS Excel, MS Access, RTF, HTML, PDF, CSV, XML and more.

Import Data Wizard

Imports data from any of supported formats: MS Excel, MS Access, DBF, TXT, CSV, XML, MS Excel and more.

Export Data as SQL Scrpt

Exports data to an Execute Script as a number of INSERT statements.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Database Tools

Services

Options

How To...


Export Data Wizard

Export Data Wizard allows you to export data from a table / view or from a query result to any of supported formats (MS Excel, MS Access, MS Word, RTF, HTML, PDF, TXT, CSV, XML, DBF, MS Excel 97-2007, MS Word 97-2003 etc). You can save your settings as a template any time for future use.

To start the wizard, right-click the object in DB Explorer and select the Data Manipulation | [image] Export Data... context menu item.

Alternatively, you can open the Data tab of Table Editor / View Editor or the Result(s) tab of Query Data / Design Query, right-click the grid there and select the Data Manipulation | [image] Export Data of <object_name>... context menu item.

  • Setting name and format for the destination file
  • Selecting fields for export
  • Adjusting formats applied to exported data
  • Setting header and footer text for the destination file
  • Setting format-specific options
  • Setting common export options
  • Exporting data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Import Data Wizard

Export as SQL Script

Using templates


Setting destination file name and format

This step of the wizard allows you to select the destination file format you need to export data into.

Destination format

Specify the format of the destination file. For details refer to Supported file formats.

Destination file name

Type in or use the btnSaveAs button to specify the path to the file using the Save as... dialog. The file name extension changes automatically according to the selected Destination format.

Note: If the target file already exists, the application will show a warning dialog where you can choose the action you need.

Export Data - Setting destination file name and format

Click the Next button to proceed to the Selecting fields for export step of the wizard.


Selecting fields for export

This step of the wizard allows you to select the table field(s) to be exported.

To select a field, you need to move it from the Available fields list to the Selected fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Export Data - Selecting fields for export

If you leave all the fields in the Available fields list, all fields of the table (except BLOBs) will be exported.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Adjusting data formats

This step allows you to customize formats applied to exported data.

Data formats

Edit the format masks to adjust the result format in the way you need: Integer, Float, Date, Time, DateTime, Currency, Boolean True, Boolean False, NULL string, Decimal separator, Thousand separator, Date separator, Time separator.

Export Data - Adjusting data formats

Hint: The formats used by default are specified in the Data Export section of the Environment Options dialog.

For more details refer to Format specifiers.

Click the Next button to proceed to the Setting header and footer step of the wizard.


Setting header and footer

Set Header text and Footer text for the result file. This text will appear at the beginning and at the end of the result file respectively.

Export Data - Setting header and footer

If you are exporting the result of a query, it is possible to add the text of the query to the header and/or to the footer of the output file. Use the corresponding Add to Header / Add to Footer buttons to add the query text or the query template to the header/footer of the output file.

Export Data - Setting header and footer - Add to header and footer

Click the Next button to proceed to Setting format-specific options.


Setting format-specific options

This step of the wizard allows you to customize Format-specific options:

  • Excel 97-2003 options
  • Access options
  • Word / RTF options
  • HTML options
  • PDF options
  • TXT options
  • CSV options
  • XML options
  • MS Excel 97-2007 / ODS options
  • MS Word 2007 / ODT options

To get more information about the file formats, see the Supported file formats page.


Excel 97-2003 options

This step allows you to set options for the target MS Excel 97-2003 (*.xls) file.

You can customize Data format, Extensions and set Advanced options available within the corresponding tabs:

  • Data format
  • Extensions
  • Advanced

Export Data - Format-specific options - Excel

When you are done, click the Next button to proceed to Setting common export options.


Data format

The Data Format tab contains general options which allow you to adjust the format for each kind of Excel cells. This means that you can specify such parameters as font, borders, filling color and method, etc. for each entity (such as data field, header, footer, caption, data, hyperlink and so on) separately. Also it is possible to create styles to make the target Excel file striped by columns or rows.

  • Fields
  • Options
  • Styles

For your convenience the previews illustrating the changes are displayed in the Sample Group area on each page of Data Format tab.


Fields

Using the Fields tab you can set font options, border and fill options and aggregate functions for all the fields you want to export.

The Font tab allows you to specify properties of the font that will be used in the output Excel file cells.

Use the Font and Size drop-down lists to select the font and size to be applied to the output text.

Use the buttons below to set font color, make text bold, italicized, strikethrough text, set underline effects, specify text horizontal and vertical align.

Export Data - Format-specific options - Excel - Data Format - Fields

The Borders tab allows you to specify properties of the borders of the output Excel file cells.

Press the [image] [image] [image] [image] buttons on the left to show/hide the borders they indicate.

Use the drop-down list for each border to select the line type and the [image] button on the right to select the line color for each border.

Export Data - Format-specific options - Excel - Data Format - Fields - Borders

The Fill tab allows you to specify the fill pattern for the output Excel file cells.

Use the drop-down list to select the preferable fill pattern type.

Press the [image] button on the left to set the background color for the fill pattern.

Press the [image] button on the right to set the foreground color for the fill pattern.

Export Data - Format-specific options - Excel - Data Format - Fields - Fill

The Aggregate tab allows you to specify an aggregate function for the field in the output Excel file.

Select a function that will be applied to the field:

RadioButton None

RadioButton AVG

RadioButton MAX

RadioButton SUM

RadioButton MIN

Export Data - Format-specific options - Excel - Data Format - Fields - Aggregate

You can reset the changes any time using the Reset Item and the Reset All buttons.


Options

Using the Options tab you can set font options, border and fill options for all elements of the Excel sheet (header, caption, footer, aggregates and hyperlinks).

Export Data - Format-specific options - Excel - Data Format - Options

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Styles

Using the Styles tab you can make a style template: set font options, border and fill options and save them.

To add a style template, click the iconPlus Plus button.

To delete a style template, select it and click the iconMinus Minus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Excel - Data Format - Styles

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Extensions

The Extensions tab provides an ability to add hyperlinks and notes and to any cell of the target file, to specify a value of a cell, to create a chart and to merge cells.

Click the iconPlus Plus button to add an element;

click the iconMinus Minus button to delete an element.

  • Hyperlinks
  • Notes
  • Charts
  • Cells
  • Merged Cells


Hyperlinks

If you need to create a hyperlink:

  • set the cell coordinates (Col and Row);
  • specify whether this is a local link or URL;
  • enter the title of the hyperlink;
  • specify the target file location or address.

Export Data - Format-specific options - Excel - Extensions - Hyperlinks

Use the Col and Row spinner controls to specify the column and row for the hyperlink in the output file.

The Style group allows you to select the preferable hyperlink style:

RadioButton URL

RadioButton Local file (i.e. the file is located on your local machine or on a machine in the LAN)

Use the Title box to specify the hyperlink name.

The Target box lets you enter the path to the target file or URL. Use the EllipsisButton button to check whether the specified location is available.


Notes

If you need to create a note:

  • set the cell coordinates (Col and Row);
  • enter text of a note for the cell;
  • set the font and fill properties using the corresponding tabs.

The Base tab allows you to specify basic properties of the note to be added to the output Excel file.

Use the Col and Row spinner controls to specify the column and row for the note in the file.

Use the edit-box below to enter the text of the note.

Export Data - Format-specific options - Excel - Extensions - Notes - Base

The Font tab allows you to specify properties of the font that will be used for the note.

Use the Font and Size drop-down lists to select the font and size to be applied to the output text.

Use the buttons below to set font color, make text bold, italicized, strikethrough text, set underline effects, specify text horizontal and vertical align.

The Orientation group allows you to select the note text orientation:

RadioButton No rotation

RadioButton Top to bottom

RadioButton Counterclockwise

RadioButton Clockwise

Export Data - Format-specific options - Excel - Extensions - Notes - Font

The Fill tab allows you to specify the fill type and transparency for the note.

The Fill Type group allows you to select whether the fill color will be solid or gradient:

RadioButton Horizontal

RadioButton Vertical

RadioButton Diagonal up

RadioButton Diagonal down

RadioButton From corner

RadioButton From center

Press the [image] button to set the background color for the fill pattern.

Press the [image] button to set the foreground color for the fill pattern.

The Transparency control allows you to set the transparency degree for the note. Move the slider between the 0% and 100% threshold values to select the required transparency value within this scope.

Export Data - Format-specific options - Excel - Extensions - Notes - Fill


Charts

If you need to create a chart:

  • enter the chart title;
  • select the chart style;
  • set the legend position;
  • specify if you want to show the legend;
  • specify if you want to set the chart color automatically;
  • define the chart position and category labels using the corresponding tabs.

The Base tab allows you to specify basic properties of the chart to be added to the output Excel file.

Use the Title box to specify the chart name.

Use the Style drop-down list to select the preferable chart style (Column, Column 3D, Bar, Bar 3D, Line, Line Mark, Line 3D, etc.).

The Legend position group allows you to specify position of the chart legend:

RadioButton Bottom

RadioButton Top

RadioButton Left

RadioButton Corner

RadioButton Right

CheckBox Show legend

This options specifies whether the chart legend will be visible or not.

CheckBox Auto color

If this option is selected, each series will be automatically differentiated with different colors on the chart, otherwise one color will be applied for all series.

Export Data - Format-specific options - Excel - Extensions - Charts - Base

The Position tab allows you to specify properties pertaining to the chart position on the output file sheet.

RadioButton Auto

Specifies automatic position of the chart.

The Placement group allows you to specify the chart position relative to the data:

RadioButton Bottom

RadioButton Right

Use the Left and Top spinner controls to specify the spacing between the chart and data at the left and at the top respectively.

Use the Height and Width spinner controls to specify the chart height and width respectively.

RadioButton Custom

Specifies absolute position of the chart (irrelative to the data). Use the spinner controls to set the coordinates you need.

Export Data - Format-specific options - Excel - Extensions - Charts - Position

The Category Labels tab allows you to specify in which rows and columns the chart will be built.

RadioButton Column

Use the drop-down list to select the column that will be used to take values for x-axis.

RadioButton Custom

Specify the range of cells from which x-axis values will be taken. Use the spinner controls to set the range you need.

Export Data - Format-specific options - Excel - Extensions - Charts - Category Labels

To build a chart, you also need to create series that will be used to take values for y-axis. To add series for the chart:

  • add one or more series using the iconPlus button;
  • enter the titles;
  • set data ranges (select a column from the drop-down list or set the custom range);
  • define colors for all the graphs.

Use the Title box to specify the series name.

Data range

RadioButton Column

Use the drop-down list to select the column that will be used to take values for the series.

RadioButton Custom

Specify the range of cells from which the series will be formed. Use the spinner controls to set the range you need.

Press the [image] button to set the color for the series.

Export Data - Format-specific options - Excel - Extensions - Series


Cells

If you need to add a value in a specific cell:

  • set the cell coordinates (Col and Row);
  • select the cell type;
  • enter a value;
  • if you are adding a numeric or a date/time value, you can set the cell format;
  • set the font, borders and fill properties using the corresponding tabs.

Export Data - Format-specific options - Excel - Extensions - Cells

The Base tab allows you to specify basic properties of the cell.

Use the Col and Row spinner controls to specify the column and row denoting the cell.

Use the Cell type drop-down list to select the data type for the cell (Boolean, DateTime, Numeric or String).

Set the required value in the Value edit box.

The Formats group allows you to specify data format for numeric or a date/time types.

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.


Merged Cells

If you want to merge two or more cells, set the range of cell coordinates: First col, Last col, First row, Last row. Use the spinner controls to set the range you need.

Export Data - Format-specific options - Excel - Extensions - Merged Cells


Advanced

The Advanced tab allows you to set a number of advanced options to be applied to the result MS Excel file.

Page header

If necessary, enter some text for the page header.

Page footer

If necessary, enter some text for the page footer.

Hint: It is also possible to set macros in the Page header and Page footer fields:

&N stands for the quantity of pages;

&P - the number of the current page.

Sheet title

Specify the sheet title for the target file.

Page background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the page background.

Export Data - Format-specific options - Excel - Advanced

CheckBox Calculate column width automatically

This option allows the wizard to determine column width in the target file automatically according to column size.


Access options

This step allows you to set options for the target MS Access (*.mdb, *.accdb) file.

Set the name for the target table and specify whether the wizard should create a new table in the MS Access database if it does not exist yet, or use the existing table to export data into.

Export Data - Format-specific options - Access

When you are done, click the Next button to proceed to Setting common export options.


Word / RTF options

This step allows you to set options for the target MS Word (*.doc) and Rich Text Format (*.rtf) files.

  • Base Styles
  • Strip Styles

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Word

When you are done, click the Next button to proceed to Setting common export options.


Base Styles

The Base Styles tab contains the list of target file entities: HEADER, CAPTION, DATA, FOOTER. You can customize style options, such as font and size, background and foreground colors, text alignment, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel. You can also switch page orientation for the target Word/RTF file using this tab.

Export Data - Format-specific options - Word - Base Styles

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, strikethrough text, specify horizontal align.

CheckBox Highlight

Enables/disables text highlight.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

Press the [image] button to set the highlight color for the text.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Strip Styles

Using the Strip Styles tab you can create a style template: set font, size, background and foreground colors, text alignment, highlight and save them.

To add a style template, click the iconPlus Plus button.

To delete a style template, select it and click the iconMinus Minus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Word - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.


HTML options

This step allows you to set options for the target HTML (*.html) file.

  • Preview
  • Basic
  • Multi-file
  • Advanced

Export Data - Format-specific options - HTML

When you are done, click the Next button to proceed to Setting common export options.


Preview

The Preview tab allows you to customize the style that will be applied to the target HTML file using a number of built-in templates provided in the Templates drop-down list.

Export Data - Format-specific options - HTML - Preview

You can select any of the pre-defined templates and customize it by clicking objects in the preview panel, and save the settings as a custom template using the Save template... button. Use the Load template... button to load a previously saved custom template from your hard disk.

Click on an element of the table to select the color that will be applied for this element (background, font, header row, odd row, even row, non-visited link, visited link, active link).


Basic

The Basic tab allows you to specify the basic parameters of target HTML file:

  • specify the title of the result file;
  • select whether the cascade style sheet (CSS) should be internal or external (the Ellipsis EllipsisButton button to browse for a *.css file);
  • determine whether boolean fields of the table should be exported as HTML check boxes.

Export Data - Format-specific options - HTML - Basic


Multi-file

The Multi-file tab provides you with an ability to split the target HTML file into several separate files. This tab allows you to specify the record count for a single file, set an option to generate an index HTML file, and add an ability to navigate between the exported files.

Export Data - Format-specific options - HTML - Multi-file

Multi-file export

CheckBox Use multi-file export

Enables/disables the multi-file export feature.

Record(s) in a single file

Use the spinner control to specify the number of records to be exported into each of the files.

CheckBox Generate index

Specifies that an index file containing links to all the data files will be generated. Use the edit-box next to the checkbox to set a name for the index file.

Navigation

This group allows you to specify properties for navigation elements, i.e. the elements that provide quick access to pages of the multi-file document. Navigation is implemented as a set of hyperlinks.

CheckBox On top

Specifies that the hyperlinks will be placed at the top of the page.

CheckBox On bottom

Specifies that the hyperlinks will be placed at the bottom of the page.

Use the Index link, First link, Prior link, Next link and Last link boxes to specify captions for the corresponding navigation elements.


Advanced

The Advanced tab allows you to set a number of advanced options to be applied to the result HTML file.

Export Data - Format-specific options - HTML - Advanced

Body options

Default font

Use the drop-down list to select the font that will be used in the result file by default.

Background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the page background.

Table options

Use the spinner controls to specify common table options: cell padding, cell spacing, border.

Background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the table background.

It is also possible to define advanced attributes for both the HTML body and table.


PDF options

This step allows you to set options for the target PDF (*.pdf) file.

Fonts

This group of options allows you to customize fonts for the header, caption, data, footer of the result file.

Use the Base font name and Font encoding drop-down lists to select the preferable font (Helvetica, Courier, Times Roman, etc.) and encoding (Standard, WinANSI, MacRoman, PDFDoc) respectively, and the Font size spinner control to specify the font size.

Click the Font color... button to select the color to be applied to the font.

For your convenience the preview illustrating the changes is displayed in the Sample area.

Export Data - Format-specific options - PDF

Page options

Use the Page size drop-down list to select one of the standard page formats (Letter, Legal, A3, A4, etc.).

Use the Width and Height spinner controls to specify the page width and height respectively.

Use the Units drop-down list to select the unit of measure that will be used in report settings: inches, millimeters, or dots.

Use the Orientation drop-down list to select the preferable page orientation: portrait or landscape.

Margins

Use the Left, Right, Top, Bottom spinner controls to specify the corresponding page margins for the output PDF file.

Grid options

Use the Col spacing, Row spacing, Line width spinner controls to specify spacing for grid columns, rows, and grid line width respectively.

When you are done, click the Next button to proceed to Setting common export options.


TXT options

This step allows you to set options for the target text (*.txt) file.

Set the Calculate column width option on if you want each column of the target file to be adjusted to the maximum number of characters in it. The Spacing option specifies the number of spaces between columns in the target file.

Export Data - Format-specific options - TXT

When you are done, click the Next button to proceed to Setting common export options.


CSV options

This step allows you to set options for the target CSV (*.csv) file.

CheckBox Quote strings

Check this option to apply quoting for string values in the target file.

CheckBox Quote captions

Check this option to apply quoting for captions in the target file.

Specify the column separator using the Comma drop-down list and the preferable quote character using the Quote drop-down list.

Export Data - Format-specific options - CSV

When you are done, click the Next button to proceed to Setting common export options.


XML options

This step allows you to set options for the target XML (*.xml) file.

Specify XML document encoding in the Encoding edit box and set the Standalone option on if you intend to create a standalone XML document (standalone="yes").

XML type

Select the type of the result XML document: Datapacket 2.0 or Access.

Conversion between generic XML documents and documents of the XML-Datapacket (CDS) format can be performed with the help of XML Mapper by Borland®.

Export Data - Format-specific options - XML

When you are done, click the Next button to proceed to Setting common export options.


MS Excel / ODS options

This step allows you to set options for the target MS Excel (*.xlsx) or ODF Spreadsheets (*.ods) file.

Using the Base Styles tab you can set font and border options for all elements of the Excel / ODS sheet (HEADER, CAPTION, DATA, FOOTER). You can customize style options, such as font and size, background and foreground colors, text alignment, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel.

If necessary, you can also specify the sheet name for the target Excel / ODS file.

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, specify horizontal and vertical align.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

Press the Wrap Text button to enable/disable the text wrapping feature.

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Excel 2007 - Base Styles

Using the Strip Styles tab you can create a style template: set font, size, background color, text alignment, wrap text options and save them.

To add a style template, click the iconPlus Plus button.

To delete a style template, select it and click the iconMinus Minus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Excel 2007 - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.

The Border tab allows you to specify properties of the borders of the output Excel / ODS file cells.

CheckBox Use border

Enables/disables borders in the output file.

Press the [image] button to set the color to be applied to the borders.

Use the Border Style drop-down list to select the preferable style that will be used for borders (thin, dashed, dashdot, dotted, etc.).

Export Data - Format-specific options - Excel 2007 - Border

When you are done, click the Next button to proceed to Setting common export options.


MS Word / ODT options

This step allows you to set options for the target MS Word (*.docx) or ODF text (*.odt) file.

Using the Base Styles tab you can set font options for all elements of the Word / ODT document (HEADER, CAPTION, DATA, FOOTER). You can customize style options, such as font and size, background and foreground colors, text alignment, text highlight, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel.

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, strikethrough text, specify horizontal align.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

CheckBox Highlight

Enables/disables text highlight.

If this option is enabled, you should select the preferable highlight color from the drop-down list.

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Word 2007 - Base Styles

Using the Strip Styles tab you can create a style template: set font, size, background color, text alignment, highlight options and save them.

To add a style template, click the Plus iconPlus button.

To delete a style template, select it and click the Minus iconMinus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Word 2007 - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.

Using the Border tab you can enable borders in the result Word 2007 / ODT document and customize them.

CheckBox Use border

Enables/disables borders in the output file.

Press the [image] button to set the color to be applied to the borders.

Use the Border Style drop-down list to select the preferable style that will be used for borders (single, thick, double, hairline, etc.).

Export Data - Format-specific options - Word 2007 - Border

When you are done, click the Next button to proceed to Setting common export options.


Setting common export options

Use this step of the wizard to set common export options. The detailed description of these options is given below.

Export Data - Setting common export options

Constraints

CheckBox Export empty tables

If checked, you can export the table even if it does not contain any data.

Skip ... record(s)

Specifies the number of records to be skipped before export starts.

RadioButton Export all records

Specifies that all records of the table will be exported.

RadioButton Export only ... record(s)

Specifies the number of records to be exported.

CheckBox Open files after export

If this option is checked, the result file will be opened with the currently associated program after the export operation is completed.

CheckBox Print files after export

If this option is checked, the result file will be sent to the default printer after the export operation is completed.

When you are done, click the Next button to proceed to the last step of the wizard.


Exporting data

This step of the wizard is intended to inform you that all export options have been set, and you can start the export process.

The log area allows you to view the log of operations and errors (if any).

Export Data - Exporting data

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the export process.

After the operation is completed, you can view the number of exported records, elapsed time, estimated export speed, and the log of operations and errors (if any).


Import Data Wizard

Import Data Wizard allows you to import data to a table / view from any of supported formats (MS Excel, MS Access, DBF, XML, TXT, CSV, HTML, ODF). You can save your settings as a template any time for future use.

To start the wizard, right-click the table/view in DB Explorer, select the Data Manipulation | [image] Import Data... context menu item.

Alternatively, you can open the Data tab of Table Editor / View Editor, right-click the grid there, then select the Data Manipulation | [image] Import Data to <object_name>... context menu item.

  • Setting source file name and format
  • Selecting the source to import data from
  • Setting correspondence between the source and target fields
  • Adjusting common data formats
  • Setting advanced field formats
  • Setting import mode and data write type
  • Customizing common import options
  • Importing data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Export Data Wizard

Export as SQL Script

Using templates


Selecting source file name and format

This step of the wizard allows you to select the source file format you need to import data from.

Import type

Specify the format of the source file. For details refer to Supported file formats.

Source file name

Type in or use the ExplorerButton button to specify the path to the file using the Open file... dialog. The file name extension changes automatically according to the selected Import Type.

Import Data - Selecting source file name and format

CSV format parameters

For CSV import you should define Delimiter and Quote settings using the corresponding drop-down lists.

Click the Next button to proceed to the Setting fields correspondence step or to the Selecting data source step of the wizard if you have selected MS Access as the source file format.


Selecting data source

This step of the wizard is only available when you are importing data from MS Access. Select a table from the table list or input a query in the corresponding text boxes to specify the data source.

If you choose a query as the data source, you also can load a SQL query from a *.sql file or save the current query text to a file using the Load from File... and the Save to File... buttons correspondingly.

Import Data - Selecting data source

Click the Next button to proceed to the Setting fields correspondence step of the wizard.


Setting fields correspondence

This step of the wizard allows you to set correspondence between columns of the source file and fields of the target Oracle table.

  • MS Excel
  • MS Access
  • DBF
  • XML Datapacket
  • TXT
  • CSV
  • HTML
  • XML Generic
  • MS Excel/Word 97-2003, ODF

To get more information about the file formats, see the Supported file formats page.


Excel 97-2003

Specify ranges in the grid for the target and source fields:

  • select a field of the target Oracle table in the Fields list;
  • proceed to the Sheet grid: click a column caption to select the whole column or click the row number to select the whole row;
  • the selected column/row of the source file gets green highlight, and a new range indicating the source and target fields correspondence appears in the Ranges list;
  • repeat the operation for all the fields you need to be included in the import process.

If the source Excel file and the destination Oracle table have the same order of columns or rows, you can use the iconAutoFillColumns Auto Fill Cols or the iconAutoFillRows Auto Fill Rows buttons to set correspondence between them automatically.

If necessary, you can choose to skip a defined number of the source file columns and/or rows using the Col(s) and Row(s) spinner controls of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - Excel

To clear ranges for a field, select the field in the Fields list and press the iconCross Clear Ranges button.

To clear all ranges specified for the target table fields, press the iconClearAllRanges Clear All button.

Right-click a range in the Ranges list to call its popup menu. Using the popup menu you can add or edit ranges manually, remove them or change their order.

Import Data - Setting fields correspondence - Excel - Popup menu

The Range dialog allows you to edit the data range for import manually.

Range Type

Use the drop-down list to select whether a column, a row, or a cell of the source Excel file will be mapped to the target table field.

Depending on the selected range type you should specify the column (e.g. B), the row (e.g. 2) or the cell (e.g. A2).

Start / Finish

These groups allow you to set the precise data range for import: select Where data started / finished or use the spinner control to specify the start/finish row (or start/finish column).

Direction

Use this group to select the direction for importing data of the specified range: Down or Up.

Sheet

Use this group to define whether the specified range will be taken from the default Excel sheet or from a custom sheet (select sheet number or sheet name using the corresponding drop-down lists).

Import Data - Setting fields correspondence - Excel - Range

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Access

Set correspondence between the source MS Access fields and the target Oracle table fields:

  • select a field of the target Oracle table in the Destination Fields list;
  • select the corresponding field of the source MS Access table in the Source Fields list;
  • click the iconPlus Add button to set correspondence between the selected fields;
  • the pair of fields appears in the list below;
  • repeat the operation for all the fields you need to be included in the import process.

Use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically on the basis of their order.

Import Data - Setting fields correspondence - Access

To remove a correspondence, select the pair of fields in the list below and press the iconMinus Remove button.

To remove all correspondences, press the iconCross Clear button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


DBF

Set correspondence between the source DBF columns and the target Oracle table fields:

  • select a field of the target Oracle table in the Destination Fields list;
  • select the corresponding column of the source DBF table in the Source Fields list;
  • click the iconPlus Add button to set correspondence between the selected fields;
  • the pair of fields appears in the list below;
  • repeat the operation for all the fields you need to be included in the import process.

Use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically on the basis of their order.

CheckBox Skip deleted records

Use the option to exclude records marked as deleted.

Import Data - Setting fields correspondence - DBF

To remove a correspondence, select the pair of fields in the list below and press the iconMinus Remove button.

To remove all correspondences, press the iconCross Clear button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


XML Datapacket

Set correspondence between the source XML columns and the target Oracle table fields:

  • select a field of the target Oracle table in the Destination Fields list;
  • select the corresponding column of the source XML table in the Source Fields list;
  • click the iconPlus Add button to set correspondence between the selected fields;
  • the pair of fields appears in the list below;
  • repeat the operation for all the fields you need to be included in the import process.

Use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically on the basis of their order.

Import Data - Setting fields correspondence - XML

To remove a correspondence, select the pair of fields in the list below and press the iconMinus Remove button.

To remove all correspondences, press the iconCross Clear button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


TXT

Set correspondence between the source text file columns and the target Oracle table fields:

  • select a field of the target Oracle table in the Fields list;
  • double-click in the text viewer area to add vertical separators delimiting the source column bounds;
  • click the area between the separators to assign the column to the selected target table field - the selected source column gets black highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If necessary, you can choose to skip a defined number of the source file lines using the Skip Lines spinner control (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - TXT

To clear all correspondences, press the iconCross Clear button.

Note: if you cannot see the content of the source text file properly, you should select the appropriate Charset to be used for processing data.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


CSV

Set correspondence between the target table fields and the source CSV file columns:

  • select a field of the target Oracle table in the Fields list;
  • proceed to the source grid viewer area: click a caption to assign the column to the selected target table field;
  • the selected column of the source file gets gray highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source CSV file and the destination Oracle table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

Note that the CSV delimiter is specified at the Selecting source file name and format step of the wizard.

The Col(s) control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Row(s) spinner control of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - CSV

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

Note: if you cannot see the content of the source text file properly, you should select the appropriate Charset to be used for processing data.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


HTML

Set correspondence between the target table fields and the source HTML file columns:

  • select a field of the target Oracle table in the Fields list;
  • proceed to the source grid viewer area: select the Table from which you intend to import data and click a column to assign the column to the selected target table field;
  • the selected column of the source file gets green highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source HTML file and the destination Oracle table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

The Col control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Row spinner control of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - HTML

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


XML Generic

In order to set mapping of a Generic XML document, you should enter the relative XPath (the path must be specified in the XPath format). Press the iconAutoFillColumns Fill Grid button to get the grid filled with text and attribute values of the selected node.

Note: if the source XML document contains huge amount of data, building the tree may take a long time.

Set correspondence between the source XML file columns and the target Oracle table fields:

  • select a field of the target Oracle table in the Fields list;
  • proceed to the source grid viewer area: click a column to assign the column to the selected target table field;
  • the selected column of the source file gets gray highlight;
  • repeat the operation for all the fields you need to be included in the import process.

You can use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically according to their order (mapping is started from the first attribute value in this case).

The Col(s) control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file lines using the Row(s) spinner control of the Skip group (e.g. if you need to exclude node headers from the imported data range).

Import Data - Setting fields correspondence - XML Document

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


MS Excel/Word, ODF

Specify ranges in the grid for the target and source fields:

  • select a field of the target Oracle table in the Fields list;
  • proceed to the Sheet grid: click a column to assign the column to the selected target table field;
  • the selected column of the source file gets green highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source file and the destination Oracle table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

The Col control indicates the currently selected source file column. You can also use this control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Skip spinner control (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - MS Excel and Word 2007, ODF

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Adjusting data formats

This step of the wizard provides a number of options for setting common formats for all imported data:

Date & Time formats: Short date, Long date, Short time, Long time;

Separators: Decimal, Thousand, Date, Time;

Boolean True (specify the text that will be displayed for the boolean TRUE values);

Boolean False (specify the text that will be displayed for the boolean FALSE values);

NULL values (specify the text that will be displayed for the NULL values).

For more information refer to the Format specifiers page.

Import Data - Adjusting data formats

Click the Next button to proceed to the Setting advanced field formats step of the wizard.


Setting advanced field formats

This step of the wizard allows you to set formats each field separately.

Select a field in the list and adjust format options that will be applied to this field only.

Import Data - Setting advanced field formats

Specify Generator value and Generator step for incremental data generation into the specified field, or enter a Constant value which will be set for all records in the field.

Specify the NULL value which will be used for the records where the value is NULL.

If necessary, specify the default value.

Use the Left / Right quotation edit boxes to specify left/right quotation marks.

Use the Quotation action drop-down list to select whether the quotation marks should be added, removed, or left 'As is'.

Use the Character case drop-down list to select the case that will be used for string values of the field: Upper, Lower, UpperFirst, UpperFirstWord, or 'As is'.

Use the Character set drop-down list to select which charset will be used for string data in the field: ANSI, OEM, or As is.

Replacements

This area allows you to set the text you need to be replaced during data import into the selected field. Press the iconPlus Plus button to specify a new replacement options using the Add Replacement dialog.

Import Data - Setting advanced field formats - Add Replacement

To edit a replacement, click the [image] Edit button.

To remove a replacement, click the iconMinus Minus button.

When you are done, click the Next button to proceed to the Setting import mode step of the wizard.


Setting import mode

This step of the wizard allows you to define the records processing mode.

Import mode

RadioButton Insert all: all records from the source file are inserted into the tables irrespective of whether any records exist in the destination table or not

RadioButton Insert new: already existing records are skipped, and new records are inserted into the destination table

RadioButton Update: all existing records are updated from the source file

RadioButton Update or insert: already existing records are updated and new records are inserted into the destination table

RadioButton Delete: already existing records are deleted

RadioButton Delete or insert: existing records are deleted and new records are inserted into the destination table

Import Data - Setting import mode

Here is an example of some import modes offered by Import Data Wizard.

All import modes (except for the Insert All mode) are based on key values information. In order to perform import operations with these modes used, you need to have matches between the source file key column(s) and the destination table key field(s).

For example, your source file contains three rows with the key values 1, 2, 3, and your destination table contains three rows with the key values 1, 2, 4.

Destination table | Source file data
Import Data - Setting import mode - Destination Table | Import Data - Setting import mode - Source Table

If you use the Insert new import mode, in this case only the row with key value 3 will be inserted into the destination table.

If you use the Update import mode, then the rows with key values 1, 2 will be updated.

If you use the Update or insert import mode, then rows 1, 2 will be updated and the row with key value 3 will be inserted.

It is applied to all other import modes, except for the Insert all mode. For all these modes (except for the Insert all mode) it is obligatory to select the primary key fields. This field (or fields) is used as key field to identify specific data in the target database.

Insert new | Update | Update or insert | Delete | Delete or insert
Import Data - Setting import mode - Result - Insert new | Import Data - Setting import mode - Result - Update | Import Data - Setting import mode - Result - Update or insert | Import Data - Setting import mode - Result - Delete | Import Data - Setting import mode - Result - Delete or insert

The key columns for these operations are defined in the Key columns area.

Import type

RadioButton Native mode

The Native mode uses single commands method that serves to generate and execute single SQL commands on the server. With the help of the Native mode your data can be imported dozen (!) times faster as compared to the Universal mode which is used for backward compatibility.

RadioButton Universal mode

With this mode selected import is performed with single commands method. Use it if Native mode import is executed with errors.

Key columns

This area allows you to select the fields of the table to be used as the key fields for the import process.

To select a field, you need to move it from the Available columns list to the Selected columns list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

When you are done, click the Next button to proceed to the Customizing common options step of the wizard.


Customizing common options

Use this step of the wizard to set common import options. The detailed description of these options is given below.

Import Data - Customizing common options

Commit

RadioButton Commit when done

Commits the transaction when all records are imported.

RadioButton Commit after each block

Inserts the COMMIT statement after a defined number of records.

RadioButton Commit changes manually

Select this option if you intend to commit the transaction manually.

Block size

Use the spinner control to define the number of records in each committed block.

Record count

RadioButton Import all records

Specifies that all records of the source file will be imported.

RadioButton Import only ... record(s)

Specifies the number of records to be imported.

When you are done, click the Next button to proceed to the last step of the wizard.


Importing data

This step of the wizard is intended to inform you that all import options have been set, and you can start the import process.

The log area allows you to view the log of operations and errors (if any).

Import Data - Importing data

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the import process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the import process.

After the operation is completed, you can view the total number of processed records, the number of inserted/updated/deleted records, the number of committed records, the number of errors, elapsed time, and the log of operations and errors (if any).


Export as SQL Script

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Export as SQL Script Wizard

Export as SQL Script wizard allows you to export data from a table / view or from a query result to Execute Script as a number of INSERT statements. You can save your settings as a template any time for future use.

To start the wizard, right-click the object in DB Explorer, select the Data Manipulation | [image] Export Data as SQL Script...context menu item.

Alternatively, you can open the Data tab of Table Editor / View Editor or the Result(s) tab of Query Data / Design Query, right-click the grid there, then select the Data Manipulation | [image] Export <object_name> as SQL Script... context menu item.

  • Selecting destination DBMS
  • Setting destination file name
  • Setting BLOB options
  • Selecting field to export
  • Editing the result table definition
  • Setting export options
  • Exporting as Execute Script

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Export Data Wizard

Import Data Wizard

Using templates


Selecting destination DBMS

This step of the wizard allows you to define the destination server you need to export data for. The result script will be generated in compliance with the specifications of the selected DBMS:

RadioButton DB2

RadioButton InterBase/Firebird

RadioButton Microsoft® SQL Server™

RadioButton MySQL

RadioButton Oracle

RadioButton PostgreSQL

Export as SQL Script - Defining type of destination server

CheckBox Add CREATE TABLE statement

Check this option to add the CREATE TABLE statement to the result script.

Click the Next button to proceed to the Setting destination file name step of the wizard.


Setting destination file name

Script destination

Specify whether the result script will be loaded to Execute Script Editor or saved to a file.

File name

Type in or use the btnSaveAs button to specify the path to the file and the file name.

File charset

If necessary, select the charset for the result script file using the corresponding drop-down list.

Enter the Table name and the Schema name to be included in the result SQL Script. Schema name should only be specified for the DBMS in which this object is implemented.

Export as SQL Script - Setting destination file name

Click the Next button to proceed to the Setting BLOB options step of the wizard.


Setting BLOB options

BLOB and arrays options

In this group of options you can determine whether BLOB fields are not to be extracted, extracted as strings, or extracted into a separate file (available for DB2, InterBase/Firebird, MS SQL, Oracle destination servers). If the latter is selected, you also need to specify the File name (the *.blo file where the BLOB data will be stored) and the location of the file on your local machine using the btnSaveAs button.

CheckBox Compress file

Check this option if you wish to compress the file containing BLOB data.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Export as SQL Script - Setting BLOB options

Note: If you choose to save BLOB fields in a file then afterwards this data can be restored only by using the SQL Manager for Oracle Execute Script tool.

Click the Next button to proceed to the Selecting fields to export step of the wizard.


Selecting fields to export

This step of the wizard allows you to select the table field(s) to be exported to SQL Script.

To select a field, you need to move it from the Available fields list to the Selected fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Export as SQL Script - Selecting fields to export

Click the Next button to proceed to the Editing table definition step of the wizard.


Editing table definition

This step is available only if the Add CREATE TABLE statement option was checked on the Selecting destination DBMS step of the wizard. It allows you to view/edit the Execute Script for creating the table.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with Query Data area and Using the context menu.

Export as SQL Script - Editing table definition

Click the Next button to proceed to the Setting export options step of the wizard.


Setting export options

Specify common export options according to your needs.

CheckBox Replace non-print characters in strings with spaces

Select this option to insert spaces instead of non-print characters.

CheckBox Quote identifiers

With this option ON all reserved words are enclosed in quotation marks.

CheckBox Use multi insert statements

Use the option to allow multi insert statements in the result script.

Note: The option is active available when destination server selected at the first step is different from Oracle. Before using the result script make sure that destination server supports such statements.

Data options

Records in block

Use the spinner control to define the number of records in each committed block.

CheckBox Insert COMMIT after each block

Check this option to add the COMMIT statement after a defined number of records.

Export as SQL Script - Setting export options

Click the Next button to proceed to Exporting as Execute Script.


Exporting as SQL Script

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Exporting as Execute Script

This step of the wizard is intended to inform you that all export options have been set, and you can start the Export as SQL Script process.

The log area allows you to view the log of operations and errors (if any).

Export as SQL Script - Exporting as SQL Script

CheckBox Load generated script into Script Editor

Check this option to load the result script to Execute Script Editor.

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the Export as SQL Script process.


Database Tools

The following database tools are available in SQL Manager for Oracle:

SQL Monitor

Displays all the SQL statements executed while working in SQL Manager for Oracle.

Execute Script

Executes SQL Scripts in the database.

Search in Metadata

Provides quick search for a string within the scope of database metadata.

Extract Database

Extracts the table metadata and/or data to an SQL Script which can be executed later on another machine to restore the database structure and/or data.

Compare Databases

Creates an SQL Script that provides database structure synchronization.

Print Metadata

Creates powerful metadata reports in the WYSIWYG mode ready for printing.

HTML Report

Creates powerful metadata reports in the HTML format.

Reports management

Tools for efficient management of reports: creating, editing, viewing, printing.

Dependency Tree

Allows you to view all the object dependencies in one diagram.

Instance Manager

Checks Oracle service status to stop or start it.

Grant Manager

Allows you to grant/revoke privileges on database objects.

Visual Database Designer

Allows you to lay out your database schema visually.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Services

Options

How To...


SQL Monitor

SQL Monitor allows you to view the log of all operations performed over databases and database objects in SQL Manager for Oracle. The content of the window is read-only.

To open the SQL Monitor window, select the Tools | btnSQLMonitor SQL Monitor main menu item, or use the Shift+Ctrl+M shortcut.

  • Using Navigation bar and Toolbar
  • Working with SQL Monitor

See also:

SQL Monitor options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in SQL Monitor.

SQL Monitor - Using Navigation bar

General

clear the content of the window

save the content to a *.txt file using the Save as... dialog

iconFindText search for a string using the Find Text dialog

iconSearchAgain find next

iconOptions configure SQL Monitor using the SQL Monitor section of the Environment Options dialog

iconRestoreDefaultSize restore the default size and position of the window

iconAlwaysOnTop specify that the window is displayed on top of other child windows

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Working with SQL Monitor

With SQL Monitor window you can see all commands sent to the server from SQL Manager.

The working area of SQL Monitor lists the log of database operations and SQL queries as items, each consisting of 3 parts: Executed (the date and time of the operation), Operation (SQL statement sent to the server), Result (the result of the operation).

Items of the context menu of SQL Monitor area provide access to various functions for working with the window content. The context menu contains standard text-processing functions (Copy, Select All), spelling checking and functions for working with the content as a whole, e.g. you can set markers, move the cursor to a particular line, save the content to a file or as a favorite query, configure the editor using the properties item or preview/print the content. Most of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text dialog and Incremental search bar contributes to more efficient work with the content of SQL Monitor.

SQL Monitor - Working with SQL Monitor


Execute script editor

Using Execute Script you can view, edit and execute SQL scripts.

To open Execute Script editor select the Tools | btnShowSQLScript Execute Script main menu items or btnShowSQLScript toolbar button. You can also use the Shift+Ctrl+S shortcut for the same purpose.

In the script area you can view and edit the SQL script text. For your convenience syntax highlight and code completion features are implemented.

  • Using Navigation bar and Toolbar
  • Working with Execute Script editor
  • Using Script Explorer
  • Script execution

Note: Execute Script Editor does not show results returned upon SELECT queries execution. Please use Query Data for that purpose instead.

See also:

Query Data

Execute Script options

Editor Options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Execute Script Editor.

SQL Script Editor - Using Navigation bar

Destination

iconDBGroup select a database group

iconDB select a database for the script

General

iconExecute execute the current script

iconCompile execute a script from file

iconNew create a new script

iconLoadFromFile load a script from an *.sql file using the Open Execute Script dialog

iconSaveToFile save the current script

iconSaveToFileAs save the script to an *.sql file using the Save as... dialog

iconDBExplorer hide/show explorer

enable/disable result log

iconOptions configure Execute Script in the Environment Options dialog

iconRestoreDefaultSize restore the default size and position of the editor window

Explorer group

iconDBExplorer browse the tree objects used in the script using the Script Explorer pane

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

See also:

Working with Execute Script editor area

Using Script Explorer

Script execution


Working with SQL Script editor area

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Working with Execute Script editor area

The Editor area of Execute Script is provided for efficient working with SQL scripts in text mode.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented:

  • using object links allowing you to open the object in the associated editor;
  • ability to display line numbers;
  • code folding for statements and clauses;
  • customizable margins and gutters;
  • formatting code for better representation

and more.

The context menu of Execute Script Editor area contains execution commands, most of the standard text-processing functions (Cut, Copy, Paste, Select All), spelling checking and functions for working with the script as a whole, e.g. you can enable/disable parsing, toggle bookmarks and comments, move the cursor to a particular line, change the case of selected text, load/save the content from/to a file or save as a favorite query, configure the editor using the Properties item or preview/print the text of the script. Most of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text / Replace Text dialogs and Incremental search bar contributes to more efficient work with the SQL code.

SQL Script Editor - Working with SQL Script editor area

For your convenience the possibility to use macros is implemented.

To start recording a macro, click the btnRecordMacro Record button available in the status bar area, or use the Shift+Ctrl+R shortcut.

To stop recording, click the btnStopRecordMacro Stop button, or use the Shift+Ctrl+R shortcut.

To call the recorded macro, use the btnPlayMacro Play button, or use the Shift+Ctrl+P shortcut.

See also:

Using Navigation bar and Toolbar

Using Script Explorer

Script execution

Managing Favorite queries

Execute Script options


Using Script Explorer

The Explorer group on the Navigation bar displays the tree of objects, used in the current script and allows you to get to the required script fragment quickly by clicking the object in the tree.

SQL Script Editor - Using Script Explorer

Hint: When you click a node in the Script Explorer tree, the corresponding SQL statement is highlighted in the editor area. If you double-click a node, the corresponding SQL statement is highlighted, and the current focus is switched to the editor area (the cursor appears after the highlighted statement).

You can disable the Object Explorer to speed up the processing of big files with iconDBExplorer Hide explorer item or at Environment options|Object editors.

See also:

Using Navigation bar and Toolbar

Working with Execute Script editor area

Database Objects Management


Script execution

When all the script parameters are set, you can immediately execute the script in Execute Script editor.

To execute a script, click the btnExecuteQuery Execute script item of the Navigation bar or toolbar. You can also use the context menu or F9 hot key for the same purpose.

SQL Script Editor - Script execution

Note: If the CheckBox Execute selected text separately option (see the Tools | Execute Script section of the Environment Options dialog) is enabled (by default) and a text fragment is currently selected, only this fragment is executed when you click Execute script on the Navigation bar or press F9. If this option is disabled, the whole script is executed, but you can still execute the selected fragment using the corresponding Execute Selected Only item of the context menu or by pressing Ctrl+F9.

If the SQL syntax is correct, the script is executed and the 'Done!' information message appears.

SQL Script Editor - Script execution - Done

If the syntax contains errors or script cannot be executed, the corresponding error message is displayed in the status bar area at the bottom of the editor window.

Hint: When you select an item from the error list (in the status bar area), the corresponding SQL statement is highlighted in the editor area. If you double-click an item, the corresponding SQL statement is highlighted, and the current focus is switched to the editor area (the cursor appears after the highlighted statement).

Note: Execute Script does not show results returned upon SELECT queries execution. Please execute such queries in Query Data to see the result dataset.

See also:

Using Navigation bar and Toolbar

Working with Execute Script editor area

Using Script Explorer


Oracle Client Checker

The Oracle Client Checker dialog allows you to check the validity of Oracle client(s) identified by SQL Manager.

To call the dialog, use the Client Checker... button which is available at the Setting connection parameters step of Register Database Wizard and in the Connection section of the Database Registration Info dialog.

Oracle client checker

The upper area of the dialog lists Oracle clients as a grid with the following columns:

Oracle Home

Status (Valid/Invalid)

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

The Detail group provides common information on the selected client:

Oracle Home name

Oracle Home

OCI version

TNS names file

NLS Lang

SQL Bin

Generate report

All information about oracle client and environment variable can be saved in the external file that can be created by clicking the Generate report button.


Search in Metadata

The Search in Metadata tool is implemented for quick search within the scope of database metadata. The tools allows you to set various search conditions and view the results.

Search in Metadata - Setting search conditions

To launch the Search in Metadata tool, select the Tools | iconSearchInMetadata Search in Metadata main menu item, or use the Ctrl+Alt+F shortcut.

The Find in metadata dialog allows you to set search conditions. It opens each time the Search in Metadata tool is launched.

Text to find

Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Database

Use the drop-down list to select a database for the search operation.

Options

Available search options are similar to those provided by the Find Text dialog. For detailed description of the search options refer to the Find Text dialog page.

When all the options are set, click OK. The Search in Metadata [search string] report window will display the search progress and results.

The Search in Metadata window allows you to view the search progress and results fetched from the database.

Search in Metadata - Viewing search results

After the search is complete, the Explorer group on the Navigation bar displays the tree of database objects in which the search string is found, and allows you to view metadata of the required object or its fragment quickly by clicking enclosed object branches in the tree.

The Object <object_name> area is provided for viewing metadata of the objects, with the search string highlighted.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with Query Data area and Using the context menu.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Find Text dialog


Extract Database Wizard

Extract Database Wizard allows you to extract database objects and/or data to an Execute Script, e.g. for backup purposes.

To start the wizard, select the Tools | btnExtractDB Extract Database... main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | btnExtractDB Extract Database... item from the context menu.

  • Selecting a database for extraction
  • Specifying destination file name
  • Setting extraction mode
  • Setting BLOB options
  • Selecting objects for metadata extraction
  • Selecting objects for data extraction
  • Customizing script options
  • Start of extraction process
  • Using templates

See also:

Execute Script Editor

Database Objects Management

Using templates


Selecting source database

This step of the wizard allows you to select the source database from which metadata and/or data are to be extracted.

If necessary, check the CheckBox Extract all metadata and data of the database option to simplify the wizard.

Extract Database - Selecting source database

Click the Next button to proceed to the Specifying destination file name step of the wizard.


Specifying destination file name

Script destination

This group of options allows you to specify whether the result Execute Script will be automatically loaded to Execute Script Editor or saved into a file.

File name

Set a name for the result *.sql file and type in or use the Save as... btnSaveAs button to specify the path to this file on your local machine or on a machine in the LAN.

File charset

If necessary, use the drop-down list to select the character set to be applied to the output file.

Extract Database - Specifying destination file name

Depending on whether you have checked the CheckBox Extract all metadata and data of the database option at the Selecting source database step, upon pressing the Next button you will either proceed to the next step of the wizard, or you will be immediately forwarded to the Setting BLOB options step, and then to the Customizing script options step of the wizard.


Setting extraction mode

This step allows you to specify the extraction mode: choose whether structure only, data only or both are to be extracted.

Extract Database - Setting extraction mode

Click the Next button to proceed to the Setting BLOB options step of the wizard.


Setting BLOB options

BLOB options

In this group of options you can determine whether BLOB fields are not to be extracted, extracted as strings, or extracted into a separate file. If the latter is selected, you also need to specify the File name (the *.blo file where the BLOB data are to be stored) and the location of the file on your local machine using the Save as... btnSaveAs button.

CheckBox Compress file

Check this option if you wish to compress the file containing BLOB data.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Extract Database - Setting BLOB options

Note: If you choose to RadioButton Extract BLOB fields into file then afterwards the result SQL file can be restored only by using the SQL Manager for Oracle Execute Script tool.

Click the Next button to proceed to Selecting objects for structure extraction.


Selecting objects for structure extraction

This step of the wizard allows you to select objects for metadata extraction.

Note that this step is only available if the CheckBox Extract all metadata and data of the database option was unchecked when selecting the source database.

RadioButton Extract all objects

Adds all objects of the database to structure extraction process.

RadioButton Extract all objects of schema...

Adds all objects of a schema to structure extraction process.

Schema name

Use the drop-down list to select the schema to extract all objects from.

RadioButton Extract selected objects

Adds only selected objects to structure extraction process.

Objects to extract

Use the drop-down list to select the type of objects to be extracted.

To select an object, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Extract Database - Selecting objects for structure extraction

Click the Next button to proceed to Selecting objects for data extraction.


Selecting objects for data extraction

This step of the wizard allows you to select tables for data extraction.

Note that this step is only available if the CheckBox Extract all metadata and data of the database option was unchecked when selecting the source database.

RadioButton Extract all tables

Adds all tables of the database to data extraction process.

RadioButton Extract data of tables selected on the previous step

Adds only the tables selected for metadata extraction.

RadioButton Extract data of the selected tables

Adds only selected tables to data extraction process.

To select a table, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the tables from one list to another.

Extract Database - Selecting objects for data extraction

Click the Next button to proceed to the Customizing script options step of the wizard.


Customizing script options

This step allows you to customize common script options and data options for the extraction process.

Script options

CheckBox Calculate dependencies

This option determines objects' dependencies usage in the extraction process. If you check this option then dependencies of every object will be analyzed before the extraction process. At first objects that have no dependent objects are extracted and then objects that depend on already extracted objects are extracted.

CheckBox Generate DROP statements

Check the option to add the DROP statements for the extracted objects in the result script.

CheckBox Generate object grants statement

Check this option to add the GRANT statements to object definitions.

CheckBox Insert description

This option determines whether object description should be added to the generated script.

Extract Database - Customizing script options

Data options

Records in a block / CheckBox Insert "COMMIT" statement after each block

These controls allow you to define whether the COMMIT statement is added to the script or not, and to specify the number of records in each block to be supplemented with this statement.

CheckBox Delete existing records

Check this option if you want to delete data from the table after it is extracted.

CheckBox Abort extraction on error

This option determines whether the extraction process should be stopped or forced to continue if an error occurs.

Click the Next button to proceed to the last step of the wizard.


Start of extraction process

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

This step of the wizard is intended to inform you that all extraction options have been set, and you can start the extraction process.

The log area allows you to view the log of operations and errors (if any).

Extract Database - Start of extraction process

CheckBox Load script to Execute Script

Check this option to load the result script to Execute Script Editor.

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the extraction process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the extraction process.


Compare Databases Wizard

Compare Databases Wizard creates an Execute Script that provides database structure synchronization. To launch the wizard use the Tools | iconCompare Compare Databases... item of the main menu.

  • Selecting source database
  • Selecting schemas of the source database
  • Selecting target database
  • Selecting schemas of the target database
  • Selecting type of the synchronization script
  • Defining options for destination script
  • Performing operation

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using templates


Selecting source database

Use this step to define source database for comparing.

Database Comparer Wizard - Select the source database

Source host

Defines host where source database is located.

Source database

Select source database from the drop-down list.

RadioButton Compare whole database

RadioButton Compare separate schemas

If RadioButton Compare separate schemas was checked then you need to select the schemas at the Selecting schemas of the source database step.

Otherwise you will proceed to the Selecting target database step.

Use the templates button to save current settings to template or to restore settings from an existing template.


Selecting schemas of the source database

This step appears only if the RadioButton Compare separate schemas option was checked at the first step.

Use this step of the wizard to select the schemas of the source database to compare.

Database Comparer Wizard - Select source schemas

For your convenience the Select All, Deselect All and Invert selections functions are implemented in the context menu of the schemas list area.

Click the Next button to proceed to the Selecting target database step of the wizard.


Selecting target database

Use this step to define target database for comparing.

Database Comparer Wizard - Specify the target database

DB group name

Defines group where target database is located.

Target database

Select target database from the drop-down list.

If RadioButton Compare separate schemas at the first step was checked then you need to select the schemas of the target database at the Selecting schemas of the target database step.

Otherwise you will proceed to the Selecting type of the synchronization script step.

Use the templates button to save current settings to template or to restore settings from an existing template.


Selecting schemas of the target database

This step appears only if the RadioButton Compare separate schemas option was checked at the first step.

Use this step of the wizard to select the schemas of the target database to compare.

Database Comparer Wizard - Select terget schemas

For your convenience the Select All, Deselect All and Invert selections functions are implemented in the context menu of the schemas list area.

Click the Next button to proceed to the Selecting type of the synchronization script step of the wizard.


Selecting type of the synchronization script

Specify the direction of comparing selected database.

Database Comparer Wizard - Select the type of synchronization script

RadioButton Target database into source database

Enables reverse comparing: the synchronization script will contain statements which make the target database identical to the source one.

RadioButton Source database into target database.

Enables direct comparing: the synchronization script will contain statements which make the source database identical to the target one.

Click the Next button to proceed to the Defining options concerned destination script step.

Use the templates button to save current settings to template or to restore settings from an existing template.


Defining options for destination script

Use this step to define additional option for destination script.

Database Comparer Wizard - Select additional options

RadioButton Automatically load to Execute script

With this option enabled, the synchronization script will not be saved. It will be loaded to Execute Script.

RadioButton Save to file

Use this option if you need to save the synchronization script to a file.

File name

Defines the name of the file to save the synchronization script to. Click the btnSaveAs Save button to locate file using the standard dialog or type the file name and it's location manually.

File charset

Specified character set will be used when saving the script to file.

Click the Next button to proceed to the Performing operation step.

Use the templates button to save current settings to template or to restore settings from an existing template.


Performing operation

This step of the wizard is intended to inform you that all necessary options have been set, and you can start comparing databases.

The log area allows you to view the log of operations and errors (if any).

Compare Database Wizard - Comparing database

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the process is completed. If the option is disabled then you can repeat the operation with the same or redefined parameters.

Click the Run button to run the backup database operation.

Use the templates button to save current settings to template or to restore settings from an existing template.


Print Metadata

Print Metadata allows you to generate and print metadata reports of any database object(s).

To open the window, select the Tools | btnPrintMetadata Print Metadata main menu item or use the btnPrintMetadata Print Metadata button on the main toolbar. Alternatively, you can right-click the database alias in the DB Explorer tree and select the Tasks | Print Metadata item from the context menu.

  • Using Navigation bar and Toolbar
  • Selecting objects
  • Printing options
  • Print Preview

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management

Print Metadata options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Print Metadata.

Print Metadata - Using Navigation bar

Database

iconDB select a database for the printing report

General

iconPrint print metadata of the selected object(s)

iconPreview preview the printing report

iconRestoreDefaultSize restore the default size and position of the window

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Selecting objects

The Print Metadata window allows you to select the database objects for printing metadata.

To select an object, you need to move it from the Available Objects list to the Objects for Printing list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Print Metadata - Selecting objects

After you select one or several objects, the Printing Options pane appears at the bottom. Select an object in the Objects for Printing list and specify items to be included into the printing report. For details see Printing options.

Note: You can btnPrintPreview Preview the printing report and btnPrintMetadata Print metadata for objects of the selected type using the corresponding items of the Navigation bar (or toolbar). For details see Report Viewer.


Printing options

The Printing Options area is available in the bottom right corner of the Print Metadata window.

Print Metadata - Printing options

Categories for printing

Use this group to specify items to be included into the printing report: Fields, Indexes, Description, DDL, Keys, Foreign keys, Checks, Triggers (availability of the items depends on the object).

Click the Print button to call the standard Print dialog to set printer configuration and start printing the report.

Click the Preview button to call the Report Viewer dialog to preview the report.

Click the Design button to call Report Designer to edit the report.


HTML Report Wizard

HTML Report wizard allows you to generate a detailed HTML report of the selected database objects.

To start HTML Report Wizard, select the Tools | [image] HTML Report main menu item, or use the [image] HTML Report button on the main toolbar. Alternatively, you can right-click the database alias in the DB Explorer tree and select the Tasks | HTML Report... item from the context menu.

  • Selecting database and directory
  • Selecting object types
  • Selecting schemas
  • Specifying CSS for HTML report
  • Setting additional report options
  • Creating HTML report
  • Using templates

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management


Selecting database and directory

At this step of the wizard you should select the source database and output directory for the HTML report.

Source database

Use the drop-down list of registered and connected databases to select the source database for the report.

Output directory

Type in or use the ExplorerButton button to specify the path to the output directory for the result HTML files using the Browse for Folder dialog.

HTML Report - Selecting database and directory

Click the Next button to proceed to the Selecting object types step of the wizard.


Selecting object types

Use this step of the wizard to select the types of objects to be included in the result HTML report.

To select an object, you need to move it from the Available objects list to the Selected objects list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

HTML Report - Selecting object types

Click the Next button to proceed to the Selecting schemas step of the wizard.


Selecting schemas

Use this step of the wizard to select the schemas containing objects of the types selected at the previous step.

To select a schema, you need to move it from the Available schemas list to the Selected schemas list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the schemas from one list to another.

HTML Report - Selecting schemas

Click the Next button to proceed to the Specifying CSS step of the wizard.


Specifying CSS

This step of the wizard allows you to edit the CSS (Cascading Style Sheet) file that will be used by the result HTML report.

At the CSS Preview tab choose the style that will be applied to the target HTML file. You can select any of the pre-defined templates from the Template drop down list.

Also you can edit the CSS (Cascading Style Sheet) file manually at the CSS Text tab.

HTML Report - Specifying CSS

Click the Next button to proceed to the Setting additional report options step of the wizard.


Setting additional report options

Use this step of the wizard to set additional HTML report options.

HTML Report - Setting additional report options

If necessary, you can set optional text to Report header and Report footer of the result HTML report. For your convenience the default header and footer text is already available. If necessary, you can edit this text according to your needs.

DDL font size

This control allows you to set the font size for the DDL section. Move the slider between the small and large threshold values to select the required font size value within this scope. Note that the text size also depends on your browser settings.

Click the Next button to proceed to Creating HTML report.


Creating HTML report

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

HTML Report - Creating HTML report

CheckBox Show report after generating

This option opens the result report in your default browser after generating.

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the creating HTML report process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the process.


Reports management

SQL Manager for Oracle provides several tools for efficient reports management:

Create Report Wizard

This tool is used to simplify the process of creating reports.

Report Designer

It is a basic tool for creating powerful reports.

Report Editor

Allows you to manage created reports.

Report Viewer

Allows you to preview reports before printing and export them to other formats.

Reports can be stored either in the database (table ORAMREPORTS will be created to store them) or in a directory on your hard drive specified on the Directories page of the Database Registration Info dialog.


Create Report Wizard

Using Create Report Wizard you can create a report containing required datasets, bands and fields on them, with a definite report style applied.

To start the wizard, select the Database | New Object... main menu item, then select Report in the Create New Object dialog. Alternatively, you can right-click the Reports node of the DB Explorer tree and select the New Report... item from the context menu.

  • Specifying report name and options
  • Selecting report bands
  • Selecting report style
  • Specifying paper settings
  • Specifying margins
  • Specifying other page settings

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Report Designer

Report Viewer


Specifying database name and report options

Select the source database for adding a report and choose the action you need to perform: either create a new report or import an existing report from file.

Set the name for the new report and specify the save options for it:

RadioButton Save to database

The report will be created on the server inside the database.

RadioButton Save to file

If this option is selected, the report will be saved as a *.fr3 file to the directory specified on the Directories page of the Database Registration Info dialog.

Create Report - Specifying database name and report options

Click the Next button to proceed to the Selecting report bands step of the wizard.


Selecting report bands

This step of the wizard allows you to select the bands to be included in the report.

To select a band, you need to move it from the Available Bands list to the Report Bands list. Use the Items - Move to Selected Items - Move all to Selected Items - Move to Available Items - Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Use the Edit [image] button to create datasets for 'data' bands using Design Query.

Create Report - Selecting report bands

Brief information about bands functionality is listed below. See FastReport Help for more information.

Name | Functionality
Report title | Prints once at the beginning of report
Report summary | Prints once at the end of report
Page header | Prints at the top of each page
Page footer | Prints at the bottom of each page
Master header | Prints at the beginning of master list
Master data | Data rows of master list
Master footer | Prints at the end of master list
Detail header | Prints at the beginning of detail list
Detail data | Data rows of detail list
Detail footer | Prints at the end of detail list
Subdetail header | Prints at the beginning of subdetail list
Subdetail data | Data rows of subdetail list
Subdetail footer | Prints at the end of subdetail list
Group header | Prints at the beginning of each group
Group footer | Prints at the end of each group

Click the Next button to proceed to the Selecting report style step of the wizard.


Selecting report style

Select the report style by clicking one of the images illustrating the styles available for the report.

Create Report - Selecting report style

Click the Next button to proceed to the Specifying paper settings step of the wizard.


Specifying paper settings

Specify report options: paper size and orientation, page margins, other settings. For details see Page settings.

Create Report - Specifying paper settings

Use the Margins tab to specify margins for the result report.

CheckBox Open the report after the wizard has finished

If this option is checked, the report will be opened in Report Designer after generating.

When you are done, click the Run button to start the report generation process.


Specifying margins

Page margins

CheckBox Stretch to print area

If this option is checked, the size of report is adjusted to the print area. If this option is unchecked, you can specify the left, right, top and bottom margins (in millimeters).

Create Report - Specifying margins

Use the Other tab to specify other page settings for the result report.

When you are done, click the Run button to start the report generation process.


Specifying other page settings

Options

CheckBox Print to previous page

This option allows to use white space on a previous page. This option can be used in case when a report template consists of several pages or when printing batch (composite) reports.

CheckBox Two-pass report

If this option is selected, report's formation will be performed in two steps. During the first pass, a report is formed, and is divided into pages, but the result is not saved anywhere. During the second pass a standard report formation with saving a result in the stream is performed.

CheckBox Page numbering

This option allows to print a page numbers.

Columns

Number

This parameter specifies the number of columns for multi-column reports' printing.

Gap, mm

This parameter specifies the width of the gap between columns.

Create Report - Specifying other page settings

When you are done, click the Run button to start the report generation process.


Report Designer

Report Designer allows you to create and edit reports. This tool can be opened after completion of Create Report Wizard to design a new report.

To edit an already existing project, use the appropriate Navigation bar item of Report Editor.

This module is provided by Fast Reports, Inc. (http://www.fast-report.com) and has its own help system. Press F1 key in the Report Designer to call the FastReport help.

Please find the instructions on how to create a simple report in the Report Designer below:

  • Adding dialog form
  • Adding database and query components
  • Adding report data
  • Report Preview
  • Saving the report

Note: The Object Inspector which allows you to edit report object properties, can be shown/hidden by pressing the F11 key.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Editor

Report Viewer


Adding dialog form

To add a dialog form, select the File | New Dialog main menu item in Report Designer.

The new dialog appears within the DialogPage1 tab of the designer. Use the available RAD tools to add necessary interface elements to the dialog.

Report Designer - Adding dialog form

To call the dialog, proceed to the Code tab and supply the corresponding statement (PascalScript), e.g.

begin

DialogPage1.ShowModal;

end.

Using the Language drop-down list you can select the script language to be used for the event handler: PascalScript (by default), C++Script, BasicScript, Jscript.

For instance, the following C++Script code can be used as the handler for the OnClick event of the 'Show' button to open OraQuery:

{

OraQuery1.Active = true;

}

See also:

Adding database and query components

Adding report data

Saving the report


Adding database and query components

Adding database component

In order to add the Database component:

  • proceed to the Data tab of Report Designer;
  • pick the [image] Oracle Database component on the toolbar (on the left);
  • click within the working area - the corresponding OraDatabase1 icon appears in the area;
  • set the database connection and authorization parameters using the Properties Inspector.

Report Designer - Adding database component

Adding query component

  • proceed to the Data tab of Report Designer;
  • pick the [image] Oracle Query component on the toolbar (on the left);
  • click within the working area - the corresponding OraQuery1 icon appears in the area;
  • set the database name and authorization parameters within the Properties Inspector;
  • double-click the OraQuery1 icon to open the SQL window;
  • input the SQL query that returns the required dataset and click the btnPostEdit button;
  • repeat the operation if you wish to add other query components to the report.

Report Designer - Adding query component

Note: The Properties Inspector panel which allows you to edit report object properties can be shown/hidden by pressing the F11 key.

Using the above given steps you can create as many queries as you need. In order to select a dataset returned by a query, select the Report | Data... main menu item of Report Designer to call the Select Report Datasets dialog. Pick the required query within the dialog and press OK.

Report Designer - Selecting datasets

See also:

Adding dialog form

Adding report data

Saving the report


Adding report data

Adding bands

  • proceed to the Page1 tab of Report Designer;
  • pick the Insert Band [image] component on the toolbar (on the left);
  • select the band to be added to the report;
  • click within the working area - the corresponding element appears in the area;
  • set element properties within the Properties Inspector.

Report Designer - Adding bands

Adding report data

  • proceed to the Data tab within the panel on the right side of the window;
  • pick a field within the [image] Data tree and drag it to the working area;
  • add all necessary elements one by one using drag-and-drop operation for each of them.

Report Designer - Adding report data

Note: The Properties Inspector panel which allows you to edit report object properties can be shown/hidden by pressing the F11 key.

See also:

Adding dialog form

Adding database and query components

Saving the report


Viewing the report

Viewing the report

To preview the newly created report, select the File | btnPrintPreview Preview main menu item or use the corresponding btnPrintPreview Preview toolbar button. You can also use the Ctrl+P shortcut for the same purpose. This mode allows you to view, edit and print the result report.

To print the report, use the btnPrint Print toolbar button or the corresponding context menu item.

Report Designer - Preview

It is also possible to preview/print the report using Report Viewer.

See also:

Adding dialog form

Adding database and query components

Adding report data

Saving the report


Saving the report

When all report parameters are set, you can save the report to an external *.fr3 file on your local machine or on a machine in the LAN.

To save the report, select the File | Save main menu item or use the corresponding btnSave Save Report toolbar button. You can also use the Ctrl+S shortcut for the same purpose.

If necessary, you can add the report to the database using Create Report Wizard and perform preview/print operations using Report Editor.

See also:

Adding dialog form

Adding database and query components

Adding report data


Report Editor

Report Editor allows you to view, edit, save and print reports.

To open a report in Report Editor, double-click it in the DB Explorer tree, or right-click it and select the Edit Report <report_name>... item from the context menu.

  • Using Navigation bar and Toolbar
  • Viewing Report

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Designer

Report Viewer


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Report Editor.

Report Editor - Using Navigation bar

Object

iconDB select a database

select a report

General

iconRefresh refresh the content of the window

edit report using Report Designer

iconSaveToFile save the current report

iconSaveToFileAs save the report to a *.fr3 file using the Save as... dialog

iconPrint print the report

iconRestoreDefaultSize restore the default size and position of the viewer window

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Viewing Report

The main window of Report Editor allows you to view the specified report.

Possible report operations are available through the Navigation bar and toolbar of the editor window.

Report Editor - Viewing Report


Report Viewer

Report Viewer allows you to preview reports generated in SQL Manager before printing and export them to other formats.

This module is provided by Fast Reports, Inc. (http://www.fast-report.com) and has its own help system. For more information refer to the Fast Report User Manual (FRUserManual.chm) distributed with the program.

The tool opens automatically when a btnPrintPreview Preview item is used in Print Metadata or Report Designer.

  • Using Toolbar and context menu
  • Working with Report Viewer
  • Page settings
  • Sending Report by E-mail

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Designer

Report Editor


Using Toolbar and context menu

The Toolbar and context menu provide quick access to tools implemented in Report Viewer.

Report Viewer - Using Toolbar

The Toolbar of Report Viewer allows you to:

btnPrint print the report

iconSaveToFile save the current report to an external *.fp3 file

call a menu allowing you to export the preview content to any of the available formats: PDF file, HTML file, RTF file, Excel table (OLE), Excel table (XML), BMP image, JPEG image, TIFF image, GIF image, E-mail, CSV file, Text file, Open Document Spreadsheet, Open Document Text, Text (matrix printer)

specify Export to PDF options

specify Send by E-mail options

search for text within the report content

zoom in

zoom out

enable/disable full screen view

enable/disable report outline

enable/disable report thumbnails

specify page settings

navigate to the first page of the report

navigate to the previous page of the report

navigate to the next page of the report

navigate to the last page of the report

Items of the Toolbar are also available in the context menu of the Report Viewer window. To open the menu, right-click in the working area of the viewer.


Working with Report Viewer

Report Viewer provides a quick preview of data and metadata reports generated in SQL Manager:

  • Viewing data report
  • Viewing metadata report

Data Report

The screenshot below illustrates viewing data reports generated with the Report Designer tool.

Report Viewer - Data

Metadata Report

The screenshot below illustrates viewing metadata reports generated with the Print Metadata tool.

Report Viewer - Metadata

Note: Report Viewer tools are available through the toolbar and context menu of the preview area.


Page settings

The Page Settings dialog allows you to configure page size, orientation, margins, and other settings.

Report Viewer - Page Settings

Size

Select one of the standard paper types from the drop-down list, or specify custom width and height using the corresponding controls below (in centimeters).

Orientation

Select the preferable page orientation (your selection is illustrated in the chart on the right):

RadioButton Portrait

RadioButton Landscape

Margins

Use this group to specify the left, right, top and bottom margins (in centimeters).

Other

Select the scope the settings are to be applied to:

RadioButton Apply to the current page

RadioButton Apply to all pages

For more information refer to the Fast Report User Manual distributed with the program.


Exporting report content

The Export dialog allows you to configure page range and a number of output format settings.

Report Viewer - Export to PDF

Page range

This group allows you to specify which report pages are to be exported:

RadioButton All

RadioButton Current page

RadioButton Specified pages (you should input page number(s) and/or page range(s) in the edit box)

Format-specific settings

These settings vary according to the specified output format: PDF file, HTML file, RTF file, Excel table (OLE), Excel table (XML), BMP image, JPEG image, TIFF image, GIF image, E-mail, CSV file, Text file, Open Document Spreadsheet, Open Document Text, Text (matrix printer).

For more information refer to the Fast Report User Manual distributed with the program.


Sending by E-mail

The Send by E-mail dialog allows you to send a report by e-mail in any supported format.

Report Viewer - Sending by E-mail

For more information refer to the Fast Report User Manual distributed with the program.


Dependency Tree

The Dependency Tree tool allows you to view all the object dependencies in one diagram.

To call the Dependency Tree window, select the Tools | btnDependencyTree Dependency Tree main menu item, or use the btnDependencyTree Dependency Tree button on the main toolbar.

  • Using Navigation bar and Toolbar
  • Viewing dependency tree

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Dependency Tree.

Dependency Tree - Using Navigation bar

Database

iconDB select a database for browsing object dependencies

General

iconRefresh refresh the currently displayed dependency tree

iconPrint print the diagram

iconPrintSetup set printing options using the Print Setup dialog

iconSaveAsPicture save the current diagram as a picture

iconRestoreDefaultSize restore the default size and position of the window

Object

navigate by switching to the previous object

navigate by switching to the next object

show/hide subobjects

select a root object

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

Hint: Items of the Object pane of the Navigation bar are also available in the context menu of the Dependency Tree area.


Viewing dependency tree

To view dependencies of an object, click the Select object Navigation bar item. Then select the required object in the Select Object dialog window. The dependency tree will appear in the main area of the window.

Dependency Tree - Select object

While the tree of dependencies is being built, the progress bar is displayed in the status area at the bottom of the window.

The root object is marked out with a blue frame.

The objects that the root object depends on are located to the left of the root object.

The objects that depend on the root object are located to the right of the root object.

Object dependencies are denoted as regular arrows from the left to the right (->).

A cyclic dependency (i.e. when the object already has some other depending object(s)) is denoted as a line ending with a cross (-x).

You can switch between objects by selecting them in the diagram. The selected object becomes the root object. To make an object root, you can also right-click it in the diagram area and select Set as Root from the context menu. The context menu of an object also allows you to edit it using the corresponding editor.

The history of selected root objects is also available: you can move back and forward through this history using the Previous object and the Next object links on the Navigation bar or toolbar.

Hint: To show/hide subobjects (e.g. table triggers, foreign keys), click the Show subobjects / Hide subobjects item on the Navigation bar.


Instance Manager

This tool allows you to check PostgreSQL service status, to stop or start it and set settings. To launch this tool use the Services | iconInstanceManager Instance Manager item of main menu.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Information

TNS Editor


Using Navigation and Toolbar Bar

The Navigation bar and Toolbar provide quick access to tools implemented in Instance Manager.

Instance Manager - Using Navigation Bar

Service Management

btnExecuteQuery Start service

btnStopRecordMacro Stop service

iconRefresh Refresh - get actual statistics

iconRestoreDefaultSize restore the default size and position of the window

Tick Apply changes to the service settings

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Service Status

You can manage server instance by using navigation bar.

To shut down/startup the instance click the Stop/Start Service button. Be aware that all users connected to the databases will be disconnected.

Log messages

This log shows all messages during server startup and shutdown.


Configuring Service

Here you can change selected service settings.

CheckBox Launch service on system start

Check this option to enable auto-start of the Oracle service.

InstanceManager - Configure Service

Display name

Set the name to display in the Computer Manager console.

Service description

Input custom description for the service.

Service parameters

Set service parameters for the selected service.


Grant Manager

Grant Manager allows you to set the certain user access grants for database objects.

To open Grant Manager, select the Tools | btnGrantManager Grant Manager main menu item, or use the btnGrantManager Grant Manager button on the main toolbar.

  • Using Navigation bar, Toolbar and context menu
  • Managing database-specific privileges
  • Managing column permissions
  • Filtering objects in list
  • Managing system privileges
  • Managing roles

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Users

Roles


Using Navigation bar, Toolbar and context menu

The Navigation bar, Toolbar and context menu provide quick access to tools implemented in Grant Manager.

Grant Manager - Using Navigation bar

Database

iconDB select a database for grants management

General

iconRefresh refresh the content of the window

iconEditUser call User Editor to edit a database user

iconCompile compile changes (if any)

iconClearFilter clear the currently applied filter

iconRestoreDefaultSize restore the default size and position of the window

Grantee

btnGroupManager select an existing database user/role to grant privileges to

Legend

Tick view the legend

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

The context menu is aimed at facilitating your work: you can perform a variety of operations using context menu items.

The context menu of Grant Manager allows you to:

  • grant a permission on an object to the selected user/role;
  • grant a permission (with Grant Option) on an object to the selected user/role;
  • revoke a previously granted permission;
  • grant all permissions on an object to the selected user/role;
  • revoke all previously granted permissions on an object;
  • refresh the permissions.

Grant Manager - Using context menu


Managing database-specific privileges

The Database-specific privileges area of the Objects Grants tab allows you to define privileges on database objects and grant privileges to a user or role.

To edit the privileges of a user/role on an object of a database, select the database using the Database pane of the Navigation bar, then select a user or role from the Grantee list available within the Navigation bar. Then select the type of objects to be displayed in the main working window using the drop-down list at the top.

The Object Name column contains the list of objects of the selected type; each subsequent column corresponds to the permission which can be granted on the selected object: Alter, Delete, Execute, Debug, Flashback, Index, Insert, On Commit Refresh, Query Rewrite, Read, References, Select, Under, Update, Write.

Grant Manager - Managing database-specific privileges

The list of the objects can be configured in several ways: you can specify that only granted objects are displayed in the grid, or define a schema and object name to filter the objects by that name.

Right-click a cell to grant a specific permission on a certain object. To grant a permission on an object, you should find the object in the Object Name list and the column with the corresponding permission. The context menu of a cell contains possible permissions that can be granted:

Grant

Grant with GRANT Option

Revoke (removes a previously granted permission)

Grant All

Revoke All

See also:

Using Navigation bar and context menu

Managing column permissions

Filtering objects in list

Managing system privileges

Managing roles


Managing column permissions

The Table-specific privileges area of the Objects Grants tab displays the grid with table columns and the privileges that can be granted to the selected user or role.

Use items of the context menu to grant/deny/revoke permissions on columns.

Grant Manager - Managing column permissions

If permissions on a column have been defined (for a table), the corresponding permission cell of the table contains a specific icon iconHasGrantedColumn .

See also:

Using Navigation bar and context menu

Managing database-specific privileges

Filtering objects in list

Managing system privileges

Managing roles


Filtering objects in list

In large databases with huge amount of objects it may be difficult to find the required object. For this purpose you are provided with several tools for filtering objects in list:

  • the Object type control: select the required object type from the drop-down list (e.g. Tables);
  • the Filter panel: enter a character string to filter the object names by that string;
  • the CheckBox Granted only option: check this option to display objects with at least one granted operation.

Grant Manager - Filtering objects in list

See also:

Using Navigation bar and context menu

Managing database-specific privileges

Managing column permissions

Managing system privileges

Managing roles


Managing system privileges

The System Privileges tab allows you to allocate system privileges to the selected user/role.

To edit the system privileges of a user/role, select the database using the Database pane of the Navigation bar, then select a user or role from the Grantee list available within the Navigation bar.

Grant Manager - Managing system privileges

Right-click a cell next to the system privilege to grant this privilege to the selected user or role. The context menu of a cell contains possible permissions that can be granted:

  • Grant
  • Grant with Grant Option
  • Revoke (removes a previously granted permission)
  • Grant All
  • Revoke All

See also:

Using Navigation bar and context menu

Managing database-specific privileges

Managing column permissions

Filtering objects in list

Managing roles


Managing roles

The Roles tab allows you to define which users/roles may obtain roles and define whether a role should be assigned to the selected user/role by default.

Select a user or role from the Grantee list available within the Navigation bar, then select a role to be allocated to the current user/role and right-click the corresponding cell of the Granted column. The context menu of a cell contains possible permissions that can be granted:

  • Grant
  • Grant with Grant Option
  • Revoke (removes a previously allocated role)
  • Grant All
  • Revoke All

To set the role as default for the selected user/role, double-click the corresponding cell of the Default Role column.

Grant Manager - Managing Roles

See also:

Using Navigation bar and context menu

Managing database-specific privileges

Managing column permissions

Filtering objects in list

Managing system privileges


Visual Database Designer

Visual Database Designer is provided for visual presentation of databases, database objects and relations between objects. It also allows you to create, edit and drop tables and table fields, set relations between tables and perform other operations you may need to achieve your purpose.

To open the designer, select the Tools | btnVDBD Visual Database Designer main menu item, or use the btnVDBD VDBD button on the main toolbar.

  • Using Navigation bar and Toolbars
  • Using Diagram Navigator and DB Objects pane
  • Using context menus
  • Adding/removing objects to/from diagram
  • Incremental search
  • Creating new objects
  • Creating relations
  • Working with diagram pages
  • Reverse engineering
  • Printing diagram
  • Saving/loading diagram
  • Setting diagram options

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management

Visual Database Designer options


Using Navigation bar and Toolbars

The Navigation bar and Toolbars provide quick access to tools implemented in Visual Database Designer.

VDBD - Using Navigation bar

Database

iconDB select a database for building the diagram

File

iconNew create a new diagram;

iconLoadFromFile open an existing diagram;

iconSaveToFile save the current diagram to a *.pgd file;

iconSaveToFileAs save the current diagram as a custom file

Navigator

Tick use Diagram Navigator

General

cancel latest modification;

repeat canceled modification;

iconRefresh refresh objects in the diagram;

iconProperties Print setup - define printing settings;

iconPrint print the diagram;

iconPreview show Print Preview;

iconOptions edit diagram options

iconRestoreDefaultSize restore the default size and position of the window

Pages

add a new page;

delete the current page;

delete all pages.

Database Objects

Contains the list of objects that can be placed to diagram.

VDBD - Database Objects pane

Context menu of Database Objects group allows you to:

iconFindText search for objects in the diagram using the Database Objects pane;

iconPlus add objects to the diagram using the Database Objects pane;

Tick Show Tables - отображать на диаграмме таблицы.

Tick Show Views - отображать на диаграмме представления.

Tick As tree/ Tick As list - switch objects view;

Tick Sort by... - enable/disable sorting;

iconRefresh refresh list of objects.

The main toolbar (by default, the toolbar is located at the top of the diagram area) contains a number of tools (including items of the Navigation bar, context menu, tools for printing diagram, etc.) allowing you to:

iconDB select the database for building the diagram;

iconNew create a new diagram;

iconLoadFromFile open an existing diagram;

iconSaveToFile save the current diagram to a *.pgd file;

iconSaveAsPicture save the current diagram as an image;

activate the Incremental search panel;

  • adjust diagram zoom for optimal representation: iconZoomIn zoom in, iconZoomOut zoom out, iconZoomFitModel fit model;

iconZoomSelectRectangleToFit switch cursor mode: select / select rectangle to fit;

iconPrintSetup open the Print Setup dialog;

iconPrint print the diagram;

iconPreview show Print Preview;

iconAlwaysOnTop arrange objects in the diagram;

btnExtractDB extract metadata of all objects in the diagram and load the script to Execute Script Editor;

btnReverseEngineer perform Reverse Engineering;

iconRefresh refresh objects in the diagram;

iconOptions view/edit diagram options;

  • specify a predefined zoom value;

iconRestoreDefaultSize restore the default size and position of the window;

cancel latest modification;

repeat canceled modification.

Object Customization panel allows you to define font color, pen color and brush color.

VDBD - Toolbars - Main

The Pages toolbar (by default, the toolbar is located at the top of the diagram area) contains tools for working with diagram pages allowing you to:

add a new page;

delete the current page;

delete all pages.

Diagram toolbar located on the left allows you to:

align left edges;

align right edges;

align tops;

align bottom;

align horizontal centers;

align vertical centers;

space equally, horizontal;

space equally, vertical.

set the cursor mode to Select;

enables creating tables on clicking;

enables creating views on clicking;

create a new relation; switch to create relation mode;

enables creating comment on clicking.

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.

See also:

Using Diagram Navigator and DB Objects pane

Using context menus

Adding/removing objects to/from diagram

Incremental search

Creating new objects

Creating relations

Working with diagram pages

Reverse engineering

Printing diagram

Saving/loading diagram

Setting diagram options


Using Diagram Navigator and DB Objects pane

To navigate within the large diagram, use the Navigator tool available on the Navigation bar. It allows you to see the whole diagram in a reduced scale and to perform a number of operations over the diagram objects.

VDBD - Diagram navigator

A mouse click in the Navigator area sets the center of the visible diagram area. The area currently visible in the main diagram area is outlined in a red bounding rectangle.

Using the Navigator you can work with the diagram objects in the same way as in the main diagram area: add/remove, create new objects, move objects within the diagram and perform other operations.

The Database Objects pane available on the Navigation bar allows you to browse the list of available database objects that can be added to the diagram.

VDBD - Database Objects pane

Select and drag an object to the diagram area or double-click it to add the object to the diagram.

Right-click an item within the list to call the context menu allowing you to:

iconFindText find the selected object in the diagram (if the object is found, it will be highlighted in the diagram area);

iconPlus add new objects to the diagram by Reverse engineering;

Tick toggle objects representation mode: as a tree / as a list;

Tick select the sorting mode applied to the objects in the list: by schema, name / by type, schema, name / by name, schema / by type, name, schema;

iconRefresh refresh the list.

See also:

Using Navigation bar and Toolbars

Adding/removing objects to/from diagram

Creating new objects

Creating relations

Working with diagram pages


Using context menus

The context menu of the diagram area contains a number of items available in the Navigation bar and toolbars and allows you to:

  • select all objects in the diagram area;
  • adjust diagram zoom for optimal representation: zoom in, zoom out, select rectangle to fit, fit model, specify a predefined zoom value;
  • set the cursor mode to Select or create a new table, relation, or comment;
  • configure the grid: draw grid, snap to grid;
  • adjust the diagram style: draw primary key fields separately, draw entities icons, draw attributes icons, draw only names of entities, draw foreign key names;
  • perform Reverse Engineering;
  • extract metadata of the diagram objects to Execute Script Editor;
  • view/edit diagram options.

VDBD - Using context menu

The context menu of an entity contains items for working with the object and allows you to:

  • edit the object using its editor (Table Editor, View Editor);
  • create a new object using its editor (New table, View Editor);
  • drop the object from the database;
  • show/hide object subitems;
  • remove the object from the diagram.

VDBD - Using entity context menu

The context menu of a field contains items for working with the object and its fields and allows you to:

  • edit the selected field using its editor (Field Editor);
  • create a new field;
  • drop the selected field;
  • edit the object using its editor (Table Editor, View Editor);
  • create a new object using its editor (New table, View Editor);
  • drop the object from the database;
  • show/hide object subitems;
  • remove the object from the diagram.

VDBD - Using field context menu

See also:

Using Navigation bar and Toolbars

Adding/removing objects to/from diagram

Incremental search

Creating new objects

Creating relations


Adding/removing objects to/from diagram

To add an object to the diagram:

  • drag it from the Database Explorer tree to the diagram area

or

  • drag it from the Database Objects pane (available on the Navigation bar) to the diagram area or simply double-click this object in the list.

To add objects by Reverse engineering, you can right-click within the Database Objects list and select the iconPlus Add new objects... context menu item.

To remove an object from the diagram, select it in the diagram area, then right-click its title and choose the Remove <object_name> item from the context menu, or just press the Del key.

VDBD - Removing objects from diagram

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Using context menus

Creating new objects

Creating relations

Reverse engineering

Database Objects Management


Incremental search

To search for an object within the diagram:

  • right-click the required object in the Database Objects pane and select the btnFindText Find Object in Diagram item from the context menu

or

  • click the [image] Incremental Search button on the main toolbar or use the Ctrl+F shortcut to activate the Incremental Search panel in the status bar area of the designer window.

VDBD - Incremental Search

Type a string in the edit-box, and the object having the name with the closest match will be highlighted in the diagram area.

See also:

Using Diagram Navigator and DB Objects pane


Creating objects

To create a new object using Visual Database Designer:

  • press the Create table button on the New object toolbar;
  • click the desired point on the diagram to place the new object at;
  • specify object properties using its editor (New table, View Editor).

VDBD - Creating new table

Hint: To create a new object, you can also select the corresponding item from the context menu. The context menus also allow you to edit and drop database objects.

Note: Before you press the iconCompile Compile button the object is created on the diagram area only but not in the database.

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram

Incremental search

Creating relations


Creating relations

To establish a new relation (which is the foreign key in terms of database management):

  • press the Create relation button on the New object toolbar;
  • click the entity where the referential constraint should be created;
  • click the referred entity;
  • specify new foreign key properties using Foreign key Editor.

VDBD - Creating relations

Hint: To create a relation, you can also use the corresponding item of the context menu.

Once the relation is created, it is displayed as a line between two entities in the diagram area. The style the line is drawn is determined by the diagram notation.

The context menu of this line allows you to edit the foreign key using Foreign key Editor or drop the foreign key from the database.

VDBD - Creating relations - Context menu

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram

Incremental search

Creating new objects


Working with diagram pages

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Working with multiple diagram pages

You can create several pages in one diagram to split the model into several subject groups, e.g. for better comprehension.

To manage diagram pages, right-click on the tabs at the bottom of the diagram area and select the required popup menu items for adding, deleting and renaming pages.

VDBD - Working with diagram pages

Hint: Page management items are also available on the Pages toolbar of Visual Database Designer.

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram


Reverse engineering

The reverse engineering operation builds relationship diagram on the basis of the current database's structure. The objects are arranged automatically within the diagram model.

To start the reverse engineering process, press the Reverse Engineer btnReverseEngineer button on the main toolbar, or use the corresponding item of the context menu.

VDBD - Reverse engineering

The Preparing Reverse Engineering dialog allows you to select schemas containing objects to reverse engineer.

VDBD - Reverse engineering - Select schema

For your convenience the Select All and Deselect All items are available in the context menu of the schemas list.

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram


Printing diagram

Visual Database Designer allows you to print and preview the diagram.

To preview the diagram:

  • press the btnPrintPreview Print Preview button on the toolbar;
  • preview the diagram using the Print Preview window.

To setup print options:

  • press the btnPrintSetup Print Setup button on the toolbar, or use the corresponding link on the Navigation bar;
  • set printing options using the Print Setup dialog and press OK.

To print the diagram:

  • press the btnPrintMetadata Print button on the toolbar;
  • set printing options using the Print Setup dialog and press the Print button.


Print Preview

The Print Preview dialog allows you to see the diagram layout in WYCIWYG mode before it will be printed.

Use the navigation buttons or the spinner control to navigate within the preview pages.

Click the Print options... button to call the Print Setup dialog.

If necessary, specify the preview zoom according to your preferences.

Click the Print all button to start printing.

VDBD - Printing diagram - Print Preview

See also:

Print Setup dialog


Print Setup dialog

The Print Setup dialog of Visual Database Designer provides two tabs for setting printing options: Printer and Page options.

The Printer tab of the Print Setup dialog allows you to:

  • specify the printer (use the Choose printer button to select a printer which is not set by default on your system; the name, driver, port fields display the selected printer details);
  • specify print layout: print using a defined scale factor or arrange diagram at a defined number of pages horizontally and vertically;
  • set other print options.

Database tools - VDBD - Print Setup - Printer

The Page options tab of the Print Setup dialog allows you to:

  • specify page margins (in millimeters): Top margin, Bottom margin, Left margin, Right margin;
  • specify Page header and Page footer: enter the header/footer running titles text, set left/center/right align.

Database tools - VDBD - Print Setup - Page options

Hint: It is also possible to set macros in the Page header and Page footer fields:

#PCOUNT stands for the quantity of pages;

#PAGE - the number of the current page;

#DATE denotes the current date;

#TIME denotes the current time.

See also:

Print Preview


Saving/loading diagram

Use the btnSave Save Diagram and the ExplorerButton Open Diagram buttons on the main toolbar to save the diagram as a *.ord file for future use or to load the previously saved diagram.

VDBD - Saving and Loading diagram

If necessary, you can save the diagram as an image: click the btnSaveAsPicture Save as Picture button on the on the main toolbar.

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Using context menus

Adding/removing objects to/from diagram


Setting diagram options

Using the Diagram Options dialog you can setup the behavior and look of each diagram page.

To open this dialog, use the btnEnvironmentOptions Diagram options item of the Navigation bar or on the main toolbar, or select the corresponding item from the context menu.

See detailed description of each option on the Visual Database Designer page of the Environment Options dialog.

VDBD - Setting diagram options

CheckBox Apply changes to all new pages

If this option is selected, the current settings will be applied to all newly created pages of Visual Database Designer.

See also:

Using Diagram Navigator and DB Objects pane

Visual Database Designer options


Services

SQL Manager for Oracle provides graphical interface for a number of database maintenance operations. The following services are available in SQL Manager:

Database Information

Allows you to get and modify all information on configuration parameters for the current Oracle instance and current session.

Database Statistics

Allows you to view all the essential statistics on the specified database — system statistics, statistics on sessions (including hit ratio, information on locks and processes), statistics on storage, wait events, latches etc.

PL/SQL Profiler

Allows you to profile existing PL/SQL applications and identify performance bottlenecks.

Advanced Statistics Wizard

Allows you to collect, delete and import/export the statistics on specified objects for optimizer, as an aid to improve the performance.

TKProf Wizard

Makes possible to process trace files and create transient kernel reports.

Backup Database Wizard

Creates backup copies of your databases.

Restore Database Wizard

Restores your databases from previously created backups.

Flashback

Restores data to a certain state.

Job Manager

Allows you to create, schedule and run single or recurring execution of tasks in the database.

Truncate Wizard

A useful tool for truncating table and cluster data in the specified database.

Recompile Invalid Objects

Allows you to look up invalid objects in the specified schema and recompile them using their definition.

Enable/Disable constraints

A wizard used to disable and enable the constraints of different types.

To obtain detailed information concerning specific Oracle database maintenance services, refer to the official server documentation.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Options

How To...


Database Information

The Database Information tool allows you to get all information on NLS parameters for the database and configuration parameters for the current Oracle instance and current session which can be changed to optimize the server performance.

To open the tool, select the Services | btnDBProperties Database Information main menu item, or right-click the database in DB Explorer and select the Tasks | btnDBProperties Database Information item from the context menu. Alternatively, you can use the btnDBProperties Properties button on the main toolbar.

  • Common Parameters
  • Instance Parameters
  • Extended Parameters


Common Parameters

The Common Parameters tab provides two groups of parameters: Common parameters and NLS parameters.

Note: The parameters listed within this tab are read-only and their values cannot be changed.

Database Information - Common Parameters

Common parameters

This area displays common information about the Oracle server, its basic components (PL/SQL, CORE, TNS, NLSRTL), and their versions.

NLS parameters

The NLS database environment is established on creating a database and partially via initialization parameter file at the instance startup.

The NLS parameters area lists NLS parameters and their values in groups:

NLS Instance Parameters

NLS Database Parameters

NLS Session Parameters

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

See also:

Instance Parameters

Extended Parameters


Instance Parameters

The Instance Parameters tab allows you to view and edit instance configuration parameters to optimize performance.

Database Information - Instance Parameters

The Instance configuration parameters for <instance_name> area displays the parameters as a grid with the following columns: Name, Value, Default, Session Modifiable, System Modifiable. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

The area at the bottom provides the parameter editor which displays detailed information on the currently selected parameter. Some parameter values can be changed in the corresponding editor fields.

See also:

Common Parameters

Extended Parameters


Extended Parameters

The Extended Parameters tab allows you to view extended database/instance configuration parameters, such as instance name/version, database startup time, creation date, database role, information on current sessions, locks, database cache, pool size, etc.

Note: The parameters listed within this tab are read-only and their values cannot be changed.

Database Information - Extended Parameters

The Extended configuration parameters for <instance_name> area displays the parameters as a grid with the following columns: Parameter, Value. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

See also:

Common Parameters

Instance Parameters


Database Statistics

The Database Statistics tool allows you to view all the essential statistics on the specified database - system statistics, statistics on sessions (including hit ratio, information on locks and processes), statistics on storage, wait events, latches, etc.

To open the tool, select the Services | iconDatabaseStatistics Database Statistics main menu item, or right-click the database in DB Explorer and select the Tasks | iconDatabaseStatistics Database Statistics item from the context menu.

  • Using Navigation bar and Toolbar
  • System Statistics
  • Last Analyze Stats
  • Sessions
  • Storage
  • SGA
  • Wait Events
  • Latches
  • Database Alerts


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Statistics.

Database Statistics - Using Navigation bar

Database

iconDB select a database for collecting statistics

General

iconRefresh refresh the content of the active tab

iconRestoreDefaultSize restore the default size and position of the window

Refresh Options

Tick set the time interval for refreshing statistics automatically

CheckBox specify to monitor database alerts

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


System Statistics

The System Statistics tab displays the system statistics; all stats are grouped into classes - Cache, Debug, Enqueue, RAC (Real Application Clusters), RAC & Cache, Redo, SQL, SQL & Cache, User.

Database Statistics - System Statistics

The list displays items of system statistics as a grid with the following columns: Name, Value. If more convenient, you can change the order of the columns by dragging their headers horizontally.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

Last Analyze Stats

Sessions

Storage

SGA

Wait Events

Latches

Database Alerts


Last Analyze Stats

The Last Analyze Stats tab displays the objects (tables and indexes) and the date when these objects were last analyzed (i.e. when statistics was last gathered).

Hint: Statistics for tables/indexes can be gathered with the help of Advanced Statistics Wizard.

Database Statistics - Last Analyze Stats

The list displays the objects as a grid with the following columns: Owner, Name, Last Analyzed. If more convenient, you can change the order of the columns by dragging their headers horizontally.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

System Statistics

Sessions

Storage

SGA

Wait Events

Latches

Database Alerts


Sessions

The Sessions tab displays the list of sessions opened for the database (the most I/O active sessions are colored red) and additional information for each session: hit ratios, processes, locks.

Database Statistics - Sessions

The list displays the sessions as a grid with the following columns: USERNAME, SID, SERIAL#, STATUS, Lock wait, MACHINE, TYPE, COMMAND, CPU_TIME, UGA memory. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

Right-click an item within the list to call the context menu allowing you to refresh the list, kill a session, disconnect a session and set SQL trace to the trace log on the server.

Session management tools are also available through the Navigation bar of the Database Statistics window.

The lower area displays the following statistics for each session:

  • Hit Ratios
  • Process
  • Locks

See also:

System Statistics

Last Analyze Stats

Storage

SGA

Wait Events

Latches

Database Alerts


Hit Ratios

The Hit Ratio tab provides session hit ratio details and displays the hit ratio dynamics graphically.

The hit ratio of a user session is the ratio of the number of correct predictions and the total number of links the user traversed in the session.

Database Statistics - Sessions - Hit Ratio

Hit Ratio Details for the Session

Displays details for the selected session: Username, Terminal, Consistent gets, Block gets, Physical reads, Hit ratio.

Hit Ratios

The list area displays the hit ratios in groups: Buffer cache, Dictionary cache, Library cache, Sorts, Execute/Parse.

The diagram area provides visual representation of the hit ratios.

See also:

Process

Locks


Process

The Process tab provides details on processes and displays CPU usage by sessions graphically.

Database Statistics - Sessions - Process

Process detail

The list displays process details as a grid with the following columns: Parameter, Value. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

The list displays process details for the selected session: O.S. PID, DB User, O.S. User, Login time, Server type, O.S. Machine, O.S. Terminal, O.S. Program, Latch wait, Elapsed time activity, TAF Type, PGA allocated, PGA used.

The editor area below displays the last cached query to the system view for the specified session.

CPU Usage by Sessions

The diagram area provides visual representation of CPU usage by sessions.

See also:

Hit Ratios

Locks


Locks

The Locks tab displays all session locks. Select the required session from the Session list to see its locks, locked objects and detailed information on them.

Database Statistics - Sessions - Locks

All Lock per Session

The list displays all locks for the selected session as a grid with the following columns: Object name, Object type, Type, Lock mode, Request, CTime, Lock ID1, Lock ID2, Block. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Locked Objects

The list displays locked objects for the selected session as a grid with the following columns: Object name, Object type, Lock mode, Undo segment number, Slot number, Sequence number, Program. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Locked Objects of the Library Cache

The list area displays the locked objects of the library cache grouped by object type.

See also:

Hit Ratios

Process


Storage

The Storage tab displays the storage statistics in groups:

  • Tablespace
  • Control Files
  • Data Files
  • RBS Activity

See also:

System Statistics

Last Analyze Stats

Sessions

SGA

Wait Events

Latches

Database Alerts


Tablespace

The Tablespace tab consists of two basic areas: Tablespaces and Segments for <tablespace_name>.

Database Statistics - Storage - Tablespace

Tablespaces

The list displays Oracle tablespaces as a grid with the following columns: Tablespace, Alloc Size (Mb), Free Size (Mb), Used Size (Mb), Pct Used, Max(Mb), Free Space Fragmentation Index. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to refresh the list, coalesce the tablespace and set SQL trace to the trace log on the server.

Tablespace management tools are also available through the Navigation bar of the Database Statistics window.

Segments for <tablespace_name>

The list displays the selected tablespace segments as a grid with the following columns: Owner, Segment name, Segment type, Size (b), Initial Extent, Next Extent, Pct Increase, Extents, Max Extents, Extent Efficacy, Frag Count. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can also filter the rows in the Segments for <tablespace_name> list by minimum extents and segment type. Use the corresponding controls in the upper area.

See also:

Control Files

Data Files

RBS Activity


Control Files

The Control Files tab provides information on control files of the Oracle database.

Database Statistics - Storage - Control Files

The upper area lists the full paths to control files on the server.

The lower area displays control file details as a grid with the following columns: Type, Record Size, Records Total, Records Used, Pct Used, Free Size. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

See also:

Tablespace

Data Files

RBS Activity


Data Files

The Data Files tab provides information on data files of the Oracle database.

Database Statistics - Storage - Data Files

The Data Files area displays data files as a grid with the following columns: File Name, File Type, Status, Used Size (Mb), Free Size (Mb), Pct Used, Tablespace, Next Extent, Initial Extent, Min Extent, Max Extent, Pct Increase. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

See also:

Tablespace

Control Files

RBS Activity


RBS Activity

The RBS Activity tab provides information on Rollback Segment Activity.

Database Statistics - Storage - RBS Activity

The RBS Activity area displays rollback segments as a grid with the following columns: Segment Name, Tablespace, Status, Xacts, Size, Waits, Gets, Writes, Extents, Shrinks, Optimal Size. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

See also:

Tablespace

Control Files

Data Files


Redo Switch Frequency

The Redo Switch Frequency tab provides information how many times the database stopped writing to one redo log file and switched to another one.

You can set the Warning level to highlight the cell with yellow, if number of redo log switches exceeds the specified number.

Set the Critical level value to highlight the cell with red, if the number of switches exceeds this value.

Database Statistics - Storage - Redo Switch Frequency


SGA

The SGA (System Global Area) is a chunk of memory that is allocated by an Oracle instance and is shared among Oracle processes. It contains all sorts of information about the instance and the database to be operated.

The SGA tab allows you to view the following statistics on Oracle SGA:

  • Summary SGA
  • Library Cache
  • Data Dictionary Cache

See also:

System Statistics

Last Analyze Stats

Sessions

Storage

Wait Events

Latches

Database Alerts


Summary SGA

The Summary SGA tab provides information on SGA (System Global Area) memory, shred pool memory and SGA summary.

Database Statistics - SGA - Summary SGA

SGA Memory

The list area displays SGA memory usage information as a grid with the following columns: SGA Area, Total Size. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

The diagram area provides visual representation of SGA memory usage.

Hint: You can click the diagram and rotate it to get the best view.

Shared Pool Memory

The list area displays shared pool memory usage information as a grid with the following columns: Name, Total Size. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

The diagram area provides visual representation of shared pool memory usage.

Hint: You can click the diagram and rotate it to get the best view.

SGA Summary

The list area displays SGA summary as a grid with the following columns: NAME, VALUE. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

Library Cache

Data Dictionary Cache


Library Cache

The Library Cache tab provides information on Oracle library cache.

Database Statistics - SGA - Library Cache

The Library Cache area displays items as a grid with the following columns: Namespace, Gets, Get Hits, Get Hit Ratio, Pins, Pin Hits, Pin Hit Ratio, Reloads, Invalidations. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

Summary SGA

Data Dictionary Cache


Data Dictionary Cache

The Data Dictionary Cache tab provides information on Oracle data dictionary cache.

Database Statistics - SGA - Data Dictionary Cache

The Data Dictionary Cache area displays items as a grid with the following columns: Type, Parameter, Count, Usage, Fixed, Gets, Get Misses, Scans, Scan Misses, Scan Completes, Modifications, Flushes. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

Summary SGA

Library Cache


Wait Events

The Wait Events tab provides information on Oracle wait events.

Database Statistics - Wait Events

The list displays wait events as a grid with the following columns: Events, Total Waits, Time Wait(s), Total Timeouts, Average Wait(s). If more convenient, you can change the order of the columns by dragging their headers horizontally.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

System Statistics

Last Analyze Stats

Sessions

Storage

SGA

Latches

Database Alerts


Latches

Latches are low level serialization mechanisms used to protect shared data structures in the SGA. The implementation of latches is operating system dependent, particularly in regard to whether a process will wait for a latch and for how long.

The Latches tab displays aggregate latch statistics for both parent and child latches, grouped by latch name.

Database Statistics - Latches

The list displays latches as a grid with the following columns: Name, PID, Immediate Gets, Immediate Misses, Gets, Misses, Sleeps. If more convenient, you can change the order of the columns by dragging their headers horizontally.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

See also:

System Statistics

Last Analyze Stats

Sessions

Storage

SGA

Wait Events

Database Alerts


Database Alerts

The Database Alerts tab provides information on Oracle database alerts.

Note: To start monitoring of database alerts, you should select the corresponding option available on the Navigation bar. Using the Navigation bar you can also manage the list of database alerts: clear log, load the list from an external file, save the list to a file.

Database Statistics - Database Alerts

The list displays database alerts as a grid with the following columns: Timestamp, Significance, Alert. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Hint: Alerts of different significance are marked in the list by their icons and are highlighted with different colors.

Alert settings can be defined at the Database Alerts Settings section of the Environment Options dialog.

See also:

System Statistics

Last Analyze Stats

Sessions

Storage

SGA

Wait Events

Latches


PL/SQL Profiler

PL/SQL Profiler allows you to profile existing PL/SQL applications and identify performance bottlenecks.

To call the PL/SQL Profiler window, select the Services | iconPLSQLProfiler PL/SQL Profiler main menu item.

  • Using Navigation bar and Toolbar
  • Using PL/SQL Profiler

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in PL/SQL Profiler.

PLSQL Profiler - Using Navigation bar

Database

iconDB select a database for profiling

General

iconRefresh refresh the currently displayed profiler information

iconExecute start profiler

iconPause pause profiler

stop profiler

iconClear clear profiler log

iconRestoreDefaultSize restore the default size and position of the window

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Using PL/SQL Profiler

PL/SQL Profiler provides three basic areas: Run-specific information, Information about each library unit in a run, Data from all profiler runs.

Run-specific information

The list displays profiler sessions as a grid with the following columns: Run date, Run owner, Elapsed time (msec). If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

Right-click an item within the list to call the context menu allowing you to delete the selected session.

PLSQL Profiler - Using PLSQL Profiler

Information about each library unit in a run

The list displays extended information about each library unit as a grid with the following columns: Unit type, Unit owner, Unit name, Total time (msec), Total time. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

Data from all profiler runs

This area allows you to view data from all profiler runs as a grid with the following columns: Line, Occurrences, Total time, Min time, Max time, Total time (msec), TOTALTIME. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

In order to filter items in grid, you can use Custom Filter and Filter Builder dialog. For more information refer to the Filtering records page.

If necessary, you can switch to the Source tab to view the source for all profiler runs.


Advanced Statistics Wizard

Advanced Statistics Wizard allows you to collect various statistics as an aid to improve the performance. You can choose to collect and manage statistics for the whole system or database, schemas, tables and domain indexes.

To start the wizard, select the Services | iconAdvancedStatisticsWizard Advanced Statistics Wizard main menu item, or right-click the database or any database object in DB Explorer and select the Tasks | Gather Statistics / Tasks | Delete Statistics item from the context menu.

  • Selecting database and stats mode
  • Selecting objects
  • Specifying additional settings
  • Managing statistics

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using templates


Selecting database and stats mode

This step of the wizard allows you to select the source database and stats mode: stats operation and object type.

Database

Use the drop-down list to select the source database that contains objects for gathering statistics.

Stats operation

Use the drop-down list to select the statistics operation: gathering, delete, export, import.

Get statistics for

This group allows you to define the object type for retrieving statistics:

RadioButton System

RadioButton Database

RadioButton Schema

RadioButton Table

RadioButton Index

Advanced Statistics Wizard - Selecting database and stats operation

Click the Next button to proceed to the Selecting objects step (if you intend to get statistics for schemas, tables or indexes) or to the Specifying additional settings step of the wizard (if you intend to get statistics for the entire system or database).


Selecting objects

This step of the wizard allows you to select objects of the specified type for the statistics operation.

Note that this step is only available if you have specified the following object types to get statistics for at the previous step:

RadioButton Schema

RadioButton Table

RadioButton Index

Advanced Statistics Wizard - Selecting objects

If you have specified RadioButton Schema as the object type to get statistics for, you should select schema(s) for the statistics operation.

To select a schema, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

If you have specified RadioButton Table as the object type to get statistics for, you should select table(s) for the statistics operation.

Schema

Use the drop-down list to select the schema to get tables from.

To select a table, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

If you have specified RadioButton Index as the object type to get statistics for, you should select index(-es) for the statistics operation.

Schema

Use the drop-down list to select the schema to get indexes from.

To select an index, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Click the Next button to proceed to the Specifying additional settings step of the wizard.


Specifying additional settings

Use this step of the wizard to specify additional settings for the specified statistics operation. The set of of options depend on the objects for statistics, selected at the first step.

Advanced Statistics Wizard - Specifying additional settings - Schema

Target schema

Use the drop-down list to select the schema containing the stat table.

Target name

Use the drop-down list to select the stat table (stattab) identifier describing where the current statistics will be saved, or enter a name (the stat table that will be created in this case).

Stat ID

Specify identifier (optional) to associate with these statistics within stat table (stattab).

Mode

Use the drop-down list to specify further specification of which objects to gather statistics for:

NOWORKLOAD (in this mode characteristics of the I/O system are captured; gathering may take a few minutes and depends on the size of the database; during this period Oracle will estimate the average read seek time and transfer speed for the I/O system)

INTERVAL (in this mode system activity is captured during a specified interval)

START | STOP (system activity is captured during specified start and stop times, and the dictionary or stat table is refreshed with statistics for the elapsed period)

Interval

Specify time, in minutes, to gather statistics. This value is applied only when INTERVAL mode is selected.

Partition name

Specify the name of the partition on which you want statistics to be gathered.

Granularity

Use the drop-down list to specify granularity of statistics to collect:

ALL (gathers all, i.e. subpartition, partition, and global, statistics)

AUTO (determines the granularity based on the partitioning type)

DEFAULT (gathers global- and partition-level statistics)

GLOBAL (gathers global statistics)

GLOBAL AND PARTITION (gathers the global and partition level statistics; no subpartition level statistics are gathered even if it is a composite partitioned object)

PARTITION (gathers partition-level statistics)

SUBPARTITION (gathers subpartition-level statistics)

Options

Use the drop-down list to specify further specification of which objects to gather statistics for:

GATHER (gathers statistics on all objects in the schema)

GATHER AUTO (gathers all necessary statistics automatically; Oracle implicitly determines which objects need new statistics, and determines how to gather those statistics)

GATHER STALE (gathers statistics on stale objects as determined by looking at the *_tab_modifications views; also returns a list of stale objects)

GATHER EMPTY (gathers statistics on objects which currently have no statistics; also returns a list of objects which currently have no statistics)

LIST AUTO (returns a list of objects to be processed with GATHER AUTO)

LIST STALE (returns list of stale objects as determined by looking at the *_tab_modifications views)

LIST EMPTY (returns list of objects which currently have no statistics)

Method opt

Use the drop-down list to specify the method of gathering stats: FOR ALL INDEXES COLUMNS, FOR ALL HIDDEN COLUMNS.

Degree

Specify degree of parallelism (1 - serial execution).

Estimate percent

Specify the percentage of rows to estimate.

CheckBox No invalidate

If this option is selected, the dependent cursors are not invalidated.

CheckBox Block sample

This option specifies whether or not to use random block sampling instead of random row sampling. Random block sampling is more efficient, but if the data is not randomly distributed on disk, then the sample values may be somewhat correlated.

CheckBox Force

If this option is selected, statistics of the schema are gathered even if the object is locked.

CheckBox Gather sys

Select this option to gather statistics on the objects owned by the SYS user.

Click the Next button to proceed to the Managing statistics step of the wizard.


Managing statistics

This step of the wizard is intended for informing you that all extraction options have been set, and you can start the extraction process.

The log area allows you to view the log of operations and errors (if any).

Advanced Statistics Wizard - Managing statistics

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the statistics operation.


TKProf Wizard

TKProf Wizard makes it possible to process trace files and create transient kernel reports.

To start the wizard, select the Services | iconTKProfWizard TKProf Wizard main menu item.

  • Specifying common settings
  • Selecting input files
  • Setting sorting options
  • Defining execution plan
  • Specifying additional options

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Templates


Defining common settings

Use this step to define trace file and TKProf utility locations and specify database.

TKProf Wizard - Specifying common options

Database

Select the database for which trace files were created.

Trace files directory

Specifies the location of trace files to be processed.

TKProf

Locates the 'tkprof.exe' file.

Click the Next button to proceed to the Selecting input files step of the wizard.


Selecting input files

At this step you need to define input files.

TKProf Wizard - Selecting input files

Press the btnAddItem Add trace file button to open the standard Open file dialog and locate the needed trace file.

To remove a file from the list select it and press the btnRemoveItem Delete trace file button.

You can also clear list by pressing the btnClearList Clear list button.

Click the Next button to proceed to the Setting sorting options step of the wizard.


Setting sorting options

At this step you can set result file sorting options.

The utility sorts traced SQL statements in descending order of specified sort option before listing them into the output file. If more than one option is specified, then the output is sorted in descending order by the sum of the values specified in the sort options.

TKProf Wizard - Setting sorting options

Check the parameters you need to sort statements by.

With no sorting parameters selected, TKProf lists statements into the output file in order of first use.

Press the Next button to proceed to the Defining connection options of the wizard.


Defining execution plan

At this step of the wizard you should indicate whether execution plan should be generated.

RadioButton Don't use the EXPLAIN PLAN statement

Use this option if you don't need to generate execution plan.

Decide whether utility should RadioButton Connect to the registered database or to the RadioButton unregistered database.

For the unregistered database you need to define connection parameters: User/Password, Database name and Connection type.

TKProf Wizard - Defining explain plan

CheckBox Explain to

Use this option to insert execution plan data to a table. If the option is disabled the utility generates a file with the data.

Schema

Defines schema that contains table where the execution plan data should be inserted.

Name

Defines name of the existing table to insert execution plan into.

Press the Next button to proceed to the Specifying additional options step of the wizard.


Specifying additional options

Use this step to define additional options for the operation.

Output directory

Specify path to the output files.

TKProf Wizard - Specifying additional options

CheckBox List only first N SQL statement(s)

Define the amount of the statements to be included into the result file.

CheckBox Aggregate multiple users

Enable the option to list statements of all users. By default only current user statements are included to the result file.

CheckBox Do not list SQL statements run as user SYS

Enable the options to exclude statements that were executed under the user SYS.

CheckBox Generate Insert file

Indicates whether the file containing Insert statements should be generated.

CheckBox Generate Record File

Indicates whether nonrecursive queries' results should be inserted to the record file.

CheckBox Open folder after creation

Enable the option to open the output directory after operation is performed.

To Close the wizard after successful completion use the corresponding option.

To launch TKProf with the defined settings press the Run button.


Backup Database

Backup Database Wizard is intended for creating backups of your Oracle database. During its work the script to perform backup will be created, which can be edited manually, if needed.

The wizard will guide through the entire process - checking current instance settings, tuning all the options necessary both for User-managed backup script and Oracle Recovery Manager backup.

Important: Please note that you must have a clear idea of the backup/restore mechanism. Note that a wrong combination of backup/restore settings can damage your database!

To start the wizard, select the Services | [image] Backup Database main menu item, or right-click the database in DB Explorer and select the Tasks | [image] Backup Database item from the context menu.

  • Selecting database and backup strategy
  • Checking database and instance settings
  • User-managed script: Selecting datafiles
  • User-managed script: Setting additional options
  • RMAN: Specifying backup type and options
  • RMAN: Setting additional options
  • Scheduling backup scripts
  • Running database backup operation

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Restore Database

Templates


Selecting database and backup strategy

Use this step of the wizard to specify the database name, script and backup directories, and the preferable backup strategy.

Backup Database - Setting DB name and backup mode

Database

Use the drop-down list to select the database to backup.

Script directory

Type in or use the arrow-down button to specify the path to the backup script on the local machine or in the LAN.

Backup directory

Specify the directory where the database backup will be stored.

Backup using

Use this group to define the preferable backup strategy:

RadioButton User-managed script wizard

RadioButton Recovery manager (RMAN)

Click the Next button to proceed to the Checking database and instance settings step of the wizard.


Checking database and instance settings

This step of the wizard allows you to check the current database settings and choose between online and cold backups.

Backup Database - Checking database and instance settings

Use the list area to check the current database parameters:

Database name

Instance name

Version

Archivemode

Archivelog destination

Controlfiles

SPFILE

PFILE

DB block size

The Database information area provides extended information for the parameter currently selected in the list.

CheckBox Online backup

Select this option to perform online backup. If this option is deselected, cold backup will be performed.

During cold backup the database is shut down and copying of the datafiles is performed by means of the operating system itself.

In online mode there is no need to shutdown the database but it requires the ARCHIVELOG mode.

Click the Next button to proceed to the Selecting datafiles step (if the User-managed script strategy was specified at the first step) or to the Specifying backup type and options step of the wizard (if the Recovery manager strategy was specified).


Selecting datafiles

This step of the wizard allows you to select datafiles of the database to backup (for User-managed script strategy).

To add a file to the backup, select it in the list and set the respective flag in the Backup column.

Backup Database - User-managed script - Selecting datafiles

Click the Next button to proceed to the Setting additional options step of the wizard.


Setting additional options

This step of the wizard allows you to set additional options for the database backup operation (for User-managed script strategy).

Backup Database - User-managed script - Setting additional options

Backup logname

Set a name for the log file and type in or use the Save as... btnSaveAs button to specify the path to this file on your local machine or on a machine in the LAN.

CheckBox Backup controlfile

This option specifies whether the controlfile should be included into backup.

CheckBox Recreate PFILE if need

If this option is selected, the appropriate command which recreates the PFILE from existing SPFILE is added to the backup script.

CheckBox Recreate temporary data files

Specify whether the Oracle temporary datafiles should be recreated.

OS specific options

Specify the OS to use commands for in the generated script:

RadioButton Unix

RadioButton Windows

RadioButton Manually (specify the copy command in the corresponding box)

Click the Next button to proceed to the Scheduling backup scripts step of the wizard.


Specifying backup type and options

This step of the wizard allows you to specify backup parameters: select backup type and backup options for RMAN backup strategy.

Backup type

RadioButton Full backup

Specifies backup of a datafile that includes every allocated block in the file being backed up.

RadioButton Incremental backup

The goal of an incremental backup is to back up only those data blocks that have changed since a previous backup. You can use it to create incremental backups of datafiles, tablespaces, or the whole database.

Using the Backup level drop-down list you can specify either a level 0 backup which includes every block in the file except blocks compressed out because they have never been used, or a N-level backup (N between 1 and 4) which includes only those blocks that have been changed since the parent backup was taken.

Backup Database - RMAN - Specifying backup type and options

CheckBox Delete expired archivelog

If this option is selected, a special command which removes expired archievelogs is added to the RMAN script.

CheckBox Autobackup controlfile

Checking the option ensures that a usable backup of the control file is included with the backup and tagged in order to simplify restoring the control file with the rest of the database (starting from Oracle version 9).

Snapshot controlfile name

All the changes made to the database when performing backup will be logged at the Snapshot controlfile name set (recommended for Oracle version 8).

Click the Next button to proceed to the Setting additional options step of the wizard.


Setting additional options

This step of the wizard allows you to set additional options for the database backup operation (for RMAN backup strategy).

Backup Database - RMAN - Setting additional options

User

Specify the target user under which the RMAN session will be created.

Password

Specify the password for the user under which the RMAN session will be created. This field is available only if you choose to RadioButton Run script now.

CheckBox Using catalog

Catalog can be considered as a special database which stores backup settings. Specify Catalog user, Password and Database name to use it.

RMAN script execution

Specify the OS to build the command file for:

RadioButton Build command file for Unix

RadioButton Build command file for Windows

or select RadioButton Run script now for immediate execution.

Click the Next button to proceed to the Scheduling backup scripts step of the wizard.


Scheduling backup scripts

This step of the wizard allows you to schedule backup performance.

RadioButton Do not schedule

Use this option if you don't need to schedule backup operation.

RadioButton DBMS_SCHEDULER

Use this option to create a backup database job.

Backup Database - Scheduling backup scripts

Database

Database where job will be stored.

Job name

Defines the name of the job to be created.

Next time

Indicates date of the next job launch.

Periodically

Use the controls of this section to define time interval between job launches.

Custom interval

If needed you can edit the interval manually in this field.

Click the Next button to proceed to the last step of the wizard.


Running database backup operation

This step of the wizard is intended for informing you that all backup options have been set, and you can start the backup process.

The log area allows you to view the log of operations and errors (if any).

Backup Database - Running database backup operation

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the backup process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the backup process.


Restore Database

Restore Database Wizard is intended for restoring your Oracle database from backups. During its work the script to perform restore will be created, which can be edited manually, if needed.

The wizard will guide through the entire process - checking saving backup settings, tuning all the options necessary both for User-managed script and Oracle Recovery Manager restore.

Important: Please note that you must have a clear idea of the backup/restore mechanism. Note that a wrong combination of backup/restore settings can damage your database!

To start the wizard, select the Services | [image] Restore Database main menu item, or right-click the database in DB Explorer and select the Tasks | [image] Restore Database item from the context menu.

  • Selecting database and restore strategy
  • User-managed script: Verifying current settings
  • User-managed script: Selecting datafiles
  • User-managed script: Setting additional options
  • RMAN: Setting additional options
  • Running database restore operation
  • Using templates

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Backup Database


Selecting database and restore strategy

Use this step of the wizard to specify the database name, script and backup directories, and the preferable restore strategy.

Restore Database - Setting DB name and restore mode

Database

Use the drop-down list to select the database to restore.

Script directory

Type in or use the arrow-down button to specify the path to the backup script on the local machine or in the LAN.

Backup directory

Specify the directory where the database backup is stored.

Backup using

Use this group to define the preferable restore strategy:

RadioButton User-managed script wizard

RadioButton Recovery manager (RMAN)

Click the Next button to proceed to the Verifying current settings step (if the User-managed script strategy has been specified) or to the Setting additional options step of the wizard (if the Recovery manager strategy has been specified).


Verifying current settings

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Verifying current DB settings

This step of the wizard allows you to verify the current database settings for the selected User-managed script backup strategy.

Restore Database - User-managed script - Verifying current DB options

Backup logname

Check the path and name of the log file or use the ExplorerButton Explorer button to specify the path to this file on your local machine or on a machine in the LAN.

Database name

View/edit the name of the database to restore.

Instance name

View/edit the name of the Oracle instance where the database resides.

Server version

View/edit the version of the server.

Oracle home

Specify the Oracle Home storage.

Archivelog destination

View/edit the path to the archivelog.

Controlfile name

View/edit the name of the controlfile.

Controlfile destination

View/edit the path to the controlfile.

CheckBox Restore from online backup

If this option is selected, the previously created online backup will be used to restore the database.

CheckBox Enforce shutdown of the instance

Select this option to add the command to shutdown the server to the result script.

Click the Next button to proceed to the Selecting datafiles step of the wizard.


Selecting datafiles

This step of the wizard allows you to select datafiles of the database to restore (for User-managed script strategy).

To add a file, select it in the list and set the respective flag in the Backup column.

Restore Database - User-managed script - Selecting datafiles

Click the Next button to proceed to the Setting additional options step of the wizard.


Setting additional options

This step of the wizard allows you to set additional options for the database restore operation (for User-managed script strategy).

Restore Database - User-managed script - Setting additional options

Controlfile

Specify the action for the controlfile:

RadioButton Don't restore controlfile

RadioButton Restore controlfile

RadioButton Recreate controlfile

RadioButton Recreate with set database

OS specific options

Specify the OS to use commands for in the generated script:

RadioButton Unix

RadioButton Windows

RadioButton Manually (specify the copy command in the corresponding box)

CheckBox Recreate instance

If this option is selected, a command to recreate the instance will be added to the result script.

CheckBox Recreate temporary files

If this option is selected, a command to recreate temporary files will be added to the result script.

CheckBox Recreate password file

If this option is selected, a command to recreate the password file will be added to the result script.

Click the Next button to proceed to the last step of the wizard.


Setting additional options

This step of the wizard allows you to set additional options for the database restore operation (for RMAN strategy).

Restore Database - RMAN - Setting additional options

Target

Target database user

Specify the target user under which the RMAN session will be created.

Database name

Specify the name of the target database to restore.

Password

Specify the password for the user under which the RMAN session will be created.

CheckBox Using catalog

Catalog can be considered as a special database which stores backup settings. Specify Catalog user, Password and Database name to use it.

RMAN script execution

Specify the OS to build the command file for:

RadioButton Build command file for Unix

RadioButton Build command file for Windows

or select RadioButton Run script now for immediate execution.

CheckBox Restore from online backup

If this option is selected, the previously created online backup will be used to restore the database.

CheckBox Restore controlfile from autobackup

Select this option to restore the control file from autobackup, or specify the name of the snapshot controlfile name containing all the changes (if any) made to the database.

Click the Next button to proceed to the last step of the wizard.


Running database restore operation

This step of the wizard is intended for informing you that all restore options have been set, and you can start the restore process.

The log area allows you to view the log of operations and errors (if any).

Restore Database - Running database restore operation

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the restore process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the restore process.


Flashback

Flashback Wizard is a very powerful tool for restoring data to a certain state. You can either return table data to the recent state or restore dropped table to before-drop state.

To start the wizard select Services | iconFlashback Flashback main menu item.

  • Specifying the source database and selecting the operation
  • Selecting the table to flashback
  • Specifying flashback settings
  • Previewing the data in the selected flashback point
  • Running flashback operation

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Backup Database

Restore Database

Using templates


Specifying the source database and selecting the operation

At this step of the wizard you can specify the source database, and Flashback operation type.

Flashback Wizard - Specifying the source database and selecting the operation

Database

Select the source database from the Database drop-down list.

Flashback

RadioButton Table to before drop state

This flashback type allows you to restore any dropped table back into the database.

RadioButton Table data

Use this flashback type to restore a table data to the recent state.

Note: You can't flash back a table to the state earlier then its last DDL changes.

Click the Next button to proceed to the Selecting the table to flashback step (if Flashback to before drop state was specified) or to the Specifying flashback settings step (if Flashback table data was specified).


Selecting the table to flashback

Use this step to specify the dropped table to be restored to the database.

(Available only if the Flashback to before drop state flashback mode was specified at the first step.)

Flashback Wizard - Selecting the dropped table to flashback

Use the Rename to field to assign the name for the result table.

Click the Next button to proceed to the Running flashback operation step of the wizard.


Specifying flashback settings

Use this step to specify the table to flash back and the restore point.

(Available only when the Flashback table data mode was specified at the first step.)

Flashback Wizard - Specifying flashback settings

Current SCN

The latest SCN is displayed at this field.

Schema

Select the needed schema from the drop-down list.

Table name

Specify the table you want to flash back.

Flashback SCN

This field displays the SCN of the chosen restore point. Type the value in only if you are sure the value is right.

Flashback using

RadioButton SCN

Choose the flashback point from the whole database SCN list.

RadioButton Restore point

Select the flashback point from the list of restore points contained in the built-in restore point table.

RadioButton EMS Manager restore point

Choose the flashback point from the list of restore points contained in SQL Manager restore point table.

RadioButton Timestamp

Use this variant either to define the approximate date and time of the needed flashback point (Timestamp point), or the date and time interval to use the closest flashback point (Before current timestamp).

Click the Next button to proceed to the Previewing the data in the selected flashback point step of the wizard.


Previewing the data in the selected flashback point

This step allows you to preview the data in the selected flashback point to ensure that it is the exact point you need.

(Available only when the Flashback table data mode was specified at the first step.)

Flashback Wizard - Previewing the data

Use data filtering and grouping to make the preview process easier.

CheckBox Enable triggers

Use this option to enable/disable triggers when the flashback operation processes.

Click the Next to proceed to the Running flashback operation step of the wizard.


Running flashback operation

This step of the wizard is intended for informing you that all flashback options have been set, and you can start the flashback process.

The log area allows you to view the log of operations and errors (if any).

Flashback Wizard - Running flashback

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the flashback process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the flashback process.


Job Manager

Job Manager allows you to create, schedule and run single or recurring execution of tasks in the database. Job (routine) is a stored procedure, PL/SQL anonymous block or external C/Java procedure. Jobs are executed in server processes in the background mode.

To open the tool, select the Services | btnJobManager Job Manager main menu item, or use the btnJobManager Job Manager button on the main toolbar, or right-click the database in DB Explorer and select the Tasks | btnJobManager Job Manager item from the context menu.

  • Using Navigation bar and Toolbar
  • Managing jobs
  • Job Editor

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in the Job Manager tool.

Jobs - Jobs manager - Navigation bar

Database

iconDB select a database

General

iconRefresh refresh currently displayed information

iconNewjob add new job

iconEditjob edit selected job

iconDeletejob delete a job

iconExecute start job

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Managing jobs

Job Manager allows you to browse the list of jobs and manage them efficiently.

Jobs - Jobs manager

The list displays the existing jobs as a grid with the following columns: Job ID, Owner, Status, This date, Next date, Last date, What.

Right-click an item within the list to call the context menu allowing you to create a new job and specify its properties using Job Editor, start an idle job manually, stop a running job, edit, delete the selected job, or refresh the list.

Jobs management tools are also available through the Navigation bar of Job Manager.

Note: the current user can only run a job manually if he owns it.

See also:

Job Editor


Job Editor

Job Editor allows you to define job properties. It opens automatically when you create a new job and is available on editing an existing one.

Job ID

This field is not editable. Job ID is allocated by the server automatically.

Job owner

This field stores the name of the user who creates the job.

Jobs - Job Editor - General

General

Next time

Specify the next execution date and time for the job using the corresponding boxes.

CheckBox Periodically

This option specifies recurrent execution of the job.

Set the interval between executions for a specified job. Use the Every minute, Every hour, Every day and Custom interval fields for defining a recurrence period.

Specify the periodicity of the job execution:

RadioButton Every minute

Use the spinner control below to define the Every ... minute(s) value.

RadioButton Every hour

Use the spinner control below to define the Every ... hour(s) value.

RadioButton Every day

Use the spinner control below to define the Every ... day(s) value.

If more convenient, you can use the Custom interval field to specify the execution interval for the job.

Jobs - Job Editor - PLSQL code

PL/SQL Code

Object type

Use the drop-down list to select the type of object (procedure or package) containing external C/Java procedures.

Schema

Use the drop-down list to select the schema that contains the stored procedure or package.

Package

Use the drop-down list to select the package to be used by the job.

Routine

Use the drop-down list to select the stored procedure to be used by the job.

If necessary, you can also create a PL/SQL anonymous block directly in the What editor area.

CheckBox Parse

If this option is enabled, Oracle parses the procedure associated with the job.

CheckBox Broken

Disables job execution. Oracle does not attempt to run broken jobs. However, you can force a broken job to run.

When finished, press OK to run Execute Script that creates the specified job.

See also:

Managing jobs


Truncate Wizard

Truncate Wizard allows you to truncate tables and clusters in the selected database.

To start the wizard, select the Services | iconTruncate Truncate Table/Cluster main menu item, or right-click a table or cluster in DB Explorer and select the Tasks | iconTruncate Truncate Table / Tasks | iconTruncate Truncate Cluster item from the context menu.

  • Selecting database and object type
  • Selecting objects
  • Setting truncate options

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using templates


Selecting database and object type

This step of the wizard allows you to select the source database and object type for truncation.

Database

Use the drop-down list to select the source database that contains objects to be truncated.

Object type

Use the drop-down list to select the type of object to be truncated: table, cluster.

Truncate Wizard - Selecting database and object type

Click the Next button to proceed to the Selecting objects step of the wizard.


Selecting objects

This step of the wizard allows you to select objects of the specified type for the truncate operation.

Schema

Use the drop-down list to select the schema which contains tables/clusters to be processed.

To select a table/cluster, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Truncate Wizard - Selecting objects to truncate

Click the Next button to proceed to the Setting truncate options step of the wizard.


Setting truncate options

Materialized view log options

Specify whether a materialized view log defined on the table/cluster is to be preserved or purged when the table/cluster is truncated.

Storage

RadioButton Drop

Select this option to deallocate all space from the deleted rows from the table or cluster except the space allocated by the MINEXTENTS parameter of the table or cluster. This space can subsequently be used by other objects in the tablespace.

RadioButton Reuse

Select this option to retain the space from the deleted rows allocated to the table or cluster. Storage values are not reset to the values when the table or cluster was created. This space can subsequently be used only by new data in the table or cluster resulting from insert or update operations.

Truncate Wizard - Setting truncate options

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the process is completed.

Click the Run button to run the operation.


Recompile Invalid Objects

The Recompile Invalid Objects service allows you look up for invalid objects in the specified schema and recompile them.

To call the Recompile Invalid Objects service, select the Services | iconRecompile Recompile Invalid Objects main menu item, or right-click the database in DB Explorer and select the Tasks | iconRecompile Recompile Invalid Objects item from the context menu.

  • Using Navigation bar and Toolbar
  • Working with recompile service

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in the Recompile Invalid Objects tool.

Recompile Invalid Objects - Using Navigation bar

Database

iconDB select a database recompiling invalid objects

General

iconFindText Find invalid objects according to currently specified criteria

iconGetInvalidDependencies Get invalid dependencies

iconCompileWithDebugInfo Recompile all invalid objects

iconRecompileDependency Recompile dependency

iconRecompileAllDependencies Recompile all dependencies

iconClear Clear the content of the window

iconRestoreDefaultSize Restore the default size and position of the window

NB: You can enable\disable Toolbars and Navigation bars at Environment Options.


Working with recompile service

Schema

Use the drop-down list to select the schema containing objects to search.

Object type

Use the drop-down list to select the object type to search.

CheckBox With debug info

Adds the code for PL/SQL debugger.

To perform the search, click the iconFindText Find invalid objects link on the Navigation bar.

To get dependencies of invalid objects click the iconGetInvalidDependencies Get invalid dependencies link on the Navigation bar.

Recompile Invalid Objects - Working with recompile service

The list below displays invalid objects of the specified type found within the selected schema as a grid with the following columns: Object name, Object ID, Hint. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Hint: Objects of different type are marked in the list by different icons.

To recompile invalid objects, click the iconCompileWithDebugInfo Recompile all invalid objects link on the Navigation bar.

If you want to recompile a single dependency that is currently selected the click the iconRecompileDependency Recompile dependency link on the Navigation bar.

If you want all dependencies to be recompiled then click the Recompile all dependencies link on the Navigation bar.


Enable/Disable constraints

Enable/Disable constraints wizard allows you to enable and disable constraints; it finds the them and converts them using Oracle statements.

To start the wizard, select the Services | iconEnableDisableConstraints Enable/Disable constraints main menu item, or right-click the database in DB Explorer and select the Tasks | iconEnableDisableConstraints Enable/Disable constraints item from the context menu.

  • Selecting database
  • Selecting schema and tables
  • Specifying operation and target

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Templates


Selecting database

This step of the wizard allows you to select the source database.

Database

Use the drop-down list to select the source database that contains tables with constraints to be enabled/disabled.

Enable and Disable Constraints - Selecting database

Click the Next button to proceed to the Selecting schema and tables step of the wizard.


Selecting schema and tables

This step of the wizard allows you to select tables to enable/disable constraints.

Schema

Use the drop-down list to select the schema which contains tables to search for constraints.

To select a table, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Enable and Disable Constraints - Selecting tables

Click the Next button to proceed to the Specifying operation and target step of the wizard.


Specifying operation and target

Operation

Specify the operation to be performed over the constraints:

RadioButton Enable constraints

RadioButton Disable constraints

Target

Select the constraint types to be enabled/disabled: check constraints, primary key, foreign keys, foreign key reference.

Enable and Disable Constraints - Specifying constraint type and operation

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the process is completed.

Click the Run button to run the operation.


Options

SQL Manager for Oracle provides you with capabilities for flexible personalization of the application.

Please see the chapters below to learn how to use personalization tools effectively.

  • Environment Options
  • Editor Options
  • Find Option dialog
  • Keyboard Templates
  • Object Templates
  • Save Settings
  • Localization

The Options menu allows you to export all program settings to a *.reg file for future use, e.g. when you need to move the settings to another machine (see Save Settings for details).

Hint: Each of the SQL Manager Options dialogs is provided with the Reset to defaults button. You can use it either to Reset current category or to Reset all categories.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

How To...


Environment Options

Environment Options allow you to customize general options of the SQL Manager application.

To open the Environment Options window, select the Options | btnEnvironmentOptions Environment Options... main menu item, or use the btnEnvironmentOptions Environment Options button on the main toolbar.

Preferences

Full mode activation

Confirmations

Appearance

Tools

DB Explorer

Search

Object Editors

Query Data

SQL Monitor

Database Alerts

Execute Script

Design Query

Style & Color Palette

Visual Database Designer

Print Metadata

Data Export

Fonts

Grid

Data Options

Print Data

Color & Formats

Advanced

Column Options

Localization

Global Shortcuts

Find Option

See also:

Editor Options


Preferences

CheckBox Show splash screen at startup

Displays the splash screen of SQL Manager for Oracle at the application startup.

CheckBox Restore desktop on connect

This option determines whether the previously opened windows and their positions should be restored upon connection to the database.

CheckBox Do not restore if 'Refresh objects on connection' database registration option is off

Check this option to perform restoring desktop operation if the 'Refresh objects on connection' option of the Database registration info is on.

CheckBox Disable multiple instances

Checking this option prevents one from running multiple instances of SQL Manager for Oracle.

CheckBox Show desktop panel (for MDI Environment style only)

Displays Desktop Panel when no child windows are open.

CheckBox Show Full Version features

This option is available in the Lite version of SQL Manager. When selected, a 30-day period of fully-functional usage is activated.

Environment Options - Preferences

If necessary, you can reset all toolbars and menus of the application using the corresponding button.

Hint: The Reset to Defaults button which is common for all sections of the Environment Options dialog opens a menu with items allowing you to discard all changes and reset options of the current category or of all categories to their defaults.

See also:

Confirmations

Windows

Tools

Fonts

Grid

Localization

Find Option


Full mode activation

Note that when using the FREE Lite version of SQL Manager for Oracle (which contains functional limitations) you can activate a 30-day period of fully-functional usage. During this period you will get the splash screen displaying the number of days left every time you start the application. After the period expires, you will be able to continue using the Lite version.

To activate the 30-day Full version mode, please enable the CheckBox Show Full Version features option available on the Preferences page of the Environment Options dialog (note that this option is only available in the Lite version of SQL Manager).


Confirmations

CheckBox Confirm saving the object (or document) upon closing the editor

If this option is selected, the program requires confirmation each time you want to save changes in a database object or document.

CheckBox Confirm dropping of object

If this option is selected, the program requires confirmation of dropping a database object.

CheckBox Confirm exit from SQL Manager

If this option is selected, you are prompted for confirmation each time when you exit the application.

Environment Options - Confirmations

CheckBox Confirm transaction commit

If this option is selected, the program requires confirmation on attempt to commit a transaction.

CheckBox Confirm transaction rollback

If this option is selected, the program requires confirmation on attempt to rollback a transaction.

CheckBox Confirm deleting records

This option enables/disables a confirmation dialog for deleting records.

CheckBox Confirm metadata changing (Changing Metadata Window)

This option enables/disables the Changing Metadata window.

CheckBox Confirm transformation of misprint into substitution

If this option is selected, you need to confirm replacing a misprinted word with a corresponding substitution word (see Spell Checking).

CheckBox Confirm addition into spell checking dictionary

The option defines whether confirmation is required to add new words into spell checking dictionary.


Windows

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Appearance

Theme

Select the main color theme for the application: Light, Blue or Dark.

Environment style

This group allows you to define the basic window environment - RadioButton MDI (like Microsoft® Office) or RadioButton Floating windows (like Borland® Delphi IDE).

Windows restrictions

This option allows you to set the number of editors (Table Editor, Query data etc.) that can be opened simultaneously.

Zoom options

This group of options is only available if Environment Style is set to Floating windows environment. It allows you to set maximization size for child windows:

RadioButton Full screen

RadioButton Restricted by Main Form

RadioButton Restricted by Main Form and DB Explorer

RadioButton Justified my Main Form and DB Explorer

Environment Options - Windows

Bar style for child forms

Here you can define the location of action buttons: RadioButton within the Navigation bar (on the left) and/or RadioButton on the Toolbar.

If necessary, you can also CheckBox Enable floating toolbars for your application.


Tools

CheckBox Show only connected databases in drop-down menu

If this option is checked, only connected databases are displayed in drop-down menus of such tools as Design query, Execute Script etc.

CheckBox Allow using parameters in query text

This feature allows you to specify different values within a query in a popup dialog just before the query execution. Use the colon (':') character before an identifier (e.g. :P1) to specify a parameter within the query.

CheckBox Add ROWID to simple SELECT queries to make them updatable

Determines whether the ROWID is added to SELECT queries for update purposes.

Environment Options - Tools

New tool form should be opened for

This option defines which database should be selected in the launched tool.

RadioButton Database currently selected in DB Explorer

Tool will be opened with the database focused in the DB Explorer selected.

RadioButton Database selected in currently focused form

Tool will be opened with the database which is selected in the current form.

SQL *Plus console path

In this field set the path to the console application.


DB Explorer

General options

CheckBox Show database groups

Shows/hides database groups in the DB Explorer tree.

CheckBox Show table subobjects

Shows/hides table subobjects (fields, indexes, etc.) in the DB Explorer tree.

CheckBox Show view subobjects

Shows/hides view subobjects (fields, keys, etc.) in the DB Explorer tree.

CheckBox Sort by aliases

Use this option to apply sorting registered databases by their aliases in the DB Explorer tree.

CheckBox Rename objects by editing in place

Allows you to edit object names in DB Explorer by selecting any object and clicking its alias one more time.

CheckBox Refresh objects on showing in SQL Assistant

This option enables/disables refreshing objects each time they are displayed in SQL Assistant.

CheckBox Auto expand navigation pane

Enable this option if you need navigation pane be expanded when the program is launched.

CheckBox Show hints

If this option is selected, popup hints will be shown when setting a cursor on the object in the database explorer.

Recent objects count

Defines the number of objects displayed within the Recent menu of the DB Explorer.

Environment Options - Tools - DB Explorer

Table / Procedure / Function / View / Other objects' details in SQL Assistant

These options switch the SQL Assistant mode for displaying details for Oracle objects selected in the DB Explorer tree:

for tables: fields, primary/unique keys, Foreign keys, checks, indexes, triggers, table status, definition or description;

for views: fields, primary/unique keys, Foreign keys, triggers, definition or description;

for procedures/functions: parameters or definition;

for other objects: definition or description.

See also:

Database Explorer


Search

Here you can set search options for DB Explorer search string:

Environment Options - Tools - DB Explorer - Search - String

Search options

CheckBox Search by categories

This option determines the search scope when the Find Item feature is used: if this option is selected, the search is performed within the currently selected category (node in the tree) only.

CheckBox Use case sensitive search

If this option is selected, the search string case is considered when using the Search Panel.

Environment Options - Tools - DB Explorer - Search

CheckBox Don't search in collapsed nodes

Enable the option to search within the expanded nodes only.

CheckBox Start-with search

Check this option to search for objects those names begin with the defined searched string.


Object Editors

All

CheckBox Quote low case identifiers

Enable the option to quote identifiers containing low case symbols.

CheckBox Always open the first tab

If this option is checked, the first tab is activated by default on opening an object in its editor.

Environment Options - Tools - Object Editors

Table Editor

CheckBox Always open the Fields tab

If this option is checked, the Fields tab is activated by default on opening a table in Table Editor.

CheckBox Show Object Explorer

Enables/disables the Object Explorer panel within the Navigation bar of Table Editor.

CheckBox Do not retrieve record count for a table

Check this option to disable retrieving record count for tables (with this feature enabled, opening large tables may take much time).

Autocreation options

CheckBox Create a synonym for the newly created object

If the option is enabled a synonym for the newly created object will be created automatically in the current schema.

CheckBox Create a public synonym for the newly created object

If the option is enabled a synonym for the newly created object will be created automatically in the public schema.

See also:

Database Objects Management


Query Data

CheckBox Explain query on execution

If this option is checked, the query plan is displayed at the bottom of the Query Data window.

CheckBox Show result for each query

With this option checked, when you execute two or more queries, the result of each query will be displayed. Otherwise, only the result of the last query will be displayed.

CheckBox Execute selected text separately

Check this option to allow execution of the selected statement separately.

CheckBox Write only successfully executed queries to database SQL log file

If this option is checked, unsuccessful queries will not be saved to the Query Data log file (see Setting log options in the Database Registration Info dialog).

CheckBox Show results on Edit tab

If this option is checked, the Results tab is displayed as a separate tab.

CheckBox Don't save queries automatically for the next session

If this option is checked, the SQL query text will not be saved. Otherwise, it will be saved in Windows registry and will be therefore available in the next application sessions.

CheckBox Show DBMS output

Enables/disables redirection of DBMS output to Query Data log.

CheckBox Always save changes in Favorite Queries before closing

This option enables/disables saving changes in SQL queries marked as Favorite automatically upon closing the editor.

CheckBox Same queries for all databases

If this option is selected, all queries will be shared among all registered databases selected in Query Data.

CheckBox Refresh DB Explorer upon successful DDL statement execution

If this option is selected, the content of DB Explorer is refreshed each time a DDL statement is executed successfully in Query Data.

Environment Options - Tools - SQL Editor

Transaction confirmation

CheckBox Disable transaction confirmation

If this option is checked, no transaction confirmation will be required on closing Design Query and Query Data.

Specify the default action (Commit or Rollback) and this action will be performed automatically each time when you close the editor.

See also:

Query Data


SQL Monitor

SQL log

This group of options allows you to enable logging of all SQL Monitor events to a file. Check the Log SQL Monitor events to file option, specify the path to the log file using the btnSaveAs button, and enter a name for the *.sql file. To clear the log file after it reaches some definite size, check the Clear log file when it is greater than... option and set the maximum file size (in Kilobytes).

Environment Options - Tools - SQL Monitor

CheckBox Show non-SQL messages

Enable this option if you wish to log non-SQL messages as well.

CheckBox Show time of operation

If this option is checked, the execution time of logged operations is added.

CheckBox Always show on top

Select this option if you want to display the SQL Monitor window in the foreground permanently.

See also:

SQL Monitor


Database Alerts

This section allows you to select the alerts monitored with the help of the Database Statistics tool.

Environment Options - Tools - Database Alerts Settings

Monitored alerts

Check a box against a database alert in the list to specify it for monitoring.

See also:

Database Statistics


Execute Script

CheckBox Abort script on error

If this option is checked, script execution is aborted if an error occurs.

CheckBox Show script explorer

If this option is checked then an Explorer group of the Navigation bar is displayed.

CheckBox Show message when done

Displays a message box on finishing script execution.

Environment Options - Tools - SQL Script

CheckBox Execute selected text separately

Check this option to allow execution of the selected statement separately.

CheckBox Don't clear error list on selected text execution

If this option is checked, the error list is not cleared upon execution of the selected statement.

CheckBox Skip unknown statements

Select this option to exclude unidentified statements from parsing.

CheckBox Show DBMS output

Enables/disables redirection of DBMS output to Execute Script log.

CheckBox Disable all code features in Execute Script

This option disables code completion, code folding, highlight and all options that are set on the Code completion page. For options that are set on the Color Scheme page, the defaults will be applied.

See also:

Execute Script Editor


Design Query

General options

CheckBox Allow SELECT queries only

When this option is checked, the INSERT, UPDATE and DELETE statements are not allowed in Design query.

CheckBox Select condition row

Displays the selected condition in different rows on the Criteria and Grouping Criteria tabs of Design query.

CheckBox Drag field name

Displays the dragged field name in the Builder area.

CheckBox Hide selection when inactive

Hides the selection when the Design Query window is inactive.

CheckBox Show field types

Displays the field data type next to the field name in the table box.

CheckBox Union all by default

Check this option to use the UNION ALL expression in Design Query by default.

The UNION keyword allows you to include the results of two SELECT statements in one resulting table.

The ALL parameter incorporates all rows into the results, including duplicates. If not specified, duplicate rows are removed.

CheckBox Show DBMS output

Enables/disables redirection of DBMS output to Design Query log.

CheckBox ANSI join

Enable this option if you want to use ANSI-92 standard in join's construction.

Environment Options - Tools - Query Builder

Visible tabs

These options specify which Design Query tabs are available and which are not. Use the check boxes to make the corresponding tabs visible/invisible.

Script format

These options specify case formatting of keywords and functions in query text within the Query tab: As is keeps the original case, Uppercase sets all the keywords/functions to the upper case, Lowercase sets all the keywords/functions to the lower case, and First upper sets the first letters of all keywords/functions to the upper case.

Additionally, you can set styles and color for all Design Query objects by using Style & Color Palette.

See also:

Design Query


Style & Color Palette

Style

These options specify the way various Design Query elements look: the Condition button: Flat, 3DLook, Raised; object borders: Bump, Etched, Raised, Sunken. If necessary, you can also specify flatness for objects and buttons using the corresponding options.

CheckBox Flat object buttons

This option sets flat style for buttons.

CheckBox Flat objects

This option sets the flat appearance of objects in Design Query.

CheckBox Windows style of tables

This option determines the appearance of tables in the Builder tab.

CheckBox Show icons on tabs

With this option selected, you can see icons next to the tab names in Design Query.

Environment Options - Tools - Query Builder - Style & Color

Color palette

These options define the colors of various Design Query elements.

Active condition row (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Active condition row

Condition text (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Condition text

Condition item text (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Condition item text

Table client area (in the diagram area):

Environment Options - Tools - QB - Style & Color - Table client area

Active table caption (in the diagram area):

Environment Options - Tools - QB - Style & Color - Active table caption

Field (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Field

Operation (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Operation

Group (at the Grouping criteria tab):

Environment Options - Tools - QB - Style & Color - Group

Predicate (at the Criteria and Grouping criteria tabs when a subquery is used):

Environment Options - Tools - QB - Style & Color - Predicate

Subquery (at the Criteria and Grouping criteria tabs when a subquery is used):

Environment Options - Tools - QB - Style & Color - Subquery

Click an item to select a color for the corresponding element using the Color dialog where you can specify the required color from the palette.


Visual Database Designer

CheckBox Automatically open last diagram file

With this option enabled the designer is opened with the last diagram edited.

Visual settings

Model notation

When you work in Visual Database Designer, you can choose one of the following modeling notations:

  • Integration DEFinition for Information Modeling (IDEF1X);
  • Information Engineering (IE).

The IDEF1X and IE notations use different symbols to represent relationships between entities (and tables).

CheckBox Draw PRIMARY KEY fields separately

Separates Primary key fields from other fields with a horizontal line.

CheckBox Draw entities icons

Displays icons at the left of each entity header according to its type.

CheckBox Draw attributes icons

Displays icons at the left of each attribute according to its type (Primary key, Foreign key, ordinary field).

CheckBox Draw only names of entities

Enables highlight for entity names only.

CheckBox Draw FOREIGN KEY name

Enables highlight for Foreign key fields.

Environment Options - Tools - VDBD

Grid options

CheckBox Show grid

Displays dots in the diagram area to make the grid visible.

CheckBox Snap to grid

Automatically aligns entities on the form with the nearest grid line. You cannot place an entity in between grid lines.

Grid size

Sets grid spacing in pixels along the x- and y-axes. Specify a higher number to increase grid spacing.

Style & Color

Additionally, you can set color for all VDBD diagram objects using the Style and Color section.

This section allows you to customize the default appearance of the diagram.

Select a diagram element from the list:

Workspace

Environment Options - Tools - VDBD - Color Palette - Work area

Selected item

Environment Options - Tools - VDBD - Color Palette - Selection

Table

Environment Options - Tools - VDBD - Color Palette - Entity

Relation

Field

Environment Options - Tools - VDBD - Color Palette - Selected attribute text

Comment

See also:

Visual Database Designer


Print Metadata

Default paper size

Define the default paper size for reports created with the Print Metadata tool used:

RadioButton A4 (210 x 297 mm)

RadioButton Letter (8 1/2 x 11 ")

Environment Options - Tools - Print Metadata

See also:

Print Metadata


Data Export

This page allows you to customize formats applied to exported data.

Environment Options - Tools - Data Export

Data formats

Edit the format masks to adjust the result format in the way you need: Integer format, Float format, Date format, Time format, DateTime format, Currency format, Boolean True, Boolean False, Null string.

CheckBox Auto save format strings

Select this option to save specified format strings automatically.

These settings can also be specified at the Adjusting data formats step of Export Data Wizard.

Fore more details see Format specifiers.

See also:

Export Data Wizard


Fonts

This section allows you to specify fonts used in the application.

The box below displays the sample text with the selected font applied.

Environment Options - Fonts

System font name

Defines the font used by SQL Manager for Oracle. Select the font name from the drop-down list of available system fonts.

System font size

Defines the font size used by SQL Manager for Oracle. Type in or use the drop-down list to select the required value.

Grid font name

Defines the font used in Grid. Select the font name from the drop-down list of available system fonts.

Grid font size

Defines the font size used in Grid. Type in or use the drop-down list to select the required value.


Grid

General options

CheckBox Striped grids

Displays the odd grid rows in a different color defined by the Strip option available on the Color & Formats page.

CheckBox Show editor immediately

Allows editing the cell value right after the cell is clicked.

CheckBox Always show editor

Set this option to make the cell editors always active.

CheckBox Enable auto-search in grid

If this option is checked, the cursor is automatically forwarded to the closest match when you start typing.

CheckBox Column auto-width

With this option set, column widths are changed in order to display all columns without using the horizontal scroll bar. If the content a column is still too large to display without a need to resize the grid, then the column values are truncated and the hidden characters are replaced with an ellipsis at the end.

CheckBox Cell auto-height

If the widths of the columns are insufficient to display the full content, then text clipping occurs. Set this option to prevent this. If this option is set, the cell content is displayed in multiple lines where necessary.

Cell max line count

Sets the number of lines to display on using the Cell auto-height option.

Environment Options - Grid

Grid layout preference

RadioButton Autofit column widths

Use this option to shrink the grid columns so that the longest visible column value fits.

RadioButton Save and restore layout

Use this option to keep the original grid width.

Root level options

These options are applied to the main view of the grid. See Grid View for details.

Detail level options

These options are applied to the detail view of the grid. See Grid View for details.

CheckBox Show "Group by" box

Displays the gray area above the column caption allowing one to group data in the grid.

CheckBox Show indicator

Activates/deactivates the row indicator pane at the left.

Environment Options - Grid - Show indicator

CheckBox Show navigator

Activates/deactivates the data navigator similar to the navigation pane at the top of the grid. The navigator is available at the bottom of detail level view.

Environment Options - Grid - Show navigator

CheckBox Show "New item row"

Displays an empty row at the bottom of a view which is a convenient way for adding data to the grid.

CheckBox Hide tabs for single detail

This option is useful when only one view is present on the detail level. When the option is enabled, the view tab is hidden.

Selection

Select whether Row or Cell should be highlighted in the grid on focusing the cell.

CheckBox Row multi-selection

With this option set, multiple rows can be selected in grid.

See also:

Grid View


Data Options

Advanced

CheckBox Shared connection within database*

Select this option to disable creation of a separated connection for each data view. Enabling this option is recommended if maximum allowed number of connections is too low. It is also recommended to enable the Auto commit option available in the Data Options section of the Database Registration info.

CheckBox Asynchronous query execution

Check this option to allow executing a query/getting object data in the background mode.

CheckBox Perform data filtration on client in data view*

If enabled, the data are filtered by SQL Manager for Oracle (on the client side).

If disabled, SQL filter is used in data view. In this case filtering is performed on the Oracle server with the help of the WHERE clause used in SQL query.

Load visible rows mode if records more than...*

Set this option to switch to the Load visible rows mode when the number of records in the dataset exceeds the specified value.

String fields width (chars)

Using this option you can limit string fields width that may improve performance on large datasets.

Environment Options - Grid - Data Options

Default grid mode

RadioButton Load all rows*

The grid loads all records from a dataset. This option increases the grid performance by reloading only changed dataset records when updating. In this mode all features (automatic sorting, filtering and summary calculations) are available.

RadioButton Load visible rows*

The grid loads only a fixed number of dataset records into memory. This option minimizes dataset loading time. Automatic sorting, filtering, summary calculations are not available in this mode.

The Default grid mode options allow you to define the grid mode which will be used by default.

With the Load all rows option enabled, when loading data, all the records are loaded into grid buffers. In this mode opening the tables with many records may take a considerable amount of time. But in this case you can make use of some advantages: in the filter drop-down list the column headers are displayed with the values for quick filtering; it is possible to open several sub-levels at the same time when viewing data in master-detail view, etc.

In case opening and other operations with an object consisting of many records takes sufficient time, the Load visible rows mode should be used instead. It can be set individually for each table and saved between sessions (can be set through the context menu of the grid).

See also:

EMS SQL Manager FAQ


Print Data

Save/restore following print data properties

These options specify which Print Data properties will be saved between work sessions (e.g. if you tick off the Page settings item, those settings will be saved and stored between the sessions).

You can save/restore the following Print Data properties: Card view representation, Detail view representation, Expanding, Formatting, Level options, "On every page" options, Pagination, Preview options, Image options, Selection options, Report size options, Showing grid elements, Page number format, Page settings, Report title.

Environment Options - Grid - Print Data


Color & Formats

Display formats

Integer fields

Defines the format for displaying NUMBER fields.

Float fields

Defines the format for displaying NUMERIC and DOUBLE PRECISION fields.

Date / Time fields

Defines the format for displaying DATE / TIME fields.

For more information refer to the Format specifiers page.

Environment Options - Grid - Color & Formats

Colors

Options of this group allow you to set colors for basic grid elements. Use the ellipsis EllipsisButton button to open the Color dialog allowing you to select the required color from the palette.

Grid

Defines the background color of the data grid.

Row

Defines the color of the selected row in the data grid.

Strip

Defines the color of the odd rows (applied if the Striped grids option is set on the Grid page).

NULL values

Text

Defines the text that stands for NULL values in grid.

Font color

Defines the font color for displaying NULL values in the grid. Use the ellipsis EllipsisButton button to open the Color dialog allowing you to select the required color from the palette.


Advanced

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Advanced options

CheckBox Cell hints for clipped text

Indicates whether a hint box is displayed when hovering over a cell containing clipped text.

CheckBox Focus cell on cycle

Determines whether the focus moves to the next row after it reaches the right-most cell within the current row.

CheckBox Focus first cell on new record

Determines whether the focus moves to the first cell of a newly created row.

CheckBox Next cell on pressing Enter

Determines whether the current view columns can be navigated by using the Enter key.

CheckBox Show navigator hints

Indicates whether a hint box is displayed when hovering over navigation buttons.

CheckBox MRU list in column filter

Enables showing of Most Recently Used items when filtering columns

CheckBox Expand buttons for empty details

Specifies whether to display expand buttons within master rows that do not have associated details.

Card width

Defines the width of the card used in Card View mode.

Environment Options - Grid - Advanced

Form view

CheckBox Large memo editor

Sets the number of lines for text-typed fields when viewing data in Form view.

CheckBox Word wrap in memo editor

Determines whether long strings are wrapped within the memo editor area.

CheckBox Word wrap in string editor

Determines whether long strings are wrapped within the string editor area.

Grid lines

Determines whether to display vertical and horizontal lines between cells.

Detail tabs position

Specifies the position of the tabs in detail level views: top or left.

Card layout direction

Specifies the direction of cards in Card View mode: horizontal or vertical.

Show edit buttons

Indicates when the edit buttons are displayed: never, for focused record or always.


Column Options

Common options

CheckBox Auto-select text

Determines whether all text within an editor is automatically selected when the editor gets focus.

CheckBox Hide selection on losing focus

Determines whether the visual indication of the selected text remains when the editor loses focus.

Memo editor options

CheckBox Inserting Return characters

Specifies whether a user can insert return characters into text.

CheckBox Inserting Tab characters

Specifies whether a user can insert tab characters into text.

CheckBox Word wrap in grid

Determines whether long strings are wrapped in grid.

CheckBox Popup memo editors

Turns on popup memo editors for text BLOB type fields.

Environment Options - Grid - Column Options

Spin editor options

CheckBox Use Ctrl+Up instead of Up to increase value

Allows you to use Ctrl+Up and Ctrl+Down key combinations for editing spinner values (for numeric field values).

CheckBox Show large increment buttons

Determines whether fast buttons (for large increment) are visible within the editor.

Increment

Specifies the increment value for the spin editor (spinner control).

Large increment

Specifies the large increment value for the spin editor (spinner control).

Spin editor buttons' position

Specifies the position of spin editor (spinner control) buttons: vertical, horizontal / left and right or horizontal / right.


Localization

The Localization section of the Environment Options dialog is provided for managing the localization files of SQL Manager for Oracle.

You can create your own *.lng files similar to those available in the %program_directory%\Languages folder, add them to the list of available languages and set the new language as the program interface language.

Default directory

Use the Explorer ExplorerButton button to specify the directory where the *.lng files are to be stored by default.

Choose program language

Use the drop-down list of available languages to select the interface language to be applied to the application.

CheckBox Auto scan languages on startup

When checked, the directory with localization files will be scanned automatically at the application startup; all the languages found will be added to the list of available languages.

Available Languages

Lists all the languages available for localization and the corresponding *.lng files. Double-click a language in the list to edit its name or the *.lng file.

Add Defaults

This button is used to search for *.lng files in the Default directory and add all of them to the Available Languages list.

Add

Opens the Add language dialog where you can specify your own localization file and set the language name.

Edit

Opens the Edit language dialog where you can change the language name or select another localization file for the specified language.

Delete

Removes the selected language from the Available languages list (without confirmation).

Environment Options - Localization

See also:

Localization


Global Shortcuts

This section allows you to view/edit shortcuts most needed actions when working with SQL Manager for Oracle.

Environment Options - Global Shortcuts

To edit shortcut, select the required action click the ellipsis button and press the preferred key combination to assign it with the action.

Environment Options - Global Shortcuts - Edit


Find Option

The Find Option section allows you to search for options available within the Environment Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Environment Options.

Environment Options - Find Option

The Available options area lists all options of the Environment Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Editor Options

Editor Options allow you to set the parameters of viewing and editing SQL statements within Query Data and other SQL editing tools of the SQL Manager application.

To open the Editor Options window, select the Options | btnEditorOptions Editor Options... main menu item, or use the btnEditorOptions Editor Options button on the main toolbar.

  • General
  • Display
  • SQL Formatter
  • Key Mapping
  • Spell Checking
  • Find Option

See also:

Environment Options


General

Editor options

CheckBox Auto indent

If this option is checked, each new indention is the same as the previous one when editing SQL text.

Indents and outdents are used in the process of text editing to make the source code easier to read.

CheckBox Insert mode

If this option is checked, the insert symbols mode is on by default.

CheckBox Find text at cursor

If this option is checked, the Text to find field in the Find Text dialog is automatically filled with the text on which the cursor is set.

CheckBox Always show hyperlinks

If this option is checked, hyperlinks are displayed in the editor window. To open a link, click it with the Ctrl key pressed.

CheckBox Double click line

If this option is checked, double-clicking the line on which the cursor is set selects the whole line.

CheckBox Trim trailing spaces

If this option is checked, all spaces after the last symbol in line will be trimmed.

CheckBox Fixed line height

Prevents line height calculation. If this option is checked, the default line height is taken.

CheckBox Persistent blocks

Keeps marked blocks selected even when the cursor is moved with the arrow keys used, unless a new block is selected.

CheckBox Fixed column move

If this option is checked, the caret keeps its horizontal position when moved between lines.

CheckBox Optimal fill

Check this option to enable optimal algorithm of filling text content in the working area of the editor.

CheckBox Unindent keep align

Keeps align for the lines that are not indented.

CheckBox Smart caret

This option determines the caret movement (up, down, line start, line end). The caret is moved to the nearest position on the screen.

CheckBox Resolve aliases

Enables/disables the syntax highlight and code completion features for aliases.

Editor Options - General

CheckBox Overwrite blocks

Replaces a marked block of text with whatever is typed next. If Persistent Blocks is also selected, the text you enter is appended to the currently selected block.

CheckBox Show caret in read only mode

Displays/hides the caret in read-only mode.

CheckBox Copy to clipboard as RTF

If this option is checked, the selected text is copied in RTF format.

CheckBox Drag and drop text

This option allows to drag and drop selected text.

CheckBox Group undo

This option allows you to undo multiple actions of the same kind.

CheckBox Group redo

This option allows you to redo multiple actions of the same kind.

CheckBox Cursor beyond EOL

If this option is checked, the horizontal position of a cursor is kept. If you move the cursor (using the Up and Down arrow keys) onto a line having length less than the current cursor horizontal position, it will be positioned after the last symbol of the line.

CheckBox Enable column selection

Enables/disables column selection mode.

CheckBox Hide cursor on type

Hides/displays mouse cursor within the working area while a user is typing some text.

CheckBox Hide dynamic (no focus)

Hides dynamic highlights when an editor is not focused.

CheckBox Collapse empty lines

Collapses empty lines after a text range when this range has been collapsed.

CheckBox Scroll last line

When the option is enabled, you can scroll to the last line of the text only, otherwise you can scroll to the end of the page.

CheckBox Seek variables

Switches code completion feature for variables.

CheckBox Word wrap

When on, text is wrapped at the right margin of the editor area to fit in the visible area.

CheckBox Variable horizontal scrollbar

If this option is checked, the horizontal scrollbar varies according to the current content of the editor.

CheckBox Float markers

When enabled, markers are linked to the text, and they will move with the text while the text is being edited; otherwise the markers are linked to the caret position, and stay unchanged while the text is being edited.

CheckBox Undo after save

Keeps undo buffer unchanged after saving.

CheckBox Disable selection

Disables any selection when editing.

CheckBox Draw current line focus

Draws the focus rectangle around the current line when the editor has focus.

CheckBox Hide selection (no focus)

Hides the selection when the editor loses focus.

CheckBox Greedy selection

Selects an extra column/line in column/line selection modes.

CheckBox Keep selection mode

Enables selection for caret movement commands (like in BRIEF).

CheckBox Select search result

Determines whether the search result should be selected.

CheckBox Smart paste

When this option is enabled, the editor gets both Unicode and ANSI content from the clipboard, converts them using the selected character set and selects the best text to be pasted. This allows getting correct text copied from both ANSI and Unicode applications disregarding the currently selected keyboard language.

CheckBox Disable all code features

This option disables code completion, code folding, highlight and all options that are set on the Quick Code page. For options that are set on the Highlight page, the defaults will be applied.

Collapse level

Specifies the level of text ranges that will be affected by the "Collapse all" command.

Undo limit

Defines the maximum number of changes possible to be undone.

Tab mode

Specifies the way the TAB key is processed. Possible values are: Use tab character (inserts a tab character); Insert spaces (inserts space characters); Dialog behaviour (when the edit control is in a dialog, the focus is switched to the next control); Smart tab (tabs to the first non-white space character in the preceding line).

Tab stops

Defines the tab length used when editing a text.

Comment symbols

Defines the symbols which will be used to comment code fragments.

Block indent

Specify the number of spaces to indent a marked block.

Hint: The Reset to Defaults button which is common for all sections of the Editor Options dialog opens a menu with items allowing you to discard all changes and reset options of the current category or of all categories to their defaults.


Display

Default editor fonts

Use these options to set the font and size used in the editor.

CheckBox Show only fixed-width fonts

Use this option to display only fonts with fixed width in the Font dialog.

Gutter

CheckBox Show line numbers

If this option is checked, line numbers are displayed in the SQL text editor window.

CheckBox Gutter auto width

Enable this option to specify that the gutter width will be adjusted automatically.

CheckBox Display line state

If this option is checked, a colored line indicating the state of all altered lines in the text is displayed at the gutter of the editor window.

CheckBox Use code folding

Check this option to enable to code folding feature of Query data.

Width

Defines the gutter width in the editor window.

Use these options to set the Font, Size and Numbering style used in the gutter.

CheckBox Show only fixed-width fonts

Use this option to display only fonts with fixed width in the Font dialog.

Editor Options - Display

Right margin

CheckBox Visible

Makes the right text margin visible.

CheckBox Word break

Allows breaking the words at the right margin.

Position

Defines the position of the right text margin in the editor window.

Color

Defines the color of the right margin in the editor window. Select an item from the drop-down list or click the ellipsis EllipsisButton button to select a color using the Color dialog where you can specify the required color from the palette.

Code staples

CheckBox Visible

Makes the code staples visible in the editor window.

CheckBox Single color

Check the option to apply a single color for code staples.

CheckBox Offset

Specify the offset value for code staples.

Color

Defines the code staples color in the editor window (if the Single color option is deselected). Select an item from the drop-down list or click the ellipsis EllipsisButton button to select a color using the Color dialog where you can specify the required color from the palette.

Fonts

Use these options to set the fonts, style, size and color used in the editor. If the Show only fixed-width fonts option is checked, only fonts with fixed width are displayed in the Font dialog.


Color Scheme

Scheme

Select the default color scheme for all editors: Default (Light) or Dark.

Editor Options - Display - Highlight

The Element list contains all elements available in SQL editors of the program. For your convenience the preview area (located below the Element list) illustrates the changes being made to each of the elements

Controls for changing the properties of the item selected in the Element list are located on the right. Use the following instructions for each of the elements.

CheckBox Bold

Highlights the element with bold.

CheckBox Italic

Makes the element text cursive.

CheckBox Foreground

Select the foreground color for the element.

CheckBox Background

Select the background color for the element.

CheckBox Effects

Enables additional effects for the element text.


Code Completion

The Quick Code section of the Editor Options dialog allows you to specify the automatic features, fonts, styles, foreground and background colors, borders and other attributes of the text used by the editor to display objects for 'quick code': tables, UDFs, indices, fields, foreign keys, procedures, functions, views, triggers, scheduled events, SQL keywords, SQL functions.

Automatic features

CheckBox Code completion

If this option is checked, then on typing the first word characters in the SQL text editor you will be offered some variants for the word completion in a popup list (an analogue of the Code Insight feature in Delphi IDE). The popup list will appear after a period of time defined by the Delay option.

Delay

Using this option you can change the time after which completion variants popup.

Sensitivity

This option allows you to set the number of characters to be typed before code completion is activated.

CheckBox Parameters completion

If this option is checked, the Delphi-like hint for key words is enabled.

CheckBox Group by type

If enabled, the items in the code completion list are sorted by type, otherwise they are sorted by name.

CheckBox Sort column names

Enable this option to force sorting for field names.

CheckBox Show information hints

This option enables/disables information hints for variants offered by code completion feature.

CheckBox Auto launch keyboard templates

Allows you to use keyboard templates for faster typing frequently used expressions (see Keyboard Templates).

CheckBox Accept by Space key too

Enables selecting the completion item with Space key.

Editor Options - Display - Quick Code

Completion list object

The list contains all objects for which you can set quick code parameters. For your convenience the preview area (located to the right of the Completion list object list) illustrates the changes being made to each of the objects.

If you press the Disable element button, the standard settings will be applied to this object; the button text will change to Enable element. If you press this button, you will be able to change font and color attributes for this object.

Controls for changing the properties of the item selected in the Completion list object list are located on the right.


SQL Formatter

SQL Formatter is a feature implemented in SQL Manager for Oracle and is a useful tool for formatting SQL queries and scripts, making SQL statements easy to read. SQL Formatter is introduced in Query Data, Execute Script and some object editors.

The Settings tab of the SQL Formatter section allows you to enable this feature and apply SQL formatting to subqueries, if necessary.

CheckBox Format SQL query

Check this option to enable SQL formatting.

CheckBox Format subquery

Enables SQL formatting for subqueries.

Editor Options - SQL Formatter


SQL Words

The SQL words page of the SQL Formatter section allows you to select the key words for each action of SQL formatter and to set formatting parameters.

Wrap first element

Wraps the selected text at a specific column. Select the SQL key words after which formatting should be applied.

Params in line/list

Allows you to display the parameters followed by the defined key words in list or in line.

Editor Options - SQL Formatter - SQL Words

OR - AND

Set the placement of the AND an OR operators according to the operands followed by them. See the example below.

RadioButton Left

WHERE

AND ...

AND ...

AND ...

RadioButton Separate

WHERE

...

AND

...

AND

RadioButton Right

WHERE

... AND

... AND

... AND

The Keywords case / Identifiers case options allow you to define the case of the corresponding items.

You can choose UPPER, lower, Capitalize.

Default case means that the name of the identifier/keyword remains "AS IS".

CheckBox Space before bracket

Adds a "space" character before the opening bracket and after the closing one.

CheckBox Space into brackets

Adds a "space" character after the opening bracket and before the closing one.

Indent in list

Sets the size of indent relatively to the previous string.


Find Option

The Find Option section allows you to search for options available within the Visual Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Visual Options.

Visual Options - Find Option

The Available options area lists all options of the Visual Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Key Mapping

For your convenience key mapping is provided in SQL Manager for Oracle. On this page you can set the shortcuts for various commands/operations according to your needs.

Use the Commands list on the right to select the command for which you need to make a shortcut, then place cursor into the Key editor and press the key combination you find useful (use Ctrl Alt Shift buttons). After setting the shortcut, press the New button to add it to the list of existing Key combinations. If the specified shortcut is already assigned to another command/operation, an error message with the command/operation will be returned.

Editor Options - Key Mapping

Note: It is possible to set more than one key combination for the same command/operation (e.g. Ctrl-K, Ctrl-H) using the Add button.

If necessary, you can export the current Key mapping list to an external file by pressing the Export button.

Manage the shortcuts within the Key combinations list using the Delete (to remove the selected item) and the Clear (to remove all shortcuts for this command/operation) buttons.

It is also possible to save a custom key mapping scheme, if necessary:

  • set the shortcuts for the appropriate commands/operations;
  • click the Save As... button;
  • input the new scheme name in the corresponding dialog.

To delete a scheme, select it in the Scheme name drop-down list and press the Delete button.

See also:

Query Data

SQL Manager shortcuts


Spell Checking

Spell checking is a new feature implemented in SQL Manager for Oracle for your convenience.

Set the necessary Spell checker mode:

RadioButton Highlighting

In this mode incorrectly spelled and misprinted words are highlighted in the editor.

RadioButton Autocorrection

In this mode incorrectly spelled and misprinted words are replaced with the corresponding words from the Substitutions list automatically.

RadioButton None

In this mode the spelling checker is disabled.

Use the Add... button to add a new item to the Substitutions list, the Edit... button to alter the selected substitution, and the Delete button to remove the selected substitution from the spelling checker vocabulary.

Editor Options - Spell Checking

Case sensitivity

CheckBox Support case consistency with substitution

If this option is selected, the spelling checker uses the case of words-substitutions when performing a replacement.

CheckBox Ignore case while spell checking

Check this option to disable case checking.

CheckBox Keep the misprint case when replacing

Check this option if you do not wish to change the case of the replaced word.

Misprints

Controls of this group allow you to manage the spelling checker vocabulary: use the Add... button to add a new misprint to the vocabulary, the Auto button to use the default list of misprints, the Edit... button to change the selected misprint, the Delete button to remove the selected misprint from the vocabulary, and the Clear button to empty the list of misprints for the currently selected substitution.

It is also possible to exclude a misprint from spell checking without deleting the misprint. This misprint will therefore remain in the vocabulary, but it will be ignored by the spelling checker.

To mark a misprint as excluded, you need to move it from the Check list to the Ignore list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the misprints from one list to another.


Find Option

The Find Option section allows you to search for options available within the Editor Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Editor Options.

Editor Options - Find Option

The Available options area lists all options of the Editor Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Bars and menus

Use the Bars and menus section of the Visual options dialog to customize SQL Manager bars style, menus animation and a number of general options concerning toolbars and menus usage.

Visual Options - Bars and menus

Bar style

Use the drop-down list to select the painting style that will be applied to the bars:

Standard

Enhanced

Flat

XP native

Office 11

Note: If the XP native style is selected, bars use the currently applied XP theme to paint themselves. However, if the currently installed operating system is not Windows XP or the Windows Classic theme is currently applied, bars will be painted using the Enhanced style.

Menu animation

Use the drop-down list to specify the menu animation effects:

None (no animation)

Random (random choice: Unfold, Slide, Fade)

Unfold (unfolding menus)

Slide (sliding drop-down and popup menus)

Fade (menus fade in when appearing)

CheckBox Sunken border

If this option is enabled, the border of each dockable bar is drawn using sunken borders. Otherwise, no border is drawn around the dockable bar.

CheckBox Use F10 for menu

If this option is disabled, the application does not respond to the F10 key press events and the main menu will not will be called.

CheckBox Menu shows recent commands first

This option determines whether the most frequently used items will be placed in menus at first position.

If this option is enabled, frequently used menu items are "promoted" and displayed higher on the list. Unused and infrequently used menu items are visually suppressed and appear "collapsed".

Hint: If you wish to disable this feature, you can also right-click the toolbar and select the Customize... popup menu item to call the Customize dialog, then proceed to the Options tab within the dialog, and deselect the Menus show recently used commands first option.

CheckBox Show full menus after delay

This option is available only if the Menu shows recent commands first option is selected.

If this option is enabled, infrequently used menu items (if they appear "collapsed") will be automatically expanded after a delay upon setting mouse cursor (or upon selection with the Up/Down keys) on the bottom of the menu. Otherwise, the menu expands only after clicking its bottom-most button (or using the Ctrl+Down shortcut).

CheckBox Flat close buttons

This option determines the border style of the Close buttons.

If this option is enabled, the Close button is drawn flat. Otherwise, it has a 3D look.

CheckBox Gray-scale disabled images

This option specifies whether default images must be painted faded.

By default, images within disabled links are painted grayscale when the XP native or Office11 bar style is used. For other bar styles, such images are painted grayed out.

If this option is enabled, images of disabled links will be painted grayscale independently of the selected bar style.

Hint: The Reset to Defaults button which is common for all sections of the Visual Options dialog allows you to discard all changes and reset options to their defaults.


Trees and lists

Use the Trees and lists section of the Visual options dialog to view and edit the corresponding options.

Visual Options - Trees and lists

Look & feel

This setting determines the manner in which tree and list elements are painted. Use the drop-down list to select the painting style that will be applied to the trees and lists:

Standard

Flat

UltraFlat

CheckBox Hide selection

This option specifies how selected tree nodes and list items are displayed when focus leaves the tree or list control.

If this option is enabled, selected nodes look like other nodes. Otherwise, selected nodes/items are highlighted within the tree/list.

CheckBox Hide focus rectangle

This option determines whether a focus rectangle is displayed around the focused tree node or list item within the tree or list control.

If this option is disabled, the focused node/item is not highlighted but the focus rectangle is displayed around it.

CheckBox Native style

This option determines whether the native Windows style will be applied to the trees and lists.

The option has the highest priority for trees and lists. If this option is selected, the tree nodes and list items are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Edit controls

Use the Edit controls section of the Visual options dialog to customize the appearance of various SQL Manager for Oracle edit controls: Border style, Button style, Button transparency, etc.

Visual Options - Edit controls

Border style / Button style

Use these drop-down lists to specify the style around an editor (the edit control borders) and select the painting style that will be applied to the edit control buttons (ellipsis button, arrow-down combo-box button, etc.) respectively:

None

Single

Thick

Flat

3D

UltraFlat

Button transparency

Represents the button transparency mode within an editor. Use the drop-down list to specify the transparency that will be applied to the edit control buttons (ellipsis button, arrow-down combo-box button, etc.):

None (a button is always displayed in a non-transparent fashion)

Inactive (a button is drawn when the editor has focus or when the mouse cursor is positioned over the button; otherwise, the button is transparent)

Always (a button is always transparent)

Hide inactive (a button is drawn only when the editor has focus; otherwise, the button is invisible)

Hide unselected (a button is drawn when the editor has focus or when the mouse cursor is positioned over the editor region; otherwise, the button is invisible).

Edges

This group defines which edges are displayed within an editor. Check/uncheck the boxes to hide/show individual edges of the edit controls:

CheckBox Left (if unchecked, the left border edge is invisible)

CheckBox Right (if unchecked, the right border edge is invisible)

CheckBox Top (if unchecked, the top border edge is invisible)

CheckBox Bottom (if unchecked, the bottom border edge is invisible)

CheckBox Hot track

This option specifies whether editor items are highlighted when the mouse cursor is positioned over an edit control. Select this option to highlight an edit control in response to mouse movements.

CheckBox Shadow

If this option is selected, a shadow is displayed for the edit controls.

CheckBox Native style

This option determines whether the native Windows style will be applied to the edit controls.

The option has the highest priority for edit controls. If this option is selected, the edit controls are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.

CheckBox Autosize

This option specifies whether an editing field is resized to entirely display its contents.


Check boxes

Use the Check boxes section of the Visual options dialog to customize the border style and the appearance of check boxes and radio buttons.

Visual Options - Check boxes

Border style

This setting determines the manner in which check box and radio group borders are painted. Use the drop-down list to select the painting style that will be applied to the check boxes and radio groups:

None

Single

Thick

Flat

3D

UltraFlat

CheckBox Shadow

If this option is selected, a shadow is displayed for the check boxes and radio groups.

CheckBox Native style

This option determines whether the native Windows style will be applied to the check boxes and radio buttons.

The option has the highest priority for check boxes and radio buttons. If this option is selected, the check boxes and radio buttons are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Buttons

Use the Buttons section of the Visual options dialog to customize SQL Manager buttons.

Visual Options - Buttons

Button kind

This setting determines the manner in which a button is painted. Use the drop-down list to select the painting style that will be applied to buttons:

Standard

Flat

UltraFlat

CheckBox Native style

This option determines whether the native Windows style will be applied to the buttons.

The option has a higher priority than the Button kind setting. If this option is selected, the buttons are painted according to the native Windows style, otherwise the Button kind selection is applied.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Page controls

Use the Page controls section of the Visual options dialog to customize the style of all SQL Manager page controls.

Visual Options - Page controls

Tabs are visual elements of tab controls. Their purpose is to identify pages and switch between them. Once a tab is clicked, the corresponding page is selected.

Pages are container controls that represent the contents of tab controls. Tab controls contain a single page, whose context is to be updated each time the selected tab changes. Page controls contain the number of pages equal to the number of tabs.

Tab style

Use the drop-down list to select the painting style that will be applied to the tab controls:

Tabs (tabs are painted as notebook tabs)

Buttons (the selected tab is painted as a pressed button, other tabs are painted as released buttons)

Flat (tabs are painted as notebook tabs, but appear lowered slightly)

CheckBox Hot track

This option specifies whether tab captions are highlighted when the mouse pointer hovers over tabs. Select this option to enable tab highlighting.

CheckBox Multiline pages

This option specifies whether tabs are arranged across several rows.

If this option is enabled, tabs are automatically arranged into the minimum number of rows required to fit all of them. If this option is disabled, tabs are displayed within a single row.

CheckBox Native style

This option determines whether the native Windows style will be applied to the tab controls.

The option has the highest priority for the tab controls. If this option is selected, the tabs are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.

Options of the Slants group allow you to apply the Slanted painting style to tabs and specify the appearance aspects (positions) of tab slants.

CheckBox Slants

If this option is enabled, the Slanted painting style is applied to a tab control: all tabs appear slanted, and the selected tab's top edge is highlighted.

Slants Positions

Specify the positions (sides) at which the tabs are bent by slants.

RadioButton Left (slants bend left sides of the tabs)

RadioButton Right (slants bend right sides of the tabs)


Group boxes

Use the Group boxes section of the Visual options dialog to customize all SQL Manager group boxes to your liking.

Visual Options - Group boxes

Border style

This setting determines the manner in which group box borders are painted. Use the drop-down list to select the painting style that will be applied to the group box borders:

None

Single

Thick

Flat

3D

UltraFlat

CheckBox Shadow

If this option is selected, a shadow is displayed for the group boxes.

CheckBox Native style

This option determines whether the native Windows style will be applied to the group boxes.

The option has the highest priority for the group boxes. If this option is selected, the group boxes are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Splitters

Use the Splitters section of the Visual options dialog to customize all SQL Manager splitters to your liking.

Visual Options - Splitters

Hot zone style

This setting determines the manner in which splitter hot zones are painted. Use the drop-down list to select the hot zone style that will be applied to the splitters:

Windows XP task bar

Media Player 8

Media Player 9

Simple

None (hot zone is disabled)

CheckBox Hot zone drags a splitter

This option is applied when the Hot zone style value is different from None, and specifies whether the splitter can be dragged by its hot zone.

If this option is enabled, you can drag the splitter by its hot zone (i.e. use any part of the splitter's area for dragging). Otherwise, attempts to drag the splitter by the hot zone will have no effect.


Navigation bar

Use the Navigation bar section of the Visual options dialog to customize the Navigation bars of all SQL Manager tools according to your preferences.

Visual Options - Navigation bar

View style

Several types of control representations (views) are available for Navigation bars. View styles define the appearance of Navigation bar elements (background, scroll buttons, group headers, links/items and hint boxes). Use the drop-down list to select the view style that will be applied to the Navigation bars:

Office 11

XP

Simple

Advanced

CheckBox Border

This option specifies whether a border style will be applied to the Navigation bars.

If this option is enabled, the Navigation bars have thin borders. Otherwise, no borders are drawn around the Navigation bars.


Save Settings

Save Settings Wizard allows you to export the settings of SQL Manager for Oracle - wholly or partially - to a single *.reg file which can be applied afterwards to SQL Manager for Oracle installed on another machine, or it can be used to backup previous settings.

To start the wizard, select the Options | iconSaveToFileAs Save Settings main menu item.

  • Specifying destination file
  • Selecting settings
  • Selecting databases
  • Saving settings

To apply saved settings you need to open the created *.reg file, then press the OK button in the window appeared. All settings will be applied automatically (they will be added in the Windows Registry).


Specifying destination file

This step of the wizard allows you to specify the location of the destination file.

Filename

Use the btnSaveAs button to set the path to the *.reg file where the application settings are to be saved.

Note: If the target file already exists, the application will show a warning dialog where you can choose the action you need.

Save Settings - Specifying destination file

Press the Next button to proceed to the next step of the wizard.


Selecting settings

This step of the wizard allows you to specify the information you need to be saved to the result file: Database registration info, Favorite objects, Tabs, Environment options, Editor options, Visual options, Keyboard templates, Object templates, External tools list, Form placements, MRU lists, Favorite queries stored in registry.

Save Settings - Selecting settings

Press the Next button to proceed to the next step of the wizard.


Selecting databases

This step of the wizard allows you to select the database(s) to save the registration settings.

To select a database, you need to move its alias from the Available Databases list to the Selected Databases list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the databases from one list to another.

Save Settings - Selecting databases

Press the Next button to proceed to the last step of the wizard.


Saving settings

This step of the wizard is intended to inform you that the saving settings operation has been configured, and the wizard is ready to save the application settings to the specified file.

The log area allows you to view the log of operations and errors (if any).

Save Settings - Saving settings

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Run button to start saving settings.


Localization

When using SQL Manager for Oracle, your are provided with multi-language interface support. You can change the program language, specify the directories for your localization files easily, edit existing localizations and create your own localization files.

Changing Program Language

  • select the Options | Select Program Language... main menu item;
  • select the interface language in the Select Language dialog;
  • click OK to apply the language and close the dialog.

Editing Program Localization

  • open one of the program windows (e.g. Table Editor, Query Data) where you wish to edit the localization of captions and hints;
  • use the Shift+Ctrl+L keyboard shortcut to open the Localization Editor window;
  • edit window captions and hints as necessary;
  • click the Save btnSave button on the toolbar.

Note: The Localization Editor window is only available if the currently selected language is different from the default.

Creating New Localization Files

  • create a new localization file similar to those located in the %program_directory%\Languages folder;
  • select the Options | Environment Options main menu item;
  • proceed to the Localization section of the Environment Options dialog;
  • click the Add button;
  • set the language name and the path to the new *.lng file within the Language Info Editor dialog.

The new language is added to the list of available languages. Now you can set it as the interface language using the Select Program Language dialog or the Localization section of the Environment Options dialog.

See also:

Localization

Language Info Editor


Localization Editor

The Localization Editor window allows you to edit the captions and hints of any SQL Manager window, if the selected program language is different from the default one.

To call this window, use the Shift+Ctrl+L shortcut in any child window of SQL Manager for Oracle.

The working area of the window contains the element names and the corresponding strings divided by the "=" character. These strings are what you see in the program as menu items, window captions, button hints, etc. Edit them to change the program appearance. Be careful and do not edit the identifiers that stand before the "=" character - this will not produce any effect.

For your convenience the Find and Replace features are provided - the corresponding btnFindText btnReplaceText toolbar buttons are used to call the Find Text dialog or the Replace Text dialog respectively. The Search Again btnSearchAgain button enables the repeated search for the text that was last searched.

Localization - Localization Editor

When you are done with editing, click the Save btnSave button on the toolbar to apply the changes you have made.

See also:

Select Program Language

Localization


Select Program Language

The Select Language dialog allows you to select a language for SQL Manager for Oracle localization.

To open this dialog, select the Options | Select Program Language... main menu item.

The dialog displays the list of available languages configured on the Environment Options | Localization page. Select a language from the list and click OK to confirm your choice and close the dialog.

Localization - Select Program Language

See also:

Localization Editor

Localization


Keyboard Templates

The Keyboard Templates window allows you to create new keyboard templates for quicker typing regularly used expressions and to edit the existing ones.

To open this window, select the Options | Keyboard Templates... main menu item.

To add a new keyboard template, click the Add Template... button, set the template name and define the template expression. In the upper right area of the window you can change the case of the template expression (As is, Uppercase, Lowercase, First upper).

You can deactivate an existing template by selecting it from the list on the left and removing the Active flag of the template.

If necessary, you can also edit the template name using the Edit Template... button, delete the template using the Delete Template button or edit the template expression within the Expansion area of the window. For faster editing you can use the Cursor, Author, Time, Date, Clipboard, Marker buttons.

Hint: Add/edit/delete template items are also available in the context menu of the template list on the right.

CheckBox Old style

This option specifies whether the selected keyboard template expansion should conform to the template specifications used in the earlier versions of SQL Manager for Oracle.

Once you have defined the templates, you can use them in Query Data. First of all, make sure that the CheckBox Auto launch keyboard templates option is selected on the Code Completion page of the Editor Options dialog. When editing SQL text in Query Data, type a template name and use the Ctrl+J shortcut: the text associated with the template (Expansion) will be inserted automatically.

Hint: The Reset to defaults button which is available at the bottom of the Keyboard Templates dialog allows you to discard all changes and restore the settings to their defaults.

See also:

Code Completion

SQL Manager shortcuts


Object Templates

The Object Templates window allows you to preset the definition template for the name and/or body of an object to be created.

To open this window, select the Options | Object Templates... main menu item.

Select an object in the tree (Object Type, Object Type Body, Package, Package Body, Procedure, Function) and set its template using the editor area.

See also:

Database Objects Management


Find Option dialog

The Find Option dialog allows you to search for SQL Manager options easily.

To open this dialog, select the Options | Find Option main menu item.

Option

In this field you can enter the name of the option to search for within the entire set of SQL Manager options.

Find Option dialog

The Available options area lists all options by categories according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding dialog where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


How to...

The succeeding pages of this chapter are intended to provide you with brief instructions on how to perform this or that operation correctly using SQL Manager for Oracle.

Work with Databases

Connect to a database

Edit database connection parameters

Make work with a database faster

Design a visual database structure

View an ER diagram

Backup a database

Restore a database from a backup

Create a database copy

Document a database

Save metadata reports to file

Log database changes

Get an SQL dump

Synchronize two databases

Work with Database Objects

Group objects

Find objects

View dependecies

Get an object DDL

Work with Data

View tables with many records

Set data filter

Sort and group data

Export/import data

Export data as SQL Script

Export filtered data

Edit data of master-detail tables

Create an autoincrement field

Add image to table

Set data display format

Work with Queries and Scripts

Create SQL statements rapidly

Control a query productivity

Work with several queries at once

Save most frequently used queries

Execute queries with parameters

Export query results into file

Execute scripts

Execute a large SQL Script

Make Execute Script work faster

Customize work with Query/Script text

View executed queries and scripts

Debug procedures

Create a simple report in Report Designer

Transfer program settings

Update SQL Manager

Report bugs and suggestions


Connect to a database

If you want to connect to a database that has not been registered yet then perform the following operations:

  1. Launch the Register Database wizard by selecting the Database | btnRegisterDB Register Database... main menu item.
  2. On the first step specify connection parameters: Oracle Home storage for this connection and DB group name. If needed you can set Tunneling parameters as well.

Note: To register several databases at once uncheck the CheckBox Register a single database option. In this case you will proceed to the Selecting databases step of the wizard where you are to define databases you want to be registered.

  3. On the last step of the wizard set database name and Authentication parameters.
  4. The registered database(s) is/are now displayed in the DB Explorer. To connect to the database double-click its alias or select the btnConnectToDB Connect to Database item of the database context menu.


Edit database connection parameters

If you have made a mistake when creating or registering a database or the information provided is incomplete then it can be edited using the Database Registration Info dialog. You can view this information both for connected or disconnected database.

To open the dialog, select the database or any of its objects in the DB Explorer tree, then select the Database | btnDBRegistrationInfo Database Registration Info... main menu item, or right-click the database alias in DB Explorer and use the btnDBRegistrationInfo Database Registration Info... context menu item.

The connection parameters can be changed on the Connections tab of the dialog. Here you can define or redefine the following properties in the corresponding boxes: Server name, User name, Password, Database name, Database alias and Font charset.


Make work with a database faster

If your database contains too many objects or if connection to the database is slow you can increase work speed by uncheking the CheckBox Refresh objects on connection option when registering database or editing the Database Registration Info.


Design a visual database structure

To design your database visually you may use the Visual Database Designer. It allows you to create, edit and drop tables and table fields, set relations between tables and perform other operations you may need to achieve your purpose. All new objects are displayed on a diagram.


View an ER diagram

The relationship diagram is built using the reverse engineering operation.

To view an ER diagram of a scheme you should follow the steps:

  1. Run Visual Database Designer;
  2. Click the btnReverseEngineer Reverse Engineer button on the main toolbar or use the corresponding item of the context menu.
  3. Choose schemas to reverse engineer from.

The created diagram can be saved as a *.ord file ( btnSave Save Diagram button) or as an image ( btnSaveAsPicture Save as Picture button).


Backup a database

A database backup is created by means of the Backup Database Wizard. To launch it choose Services | [image] Backup Database main menu item.

There are two ways to create a backup of an oracle database: User-managed script and Recovery manager (RMAN).

Recovery Manager (RMAN) is an Oracle utility that can back up and restore database files. It is a feature of the Oracle database server and does not require separate installation.

User-managed script method consists in using operating system commands for backups.

Note: Use of RMAN is highly recommended because it is more robust and greatly simplifies administration.

The following are possible circumstances in which you may choose to employ user-managed methods rather than use RMAN:

  • You are migrating from an older version of the database to the current version and do not immediately want to update your legacy backup scripts.
  • You maintain a network containing Oracle7 and later databases and want a single backup and recovery method to handle all databases in the same way. RMAN only supports Oracle databases of release 8.0 or greater.
  • All your RMAN backup are lost and you are forced to restore user-managed backups and perform recovery with the SQL*Plus RECOVER command.

To perform Oracle backup with user-managed script:

  1. Select the RadioButton User-managed script wizard option in the Backup using group on the first step of the wizard.
  2. On the second step define whether you want to perform hot (on-line) or cold (off-line) backup. A hot backup is performed while the database is open and available for use. A cold backup is performed while the database is off-line and unavailable to its users.

Note: It is easier to restore from off-line backups as no recovery (from archived logs) would be required to make the database consistent. Nevertheless, on-line backups are less disruptive and don't require database downtime.

  3. Select datafiles of the database to backup on the third step.
  4. On the next step set additional options for user-managed script, including OS to use commands for in the generated script: Unix, Windows or Manually (specify the copy command).

To perform Oracle backup with Recovery manager:

  1. Select the RadioButton Recovery manager (RMAN) option in the Backup using group on the first step of the wizard.
  2. On the second step define whether you want to perform hot (on-line) or cold (off-line) backup. A hot backup is performed while the database is open and available for use. A cold backup is performed while the database is off-line and unavailable to its users.

Note: It is easier to restore from off-line backups as no recovery (from archived logs) would be required to make the database consistent. Nevertheless, on-line backups are less disruptive and don't require database downtime.

  3. On the third step specify the backup type: Full or Incremental.
  4. On the next step set additional options for Recovery manager such as: Username and Password to define under which user the RMAN session will be created; Catalog settings (catalog is considered as a special database which stores backup settings); RMAN script execution (the OS to build the command file for).


Restore a database from backup

Use the Restore Database Wizard to restore a database from a backup. To launch the wizard and set restore options choose the Services | [image] Restore Database main menu item.

There are two ways to restore an Oracle database: User-managed script and Recovery manager (RMAN).

Recovery Manager (RMAN) is an Oracle utility that can back up, restore, and recover database files. It is a feature of the Oracle database server and does not require separate installation.

User-managed script method consists in using operating system commands to restore a database.

Note: Use of RMAN is highly recommended because it is more robust and greatly simplifies administration.

The following are possible circumstances in which you may choose to employ user-managed methods rather than use RMAN:

  • You are migrating from an older version of the database to the current version and do not immediately want to update your legacy backup scripts.
  • You maintain a network containing Oracle7 and later databases and want a single backup and recovery method to handle all databases in the same way. RMAN only supports Oracle databases of release 8.0 or greater.
  • All your RMAN backup are lost and you are forced to restore user-managed backups and perform recovery with the SQL*Plus RECOVER command.

To perform Oracle restore with user-managed script:

  1. Select the RadioButton User-managed script wizard option in the Restore using group on the first step of the wizard.
  2. On the second step verify and edit the current database settings for the selected User-managed script backup strategy.
  3. Select datafiles of the database to restore on the third step.
  4. On the fourth step set additional options for the database restore operation, including action to be taken on the control file and OS used when performing a restore process.

To perform Oracle restore with Recovery manager:

  1. Select the RadioButton Recovery manager (RMAN) option in the Restore using group on the first step of the wizard.
  2. On the second step set additional options for the database restore operation (for RMAN strategy).


Create a database copy

In order to create a copy of the whole database or of separate objects you can:

  1. Extract DB objects structure and data into Execute Script using the Extract Database Wizard. The result script can be used to copy or restore your database.
  2. Create database backups with the help of the Backup Database Wizard.
  3. Create copies of separate database objects by using the Duplicate Object Wizard.
  4. Generate a synchronization script that will convert a source database into a target one using the Compare Databases Wizard.


Document a database

There are several ways to document a database:

  1. You can generate a detailed HTML report of the selected database objects using HTML Report Wizard.
  2. You can generate and print metadata reports of any database object(s). Generated reports can be exported to any of the available formats: HTML file, Excel file, Text file, RTF file, CSV file, HTML file, BMP image, Excel table (OLE), JPEG image, TIFF image.
  3. You can save the Visual Database Designer diagram as a *.ord file for future use. If necessary, you can also save the diagram as an image.


Save metadata reports to file

To save a metadata report in a file of any supported format (*.txt, *.csv, *.pdf, *.html) you should do the following:

  1. Open the Print Metadata window by selecting the Tools | iconPrint Print Metadata item of the main program menu.
  2. Mark the needed objects and define printing settings and click the btnPrintPreview Preview button on the navigation bar or toolbar.
  3. In the opened Preview window click btnPreviewExport Export and select from the drop-down list the needed file format for report saving. When done, specify file name and location.


Log database changes

If you want to perform metadata changes logging and SQL query logging you need to:

  1. Check the CheckBox Enable log of metadata changes and specify the path to the *.sql file to store the metadata logs.
  2. Check the CheckBox Enable log of Query Data queries and specify the path to the *.sql file to store the logs of SQL queries: date/time of query execution, SQL text, execution result or errors (if any).

This can be done in the Database Registration Info | Logs window.


Get an SQL dump

To get an SQL dump (an *.sql file) of your database use the Extract Database Wizard that will extract database objects and/or data to an Execute Script, e.g. for backup purposes.


Synchronize two databases

The synchronization between two databases can be done with a help of the Compare Databases Wizard. This wizard allows you to compare databases and create a script to deploy changes from one database into another one.

To run the wizard use the Tools | iconCompare Compare Databases... item of the main menu.


Group objects

If you want to group objects you can do it in one of the following ways:

  • Using Favorite objects (situated in the DB Explorer tree):
  1. Click create New Sub Folder in the Favorite Objects folder using the corresponding item of the context menu
  2. Define its name and drag-and-drop necessary objects there or use the Add Object item of the created folder context menu. Pick the objects to add to folder from the appeared dialog.
  • Using DB Explorer tabs:
  1. Right-click the necessary object in the DB Explorer.
  2. Choose the btnNewTabFromHere New Tab from Here item of the object context menu and define the name of the tab.
  3. Now your objects are stored on the separate tab of a DB Explorer.

Note: If an object is not a tree node, it cannot be placed on a separate tab.


Find objects

In order to search for objects you need you can:

  1. Call the Find Object dialog by right-clicking the Database alias, any database object group nodes or objects in the DB Explorer tree and select the Find Object... context menu item.
  2. Call the Find Object dialog by using the Ctrl+F shortcut.
  3. Type in the first letters in the edit-box of the Search Panel, and the corresponding object will be highlighted in the tree, as displayed in the picture below.

Note: Objects among which the search is performed should be updated and the object node should be expanded.

  4. Launch the Search in Metadata tool by selecting the Tools | iconSearchInMetadata Search in Metadata main menu item, or using the Ctrl+Alt+F shortcut. After the search is complete, the Explorer group on the Navigation bar displays the tree of database objects in which the search string is found, and allows you to view metadata of the required object or its fragment.


View dependecies

If you want to view all the object dependencies then:

  1. Use a dependencies tab in the Table Editor.
  2. Use the Dependency Tree tool.

These tools may be useful when you can't find an object that prevents your from dropping a table.


Get an object DDL

In order to get an object DDL you can:

  1. Right-click the object in the DB explorer tree and select the Script to New Query Data | Create context menu item.
  2. Right-click the object and select the Edit Table <table_name>... context menu item or double-click the table and then proceed to the DDL tab in the opened table editor window.
  3. Right-click the object in the DB explorer tree and select the Data Manipulation | Export Data as Execute Script context menu item.


View tables with many records

If your table contains a lot of records you can minimize dataset loading time by:

  1. Setting the number of records to be selected;
  2. Enabling RadioButton Load visible records in order to load only a fixed number of dataset records into memory

These options can be set only for the selected database on the Data Options page of the Database Registration Info.

Default settings for newly registered databases can be defined on the Grid | Data Options page of the Environment Options dialog.


Set data filter

Quick Filtering (by the current value in a cell)

Open the context menu of the needed column and choose the Quick Filter item. Then choose a filter condition in the opened submenu.

Filtering by Column

HowTo - Grid View - Quick Filter

Open the drop-down list on the column title and choose a filter condition from the list.

You can set advanced conditions by using the Custom... menu item.

When choosing this item, the special window for setting filter conditions opens.

Advanced Filtering

You can set advanced filter options by pressing the button btnSetFilter on the toolbar of the Data View and set filter parameters in the Filter Builder. Apply the set conditions by pressing the Apply button.

If a filter is set for a table, the special bar appears in the lower part of the table where you can see filter conditions and the history of filter changes opened by pressing the drop-down list.

Data View - Grid View - Filtering records - Filtering panel

Disable Filtering

To cancel filtering, open the context menu of the column and choose the Disable filter item.

Or press the btnClose button on the filter toolbar.


Sort and group data

In order to sort data, do the following:

  1. Open data at the Data or Results tab.
  2. Choose the column by which you need to sort data and click the column title.
  3. If the column was not sorted, the first click will sort it in the ascending order and the second one - in the descending order.

Note: To cancel the sorting, open the context menu by right-clicking the necessary column and choose the Clear Sorting item, or press the Ctrl button and click the column title.

To enable grouping, drag the column title to the special grouping car above the table.

HowTo - Data View - Grid View - Grouping data by two columns_Small

Note: To disable grouping, drag the column title from the group bar back to the table.


Export/import data

You can export data from a database table into an external file of any supported format by means of the Export Data Wizard. There are several ways to launch it:

  1. Open the Data or Results tab, press [image] Export Data on one of the Data View toolbars.
  2. Open the Data or Results tab, choose Data Manipulation | Export Data in the Data Grid context menu.
  3. Open the table context menu in the DB Explorer, choose the Data Manipulation | Export Data item.
  4. Open the Data or Results tab and use the shortcut Shift+Ctrl+E.

You can import data from external sources into a table or view using Import Data Wizard:

  1. Open the Data tab, press the Import Data button on one of the Data View toolbar.
  2. Open the Data tab, choose Data Manipulation | Import Data in the Data Grid context menu.
  3. Open the table context menu in the DB Explorer, choose the Import Data item.
  4. Open the Data tab and use the shortcut Ctrl+I.


Export data as SQL script

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Export data as Execute Script

You can export data from a database table into SQL Script with INSERT INTO statements in one of the following ways:

  1. Open the Data or Results tab, press the [image] Export Data as SQL Script on one of the Data View toolbars and set export parameters in the opened Export as SQL Script Wizard.
  2. Open the Data or Results tab, choose Data Manipulation | [image] Export Data as SQL Script in the Data Grid context menu and set export parameters in the opened Export as SQL Script Wizard.
  3. Open the table context menu in the DB Explorer, choose the Data Manipulation | [image] Export Data as SQL Script item and set export parameters in the opened Export as SQL Script Wizard.

Note: In order to extract table DDL (CREATE TABLE statement), check the CheckBox Add CREATE TABLE statement box at the Step 1.


Export filtered data

If you have set a filter in a Data View and want to export only this data then you need to uncheck CheckBox Perform data filtration on client in data view option on the Database Registration Info | Data Options tab. In this case all the changes made by applying filters are performed on the Oracle server with the help of the WHERE clause used in SQL query. Otherwise your changes will just be displayed on your client machine but data will be exported into a file without applied filters.


Edit data of master-detail tables

You can work with data in multi-level mode, that is you can view and modify it in several related tables simultaneously.

To manage grid levels, right-click the grid and select the Grid Levels context menu group. Click Add Grid Level in the menu to run the Create Grid Level wizard. After the level is added you can edit data of the related tables.


Create an autoincrement field

To create an autoincrement field you need to check CheckBox Autoincrement option when creating or editing field. If this option is enabled then an autoincremental field will be created using trigger and sequence.


Add image to table

If you want to add an image to a table then do the following:

  1. Open the table on the Data tab.
  2. Go to the BLOB View section (the navigation buttons are located in the bottom part of the window) and then proceed to the Image tab.
  3. If there are several BLOB fields, choose the required field from the Select BLOB Column drop-down list on the toolbar of the Blob View tab and press the iconLoadFromFile Load from File button on the same toolbar.
  4. Choose the needed image file in the appeared dialog.

HowTo - Grid View - BLOBView - Select BLOB Column

Note: Adding images to table is possible only if table contains at least one BLOB field.


Set data display format

To set the format for displaying data open the Options | btnEnvironmentOptions Environment Options dialog from the main program menu, proceed to the Color & Formats tab and define or choose the display format for some data types in the Display formats section.


Create SQL statements rapidly

There are two options for creating SQL queries rapidly:

In the DB Explorer

  1. Right-click a table in the DB Explorer
  2. Choose Script to New Query Data context menu item.
  3. Select the necessary query type.

In the Design Query

  1. Open Design Query.
  2. On the Builder tab drag an object from the DB Explorer tree to the diagram area.
  3. Choose necessary fields to include in the query by checking the corresponding box located to the left from the field name in the list, or just by double-clicking it. To include all fields of the table/view, check the box located to the left of the table/view caption.
  4. Associate two objects by their fields.Drag a field from one object list to another. This will set a link between these objects by the selected fields. It is indicated by a bidirectional arrow between the linked fields.
  5. Edit link properties. Double-click the linking arrow or right-click it and select the Property popup menu item. The Link properties dialog allows you to change the association condition by choosing it from the drop-down list.
  6. You can view and edit your SQL statement on the Edit tab of the Design Query.


Control query productivity

You can view a query productivity on the query plan. It allows you to view the sequence of actions performed by the database server in the process of the query execution, and the amount of system resources used for the query execution.

To view the Plan of a query, open the query in Query Data and use the btnExplainQuery Show estimated execution plan item of the Navigation bar or toolbar.


Work with several queries at once

Query Data provides a possibility to open and edit several queries. You can create tabs in the lower part of the Query Data, each tab may contain a separate query. There are several ways for creating tabs:

  1. Open btnShowSQLEditor Query Data and choose btnNewSQLEditor Add New Query on one of the toolbars.
  2. Open btnShowSQLEditor Query Data and choose btnNewSQLEditor Add New Query in the context menu of the existing tab. HowTo - WorkWithQueries - AddNewQuery
  3. Use the shortcut Ctrl + N.

Note: Each tab can be renamed and any query can be added to Favorite Queries.


Save most frequently used queries

Use the Favorite Queries feature to store your most frequently used SQL queries. To access the list of your favorite queries you can use the Favorite Queries node of DB Explorer or create a separate tab for your Favorite queries.

Using the context menu you can create a new Favorite query or edit an existing one using Favorites editor, open any of the existing queries in Query Data or remove a query if you don't need it any longer.


Execute queries with parameters

If you want to use queries with parameters then you should check CheckBox Allow using parameters in query text option in the Environment Options | Tools.

This feature allows you to specify different values within a query in a popup dialog just before the query execution. Use the colon (':') character before an identifier (e.g. :P1) to specify a parameter within the query.


Export query results into file

When executing queries, their results can be displayed on the Edit or Results tab in the Data View.

You can copy data from database tables into an external file of any supported format in one of the following ways:

  1. Open the Data or Results tab, press [image] Export Data on one of the Data View toolbars and define export parameters in the opened Data Export Wizard.
  2. Open the Data or Results tab, choose Data Manipulation | [image] Export Data in the Data Grid context menu and define export parameters in the opened Data Export Wizard.
  3. Open the table context menu in the DB Explorer, choose the [image] Export Data item and define export parameters in the opened Data Export Wizard.
  4. Open the Data or Results tab and use the shortcut Ctrl+E.


Execute scripts

Execute Script allows you to create, view, edit and execute SQL scripts. To open Execute Script Editor select the Tools | btnShowSQLScript Execute Script... main menu item. This tool is intended for work with a great number of SQL statements and with scripts that are stored in files. For instance, you can execute a script directly from a file without loading it to the Editor window. This reduces memory usage. However Execute Script allows just to estimate whether the execution of script statements will be successful, but it does not return query result.

Note: To execute SQL scripts you should use Execute Script, not Query Data. The latter is intended for creating, editing and executing SQL statements. It also provides a possibility to view query result, perform various operations with it (data import, data export, etc.) and manage transactions.


Execute a large SQL script

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Execute a large Execute Script

If you need to execute a large SQL Script it's not necessary to load it from file to the Execute Script Editor window as it can take a lot of time. Instead you can execute script directly from *.sql, *.zsql or *.txt file. In order to do this click the iconCompile Execute script from file button of the Navigation bar and Toolbar in Execute Script editor.


Make SQL script work faster

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Make Execute Script work faster

In order to make the Execute Script editor work faster, you can disable some functions.

Parsing

Choose and disable the iconDBExplorer Disable Parsing item on one of Execute Script Editor toolbars.

Automatic Creation of Hierarchical Text Structure

Uncheck the CheckBox Use code folding box on the Display tab of the Editor options.

Syntax Highlight and Quick Code for Aliases

Choose Options | Editor options in the main menu, proceed to the General tab and uncheck the CheckBox Resolve aliases box - the syntax highlight and quick code for aliases will be disabled.


Customize work with query/script text

Using Internal Link

The name of the object existing on a database is highlighted in a query/script text. You can open such an object by holding the Ctrl key and clicking the object with a mouse.

Adding Text Template

To add a keyboard template, use Ctrl+J shortcut.

Automatic Completion (Object List)

You can call the autocompletion list by starting to enter the first characters of the text and using the shortcut Ctrl + Space.

Customize Autocompletion List

Choose Options | Editor options in the main program menu, proceed to the Code Completion tab and define the list and quick code parameters.

Automatic Formatting of Query/Script

Choose Quick Code | Format in the Query Data/Execute Script context menu or the Shift+Ctrl+F shortcut to apply automatic formatting.

Setting Font and Query/Script Format at the Display tab

Choose Options | Editor options in the main program menu, proceed to the Display tab and define common font and format parameters for Query Data/Execute Script.

Setting Font and Query/Script Format at the Highlight tab

Choose Options | Editor options in the main program menu, proceed to the Color Scheme tab and define font options for each element.

Note: If some font parameters are defined on the Highlight tab, they will be applied to the query/script text and not the ones defined on the Display tab.


View executed queries and scripts

To view all queries and scripts sent to the server you need to launch SQL Monitor. It will show you the log of database operations and SQL queries as items, each consisting of 3 parts: Executed (the date and time of the operation), Operation (SQL statement sent to the server), Result (the result of the operation).

Note: SQL Monitor only displays scripts and queries executed in SQL Manager for Oracle during current session.


Debug procedures

To debug procedures as well as functions, packages, triggers, object types you may use PL/SQL Code Debugger. It provides step-by-step debugging session.

To debug a PL/SQL object you need it to compile it with debug info.


Create a simple report in Report Designer

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Create simple report in the report designer

To create a report using Report Designer:

  1. Select the Tools | [image] Report Designer main menu item.
  2. In the opened Report Designer select the File | [image] New Report main menu item, or click the [image] New Report item of the navigation bar. The following objects will be added to the newly created report: ReportTitle, MasterData and PageFooter.
  3. Connect to data source.
  4. Add ADOTable or ADOQuery object.
  5. Link ADOTable or ADOQuery with ADODatabase.
  6. Place database fields Page1. Move the required fields from Data Tree to Band MasterData.


Transfer program settings

If you want to apply current program settings (wholly or partially) to SQL Manager for Oracle installed on another machine you can save them into a single *.reg file. This can be done by means of the Save Settings Wizard.

Note that Favorite Queries are not saved in this case. To get access to your queries from another machine please store them in the database.


Update SQL Manager

SQL Manager for Oracle can be updated in the following ways:

  1. Download the SQL Manager for Oracle distribution package from the download page, then extract archive to the preferable directory (e.g. c:\unzipped). Close SQL Manager for Oracle if it's opened and run OraManagerFullSetup.exe or OraManagerLiteSetup.exe.
  2. Select the Help | SQL Manager Direct, then press the Update button. If new SQL Manager for Oracle version is released it will be offered for downloading. Click Yes in the dialog window to update SQL Manager for Oracle automatically.


Report bugs and suggestions

  1. Before reporting bugs and suggestions make sure you are using the latest version of the SQL Manager for Oracle.
  2. If so then you may contact us via Members Area on http://www.sqlmanager.net/, via Help main menu or by sending an email to support@sqlmanager.net.
  3. Please, don't forget to mention your OS version, Oracle server version and program version.
  4. Describe the steps to reproduce the bug in detail and illustrate them with screenshots.


Advanced connection settings

You need the installed Oracle client on the client computer where SQL Manager for Oracle will be used. The version of the Oracle client should be compatible with the version of Oracle server you need to connect.

You need to add the connection settings of Oracle server databases to your TNS names file (tnsnames.ora file). This is a configuration file which contains databases description.

If you use Database Client the tnsnames.ora file is located in the %HOME_name\NETWORK\ADMIN directory.

If you use Instant Client for oracle, you should create tnsnames.ora file manually. since it does not exist. File should be created in the same directory where Oracle instant client is installed (e.g. C:\OracleInstantClient\). This file can be created using any text editor (create a simple text file and then change its name and extension).

Only for Instant Client: After the tnsnames.ora file is created and database description is added, create TNS_ADMIN environment variable. For this please do the following:

  1. Right-click 'My computer'.
  2. Select 'Properties' menu item.
  3. Proceed to the 'Advanced' tab and press 'Environment Variables' button.
  4. Press 'New...' button in the 'System variables' section.
  5. Set 'Variable name:' TNS_ADMIN, 'Variable value:' C:\OracleInstantClien\tnsnames.ora
  6. Press 'OK' button to save the variable.

Find PATH variable in the same dialog, double-click it and add path to the Oracle Instant client libraries (they are located in the directory where client is installed, i.e. C:\OracleInstantClient\). Remember that the paths entries should be separated with semicolons ( ; ).

SQL Manager for Oracle connects to the server (with the help of Oracle client) via TCP/IP protocol. Here is an example of TCP/IP connection specified in TNS names file:

DB_Alias =

(DESCRIPTION =

(ADDRESS_LIST =

(ADDRESS = (PROTOCOL = TCP)(HOST = Host_name)(PORT = 1521))

)

(CONNECT_DATA =

(SERVER = DEDICATED)

(SERVICE_NAME = Database_Name)

)

)

PROTOCOL is the keyword that identifies the specific protocol adapter used. For this protocol, the value is TCP. The value can be entered in either uppercase or lowercase.

HOST is the host name or IP address.

PORT is the TCP/IP port number.

SERVICE_NAME the name of service on server; the database instance name may differ from the actual database name, but generally the names match.

DB_Alias any name of the connection

When the client is installed, you can register a database in SQL Manager for Oracle. To open the wizard, select the Database | Register Database... main menu item, or use the Register Database btnRegisterDB button on the main toolbar. You can also use the Shift+Alt+R shortcut for the same purpose.

At the firs step select Oracle client HOME in Home name dropdown list. Proceed to the step Setting registration options and select database from the Database name dropdown list. The databases names are taken from the tnsnames.ora file.

Note: If you have a 64-bit version of OS, you might probably have a 64-bit Oracle client. Since SQL Manager for Oracle is a 32-bit program, it cannot work a 64-bit client. In this case you need to install a 32-bit Oracle client.


Program interface

SQL Manager for Oracle
  • Index
  • « Prev
  • Next »

Main menu

The main menu allows you to perform various Database operations, open To-Do List and activate/deactivate Database Explorer, SQL Assistant and various toolbars within the View menu, manage your databases using items of the Tools and Services menus, customize the application using the Options menu, manage SQL Manager Windows using Window List and other tools, access Registration information and product documentation, update the product to the latest version using the corresponding items available within the Help menu.

Appendix - Program interface - MainMenu

Note: To learn how to configure SQL Manager menus, refer to the Customize toolbars and menus page.

Navigation bars in object editors and program tools

Navigation bars are interface elements that enable users to quickly locate tools they need. Navigation bar items are displayed within a group with the help of links. A typical Navigation bar of SQL Manager contains links to commonly accessed tools (refresh, print, restore default size of the window), options pertaining to the editor or tool, and specific tools.

Appendix - Program interface - NavBar - Expanded

Navigation bar panes (groups) can be expanded/collapsed. When expanded, a pane provides access to its links; when collapsed, panes are displayed as headers only.

To expand/collapse a pane, click the pane header. The [image] [image] icons indicate the current pane state (collapsed/expanded respectively).

Appendix - Program interface - NavBar - Collapsed

Note: Depending on the current tab selection, Navigation bars in most of the program tools expand to one or more additional panes with tab-specific actions that can be useful for working with the object or service.

Hint: Most items of the Navigation bars are also available on the Toolbars.

Toolbars in the main program window, object editors and program tools

A toolbar is a horizontal row or vertical column of selectable image buttons that give the user a constantly visible reminder of and an easy way to select certain application functions. Most SQL Manager editors and tools are supplemented with toolbars.

Appendix - Program interface - Toolbar

To enable the toolbars in SQL Manager for Oracle, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

Hint: Most SQL Manager toolbars are dockable, i.e. you can place a toolbar to any available location within the parent window.

To learn how to configure toolbar items, refer to the Customize toolbars and menus page.

Progress bars

A progress bar is an interface element that conveys the progress of a task or service. Several SQL Manager editors (e.g. Execute Script),tools (e.g. Dependency Tree) and wizards (e.g. Import Data Wizard) are supplemented with progress bars indicating the progress of lengthy operations.

The graphic of SQL Manager progress bars is accompanied by a textual representation of the progress in the percent format.

Splitters

Splitter controls are used to resize docked controls at run time. In SQL Manager for Oracle the splitter controls are used on the main form, DB Explorer, and in program tools and editors as a separator between the working area and Navigation bars, status bars, etc.

Incremental Search bar

Incremental search bar is the tool which is available in the status bar area of some SQL Manager tools. The bar is normally called through the Ctrl+I shortcut. Type in the first letters of the search string, and the corresponding string will be highlighted in the search scope.


Viewing object DDL structure

The DDL (Data Definition Language) tab displays the SQL statements for creating the object with all its subobjects (if there are any). This text is read-only. If you want to change the object definition, use the appropriate editor tabs instead, or copy the text to the Windows Clipboard and paste it in the Query Data or Execute Script Editor.

Appendix - Viewing DDL structure

Hint: If more convenient, you can use the Save DDL to file and Open DDL in Execute script items available on the DDL pane within the Navigation bar of object editors.


Editing object description

The Description tab allows you to view and edit the comment for the object (optional).

Appendix - Editing object description

You can save changes made in this area by clicking the Save Description item on the Navigation bar.

If the changes have not been saved, on attempt to select another tab of the editor you will be prompted for an action whether changes in the object description should be saved or discarded.


Browsing object dependencies

The Dependencies tab allows you to view objects that depend on the object being edited, and the objects that the edited object depends on.

While the tree of dependencies is built, the progress bar is displayed in the status area of the editor window.

Appendix - Browsing object dependencies

Hint: To open a dependent object or a depending object in its editor, you can simply double-click the object alias in the Objects that <object_name> depends on and Objects that depend on <object_name> lists.

See also:

Dependency Tree


Setting object permissions

The Permissions tab allows you to view the permissions currently allocated for this object, and to grant permissions on the object to any of the existing users and roles.

Appendix - Setting object permissions

For details see Grant Manager.


Setting program roles

The Program Roles tab allows you to grant and revoke roles to program units.

This tab is available for function, procedure and package editors.

Appendix - Setting program roles

The table lists available roles that can be granted to program units.

The context menu allows you to:

  • grant code based access control role to program unit;
  • revoke a previously granted permission;
  • grant all code based access control roles to program unit;
  • revoke all previously granted permissions.


Adding restore point

You can add a restore point before changing the data, to get possibility to flash back to the current data state.

Click the iconAddRestorePoint Add restore point item of the Navigation bar or toolbar to open the Add restore point dialog:

Appendix - Add Restore Point

Date

Date and time when the restore point was created. This field can't be modified.

SCN

System Change Number - the unique number of the restore point. The value is generated automatically and can't be modified.

Name

Define the restore point name at this field.

Store in

The RadioButton Built-in DBMS restore point table is available in Oracle 10 and higher. The alternative RadioButton EMS Manager restore point table allows you to create the restore point in Oracle 9 too.


Changing Metadata window

The Changing Metadata window is used to trace the errors and edit SQL statements during their compilation. The compilation window appears each time metadata is changed, both when the compilation is successful and when there are compilation errors. To hide this window for successful metadata changes, select the CheckBox Don't show this window on success option.

Compile SQL

This area displays the SQL statement pending to be executed to perform metadata changing. In this area you can view and edit the SQL statement.

In case of a compilation error the Error tab also becomes visible - here you can view the error description returned by the server.

Commit

This button starts execution of the statement(s). Click it to commit the current transaction. This button is available only if there were no errors in compilation.

Rollback

This button cancels the script execution and allows you to return to the previous stage (editor window or DB Explorer).

Appendix - Changing Metadata window

If necessary, you can copy information to clipboard and save it in a text editor afterwards (the button is only enabled when a compilation error occurs).

If you want this window to appear only in case of an error, uncheck the CheckBox Confirm metadata changing (Changing Metadata Window) option (checked by default) available within the Confirmations section of the Environment Options dialog.


Find Text dialog

The Find Text dialog is provided for quick and flexible searching for specified text within the working area of SQL Manager editors.

Text to find
Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Options

CheckBox Case sensitive
This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only
Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions
Recognizes regular expressions in the Text to find field.

For example, you can type "empl*" to search for metadata containing the "empl" substring; enter "^emp" to search for words starting with "emp" or "^emp|emp$" to search for the string "emp" at the beginning or at the end of the string.

Note: The syntax of regular expressions that can be used in the Text to find field is similar to that used in Perl regular expressions. Comprehensive information about it can be found at http://perldoc.perl.org/perlre.html#Regular-Expressions.

Direction

RadioButton Forward
Searches from the current position to the end of the working area.

RadioButton Backward
Searches from the current position to the beginning of the working area.

Scope

RadioButton Global
Searches within the entire working area, in the direction specified by the Direction setting.

RadioButton Selected text
Searches only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Origin

RadioButton From cursor
The search starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope
The search covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker
The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Show All button to highlight every occurrence of the search string.


Replace Text dialog

The Replace Text dialog is provided for searching and replacing text within the working area of SQL Manager editors.

Text to find
Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Text to replace
This box allows you to enter a string to replace the search string. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered strings. To replace the search string with an empty string, leave this input box blank.

Options

CheckBox Case sensitive
This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only
Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions
Recognizes regular expressions in the Text to find field.

CheckBox Replace with template
This option requires the Regular expressions option selection.

Enable this option to use regular expressions in the Text to replace field. Expression used in this field will be applied to each string that matches the Text to find expression.

Note: The syntax of regular expressions that can be used in the Text to find and the Text to replace fields is similar to that used in Perl regular expressions. Comprehensive information about it can be found at http://perldoc.perl.org/perlre.html#Regular-Expressions.

CheckBox Prompt on replace
Check this option if you wish to be prompted before replacing upon each occurrence of the search string. When this option is off, the search string is replaced automatically.

Direction

RadioButton Forward
Searches and replaces from the current position to the end of the working area.

RadioButton Backward
Searches and replaces from the current position to the beginning of the working area.

Scope

RadioButton Global
Searches and replaces within the entire working area, in the direction specified by the Direction setting.

RadioButton Selected text
Searches and replaces only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Origin

RadioButton From cursor
The search and replace process starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope
The search and replace process covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker
The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Replace All button to replace every occurrence of the search string. If you have checked the Prompt on replace option, the confirmation dialog box appears upon each occurrence of the search string.


Format specifiers

The following format specifiers are supported in the format string:

Float/Integer format

0

Digit place holder. If the value being formatted has a digit in the position where the '0' appears in the format string, then that digit is copied to the output string. Otherwise, a '0' is stored in that position in the output string.

#

Digit placeholder. If the value being formatted has a digit in the position where the '#' appears in the format string, then that digit is copied to the output string. Otherwise, nothing is stored in that position in the output string.

.

Decimal point. The first '.' character in the format string determines the location of the decimal separator in the formatted value; any additional '.' characters are ignored.

,

Thousand separator. If the format string contains one or more ',' characters, the output will have thousand separators inserted between each group of three digits to the left of the decimal point. The placement and number of ',' characters in the format string does not affect the output, except to indicate that thousand separators are wanted.

E+

Scientific notation. If any of the strings 'E+', 'E-', 'e+', or 'e-' are contained in the format string, the number is formatted using scientific notation. A group of up to four '0' characters can immediately follow the 'E+', 'E-', 'e+', or 'e-' to determine the minimum number of digits in the exponent. The 'E+' and 'e+' formats cause a plus sign to be output for positive exponents and a minus sign to be output for negative exponents. The 'E-' and 'e-' formats output a sign character only for negative exponents.

Date/Time format

c

Displays the date using the format using the Short Date Format, followed by the time using the Long Time Format. The time is not displayed if the date-time value indicates midnight precisely.

d

Displays the day as a number without a leading zero (1-31).

dd

Displays the day as a number with a leading zero (01-31).

ddd

Displays the day as an abbreviation (Sun-Sat) using the strings of the Short Day Names.

dddd

Displays the day as a full name (Sunday-Saturday) using the strings of the Long Day Names.

ddddd

Displays the date using the Short Date Format.

dddddd

Displays the date using the Long Date Format.

e

Displays the year in the current period/era as a number without a leading zero (Japanese, Korean and Taiwanese locales only).

ee

Displays the year in the current period/era as a number with a leading zero (Japanese, Korean and Taiwanese locales only).

g

Displays the period/era as an abbreviation (Japanese and Taiwanese locales only).

gg

Displays the period/era as a full name. (Japanese and Taiwanese locales only).

m

Displays the month as a number without a leading zero (1-12). If the m specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mm

Displays the month as a number with a leading zero (01-12). If the mm specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mmm

Displays the month as an abbreviation (Jan-Dec) using the strings given of the Short Month Names.

mmmm

Displays the month as a full name (January-December) using the strings of the Long Month Names.

yy

Displays the year as a two-digit number (00-99).

yyyy

Displays the year as a four-digit number (0000-9999).

h

Displays the hour without a leading zero (0-23).

hh

Displays the hour with a leading zero (00-23).

n

Displays the minute without a leading zero (0-59).

nn

Displays the minute with a leading zero (00-59).

s

Displays the second without a leading zero (0-59).

ss

Displays the second with a leading zero (00-59).

z

Displays the millisecond without a leading zero (0-999).

zzz

Displays the millisecond with a leading zero (000-999).

t

Displays the time using the Short Time Format.

tt

Displays the time using the Long Time Format.

am/pm

Uses the 12-hour clock for the preceding h or hh specifier, and displays 'am' for any hour before noon, and 'pm' for any hour after noon. The am/pm specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

a/p

Uses the 12-hour clock for the preceding h or hh specifier, and displays 'a' for any hour before noon, and 'p' for any hour after noon. The a/p specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

ampm

Uses the 12-hour clock for the preceding h or hh specifier, and displays the contents of the TimeAMString global variable for any hour before noon, and the contents of the TimePMString global variable for any hour after noon.

/

Displays the date separator character using the Date Separator.

:

Displays the time separator character using the Time Separator.

'xx'/"xx"

Characters enclosed in single or double quotes are displayed as-is, and do not affect formatting.


Language Info Editor

The Language Info Editor dialog allows you to set the language name and specify the corresponding *.lng localization file. This dialog is opened when you add or edit a language (see Environment Options | Localization).

Language Name

The name of the language that is displayed in the Select Program Language dialog and within the Available Languages list of the Environment Options | Localization section.

Language File

The *.lng file containing the translated string resources. See the %program_directory%\Languages folder to find already existing localization files.

Adding a language

The Add language dialog allows you to specify your own localization file and set the language name.

Editing a language

The Edit language dialog allows you to change the language name or select another localization file for the specified language.


Using templates

For your convenience the ability to use templates is provided by SQL Manager for Oracle. A template is a named collection of wizard options stored in a file.

Instead of performing a long chain of routine steps all the time you can save all the options of the wizard for future use as a template file. Select the Templates | Save Template drop-down menu item, specify the template file name and set an optional comment for the template file.

When starting the wizard next time, you can load the template by selecting the Templates | Load Template drop-down menu item.

Note that saving/loading of templates is possible at any step of the wizard.


Supported file formats

RadioButton MS Excel

The contemporary e-table format used by Microsoft® (*.xlsx).

RadioButton MS Access

The database file of Microsoft® Access format (*.accdb)

RadioButton MS Word

The contemporary text processing format used by Microsoft® Word (*.docx). The result files are fully compatible with Microsoft® Word 2007.

RadioButton RTF

Rich Text Format (*.rtf) supported by many text processing programs (e.g. WordPad).

RadioButton HTML

Hyper Text Markup Language file format (*.html, *.htm), complete compatibility with HTML 4.0 specification.

RadioButton PDF

A standard format in electronic publishing (*.pdf).

RadioButton Text file

Plain text file format (*.txt).

RadioButton CSV file

Comma-Separated Value file format (*.csv).

RadioButton DIF file

Data Interchange File (*.dif) format.

RadioButton SYLK

Symbolic Links (*.slk) file format.

Note: all the text formats including Text file, CSV, DIF, SYLK are usually used as working or interchange formats.

RadioButton LaTeX

A specific file format (*.tex) which is a popular (especially among mathematicians and physicists) macroextension of TeX pack developed by D.Knut.

RadioButton XML

A markup language for documents containing structured information (*.xml).

RadioButton DBF

Database file format (*.dbf) used by dBASE and a number of xBASE applications.

RadioButton MS Excel 97-2003

The older e-table format used by Microsoft® Excel (*.xls).

RadioButton MS Word 97-2003

One of the most popular text processing formats used by Microsoft® Word (*.doc).

RadioButton MS Access 97-2003

File of Microsoft® Access format (*.mdb) with an ADO connection used.

RadioButton ODF Spreadsheets

OASIS Open Document Format for Office Applications - open document file format for spreadsheets (*.ods) used by a number of applications including OpenOffice.org and KOffice.

RadioButton ODF Text

OASIS Open Document Format for Office Applications - open document file format for word processing (*.odt) documents used by a number of applications including OpenOffice.org and KOffice.


To-Do List

The To-Do List window allows you to make up a list of tasks for the database.

To call this window, select the View | To-Do List main menu item, or use the Shift+Ctrl+T shortcut.

The task list is displayed in a form of a grid. Its columns (Action, Priority, User, Category) correspond to the task parameters. Click the column caption to sort the task list by the current parameter or change the sorting direction. Use the Navigation bar and context menu to add, edit, and delete to-do items.

Appendix - To-Do List

Database

Select the database to apply the task list to. When switching between the databases you can view different task lists.

To add a task to this list, click the Add Item link on the Navigation bar, or select Add Item from the context menu. You can also use the Ins key for the same purpose. Define the task parameters and click OK to add the new task to the list.

Appendix - To-Do List - Edit To-Do item

Text

Optional text to describe the task.

Priority

Set a numeric value to indicate the priority of the task.

User Name

The database User name this task is applied to.

Category

Set a category for the task. Using categories may be useful for grouping tasks.

To modify a task, select the task in the list and click the Edit Item link of the Navigation bar, or select Edit Item in the context menu. You can also use the Enter key for the same purpose.

To remove a task, select the task in the list and click the Delete Item link of the Navigation bar, or select Delete Item in the context menu. You can also use the Del key for the same purpose.

To remove all tasks from To-Do List, click the Delete all link of the Navigation bar, or select Delete all in the context menu. You can also use the Ctrl+Del shortcut for the same purpose.


Window List

The Windows List panel allows you to browse the list of windows that are currently opened within SQL Manager for Oracle IDE.

To activate this panel as a DB Explorer tab, select the Windows | Window List main menu item, or use the Ctrl+Alt+0 shortcut.

Appendix - Window List

If necessary, you can right-click within the list area to call the popup menu which allows you to bring a window to foreground, close windows one by one or in groups, and to arrange the windows according to your preferences.


Customize toolbars and menus

For your convenience SQL Manager for Oracle provides toolbars and menus that you can customize, so the commands you use frequently are readily available and easily identifiable.

The Customize dialog allows you to create and personalize SQL Manager menus and toolbars.

To call this dialog, click More buttons... btnMoreButtons on the right side of any toolbar, then click Add or Remove Buttons and select Customize... from the drop-down menu. Alternatively, you can right-click any toolbar and select the Customize... popup menu item.

Toolbars

This list displays all currently existing toolbars of SQL Manager (both default and user-defined toolbars). Check/uncheck the box at a toolbar name to show/hide the toolbar.

New...

Use this button to add a new user-defined toolbar to the Toolbars list. Set a name for the newly created toolbar and dock it by dragging it to any permitted location within the application window.

Rename...

Use this button to rename the selected user-defined toolbar.

Delete

Use this button to delete the selected user-defined toolbar.

Appendix - Customize - Toolbars

Commands

This tab allows you to browse the list of all commands available within the menus and toolbars of the application window. Selecting categories in the Categories list displays commands of the selected category (e.g. 'Database' or 'Tools') in the Commands list.

If necessary, you can pick a command and drag it to any toolbar to create a button for this command.

Appendix - Customize - Commands

Options

Personalized Menus and Toolbars

CheckBox Menus show recently used commands first

This option determines whether the most frequently used items will be placed in menus at first position.

If this option is enabled, frequently used menu items are "promoted" and displayed higher on the list. Unused and infrequently used menu items are visually suppressed and appear "collapsed".

CheckBox Show full menus after a short delay

This option is available only if the Menus show recently used commands first option is selected.

If this option is enabled, infrequently used menu items (if they appear "collapsed") will be automatically expanded after a delay upon setting mouse cursor (or upon selection with the Up/Down keys) on the bottom of the menu. Otherwise, the menu expands only after clicking its bottom-most button (or using the Ctrl+Down shortcut).

Reset my usage data

Resets the lists of recently used commands in the toolbars and menus.

Appendix - Customize - Options

Other

CheckBox Large icons

This option displays larger icons on the parent window toolbars.

CheckBox Show ToolTips on toolbars

If this option is selected, ToolTips (hints) popup when the mouse cursor is positioned over a toolbar button.

CheckBox Show shortcut keys in ToolTips

If this option is selected, the corresponding shortcuts are displayed in ToolTips (hints) for toolbar buttons.

Menu animations

Use the drop-down list to specify the menu animation effects:

None (no animation)

Random (random choice: Unfold, Slide, Fade)

Unfold (unfolding menus)

Slide (sliding menus)

Fade (menus fade in when appearing)


SSH tunneling options

SSH (Secure Shell Host) protocol is used to heighten computer security when working with Unix systems on the Internet. SSH uses several encryption algorithms of different reliability. The spread of SSH is also related to the fact that a number of *nix operating systems (e.g. FreeBSD) include SSH server in their standard distributions. To learn more about SSH, please visit http://openssh.org.

The SSH tunneling feature of SQL Manager is a means of ensuring secure connection to Oracle servers when working over insecure connection channels. You can also use SSH tunnel to get access to the remote Oracle servers when port 3306 is closed for external connections for some reasons.

The connection via SSH tunnel works in the following way.

First, a connection is established and the process of authentication between SSH client built in SQL Manager and remote Oracle server is performed. Then all incoming and outgoing information between the application and Oracle is transmitted through SSH server with the help of a communication port (regularly port 22), and SSH server transfers this information directly to Oracle server.

To setup the connection via SSH tunnel, input the following values in the corresponding fields:

  • SSH host name is the name of the host where SSH server is running
  • SSH port indicates the port where SSH server is activated
  • SSH user name stands for the user on the machine where SSH server is running (Note: it is a Linux/Windows user, not a user of Oracle server)
  • SSH password is the Linux/Windows user password

Please note that Oracle host name should be set relatively to the SSH server in this case. For example, if both Oracle and SSH servers are located on the same computer, you should specify localhost as host name instead of the server external host name or IP address.

Appendix - SSH tunneling options

CheckBox Use Private Key for authentication

If the SSH encryption is enabled on the SSH server, a user can generate a pair of cryptographic keys (the Private key and the Public key). The Public key is placed on the SSH server, and the Private key is the part you keep secret inside a secure box that can only be opened with the correct passphrase (or an empty string as the passphrase). When you wish to access the remote system, you open the secure box with your passphrase (if any), and use the private key to authenticate yourself with the Public key on the remote Linux computer.

SSH Key file

Specify the location (the secure box) of the Private key file on your local machine.

Supported Private Key file formats are:

OpenSSH

Putty

SSH.com

Note that you need to trust your local machine not to scrape your passphrase or a copy of your Private key file while it is out of its secure box.

SSH Private Key - Passphrase


SQL Manager Direct

SQL Manager Direct is a feature of SQL Manager for Oracle which provides you with quick access to the related Internet resources and allows you to keep your SQL Manager version up-to-date.

To open the SQL Manager Direct window, select the Help | SQL Manager Direct item from the main menu.

Links to sqlmanager.net resources provided by the SQL Manager Direct window are grouped into several sections:

  • SQL Manager for Oracle News
  • General Information
  • Downloads
  • Related Products

Upon a link selection you will be immediately forwarded to the corresponding resource.

SQL Manager for Oracle News

This section takes you directly to the latest EMS news column. Using the links you can get up-to-date news, product information and downloads from sqlmanager.net.

General Information

This section offers a number of links to product news, features, Feature Matrix, system requirements, testimonials and much more.

Downloads

Using links of this section you can download other product versions from the download page.

Related Products

This section allows you to browse the list of related products developed by EMS Software development.

Appendix - SQL Manager Direct

Use the btnBack btnForward buttons to navigate in the same way as you normally do it using a web browser.

Click the Update button to refresh the page.

CheckBox Automatically poll network in interval (in days)

If this option is selected, the page is refreshed automatically after the specified time interval. Use the spinner control to set the interval (in days).

In the Status area at the bottom of the SQL Manager Direct window you can find the status of your request to the sqlmanager.net website.


Database Login dialog

The Database Login dialog appears on attempt to connect to a database if the Login prompt before connection option is enabled on the Options page of the Database Registration Info dialog.

Appendix - Database Login

Note: The SSH user name and SSH password boxes are available only if SSH tunneling is used for the database connection.

Specify user name / password, SSH user name / SSH password (if necessary) and click OK to start working with the database.


Overwriting existing output file

If a file having the same name as specified for an output file generated by SQL Manager already exists, a warning dialog is displayed.

Appendix - Overwrite File Warning dialog

You can Overwrite the file, Make it Unique, or Cancel both and change the path or file name manually.

The application makes the file unique by adding the current timestamp to the specified file name if the CheckBox Add Timestamp to filename option is enabled, or by adding a simple numeric postfix to the file name if this option is disabled.


Script conversion

The Script conversion dialog allows you to select encoding to be used for script conversion upon loading script to one of SQL Manager editors (Query Data, Execute Script Editor) from an external file.

Appendix - Script conversion

RadioButton Windows default

Specifies that the standard Windows encoding will be used for the script conversion.

RadioButton Database default

Specifies that the default encoding of the database will be used for the script conversion.

RadioButton Other encoding

Allows you to select the encoding that will be used for the script conversion.

Preview

This area displays the script with the current encoding parameters applied.


Storage attributes

The Physical Attributes / Storage tab available in object editors lets you specify how a database object should be stored in the database. Storage parameters affect both how long it takes to access data stored in the database and how efficiently space in the database is used.

Appendix - Storage attributes

Physical attributes

Tablespace

A tablespace is an allocation of space in the database that can contain schema objects. Use the drop-down list to select the tablespace where the object will be stored.

Buffer pool

This option allows you to specify a default buffer pool or cache for the object. All blocks for the object are stored in the specified cache. Use the drop-down list to select one of the following values:

KEEP: the buffer pool retains the schema object's data blocks in memory;

RECYCLE: the buffer pool eliminates data blocks from memory as soon as they are no longer needed.

DEFAULT: the buffer pool contains data blocks from schema objects that are not assigned to any buffer pool, as well as schema objects that are explicitly assigned to the DEFAULT pool.

Initial number of transactions

Specify the initial number of concurrent transaction entries allocated within each data block allocated to the database object, or select DEFAULT from the drop-down list.

CheckBox Cache

Use this option to indicate how Oracle Database should store blocks in the buffer cache.

CheckBox Row dependencies

Select this option if you want to enable row-level dependency tracking. This setting is useful primarily to allow for parallel propagation in replication environments.

Extents

An extent is a logical unit of database storage space allocation made up of a number of contiguous data blocks. One or more extents in turn make up a segment. When the existing space in a segment is completely used, Oracle allocates a new extent for the segment.

Initial extent

Specify the size (in bytes) of the first extent of the object. Oracle allocates space for this extent when you create the schema object, or select DEFAULT from the drop-down list.

Next extent

Specify the size (in bytes) of the next extent to be allocated to the object, or select DEFAULT from the drop-down list.

Percent increase

Specify the percent by which the third and subsequent extents grow over the preceding extent, or select DEFAULT from the drop-down list (the default value is 50, meaning that each subsequent extent is 50 per cent larger than the preceding extent)

Minimum extents

Specify the total number of extents to allocate when the object is created, or select DEFAULT from the drop-down list. This parameter lets you allocate a large amount of space when you create an object, even if the space available is not contiguous.

Maximum extents

Specify the total number of extents, including the first, that Oracle can allocate for the object, or select DEFAULT or UNLIMITED from the drop-down list.

Space usage

Parameters of this group allow you to control the use of free space for inserts and updates to the rows in all the data blocks of a particular segment.

Percent free

This parameter sets the minimum percentage of a data block to be reserved as free space for possible updates to rows that already exist in that block. Specify a value, or select DEFAULT from the drop-down list.

Percent used

This parameter sets the minimum percentage of a block that can be used for row data plus overhead before new rows are added to the block. Specify a value, or select DEFAULT from the drop-down list.

Free lists

Free lists

Specify the number of free lists that can be contained in each free list group, or select DEFAULT from the drop-down list (the default and minimum value for this parameter is 1, meaning that each free list group contains one free list).

Groups

Specify the number of groups of free lists for the database object being created, or select DEFAULT from the drop-down list (the default and minimum value for this parameter is 1).

Parallel

Use this group to specify the degree of parallel access to the object.

RadioButton Default

RadioButton No parallel (serial execution)

RadioButton Parallel (parallelized execution)

Parallel options

Degree

Specify the degree of parallelism which is the number of parallel threads used in the parallel operation, or select DEFAULT from the drop-down list.

A degree of parallelism equals to the number of CPUs available on all participating Instances.

Data storage options

This group is only available for tables which store data.

CheckBox Compress data

Use this option to instruct the database whether to compress data segments to reduce disk and memory use (for heap-organized tables).

CheckBox Enable row movement

This option allows you to specify whether the database can move a table row. It is possible for a row to move, for example, during table compression or an update operation on partitioned data. Note that when a row is moved, the rowid is changed.

Compress for

Use this group to specify the table compression mode:

RadioButton All operations (Oracle Database attempts to compress data during all DML operations on the table)

RadioButton Direct load operation (Oracle Database attempts to compress data during direct-path INSERT operations when it is productive to do so)


Select Object dialog

The Select Object dialog appears each time the application requests a database object selection, e.g. upon a root object selection for the Dependency Tree tool, or when choosing an object to be added to a project. This dialog is also called from DB Explorer and some object editors (Operator Editor, Synonym Editor).

Appendix - Select Object

First select the object type in the list on the left-hand side of the window. Use the drop-down list at the top to select the schema, pick the object you need and click OK the apply your selection.


SQL Manager shortcuts

Database management

Shift+Alt+R | Register a database using Register Database Wizard
Shift+Alt+U | Unregister the selected database
Shift+Ctrl+C | Connect to a database
Shift+Ctrl+D | Disconnect from a database

Database objects management

Ctrl+N | Create a new object (the object type depends on the current selection)
Ctrl+O | Edit the selected object in its editor
Ctrl+R | Rename the selected object
Shift+Del | Drop the selected object
Ctrl+Shift+C | Collapse the current DB Explorer tree branch and switch selection to the parent tree node

SQL Manager tools

F11 | View/hide Database Explorer
Ctrl+F | Search for an item in the DB Explorer tree
Shift+Ctrl+T | Open the To-Do List window
F12 | Show Query Data
Shift+F12 | Open a new instance of Query Data
Shift+Ctrl+M | Open SQL Monitor
Shift+Ctrl+S | Open Execute Script Editor
Shift+Ctrl+L | Open Localization Editor
Ins | Add a new table subobject (the subobject type depends on the current tab selection)

Data Grid

Ctrl+Shift+0

Set the selected column value to NULL

Query Data and Execute Script editors

F9 | Execute query/script
Alt+F9 | Execute selected only
Ctrl+Alt+F9 | Execute under cursor
Ctrl+Alt+F2 | Reset execution point (Query Data only)
Shift+Ctrl+<digit> | Toggle bookmark #<digit>
Ctrl+<digit> | Go to bookmark #<digit>
Ctrl+Q | Go to next bookmark
F2 | Drop marker to current position
Ctrl+Z; Alt+BkSp | Undo
Shift+Ctrl+Z; Shift+Alt+BkSp | Redo
Ctrl+F | Search for text using the Find Text dialog
Ctrl+R | Replace text using the Replace Text dialog
F3 | Search next
Ctrl+I | Start incremental search
Alt+G | Go to line number (an input number dialog prompts for the number)
Ctrl+L | Load a script from an external file
Ctrl+S | Save the script to an external file
Shift+Ctrl+F | Format the SQL text using SQL Formatter
Alt+<symbol> | Switch to the query with <&symbol> in its name (Query Data only)
Ctrl+J | Insert a keyboard template
Сtrl+D | Toggle query results display mode (at the Edit tab or at a separate one)
Shift+Ctrl+Left | Select the previous word
Shift+Ctrl+Right | Select the next word
Shift+Home | Select text to the beginning of the line
Shift+End | Select text to the end of the line
Shift+PageUp | Select one page up
Shift+PageDown | Select one page down
Shift+Ctrl+PageUp | Select text to the first line on the page
Shift+Ctrl+PageDown | Select text to the last line on the page
Shift+Ctrl+Home | Select text to the absolute beginning
Shift+Ctrl+End | Select text to the absolute end
Shift+Alt+Left | Select column symbol-by-symbol to the left
Shift+Alt+Right | Select column symbol-by-symbol to the right
Shift+Alt+Up | Select column upwards
Shift+Alt+Down | Select column downwards
Shift+Ctrl+Alt+Left | Select column word-by-word to the left
Shift+Ctrl+Alt+Right | Select column word-by-word to the right
Shift+Alt+Home | Select column to the first char of line
Shift+Alt+End | Select column to the last char of line
Shift+Alt+PageUp | Select column to the beginning of the page
Shift+Alt+PageDown | Select column to the end of the page
Shift+Ctrl+Alt+Home | Select column from the current cursor position to the beginning of the first line
Shift+Ctrl+Alt+End | Select column from the current cursor position to the beginning of the last line
Ctrl+Up | Scroll up one line with cursor position unchanged
Ctrl+Down | Scroll down one line with cursor position unchanged
Alt+Down, Alt+Up | Toggle case of a current word
Ctrl+Alt+Up | Toggle case to upper of a current selection or char
Ctrl+Alt+Down | Toggle case to lower of a current selection or char
Ctrl+G,Ctrl+F | Collapse block at current line
Ctrl+G,Ctrl+E | Expand block at current line
Ctrl+G,Ctrl+M | Collapse all blocks in the text
Ctrl+G,Ctrl+P | Expand all blocks in the text
Ctrl+= | Collapse/expand the nearest block
Esc | Collect marker (jump back)
Shift+Esc | Swap marker to current position
Shift+Ctrl+B | Jump to matching bracket (change range side)
Shift+Ctrl+I | Indent selected block
Shift+Ctrl+U; Shift+Tab | Unindent selected block
Ctrl+/ | Comment/uncomment selected block
Ctrl+Space | Show code completion
Shift+Ctrl+Space | Show code parameters
Ctrl+Alt+Space | Show character map
Ctrl+Alt+L | Show functions
Ctrl+Alt+3 | Show packages
Ctrl+Alt+A | Show array types
Ctrl+Alt+K | Show clusters
Ctrl+Alt+7 | Show contexts
Ctrl+Alt+X | Show indices
Shift+Alt+P | Insert procedure parameters
Ctrl+Alt+J | Show java sources
Ctrl+Alt+M | Show materialized views
Ctrl+Alt+O | Show object types
Ctrl+Alt+Z | Show object type bodies
Ctrl+Alt+P | Show procedures
Ctrl+Alt+5 | Show operators
Ctrl+Alt+B | Show package bodies
Ctrl+Alt+9 | Show profiles
Ctrl+Alt+G | Show SQL functions
Ctrl+Alt+S | Show schemas
Ctrl+Alt+E | Show sequences
Ctrl+Alt+T | Show tables
Ctrl+Alt+C | Show table fields
Ctrl+Alt+Y | Show synonyms
Ctrl+Alt+Enter | Show table in SQL Assistant
Ctrl+Alt+U | Show users
Ctrl+Alt+V | Show views
Ctrl+Alt+1 | Show SQL keywords
Ctrl+C; Ctrl+Ins | Copy selection to Clipboard
Ctrl+X; Shift+Del | Cut selection to Clipboard
Ctrl+V; Shift+Ins | Paste Clipboard to current position
Ctrl+Del | Delete from cursor to the next word
Ctrl+BkSp | Delete from cursor to the beginning of the word
Ctrl+B | Delete from cursor to the beginning of the line
Shift+Ctrl+Y | Delete from cursor to the end of the line
Ctrl+Y | Delete the current line
Ctrl+M; Enter; Shift+Enter | Break line at current position, move caret to a new line
Ctrl+Alt+I | Insert Tab char
Shift+Ctrl+P | Play macro
Shift+Ctrl+R | Start macro recording
Alt+End | Skip misprint
Ctrl+Alt+End | Skip all misprints
Alt+Home | Correct all misprints

Print Data View

Ctrl+O | Load a printing report from a file
Ctrl+S | Save the report to file
Ctrl+P | Open the Print dialog
Ctrl+Home | Go to the first page
Ctrl+Up | Go to the previous page
Ctrl+Down | Go to the next page
Ctrl+End | Go to the last page
Ctrl+D | Open Report Formatter
Ctrl+\ | Zoom 100%
Ctrl+0 | Zoom page width
Ctrl+1 | Whole page
Ctrl+2 | Two pages
Ctrl+4 | Four pages
Ctrl+W | Widen to source width
Ctrl+M | Show/hide margins
Ctrl+K | Set background color for the report

Working with windows, menus and tabs

Ctrl+Tab | Switch to the next tab
Ctrl+Alt+0 | Open Window List
Ctrl+Alt+D | Set defaults to all windows
Ctrl+F6 | Switch to the previous window
F6 | Switch to the next window
Ctrl+W | Close the active window
Ctrl+Down | Expand a collapsed menu


License Agreement

SQL Manager for Oracle
  • Index

End User License Agreement

  • License Agreement for SHAREWARE versions
  • License Agreement for FREEWARE versions

License Agreement for SHAREWARE versions

© 1999-2022 EMS Database Management Solutions, Inc.

All rights reserved.

IMPORTANT: PLEASE READ THIS AGREEMENT CAREFULLY BEFORE USING THE SOFTWARE.

END USER LICENSE AGREEMENT

EMS Database Management Solutions, Inc. ("EMS") agrees to provide the user ("USER") with a copy of this software product ("SOFTWARE"), and grants the USER a limited license to use the SOFTWARE. This LICENSE AGREEMENT ("LICENSE") defines what the USER may do with the SOFTWARE, and contains limitations on warranties, liabilities and remedies. This LICENSE may be revoked by EMS at any time without notice if the USER fails to comply with the terms of this LICENSE. The copyright and all other rights in the SOFTWARE shall remain with EMS.

LICENSE OF UNREGISTERED SOFTWARE

An unregistered copy of the SOFTWARE ("UNREGISTERED SOFTWARE") may be used by the USER for evaluation purposes for a period of thirty (30) days following the initial installation of the UNREGISTERED SOFTWARE. At the end of the trial period ("TRIAL PERIOD"), the USER must either register the SOFTWARE or remove it from his system. The UNREGISTERED SOFTWARE may be freely copied and distributed to other users for their evaluation.

LICENSE OF REGISTERED SOFTWARE

A registered copy of the SOFTWARE ("REGISTERED SOFTWARE") allows the USER to use the SOFTWARE only on a single computer or network and only by a single user at a time. If the USER wishes to use the SOFTWARE for more than one user, the USER will need a separate license for each individual user. The USER is allowed to make one copy of the REGISTERED SOFTWARE for back-up purposes.

DISTRIBUTION OF UNREGISTERED SOFTWARE

The uninstalled, UNREGISTERED SOFTWARE may be freely copied and distributed to other users provided the USER complies with the following requirements. If the USER offers this uninstalled, UNREGISTERED SOFTWARE for download ("SHAREWARE SITE USER"), then the SHAREWARE SITE USER agrees to:

(1) Immediately replace this version of the uninstalled, UNREGISTERED SOFTWARE with a new version of this SOFTWARE if a new version is released by EMS, or

(2) Delete this version of the UNREGISTERED SOFTWARE immediately upon written email notice by EMS.

TERM OF LICENSE

This LICENSE shall continue for as long as the USER uses the REGISTERED SOFTWARE and/or distributes the UNREGISTERED SOFTWARE according to the terms of this agreement. However, this LICENSE will terminate if the USER fails to comply with any of its terms or conditions. The USER agrees, upon termination, to destroy all copies of the REGISTERED and/or UNREGISTERED SOFTWARE. The limitations of warranties and liability set forth in this LICENSE shall continue in force even after termination.

ACCEPTANCE OF THIS LICENSE AGREEMENT

By downloading and/or installing this SOFTWARE, the USER agrees to the terms of this LICENSE.

DISCLAIMER OF WARRANTY AND LIABILITY

THE SOFTWARE AND THE ACCOMPANYING FILES ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, EMS DISCLAIMS ALL WARRANTIES, EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF PERFORMANCE, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NONINFRINGEMENT. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL EMS BE LIABLE FOR ANY DIRECT, INDIRECT, CONSEQUENTIAL OR INCIDENTAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION OR LOSS OF BUSINESS INFORMATION) ARISING OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE.

ANY LIABILITY OF EMS WILL BE LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF ORIGINAL PURCHASE PRICE.

OTHER RESTRICTIONS

The USER may not rent, lease, sublicense, translate, disassemble, reverse engineer, or de-compile the SOFTWARE, or modify or merge the SOFTWARE with any part of the software in another program. This LICENSE may not be assigned or otherwise transferred without the prior written consent of EMS.

INVALID PROVISIONS

If any provision of this LICENSE shall be declared invalid or unenforceable, the remaining provisions of this LICENSE shall remain in full force and effect to the fullest extent permitted by law. In such event, each provision of this LICENSE which is invalid or unenforceable shall be replaced with a provision as similar in terms to such invalid or unenforceable provision as may be possible which is legal and enforceable.

ENTIRE AGREEMENT

This LICENSE is the entire agreement between EMS and the USER, and supersedes any other agreement, oral or written, and may not be changed except by a written signed agreement.

License Agreement for FREEWARE versions

© 1999-2022 EMS Database Management Solutions, Inc.

All rights reserved.

IMPORTANT: PLEASE READ THIS AGREEMENT CAREFULLY BEFORE USING THE SOFTWARE.

END USER LICENSE AGREEMENT

EMS Database Management Solutions, Inc. ("EMS") agrees to provide the user ("USER") with a copy of this software product ("SOFTWARE"), and grants the USER a limited license to use the SOFTWARE. This LICENSE AGREEMENT ("LICENSE") defines what the USER may do with the SOFTWARE, and contains limitations on warranties, liabilities and remedies. This LICENSE may be revoked by EMS at any time without notice if the USER fails to comply with the terms of this LICENSE. The copyright and all other rights in the SOFTWARE shall remain with EMS.

LICENSE OF SOFTWARE

This FREEWARE edition of SOFTWARE is free and may be used by the USER for any legal purposes for an unlimited period on unlimited number of computers without any restrictions. The FREEWARE edition of SOFTWARE may have some functional restrictions and does NOT contain any ADWARE or SPYWARE.

DISTRIBUTION OF SOFTWARE

The FREEWARE edition of SOFTWARE may be freely copied and distributed to other users without any restrictions.

TERM OF LICENSE

This LICENSE shall continue for as long as the USER uses the SOFTWARE and/or distributes the SOFTWARE according to the terms of this agreement. However, this LICENSE will terminate if the USER fails to comply with any of its terms or conditions. The limitations of warranties and liability set forth in this LICENSE shall continue in force even after termination.

ACCEPTANCE OF THIS LICENSE AGREEMENT

By downloading and/or installing this SOFTWARE, the USER agrees to the terms of this LICENSE.

DISCLAIMER OF WARRANTY AND LIABILITY

THE SOFTWARE AND THE ACCOMPANYING FILES ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, EMS DISCLAIMS ALL WARRANTIES, EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF PERFORMANCE, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NONINFRINGEMENT. TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT SHALL EMS BE LIABLE FOR ANY DIRECT, INDIRECT, CONSEQUENTIAL OR INCIDENTAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, DAMAGES FOR LOSS OF BUSINESS PROFITS, BUSINESS INTERRUPTION OR LOSS OF BUSINESS INFORMATION) ARISING OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE.

OTHER RESTRICTIONS

The USER may not rent, lease, sublicense, translate, disassemble, reverse engineer, or de-compile the SOFTWARE, or modify or merge the SOFTWARE with any part of the software in another program. This LICENSE may not be assigned or otherwise transferred without the prior written consent of EMS.

INVALID PROVISIONS

If any provision of this LICENSE shall be declared invalid or unenforceable, the remaining provisions of this LICENSE shall remain in full force and effect to the fullest extent permitted by law. In such event, each provision of this LICENSE which is invalid or unenforceable shall be replaced with a provision as similar in terms to such invalid or unenforceable provision as may be possible which is legal and enforceable.

ENTIRE AGREEMENT

This LICENSE is the entire agreement between EMS and the USER, and supersedes any other agreement, oral or written, and may not be changed except by a written signed agreement.